/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2023, PgPool Global Development Group
 * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include "utils/pgstrcasecmp.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeStringConst(char *str, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static PartitionStrategy parsePartitionStrategy(char *strategy);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 326 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSENT = 276,
    ABSOLUTE_P = 277,
    ACCESS = 278,
    ACTION = 279,
    ADD_P = 280,
    ADMIN = 281,
    AFTER = 282,
    AGGREGATE = 283,
    ALL = 284,
    ALSO = 285,
    ALTER = 286,
    ALWAYS = 287,
    ANALYSE = 288,
    ANALYZE = 289,
    AND = 290,
    ANY = 291,
    ARRAY = 292,
    AS = 293,
    ASC = 294,
    ASENSITIVE = 295,
    ASSERTION = 296,
    ASSIGNMENT = 297,
    ASYMMETRIC = 298,
    ATOMIC = 299,
    AT = 300,
    ATTACH = 301,
    ATTRIBUTE = 302,
    AUTHORIZATION = 303,
    BACKWARD = 304,
    BEFORE = 305,
    BEGIN_P = 306,
    BETWEEN = 307,
    BIGINT = 308,
    BINARY = 309,
    BIT = 310,
    BOOLEAN_P = 311,
    BOTH = 312,
    BREADTH = 313,
    BY = 314,
    CACHE = 315,
    CALL = 316,
    CALLED = 317,
    CASCADE = 318,
    CASCADED = 319,
    CASE = 320,
    CAST = 321,
    CATALOG_P = 322,
    CHAIN = 323,
    CHAR_P = 324,
    CHARACTER = 325,
    CHARACTERISTICS = 326,
    CHECK = 327,
    CHECKPOINT = 328,
    CLASS = 329,
    CLOSE = 330,
    CLUSTER = 331,
    COALESCE = 332,
    COLLATE = 333,
    COLLATION = 334,
    COLUMN = 335,
    COLUMNS = 336,
    COMMENT = 337,
    COMMENTS = 338,
    COMMIT = 339,
    COMMITTED = 340,
    COMPRESSION = 341,
    CONCURRENTLY = 342,
    CONFIGURATION = 343,
    CONFLICT = 344,
    CONNECTION = 345,
    CONSTRAINT = 346,
    CONSTRAINTS = 347,
    CONTENT_P = 348,
    CONTINUE_P = 349,
    CONVERSION_P = 350,
    COPY = 351,
    COST = 352,
    CREATE = 353,
    CROSS = 354,
    CSV = 355,
    CUBE = 356,
    CURRENT_P = 357,
    CURRENT_CATALOG = 358,
    CURRENT_DATE = 359,
    CURRENT_ROLE = 360,
    CURRENT_SCHEMA = 361,
    CURRENT_TIME = 362,
    CURRENT_TIMESTAMP = 363,
    CURRENT_USER = 364,
    CURSOR = 365,
    CYCLE = 366,
    DATA_P = 367,
    DATABASE = 368,
    DAY_P = 369,
    DEALLOCATE = 370,
    DEC = 371,
    DECIMAL_P = 372,
    DECLARE = 373,
    DEFAULT = 374,
    DEFAULTS = 375,
    DEFERRABLE = 376,
    DEFERRED = 377,
    DEFINER = 378,
    DELETE_P = 379,
    DELIMITER = 380,
    DELIMITERS = 381,
    DEPENDS = 382,
    DEPTH = 383,
    DESC = 384,
    DETACH = 385,
    DICTIONARY = 386,
    DISABLE_P = 387,
    DISCARD = 388,
    DISTINCT = 389,
    DO = 390,
    DOCUMENT_P = 391,
    DOMAIN_P = 392,
    DOUBLE_P = 393,
    DROP = 394,
    EACH = 395,
    ELSE = 396,
    ENABLE_P = 397,
    ENCODING = 398,
    ENCRYPTED = 399,
    END_P = 400,
    ENUM_P = 401,
    ESCAPE = 402,
    EVENT = 403,
    EXCEPT = 404,
    EXCLUDE = 405,
    EXCLUDING = 406,
    EXCLUSIVE = 407,
    EXECUTE = 408,
    EXISTS = 409,
    EXPLAIN = 410,
    EXPRESSION = 411,
    EXTENSION = 412,
    EXTERNAL = 413,
    EXTRACT = 414,
    FALSE_P = 415,
    FAMILY = 416,
    FETCH = 417,
    FILTER = 418,
    FINALIZE = 419,
    FIRST_P = 420,
    FLOAT_P = 421,
    FOLLOWING = 422,
    FOR = 423,
    FORCE = 424,
    FOREIGN = 425,
    FORMAT = 426,
    FORWARD = 427,
    FREEZE = 428,
    FROM = 429,
    FULL = 430,
    FUNCTION = 431,
    FUNCTIONS = 432,
    GENERATED = 433,
    GLOBAL = 434,
    GRANT = 435,
    GRANTED = 436,
    GREATEST = 437,
    GROUP_P = 438,
    GROUPING = 439,
    GROUPS = 440,
    HANDLER = 441,
    HAVING = 442,
    HEADER_P = 443,
    HOLD = 444,
    HOUR_P = 445,
    IDENTITY_P = 446,
    IF_P = 447,
    ILIKE = 448,
    IMMEDIATE = 449,
    IMMUTABLE = 450,
    IMPLICIT_P = 451,
    IMPORT_P = 452,
    IN_P = 453,
    INCLUDE = 454,
    INCLUDING = 455,
    INCREMENT = 456,
    INDENT = 457,
    INDEX = 458,
    INDEXES = 459,
    INHERIT = 460,
    INHERITS = 461,
    INITIALLY = 462,
    INLINE_P = 463,
    INNER_P = 464,
    INOUT = 465,
    INPUT_P = 466,
    INSENSITIVE = 467,
    INSERT = 468,
    INSTEAD = 469,
    INT_P = 470,
    INTEGER = 471,
    INTERSECT = 472,
    INTERVAL = 473,
    INTO = 474,
    INVOKER = 475,
    IS = 476,
    ISNULL = 477,
    ISOLATION = 478,
    JOIN = 479,
    JSON = 480,
    JSON_ARRAY = 481,
    JSON_ARRAYAGG = 482,
    JSON_OBJECT = 483,
    JSON_OBJECTAGG = 484,
    KEY = 485,
    KEYS = 486,
    LABEL = 487,
    LANGUAGE = 488,
    LARGE_P = 489,
    LAST_P = 490,
    LATERAL_P = 491,
    LEADING = 492,
    LEAKPROOF = 493,
    LEAST = 494,
    LEFT = 495,
    LEVEL = 496,
    LIKE = 497,
    LIMIT = 498,
    LISTEN = 499,
    LOAD = 500,
    LOCAL = 501,
    LOCALTIME = 502,
    LOCALTIMESTAMP = 503,
    LOCATION = 504,
    LOCK_P = 505,
    LOCKED = 506,
    LOGGED = 507,
    MAPPING = 508,
    MATCH = 509,
    MATCHED = 510,
    MATERIALIZED = 511,
    MAXVALUE = 512,
    MERGE = 513,
    METHOD = 514,
    MINUTE_P = 515,
    MINVALUE = 516,
    MODE = 517,
    MONTH_P = 518,
    MOVE = 519,
    NAME_P = 520,
    NAMES = 521,
    NATIONAL = 522,
    NATURAL = 523,
    NCHAR = 524,
    NEW = 525,
    NEXT = 526,
    NFC = 527,
    NFD = 528,
    NFKC = 529,
    NFKD = 530,
    NO = 531,
    NONE = 532,
    NORMALIZE = 533,
    NORMALIZED = 534,
    NOT = 535,
    NOTHING = 536,
    NOTIFY = 537,
    NOTNULL = 538,
    NOWAIT = 539,
    NULL_P = 540,
    NULLIF = 541,
    NULLS_P = 542,
    NUMERIC = 543,
    OBJECT_P = 544,
    OF = 545,
    OFF = 546,
    OFFSET = 547,
    OIDS = 548,
    OLD = 549,
    ON = 550,
    ONLY = 551,
    OPERATOR = 552,
    OPTION = 553,
    OPTIONS = 554,
    OR = 555,
    ORDER = 556,
    ORDINALITY = 557,
    OTHERS = 558,
    OUT_P = 559,
    OUTER_P = 560,
    OVER = 561,
    OVERLAPS = 562,
    OVERLAY = 563,
    OVERRIDING = 564,
    OWNED = 565,
    OWNER = 566,
    PARALLEL = 567,
    PARAMETER = 568,
    PARSER = 569,
    PARTIAL = 570,
    PARTITION = 571,
    PASSING = 572,
    PASSWORD = 573,
    PGPOOL = 574,
    PLACING = 575,
    PLANS = 576,
    POLICY = 577,
    POSITION = 578,
    PRECEDING = 579,
    PRECISION = 580,
    PRESERVE = 581,
    PREPARE = 582,
    PREPARED = 583,
    PRIMARY = 584,
    PRIOR = 585,
    PRIVILEGES = 586,
    PROCEDURAL = 587,
    PROCEDURE = 588,
    PROCEDURES = 589,
    PROGRAM = 590,
    PUBLICATION = 591,
    QUOTE = 592,
    RANGE = 593,
    READ = 594,
    REAL = 595,
    REASSIGN = 596,
    RECHECK = 597,
    RECURSIVE = 598,
    REF_P = 599,
    REFERENCES = 600,
    REFERENCING = 601,
    REFRESH = 602,
    REINDEX = 603,
    RELATIVE_P = 604,
    RELEASE = 605,
    RENAME = 606,
    REPEATABLE = 607,
    REPLACE = 608,
    REPLICA = 609,
    RESET = 610,
    RESTART = 611,
    RESTRICT = 612,
    RETURN = 613,
    RETURNING = 614,
    RETURNS = 615,
    REVOKE = 616,
    RIGHT = 617,
    ROLE = 618,
    ROLLBACK = 619,
    ROLLUP = 620,
    ROUTINE = 621,
    ROUTINES = 622,
    ROW = 623,
    ROWS = 624,
    RULE = 625,
    SAVEPOINT = 626,
    SCALAR = 627,
    SCHEMA = 628,
    SCHEMAS = 629,
    SCROLL = 630,
    SEARCH = 631,
    SECOND_P = 632,
    SECURITY = 633,
    SELECT = 634,
    SEQUENCE = 635,
    SEQUENCES = 636,
    SERIALIZABLE = 637,
    SERVER = 638,
    SESSION = 639,
    SESSION_USER = 640,
    SET = 641,
    SETS = 642,
    SETOF = 643,
    SHARE = 644,
    SHOW = 645,
    SIMILAR = 646,
    SIMPLE = 647,
    SKIP = 648,
    SMALLINT = 649,
    SNAPSHOT = 650,
    SOME = 651,
    SQL_P = 652,
    STABLE = 653,
    STANDALONE_P = 654,
    START = 655,
    STATEMENT = 656,
    STATISTICS = 657,
    STDIN = 658,
    STDOUT = 659,
    STORAGE = 660,
    STORED = 661,
    STRICT_P = 662,
    STRIP_P = 663,
    SUBSCRIPTION = 664,
    SUBSTRING = 665,
    SUPPORT = 666,
    SYMMETRIC = 667,
    SYSID = 668,
    SYSTEM_P = 669,
    SYSTEM_USER = 670,
    TABLE = 671,
    TABLES = 672,
    TABLESAMPLE = 673,
    TABLESPACE = 674,
    TEMP = 675,
    TEMPLATE = 676,
    TEMPORARY = 677,
    TEXT_P = 678,
    THEN = 679,
    TIES = 680,
    TIME = 681,
    TIMESTAMP = 682,
    TO = 683,
    TRAILING = 684,
    TRANSACTION = 685,
    TRANSFORM = 686,
    TREAT = 687,
    TRIGGER = 688,
    TRIM = 689,
    TRUE_P = 690,
    TRUNCATE = 691,
    TRUSTED = 692,
    TYPE_P = 693,
    TYPES_P = 694,
    UESCAPE = 695,
    UNBOUNDED = 696,
    UNCOMMITTED = 697,
    UNENCRYPTED = 698,
    UNION = 699,
    UNIQUE = 700,
    UNKNOWN = 701,
    UNLISTEN = 702,
    UNLOGGED = 703,
    UNTIL = 704,
    UPDATE = 705,
    USER = 706,
    USING = 707,
    VACUUM = 708,
    VALID = 709,
    VALIDATE = 710,
    VALIDATOR = 711,
    VALUE_P = 712,
    VALUES = 713,
    VARCHAR = 714,
    VARIADIC = 715,
    VARYING = 716,
    VERBOSE = 717,
    VERSION_P = 718,
    VIEW = 719,
    VIEWS = 720,
    VOLATILE = 721,
    WHEN = 722,
    WHERE = 723,
    WHITESPACE_P = 724,
    WINDOW = 725,
    WITH = 726,
    WITHIN = 727,
    WITHOUT = 728,
    WORK = 729,
    WRAPPER = 730,
    WRITE = 731,
    XML_P = 732,
    XMLATTRIBUTES = 733,
    XMLCONCAT = 734,
    XMLELEMENT = 735,
    XMLEXISTS = 736,
    XMLFOREST = 737,
    XMLNAMESPACES = 738,
    XMLPARSE = 739,
    XMLPI = 740,
    XMLROOT = 741,
    XMLSERIALIZE = 742,
    XMLTABLE = 743,
    YEAR_P = 744,
    YES_P = 745,
    ZONE = 746,
    FORMAT_LA = 747,
    NOT_LA = 748,
    NULLS_LA = 749,
    WITH_LA = 750,
    WITHOUT_LA = 751,
    MODE_TYPE_NAME = 752,
    MODE_PLPGSQL_EXPR = 753,
    MODE_PLPGSQL_ASSIGN1 = 754,
    MODE_PLPGSQL_ASSIGN2 = 755,
    MODE_PLPGSQL_ASSIGN3 = 756,
    UMINUS = 757
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSENT 276
#define ABSOLUTE_P 277
#define ACCESS 278
#define ACTION 279
#define ADD_P 280
#define ADMIN 281
#define AFTER 282
#define AGGREGATE 283
#define ALL 284
#define ALSO 285
#define ALTER 286
#define ALWAYS 287
#define ANALYSE 288
#define ANALYZE 289
#define AND 290
#define ANY 291
#define ARRAY 292
#define AS 293
#define ASC 294
#define ASENSITIVE 295
#define ASSERTION 296
#define ASSIGNMENT 297
#define ASYMMETRIC 298
#define ATOMIC 299
#define AT 300
#define ATTACH 301
#define ATTRIBUTE 302
#define AUTHORIZATION 303
#define BACKWARD 304
#define BEFORE 305
#define BEGIN_P 306
#define BETWEEN 307
#define BIGINT 308
#define BINARY 309
#define BIT 310
#define BOOLEAN_P 311
#define BOTH 312
#define BREADTH 313
#define BY 314
#define CACHE 315
#define CALL 316
#define CALLED 317
#define CASCADE 318
#define CASCADED 319
#define CASE 320
#define CAST 321
#define CATALOG_P 322
#define CHAIN 323
#define CHAR_P 324
#define CHARACTER 325
#define CHARACTERISTICS 326
#define CHECK 327
#define CHECKPOINT 328
#define CLASS 329
#define CLOSE 330
#define CLUSTER 331
#define COALESCE 332
#define COLLATE 333
#define COLLATION 334
#define COLUMN 335
#define COLUMNS 336
#define COMMENT 337
#define COMMENTS 338
#define COMMIT 339
#define COMMITTED 340
#define COMPRESSION 341
#define CONCURRENTLY 342
#define CONFIGURATION 343
#define CONFLICT 344
#define CONNECTION 345
#define CONSTRAINT 346
#define CONSTRAINTS 347
#define CONTENT_P 348
#define CONTINUE_P 349
#define CONVERSION_P 350
#define COPY 351
#define COST 352
#define CREATE 353
#define CROSS 354
#define CSV 355
#define CUBE 356
#define CURRENT_P 357
#define CURRENT_CATALOG 358
#define CURRENT_DATE 359
#define CURRENT_ROLE 360
#define CURRENT_SCHEMA 361
#define CURRENT_TIME 362
#define CURRENT_TIMESTAMP 363
#define CURRENT_USER 364
#define CURSOR 365
#define CYCLE 366
#define DATA_P 367
#define DATABASE 368
#define DAY_P 369
#define DEALLOCATE 370
#define DEC 371
#define DECIMAL_P 372
#define DECLARE 373
#define DEFAULT 374
#define DEFAULTS 375
#define DEFERRABLE 376
#define DEFERRED 377
#define DEFINER 378
#define DELETE_P 379
#define DELIMITER 380
#define DELIMITERS 381
#define DEPENDS 382
#define DEPTH 383
#define DESC 384
#define DETACH 385
#define DICTIONARY 386
#define DISABLE_P 387
#define DISCARD 388
#define DISTINCT 389
#define DO 390
#define DOCUMENT_P 391
#define DOMAIN_P 392
#define DOUBLE_P 393
#define DROP 394
#define EACH 395
#define ELSE 396
#define ENABLE_P 397
#define ENCODING 398
#define ENCRYPTED 399
#define END_P 400
#define ENUM_P 401
#define ESCAPE 402
#define EVENT 403
#define EXCEPT 404
#define EXCLUDE 405
#define EXCLUDING 406
#define EXCLUSIVE 407
#define EXECUTE 408
#define EXISTS 409
#define EXPLAIN 410
#define EXPRESSION 411
#define EXTENSION 412
#define EXTERNAL 413
#define EXTRACT 414
#define FALSE_P 415
#define FAMILY 416
#define FETCH 417
#define FILTER 418
#define FINALIZE 419
#define FIRST_P 420
#define FLOAT_P 421
#define FOLLOWING 422
#define FOR 423
#define FORCE 424
#define FOREIGN 425
#define FORMAT 426
#define FORWARD 427
#define FREEZE 428
#define FROM 429
#define FULL 430
#define FUNCTION 431
#define FUNCTIONS 432
#define GENERATED 433
#define GLOBAL 434
#define GRANT 435
#define GRANTED 436
#define GREATEST 437
#define GROUP_P 438
#define GROUPING 439
#define GROUPS 440
#define HANDLER 441
#define HAVING 442
#define HEADER_P 443
#define HOLD 444
#define HOUR_P 445
#define IDENTITY_P 446
#define IF_P 447
#define ILIKE 448
#define IMMEDIATE 449
#define IMMUTABLE 450
#define IMPLICIT_P 451
#define IMPORT_P 452
#define IN_P 453
#define INCLUDE 454
#define INCLUDING 455
#define INCREMENT 456
#define INDENT 457
#define INDEX 458
#define INDEXES 459
#define INHERIT 460
#define INHERITS 461
#define INITIALLY 462
#define INLINE_P 463
#define INNER_P 464
#define INOUT 465
#define INPUT_P 466
#define INSENSITIVE 467
#define INSERT 468
#define INSTEAD 469
#define INT_P 470
#define INTEGER 471
#define INTERSECT 472
#define INTERVAL 473
#define INTO 474
#define INVOKER 475
#define IS 476
#define ISNULL 477
#define ISOLATION 478
#define JOIN 479
#define JSON 480
#define JSON_ARRAY 481
#define JSON_ARRAYAGG 482
#define JSON_OBJECT 483
#define JSON_OBJECTAGG 484
#define KEY 485
#define KEYS 486
#define LABEL 487
#define LANGUAGE 488
#define LARGE_P 489
#define LAST_P 490
#define LATERAL_P 491
#define LEADING 492
#define LEAKPROOF 493
#define LEAST 494
#define LEFT 495
#define LEVEL 496
#define LIKE 497
#define LIMIT 498
#define LISTEN 499
#define LOAD 500
#define LOCAL 501
#define LOCALTIME 502
#define LOCALTIMESTAMP 503
#define LOCATION 504
#define LOCK_P 505
#define LOCKED 506
#define LOGGED 507
#define MAPPING 508
#define MATCH 509
#define MATCHED 510
#define MATERIALIZED 511
#define MAXVALUE 512
#define MERGE 513
#define METHOD 514
#define MINUTE_P 515
#define MINVALUE 516
#define MODE 517
#define MONTH_P 518
#define MOVE 519
#define NAME_P 520
#define NAMES 521
#define NATIONAL 522
#define NATURAL 523
#define NCHAR 524
#define NEW 525
#define NEXT 526
#define NFC 527
#define NFD 528
#define NFKC 529
#define NFKD 530
#define NO 531
#define NONE 532
#define NORMALIZE 533
#define NORMALIZED 534
#define NOT 535
#define NOTHING 536
#define NOTIFY 537
#define NOTNULL 538
#define NOWAIT 539
#define NULL_P 540
#define NULLIF 541
#define NULLS_P 542
#define NUMERIC 543
#define OBJECT_P 544
#define OF 545
#define OFF 546
#define OFFSET 547
#define OIDS 548
#define OLD 549
#define ON 550
#define ONLY 551
#define OPERATOR 552
#define OPTION 553
#define OPTIONS 554
#define OR 555
#define ORDER 556
#define ORDINALITY 557
#define OTHERS 558
#define OUT_P 559
#define OUTER_P 560
#define OVER 561
#define OVERLAPS 562
#define OVERLAY 563
#define OVERRIDING 564
#define OWNED 565
#define OWNER 566
#define PARALLEL 567
#define PARAMETER 568
#define PARSER 569
#define PARTIAL 570
#define PARTITION 571
#define PASSING 572
#define PASSWORD 573
#define PGPOOL 574
#define PLACING 575
#define PLANS 576
#define POLICY 577
#define POSITION 578
#define PRECEDING 579
#define PRECISION 580
#define PRESERVE 581
#define PREPARE 582
#define PREPARED 583
#define PRIMARY 584
#define PRIOR 585
#define PRIVILEGES 586
#define PROCEDURAL 587
#define PROCEDURE 588
#define PROCEDURES 589
#define PROGRAM 590
#define PUBLICATION 591
#define QUOTE 592
#define RANGE 593
#define READ 594
#define REAL 595
#define REASSIGN 596
#define RECHECK 597
#define RECURSIVE 598
#define REF_P 599
#define REFERENCES 600
#define REFERENCING 601
#define REFRESH 602
#define REINDEX 603
#define RELATIVE_P 604
#define RELEASE 605
#define RENAME 606
#define REPEATABLE 607
#define REPLACE 608
#define REPLICA 609
#define RESET 610
#define RESTART 611
#define RESTRICT 612
#define RETURN 613
#define RETURNING 614
#define RETURNS 615
#define REVOKE 616
#define RIGHT 617
#define ROLE 618
#define ROLLBACK 619
#define ROLLUP 620
#define ROUTINE 621
#define ROUTINES 622
#define ROW 623
#define ROWS 624
#define RULE 625
#define SAVEPOINT 626
#define SCALAR 627
#define SCHEMA 628
#define SCHEMAS 629
#define SCROLL 630
#define SEARCH 631
#define SECOND_P 632
#define SECURITY 633
#define SELECT 634
#define SEQUENCE 635
#define SEQUENCES 636
#define SERIALIZABLE 637
#define SERVER 638
#define SESSION 639
#define SESSION_USER 640
#define SET 641
#define SETS 642
#define SETOF 643
#define SHARE 644
#define SHOW 645
#define SIMILAR 646
#define SIMPLE 647
#define SKIP 648
#define SMALLINT 649
#define SNAPSHOT 650
#define SOME 651
#define SQL_P 652
#define STABLE 653
#define STANDALONE_P 654
#define START 655
#define STATEMENT 656
#define STATISTICS 657
#define STDIN 658
#define STDOUT 659
#define STORAGE 660
#define STORED 661
#define STRICT_P 662
#define STRIP_P 663
#define SUBSCRIPTION 664
#define SUBSTRING 665
#define SUPPORT 666
#define SYMMETRIC 667
#define SYSID 668
#define SYSTEM_P 669
#define SYSTEM_USER 670
#define TABLE 671
#define TABLES 672
#define TABLESAMPLE 673
#define TABLESPACE 674
#define TEMP 675
#define TEMPLATE 676
#define TEMPORARY 677
#define TEXT_P 678
#define THEN 679
#define TIES 680
#define TIME 681
#define TIMESTAMP 682
#define TO 683
#define TRAILING 684
#define TRANSACTION 685
#define TRANSFORM 686
#define TREAT 687
#define TRIGGER 688
#define TRIM 689
#define TRUE_P 690
#define TRUNCATE 691
#define TRUSTED 692
#define TYPE_P 693
#define TYPES_P 694
#define UESCAPE 695
#define UNBOUNDED 696
#define UNCOMMITTED 697
#define UNENCRYPTED 698
#define UNION 699
#define UNIQUE 700
#define UNKNOWN 701
#define UNLISTEN 702
#define UNLOGGED 703
#define UNTIL 704
#define UPDATE 705
#define USER 706
#define USING 707
#define VACUUM 708
#define VALID 709
#define VALIDATE 710
#define VALIDATOR 711
#define VALUE_P 712
#define VALUES 713
#define VARCHAR 714
#define VARIADIC 715
#define VARYING 716
#define VERBOSE 717
#define VERSION_P 718
#define VIEW 719
#define VIEWS 720
#define VOLATILE 721
#define WHEN 722
#define WHERE 723
#define WHITESPACE_P 724
#define WINDOW 725
#define WITH 726
#define WITHIN 727
#define WITHOUT 728
#define WORK 729
#define WRAPPER 730
#define WRITE 731
#define XML_P 732
#define XMLATTRIBUTES 733
#define XMLCONCAT 734
#define XMLELEMENT 735
#define XMLEXISTS 736
#define XMLFOREST 737
#define XMLNAMESPACES 738
#define XMLPARSE 739
#define XMLPI 740
#define XMLROOT 741
#define XMLSERIALIZE 742
#define XMLTABLE 743
#define YEAR_P 744
#define YES_P 745
#define ZONE 746
#define FORMAT_LA 747
#define NOT_LA 748
#define NULLS_LA 749
#define WITH_LA 750
#define WITHOUT_LA 751
#define MODE_TYPE_NAME 752
#define MODE_PLPGSQL_EXPR 753
#define MODE_PLPGSQL_ASSIGN1 754
#define MODE_PLPGSQL_ASSIGN2 755
#define MODE_PLPGSQL_ASSIGN3 756
#define UMINUS 757

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 264 "gram.y" /* yacc.c:355  */

	core_YYSTYPE core_yystype;
	/* these fields must match core_YYSTYPE: */
	int			ival;
	char	   *str;
	const char *keyword;

	char		chr;
	bool		boolean;
	JoinType	jtype;
	DropBehavior dbehavior;
	OnCommitAction oncommit;
	List	   *list;
	Node	   *node;
	ObjectType	objtype;
	TypeName   *typnam;
	FunctionParameter *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs *objwithargs;
	DefElem	   *defelt;
	SortBy	   *sortby;
	WindowDef  *windef;
	JoinExpr   *jexpr;
	IndexElem  *ielem;
	StatsElem  *selem;
	Alias	   *alias;
	RangeVar   *range;
	IntoClause *into;
	WithClause *with;
	InferClause	*infer;
	OnConflictClause *onconflict;
	A_Indices  *aind;
	ResTarget  *target;
	struct PrivTarget *privtarget;
	AccessPriv *accesspriv;
	struct ImportQual *importqual;
	InsertStmt *istmt;
	VariableSetStmt *vsetstmt;
	PartitionElem *partelem;
	PartitionSpec *partspec;
	PartitionBoundSpec *partboundspec;
	RoleSpec   *rolespec;
	PublicationObjSpec *publicationobjectspec;
	struct SelectLimit *selectlimit;
	SetQuantifier setquantifier;
	struct GroupClause *groupclause;
	MergeWhenClause *mergewhen;
	struct KeyActions *keyactions;
	struct KeyAction *keyaction;

#line 1421 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1451 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  910
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   116552

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  520
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  706
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3287
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6230

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   757

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   509,     2,     2,
     514,   515,   507,   505,   518,   506,   516,   508,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   519,   517,
     502,   504,   503,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   512,     2,   513,   510,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   511
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   919,   919,   924,   928,   933,   941,   949,   969,   981,
     995,   996,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,
    1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,
    1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,
    1118,  1119,  1120,  1121,  1122,  1123,  1125,  1132,  1133,  1137,
    1138,  1142,  1143,  1147,  1148,  1149,  1158,  1174,  1186,  1187,
    1188,  1197,  1198,  1202,  1203,  1207,  1212,  1216,  1226,  1234,
    1238,  1242,  1247,  1251,  1299,  1301,  1305,  1309,  1313,  1317,
    1331,  1350,  1359,  1371,  1372,  1376,  1385,  1394,  1403,  1425,
    1433,  1441,  1449,  1457,  1465,  1483,  1502,  1514,  1515,  1526,
    1537,  1548,  1564,  1583,  1590,  1598,  1599,  1600,  1601,  1602,
    1603,  1617,  1624,  1631,  1638,  1648,  1657,  1666,  1670,  1679,
    1688,  1696,  1707,  1708,  1717,  1729,  1737,  1746,  1758,  1767,
    1776,  1784,  1794,  1805,  1806,  1810,  1811,  1814,  1816,  1820,
    1821,  1822,  1823,  1827,  1828,  1829,  1835,  1847,  1851,  1855,
    1872,  1880,  1881,  1882,  1886,  1887,  1888,  1892,  1893,  1897,
    1898,  1907,  1908,  1916,  1924,  1935,  1943,  1954,  1955,  1960,
    1961,  1967,  1973,  1979,  1986,  1993,  2000,  2007,  2018,  2029,
    2030,  2034,  2035,  2043,  2059,  2066,  2073,  2080,  2087,  2107,
    2117,  2127,  2137,  2147,  2159,  2171,  2181,  2191,  2201,  2213,
    2225,  2235,  2245,  2255,  2265,  2275,  2285,  2297,  2309,  2319,
    2332,  2333,  2338,  2352,  2365,  2381,  2398,  2408,  2418,  2428,
    2438,  2448,  2457,  2466,  2475,  2485,  2495,  2511,  2521,  2531,
    2541,  2551,  2568,  2578,  2588,  2598,  2609,  2623,  2639,  2648,
    2657,  2672,  2681,  2692,  2703,  2711,  2720,  2729,  2737,  2745,
    2754,  2763,  2772,  2780,  2788,  2797,  2805,  2813,  2822,  2831,
    2840,  2849,  2858,  2867,  2878,  2886,  2895,  2904,  2913,  2922,
    2931,  2940,  2948,  2956,  2964,  2971,  2982,  2983,  2987,  2996,
    3000,  3001,  3005,  3013,  3021,  3029,  3040,  3043,  3044,  3048,
    3049,  3054,  3058,  3062,  3067,  3074,  3076,  3081,  3085,  3089,
    3100,  3108,  3161,  3174,  3188,  3200,  3207,  3211,  3225,  3238,
    3239,  3244,  3254,  3265,  3276,  3303,  3310,  3344,  3380,  3403,
    3404,  3408,  3409,  3418,  3419,  3420,  3423,  3424,  3429,  3430,
    3434,  3438,  3442,  3446,  3450,  3454,  3458,  3462,  3466,  3470,
    3474,  3478,  3482,  3491,  3495,  3499,  3503,  3507,  3508,  3513,
    3517,  3524,  3531,  3532,  3533,  3534,  3535,  3539,  3543,  3551,
    3562,  3582,  3602,  3623,  3644,  3665,  3699,  3700,  3701,  3702,
    3703,  3710,  3717,  3718,  3722,  3723,  3727,  3728,  3732,  3736,
    3743,  3747,  3754,  3755,  3756,  3760,  3761,  3764,  3788,  3807,
    3829,  3830,  3834,  3835,  3839,  3840,  3844,  3845,  3849,  3850,
    3854,  3862,  3863,  3864,  3896,  3904,  3912,  3925,  3937,  3950,
    3962,  3972,  3996,  4016,  4017,  4018,  4022,  4023,  4042,  4050,
    4058,  4066,  4078,  4090,  4091,  4092,  4096,  4097,  4098,  4099,
    4100,  4101,  4102,  4103,  4104,  4105,  4114,  4122,  4126,  4140,
    4158,  4174,  4191,  4207,  4227,  4250,  4251,  4255,  4256,  4260,
    4261,  4264,  4270,  4271,  4274,  4278,  4286,  4291,  4297,  4298,
    4302,  4307,  4314,  4315,  4319,  4329,  4339,  4347,  4356,  4369,
    4381,  4388,  4396,  4404,  4412,  4420,  4430,  4431,  4435,  4436,
    4439,  4451,  4452,  4455,  4466,  4477,  4491,  4492,  4497,  4498,
    4499,  4502,  4503,  4504,  4505,  4508,  4509,  4512,  4513,  4516,
    4536,  4549,  4571,  4572,  4575,  4581,  4587,  4604,  4613,  4635,
    4649,  4666,  4682,  4683,  4684,  4696,  4710,  4727,  4741,  4742,
    4754,  4775,  4786,  4800,  4809,  4821,  4822,  4825,  4826,  4829,
    4830,  4833,  4837,  4841,  4845,  4849,  4853,  4857,  4861,  4865,
    4869,  4873,  4878,  4882,  4886,  4892,  4893,  4897,  4898,  4899,
    4906,  4909,  4910,  4922,  4938,  4954,  4955,  4963,  4964,  4968,
    4969,  4973,  4974,  4978,  4979,  4983,  4984,  4994,  5006,  5007,
    5020,  5028,  5046,  5055,  5067,  5070,  5074,  5078,  5082,  5089,
    5101,  5112,  5115,  5119,  5132,  5142,  5152,  5162,  5172,  5182,
    5192,  5202,  5212,  5222,  5232,  5242,  5252,  5271,  5283,  5284,
    5285,  5286,  5290,  5291,  5295,  5296,  5306,  5315,  5328,  5329,
    5333,  5337,  5345,  5349,  5353,  5360,  5364,  5369,  5374,  5381,
    5388,  5393,  5403,  5416,  5432,  5433,  5438,  5439,  5443,  5444,
    5454,  5464,  5473,  5491,  5512,  5533,  5555,  5589,  5605,  5606,
    5610,  5619,  5634,  5644,  5657,  5658,  5670,  5679,  5697,  5722,
    5740,  5755,  5756,  5760,  5761,  5765,  5766,  5770,  5771,  5775,
    5789,  5793,  5794,  5798,  5799,  5800,  5801,  5802,  5812,  5824,
    5825,  5836,  5859,  5891,  5892,  5893,  5897,  5899,  5921,  5923,
    5925,  5927,  5929,  5934,  5935,  5939,  5940,  5944,  5956,  5957,
    5961,  5970,  5974,  5978,  5983,  5993,  5994,  5998,  5999,  6003,
    6004,  6008,  6009,  6013,  6014,  6015,  6019,  6023,  6024,  6025,
    6029,  6030,  6035,  6036,  6063,  6064,  6065,  6066,  6067,  6068,
    6081,  6092,  6107,  6109,  6114,  6119,  6121,  6126,  6137,  6138,
    6139,  6140,  6151,  6170,  6182,  6195,  6206,  6217,  6229,  6238,
    6246,  6254,  6264,  6274,  6284,  6294,  6304,  6315,  6325,  6338,
    6341,  6342,  6345,  6349,  6356,  6357,  6358,  6359,  6360,  6361,
    6364,  6367,  6368,  6376,  6383,  6384,  6387,  6389,  6400,  6412,
    6424,  6436,  6450,  6451,  6467,  6483,  6484,  6488,  6501,  6512,
    6521,  6531,  6541,  6542,  6545,  6546,  6549,  6550,  6551,  6554,
    6568,  6573,  6584,  6594,  6607,  6608,  6612,  6621,  6634,  6645,
    6659,  6670,  6693,  6704,  6723,  6734,  6745,  6756,  6767,  6778,
    6789,  6800,  6811,  6822,  6833,  6844,  6859,  6860,  6861,  6862,
    6863,  6864,  6865,  6866,  6867,  6868,  6869,  6870,  6871,  6881,
    6882,  6883,  6884,  6885,  6889,  6890,  6891,  6892,  6893,  6894,
    6895,  6896,  6901,  6902,  6903,  6907,  6908,  6911,  6912,  6915,
    6917,  6922,  6923,  6934,  6946,  6947,  6948,  6958,  6967,  6976,
    6985,  6994,  7003,  7012,  7021,  7030,  7039,  7053,  7062,  7071,
    7080,  7089,  7098,  7107,  7116,  7128,  7129,  7143,  7154,  7165,
    7176,  7187,  7198,  7209,  7220,  7231,  7242,  7255,  7256,  7259,
    7260,  7270,  7277,  7286,  7295,  7304,  7313,  7322,  7331,  7340,
    7349,  7358,  7367,  7376,  7385,  7394,  7403,  7412,  7421,  7432,
    7433,  7436,  7437,  7447,  7465,  7481,  7509,  7511,  7513,  7515,
    7523,  7533,  7534,  7537,  7545,  7553,  7561,  7568,  7579,  7583,
    7590,  7594,  7605,  7614,  7623,  7632,  7641,  7650,  7659,  7668,
    7677,  7686,  7695,  7704,  7713,  7721,  7730,  7739,  7748,  7757,
    7766,  7775,  7784,  7797,  7798,  7802,  7803,  7808,  7809,  7819,
    7830,  7844,  7856,  7874,  7875,  7879,  7886,  7887,  7888,  7891,
    7892,  7902,  7913,  7914,  7918,  7922,  7926,  7937,  7951,  7966,
    7984,  7985,  7986,  7987,  7988,  7989,  8001,  8033,  8068,  8069,
    8073,  8074,  8077,  8078,  8083,  8095,  8114,  8119,  8124,  8131,
    8132,  8135,  8136,  8139,  8140,  8144,  8145,  8146,  8149,  8150,
    8151,  8167,  8181,  8196,  8210,  8227,  8228,  8231,  8232,  8236,
    8237,  8241,  8242,  8247,  8261,  8269,  8277,  8293,  8294,  8298,
    8299,  8314,  8324,  8334,  8344,  8354,  8367,  8368,  8369,  8370,
    8371,  8377,  8381,  8396,  8397,  8403,  8413,  8417,  8422,  8430,
    8472,  8476,  8480,  8484,  8492,  8493,  8497,  8509,  8510,  8515,
    8516,  8521,  8522,  8529,  8533,  8537,  8541,  8545,  8549,  8553,
    8557,  8561,  8565,  8569,  8573,  8577,  8581,  8585,  8589,  8594,
    8601,  8605,  8609,  8613,  8617,  8623,  8624,  8630,  8640,  8644,
    8655,  8661,  8670,  8676,  8677,  8681,  8682,  8686,  8687,  8690,
    8703,  8707,  8722,  8731,  8740,  8753,  8754,  8759,  8760,  8777,
    8788,  8799,  8810,  8821,  8832,  8846,  8857,  8871,  8882,  8896,
    8904,  8906,  8908,  8913,  8915,  8920,  8921,  8926,  8945,  8955,
    8956,  8960,  8964,  8976,  8988,  9000,  9014,  9015,  9016,  9020,
    9033,  9034,  9044,  9057,  9061,  9065,  9069,  9076,  9098,  9111,
    9124,  9139,  9140,  9143,  9144,  9147,  9148,  9158,  9168,  9186,
    9196,  9206,  9216,  9226,  9236,  9246,  9256,  9266,  9276,  9286,
    9296,  9306,  9317,  9328,  9338,  9348,  9358,  9368,  9378,  9388,
    9399,  9410,  9421,  9432,  9443,  9454,  9465,  9476,  9487,  9498,
    9509,  9520,  9532,  9544,  9556,  9568,  9580,  9592,  9603,  9614,
    9626,  9638,  9649,  9660,  9669,  9679,  9689,  9699,  9709,  9719,
    9729,  9739,  9749,  9759,  9774,  9775,  9778,  9779,  9789,  9799,
    9809,  9819,  9830,  9840,  9852,  9853,  9863,  9873,  9883,  9893,
    9903,  9913,  9923,  9933,  9943,  9953,  9963,  9973,  9983,  9993,
   10003, 10013, 10023, 10033, 10043, 10053, 10063, 10073, 10083, 10093,
   10103, 10113, 10123, 10142, 10152, 10153, 10156, 10158, 10164, 10165,
   10166, 10167, 10168, 10180, 10196, 10205, 10214, 10223, 10232, 10241,
   10250, 10259, 10268, 10277, 10286, 10295, 10304, 10313, 10322, 10331,
   10340, 10349, 10358, 10367, 10376, 10385, 10394, 10403, 10431, 10439,
   10448, 10474, 10483, 10490, 10496, 10523, 10534, 10543, 10551, 10553,
   10575, 10583, 10593, 10603, 10622, 10641, 10651, 10661, 10671, 10682,
   10693, 10704, 10715, 10726, 10744, 10753, 10770, 10788, 10789, 10790,
   10795, 10801, 10810, 10811, 10812, 10813, 10814, 10818, 10819, 10822,
   10823, 10824, 10825, 10829, 10830, 10831, 10843, 10854, 10855, 10858,
   10868, 10875, 10895, 10904, 10912, 10921, 10930, 10938, 10946, 10954,
   10962, 10970, 10978, 10986, 10997, 11005, 11016, 11017, 11018, 11022,
   11025, 11028, 11031, 11034, 11041, 11043, 11045, 11050, 11052, 11056,
   11057, 11058, 11070, 11084, 11098, 11117, 11139, 11140, 11141, 11142,
   11152, 11169, 11180, 11181, 11185, 11186, 11190, 11194, 11198, 11216,
   11217, 11218, 11219, 11220, 11221, 11222, 11229, 11230, 11241, 11249,
   11257, 11266, 11276, 11294, 11303, 11312, 11321, 11333, 11337, 11348,
   11360, 11378, 11385, 11402, 11416, 11426, 11435, 11444, 11454, 11466,
   11478, 11489, 11490, 11501, 11512, 11524, 11536, 11548, 11560, 11570,
   11583, 11584, 11598, 11623, 11635, 11644, 11656, 11670, 11671, 11683,
   11704, 11715, 11727, 11739, 11743, 11750, 11751, 11755, 11762, 11763,
   11764, 11768, 11769, 11770, 11774, 11775, 11779, 11780, 11783, 11784,
   11787, 11788, 11792, 11793, 11797, 11804, 11806, 11811, 11812, 11825,
   11833, 11844, 11852, 11863, 11864, 11865, 11866, 11867, 11868, 11869,
   11870, 11871, 11872, 11882, 11893, 11894, 11898, 11899, 11900, 11901,
   11902, 11912, 11920, 11938, 11958, 11959, 11969, 11976, 11983, 11990,
   12007, 12025, 12029, 12037, 12043, 12050, 12056, 12063, 12072, 12073,
   12077, 12079, 12084, 12095, 12105, 12115, 12121, 12130, 12139, 12145,
   12146, 12157, 12172, 12173, 12184, 12195, 12196, 12199, 12200, 12201,
   12202, 12203, 12204, 12205, 12206, 12209, 12210, 12214, 12215, 12216,
   12227, 12245, 12246, 12250, 12255, 12279, 12290, 12291, 12303, 12321,
   12322, 12326, 12333, 12340, 12347, 12357, 12370, 12371, 12375, 12388,
   12401, 12410, 12419, 12428, 12437, 12449, 12461, 12473, 12476, 12477,
   12478, 12479, 12480, 12481, 12484, 12485, 12486, 12534, 12535, 12539,
   12540, 12555, 12556, 12563, 12571, 12579, 12587, 12595, 12603, 12614,
   12615, 12647, 12663, 12680, 12681, 12700, 12704, 12708, 12723, 12730,
   12737, 12747, 12748, 12751, 12767, 12768, 12769, 12773, 12783, 12794,
   12800, 12812, 12825, 12831, 12832, 12836, 12848, 12856, 12861, 12866,
   12871, 12876, 12884, 12892, 12897, 12902, 12909, 12910, 12914, 12915,
   12916, 12923, 12924, 12928, 12929, 12933, 12934, 12938, 12939, 12943,
   12947, 12948, 12951, 12960, 12973, 12978, 12983, 12987, 12999, 13000,
   13004, 13013, 13029, 13038, 13047, 13056, 13068, 13071, 13076, 13077,
   13085, 13105, 13106, 13108, 13113, 13114, 13118, 13119, 13122, 13123,
   13148, 13157, 13167, 13168, 13172, 13173, 13174, 13175, 13176, 13180,
   13193, 13200, 13207, 13214, 13215, 13219, 13220, 13224, 13225, 13229,
   13230, 13234, 13246, 13247, 13248, 13249, 13253, 13254, 13264, 13271,
   13290, 13291, 13295, 13296, 13302, 13307, 13316, 13324, 13333, 13340,
   13348, 13357, 13366, 13370, 13396, 13400, 13414, 13435, 13457, 13470,
   13487, 13493, 13498, 13504, 13511, 13512, 13522, 13528, 13536, 13540,
   13544, 13551, 13559, 13564, 13565, 13566, 13567, 13571, 13572, 13587,
   13591, 13599, 13606, 13613, 13620, 13627, 13638, 13639, 13652, 13656,
   13664, 13678, 13692, 13693, 13708, 13719, 13732, 13737, 13738, 13741,
   13742, 13745, 13746, 13751, 13752, 13757, 13758, 13767, 13772, 13773,
   13777, 13781, 13787, 13812, 13823, 13837, 13838, 13842, 13856, 13913,
   13927, 13929, 13934, 13936, 13938, 13940, 13945, 13947, 13952, 13960,
   13980, 13985, 13992, 13997, 14003, 14008, 14017, 14019, 14022, 14026,
   14027, 14028, 14029, 14030, 14031, 14036, 14056, 14057, 14058, 14059,
   14070, 14076, 14084, 14085, 14091, 14096, 14101, 14106, 14111, 14116,
   14121, 14126, 14132, 14138, 14144, 14151, 14173, 14182, 14186, 14194,
   14198, 14206, 14218, 14239, 14243, 14249, 14253, 14266, 14274, 14284,
   14286, 14288, 14290, 14292, 14294, 14299, 14300, 14307, 14316, 14324,
   14333, 14344, 14352, 14353, 14354, 14358, 14360, 14362, 14364, 14366,
   14368, 14370, 14375, 14380, 14386, 14394, 14399, 14406, 14413, 14417,
   14421, 14457, 14458, 14460, 14469, 14485, 14487, 14489, 14491, 14493,
   14495, 14497, 14499, 14501, 14503, 14505, 14507, 14509, 14511, 14514,
   14516, 14519, 14521, 14523, 14525, 14528, 14533, 14542, 14547, 14556,
   14561, 14570, 14575, 14585, 14594, 14603, 14612, 14631, 14640, 14649,
   14658, 14667, 14684, 14693, 14702, 14711, 14720, 14729, 14738, 14742,
   14746, 14754, 14762, 14770, 14778, 14799, 14822, 14834, 14841, 14857,
   14862, 14868, 14875, 14882, 14890, 14898, 14916, 14936, 14962, 14964,
   14966, 14968, 14970, 14972, 14974, 14976, 14978, 14980, 14982, 14984,
   14986, 14988, 14990, 14992, 14994, 14996, 14998, 15002, 15006, 15011,
   15027, 15028, 15029, 15046, 15059, 15061, 15063, 15075, 15100, 15112,
   15124, 15132, 15143, 15154, 15164, 15170, 15179, 15189, 15199, 15212,
   15222, 15253, 15289, 15299, 15310, 15311, 15312, 15319, 15326, 15330,
   15334, 15338, 15342, 15346, 15350, 15354, 15358, 15362, 15366, 15370,
   15374, 15381, 15385, 15389, 15393, 15395, 15402, 15409, 15416, 15423,
   15434, 15448, 15458, 15469, 15485, 15495, 15502, 15509, 15516, 15520,
   15528, 15537, 15546, 15550, 15554, 15558, 15562, 15566, 15575, 15579,
   15589, 15593, 15597, 15602, 15613, 15619, 15633, 15644, 15658, 15674,
   15691, 15693, 15697, 15699, 15701, 15704, 15707, 15710, 15711, 15714,
   15722, 15732, 15733, 15736, 15737, 15738, 15741, 15742, 15743, 15748,
   15752, 15756, 15760, 15767, 15768, 15776, 15777, 15781, 15782, 15790,
   15791, 15795, 15796, 15801, 15810, 15812, 15827, 15830, 15858, 15859,
   15862, 15863, 15871, 15879, 15887, 15896, 15906, 15924, 15970, 15979,
   15988, 15997, 16006, 16018, 16019, 16020, 16021, 16022, 16036, 16037,
   16038, 16041, 16042, 16045, 16048, 16049, 16050, 16053, 16054, 16057,
   16058, 16059, 16060, 16061, 16062, 16063, 16064, 16065, 16066, 16067,
   16068, 16071, 16073, 16078, 16080, 16085, 16087, 16089, 16091, 16093,
   16095, 16107, 16111, 16118, 16122, 16128, 16132, 16142, 16154, 16155,
   16158, 16159, 16162, 16166, 16170, 16176, 16177, 16182, 16192, 16193,
   16194, 16195, 16196, 16197, 16198, 16199, 16203, 16204, 16205, 16206,
   16211, 16216, 16225, 16246, 16250, 16255, 16266, 16283, 16289, 16290,
   16291, 16294, 16302, 16312, 16327, 16328, 16332, 16344, 16345, 16348,
   16349, 16352, 16356, 16363, 16367, 16371, 16380, 16392, 16393, 16397,
   16398, 16402, 16403, 16406, 16407, 16412, 16421, 16426, 16432, 16433,
   16437, 16446, 16450, 16451, 16452, 16453, 16454, 16459, 16460, 16461,
   16462, 16463, 16467, 16469, 16479, 16482, 16488, 16489, 16490, 16494,
   16495, 16496, 16500, 16501, 16505, 16523, 16543, 16544, 16553, 16554,
   16558, 16559, 16562, 16570, 16578, 16586, 16609, 16610, 16621, 16625,
   16631, 16633, 16638, 16640, 16642, 16652, 16654, 16665, 16669, 16673,
   16677, 16681, 16690, 16698, 16730, 16734, 16741, 16749, 16753, 16757,
   16763, 16764, 16766, 16767, 16768, 16772, 16813, 16841, 16845, 16849,
   16855, 16857, 16871, 16907, 16920, 16921, 16924, 16925, 16942, 16943,
   16944, 16949, 16950, 16951, 16956, 16957, 16958, 16959, 16965, 16966,
   16967, 16968, 16969, 16975, 16976, 16996, 16997, 16998, 16999, 17000,
   17001, 17002, 17003, 17004, 17005, 17006, 17007, 17008, 17009, 17010,
   17011, 17012, 17013, 17014, 17015, 17016, 17017, 17018, 17019, 17020,
   17021, 17022, 17023, 17024, 17025, 17026, 17027, 17028, 17029, 17030,
   17031, 17032, 17033, 17034, 17035, 17036, 17037, 17038, 17039, 17040,
   17041, 17042, 17043, 17044, 17045, 17046, 17047, 17048, 17049, 17050,
   17051, 17052, 17053, 17054, 17055, 17056, 17057, 17058, 17059, 17060,
   17061, 17062, 17063, 17064, 17065, 17066, 17067, 17068, 17069, 17070,
   17071, 17072, 17073, 17074, 17075, 17076, 17077, 17078, 17079, 17080,
   17081, 17082, 17083, 17084, 17085, 17086, 17087, 17088, 17089, 17090,
   17091, 17092, 17093, 17094, 17095, 17096, 17097, 17098, 17099, 17100,
   17101, 17102, 17103, 17104, 17105, 17106, 17107, 17108, 17109, 17110,
   17111, 17112, 17113, 17114, 17115, 17116, 17117, 17118, 17119, 17120,
   17121, 17122, 17123, 17124, 17125, 17126, 17127, 17128, 17129, 17130,
   17131, 17132, 17133, 17134, 17135, 17136, 17137, 17138, 17139, 17140,
   17141, 17142, 17143, 17144, 17145, 17146, 17147, 17148, 17149, 17150,
   17151, 17152, 17153, 17154, 17155, 17156, 17157, 17158, 17159, 17160,
   17161, 17162, 17163, 17164, 17165, 17166, 17167, 17168, 17169, 17170,
   17171, 17172, 17173, 17174, 17175, 17176, 17177, 17178, 17179, 17180,
   17181, 17182, 17183, 17184, 17185, 17186, 17187, 17188, 17189, 17190,
   17191, 17192, 17193, 17194, 17195, 17196, 17197, 17198, 17199, 17200,
   17201, 17202, 17203, 17204, 17205, 17206, 17207, 17208, 17209, 17210,
   17211, 17212, 17213, 17214, 17215, 17216, 17217, 17218, 17219, 17220,
   17221, 17222, 17223, 17224, 17225, 17226, 17227, 17228, 17229, 17230,
   17231, 17232, 17233, 17234, 17235, 17236, 17237, 17238, 17239, 17240,
   17241, 17242, 17243, 17244, 17245, 17246, 17247, 17248, 17249, 17250,
   17251, 17252, 17253, 17254, 17255, 17256, 17257, 17258, 17259, 17260,
   17261, 17262, 17263, 17264, 17265, 17266, 17267, 17268, 17269, 17270,
   17271, 17272, 17273, 17274, 17275, 17276, 17277, 17278, 17279, 17280,
   17281, 17282, 17283, 17284, 17285, 17286, 17287, 17288, 17289, 17290,
   17291, 17292, 17293, 17294, 17295, 17296, 17297, 17298, 17299, 17300,
   17301, 17302, 17303, 17304, 17305, 17306, 17307, 17308, 17309, 17310,
   17324, 17325, 17326, 17327, 17328, 17329, 17330, 17331, 17332, 17333,
   17334, 17335, 17336, 17337, 17338, 17339, 17340, 17341, 17342, 17343,
   17344, 17345, 17346, 17347, 17348, 17349, 17350, 17351, 17352, 17353,
   17354, 17355, 17356, 17357, 17358, 17359, 17360, 17361, 17362, 17363,
   17364, 17365, 17366, 17367, 17368, 17369, 17370, 17371, 17372, 17373,
   17374, 17375, 17376, 17377, 17378, 17392, 17393, 17394, 17395, 17396,
   17397, 17398, 17399, 17400, 17401, 17402, 17403, 17404, 17405, 17406,
   17407, 17408, 17409, 17410, 17411, 17412, 17413, 17414, 17424, 17425,
   17426, 17427, 17428, 17429, 17430, 17431, 17432, 17433, 17434, 17435,
   17436, 17437, 17438, 17439, 17440, 17441, 17442, 17443, 17444, 17445,
   17446, 17447, 17448, 17449, 17450, 17451, 17452, 17453, 17454, 17455,
   17456, 17457, 17458, 17459, 17460, 17461, 17462, 17463, 17464, 17465,
   17466, 17467, 17468, 17469, 17470, 17471, 17472, 17473, 17474, 17475,
   17476, 17477, 17478, 17479, 17480, 17481, 17482, 17483, 17484, 17485,
   17486, 17487, 17488, 17489, 17490, 17491, 17492, 17493, 17494, 17495,
   17496, 17497, 17498, 17499, 17500, 17501, 17514, 17515, 17516, 17517,
   17518, 17519, 17520, 17521, 17522, 17523, 17524, 17525, 17526, 17527,
   17528, 17529, 17530, 17531, 17532, 17533, 17534, 17535, 17536, 17537,
   17538, 17539, 17540, 17541, 17542, 17543, 17544, 17545, 17546, 17547,
   17548, 17549, 17550, 17551, 17552, 17553, 17554, 17555, 17556, 17557,
   17558, 17559, 17560, 17561, 17562, 17563, 17564, 17565, 17566, 17567,
   17568, 17569, 17570, 17571, 17572, 17573, 17574, 17575, 17576, 17577,
   17578, 17579, 17580, 17581, 17582, 17583, 17584, 17585, 17586, 17587,
   17588, 17589, 17590, 17591, 17592, 17593, 17594, 17595, 17596, 17597,
   17598, 17599, 17600, 17601, 17602, 17603, 17604, 17605, 17606, 17607,
   17608, 17609, 17610, 17611, 17612, 17613, 17614, 17615, 17616, 17617,
   17618, 17619, 17620, 17621, 17622, 17623, 17624, 17625, 17626, 17627,
   17628, 17629, 17630, 17631, 17632, 17633, 17634, 17635, 17636, 17637,
   17638, 17639, 17640, 17641, 17642, 17643, 17644, 17645, 17646, 17647,
   17648, 17649, 17650, 17651, 17652, 17653, 17654, 17655, 17656, 17657,
   17658, 17659, 17660, 17661, 17662, 17663, 17664, 17665, 17666, 17667,
   17668, 17669, 17670, 17671, 17672, 17673, 17674, 17675, 17676, 17677,
   17678, 17679, 17680, 17681, 17682, 17683, 17684, 17685, 17686, 17687,
   17688, 17689, 17690, 17691, 17692, 17693, 17694, 17695, 17696, 17697,
   17698, 17699, 17700, 17701, 17702, 17703, 17704, 17705, 17706, 17707,
   17708, 17709, 17710, 17711, 17712, 17713, 17714, 17715, 17716, 17717,
   17718, 17719, 17720, 17721, 17722, 17723, 17724, 17725, 17726, 17727,
   17728, 17729, 17730, 17731, 17732, 17733, 17734, 17735, 17736, 17737,
   17738, 17739, 17740, 17741, 17742, 17743, 17744, 17745, 17746, 17747,
   17748, 17749, 17750, 17751, 17752, 17753, 17754, 17755, 17756, 17757,
   17758, 17759, 17760, 17761, 17762, 17763, 17764, 17765, 17766, 17767,
   17768, 17769, 17770, 17771, 17772, 17773, 17774, 17775, 17776, 17777,
   17778, 17779, 17780, 17781, 17782, 17783, 17784, 17785, 17786, 17787,
   17788, 17789, 17790, 17791, 17792, 17793, 17794, 17795, 17796, 17797,
   17798, 17799, 17800, 17801, 17802, 17803, 17804, 17805, 17806, 17807,
   17808, 17809, 17810, 17811, 17812, 17813, 17814, 17815, 17816, 17817,
   17818, 17819, 17820, 17821, 17822, 17823, 17824, 17825, 17826, 17827,
   17828, 17829, 17830, 17831, 17832, 17833, 17834, 17835, 17836, 17837,
   17838, 17839, 17840, 17841, 17842, 17843, 17844, 17845, 17846, 17847,
   17848, 17849, 17850, 17851, 17852, 17853, 17854, 17855, 17856, 17857,
   17858, 17859, 17860, 17861, 17862, 17863, 17864, 17865, 17866, 17867,
   17868, 17869, 17870, 17871, 17872, 17873, 17874, 17875, 17876, 17877,
   17878, 17879, 17880, 17881, 17882, 17883, 17884, 17885, 17886, 17887,
   17888, 17889, 17890, 17891, 17892, 17893, 17894, 17895, 17896, 17897,
   17898, 17899, 17900, 17901, 17902, 17903, 17904, 17905, 17906, 17907,
   17908, 17909, 17910, 17911, 17912, 17913, 17914, 17915, 17916, 17917,
   17918, 17919, 17920, 17921, 17922, 17923, 17924, 17925, 17926, 17927,
   17928, 17929, 17930, 17931, 17932, 17933, 17934, 17935, 17936, 17937,
   17938, 17939, 17940, 17941, 17942, 17943, 17944, 17945
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSENT", "ABSOLUTE_P",
  "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL",
  "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY",
  "AS", "ASC", "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC",
  "ATOMIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD",
  "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P",
  "BOTH", "BREADTH", "BY", "CACHE", "CALL", "CALLED", "CASCADE",
  "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "COMPRESSION", "CONCURRENTLY",
  "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT", "CONSTRAINTS",
  "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST", "CREATE",
  "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DEPENDS", "DEPTH", "DESC", "DETACH", "DICTIONARY",
  "DISABLE_P", "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P",
  "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED",
  "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING",
  "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN", "EXPRESSION", "EXTENSION",
  "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH", "FILTER",
  "FINALIZE", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN",
  "FORMAT", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P",
  "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P",
  "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT", "INDENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "JSON", "JSON_ARRAY", "JSON_ARRAYAGG",
  "JSON_OBJECT", "JSON_OBJECTAGG", "KEY", "KEYS", "LABEL", "LANGUAGE",
  "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST",
  "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE", "MERGE", "METHOD",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEW", "NEXT", "NFC", "NFD", "NFKC",
  "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY",
  "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OTHERS",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OVERRIDING", "OWNED",
  "OWNER", "PARALLEL", "PARAMETER", "PARSER", "PARTIAL", "PARTITION",
  "PASSING", "PASSWORD", "PGPOOL", "PLACING", "PLANS", "POLICY",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE",
  "PROCEDURES", "PROGRAM", "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL",
  "REASSIGN", "RECHECK", "RECURSIVE", "REF_P", "REFERENCES", "REFERENCING",
  "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP",
  "ROUTINE", "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCALAR",
  "SCHEMA", "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SQL_P", "STABLE",
  "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT",
  "STORAGE", "STORED", "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING",
  "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P", "SYSTEM_USER", "TABLE",
  "TABLES", "TABLESAMPLE", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY",
  "TEXT_P", "THEN", "TIES", "TIME", "TIMESTAMP", "TO", "TRAILING",
  "TRANSACTION", "TRANSFORM", "TREAT", "TRIGGER", "TRIM", "TRUE_P",
  "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P", "UESCAPE", "UNBOUNDED",
  "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN",
  "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC",
  "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VIEWS", "VOLATILE", "WHEN",
  "WHERE", "WHITESPACE_P", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK",
  "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLNAMESPACES", "XMLPARSE", "XMLPI",
  "XMLROOT", "XMLSERIALIZE", "XMLTABLE", "YEAR_P", "YES_P", "ZONE",
  "FORMAT_LA", "NOT_LA", "NULLS_LA", "WITH_LA", "WITHOUT_LA",
  "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR", "MODE_PLPGSQL_ASSIGN1",
  "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3", "'<'", "'>'", "'='",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('",
  "')'", "'.'", "';'", "','", "':'", "$accept", "parse_toplevel",
  "stmtmulti", "toplevel_stmt", "stmt", "opt_single_name",
  "opt_qualified_name", "opt_concurrently", "opt_drop_behavior",
  "CallStmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "DropRoleStmt", "CreateGroupStmt", "AlterGroupStmt", "add_drop",
  "CreateSchemaStmt", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_collate_clause", "alter_using", "replica_identity", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem",
  "alter_identity_column_option_list", "alter_identity_column_option",
  "PartitionBoundSpec", "hash_partbound_elem", "hash_partbound",
  "AlterCompositeTypeStmt", "alter_type_cmds", "alter_type_cmd",
  "ClosePortalStmt", "CopyStmt", "copy_from", "opt_program",
  "copy_file_name", "copy_options", "copy_opt_list", "copy_opt_item",
  "opt_binary", "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "column_compression", "opt_column_compression", "column_storage",
  "opt_column_storage", "ColQualList", "ColConstraint",
  "ColConstraintElem", "opt_unique_null_treatment", "generated_when",
  "ConstraintAttr", "TableLikeClause", "TableLikeOptionList",
  "TableLikeOption", "TableConstraint", "ConstraintElem", "opt_no_inherit",
  "opt_column_list", "columnList", "columnElem", "opt_c_include",
  "key_match", "ExclusionConstraintList", "ExclusionConstraintElem",
  "OptWhereClause", "key_actions", "key_update", "key_delete",
  "key_action", "OptInherit", "OptPartitionSpec", "PartitionSpec",
  "part_params", "part_elem", "table_access_method_clause", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateStatsStmt", "stats_params", "stats_param", "AlterStatsStmt",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "grant_role_opt_list", "grant_role_opt",
  "grant_role_opt_value", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_relation", "reindex_target_all",
  "opt_reindex_option_list", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "opt_no",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterTypeStmt",
  "AlterOwnerStmt", "CreatePublicationStmt", "PublicationObjSpec",
  "pub_obj_list", "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "MergeStmt", "merge_when_list",
  "merge_when_clause", "opt_merge_when_condition", "merge_update",
  "merge_delete", "merge_insert", "merge_values_clause",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_indent_option",
  "xml_whitespace_option", "xmlexists_argument", "xml_passing_mech",
  "within_group_clause", "filter_clause", "window_clause",
  "window_definition_list", "window_definition", "over_clause",
  "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "opt_window_exclusion_clause", "row", "explicit_row",
  "implicit_row", "sub_type", "all_Op", "MathOp", "qual_Op", "qual_all_Op",
  "subquery_Op", "expr_list", "func_arg_list", "func_arg_expr",
  "func_arg_list_opt", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "position_list", "substr_list", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "opt_slice_bound", "indirection",
  "opt_indirection", "opt_asymmetric", "json_value_expr",
  "json_format_clause_opt", "json_encoding_clause_opt",
  "json_output_clause_opt", "json_predicate_type_constraint",
  "json_key_uniqueness_constraint_opt", "json_name_and_value_list",
  "json_name_and_value", "json_object_constructor_null_clause_opt",
  "json_array_constructor_null_clause_opt", "json_value_expr_list",
  "json_aggregate_func", "json_array_aggregate_order_by_clause_opt",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "attr_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "SignedIconst", "RoleId",
  "RoleSpec", "role_list", "PLpgSQL_Expr", "PLAssignStmt",
  "plassign_target", "plassign_equals", "ColId", "type_function_name",
  "NonReservedWord", "ColLabel", "BareColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,    60,    62,    61,    43,    45,    42,    47,    37,
      94,   757,    91,    93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -5688

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5688)))

#define YYTABLE_NINF -2887

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2887)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    8820,    40, 19710, -5688, -5688,    40, 69257, -5688, 78548,  1187,
     183,  1425,   175,  7666, 79037, 89306,   579,   366, 20391,    40,
   89306,  2986, 59965, 74636,   318, 89306,   491,   732, 59965, 89306,
    1901, 89795,   846,  1152,   997, 90284, 79526, 73169,  1449, 89306,
    1249,   390, 90773, 80015,  1138, 80504,   732, 56064,   365,  1134,
   91262, 89306,113686,   390, 80993, 80993, 80993,  1827,  1607,  1144,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688,  1526, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,  2778, -5688,
     893,  3095,  1493,   841,  1102, -5688, -5688,  1658, 69257, 89306,
   89306, 89306,  1430, 89306,  1444, 89306,   923, 69257, 65834, 81482,
    1559,  1452, 52036, 91751, -5688, 69257, 89306, 63389, 69257, 89306,
   89306, 92240, 89306, 92729, 89306,  1761, 77081, 89306,  1651, 89306,
   89306, 63878, 93218,  1832,  1510,   240, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
    1595,  1774, -5688,   245, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, 60454, 89306,  7285,   491,  1658, -5688,  1827,
   89306,  1908, 89306,  1673, 93707, 89306, -5688, 89306,  1800, 94196,
     939,  2059, 65834,  2113, 52544,  1915, 89306, 89306, 65834, 94685,
   95174, 95663, 89306, 89306, -5688, -5688,  1935, 89306, -5688,  2091,
   66323,  1815,  2095,  2294,  2215,  1283, -5688, 81971, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, 68768,   366, -5688, -5688,
    2072, 69746,  2230, -5688, -5688, 96152,114161,  1997, -5688,   946,
   70235, 66812,  2358,  1988, 53052,  2405, -5688, 70724, -5688, 67301,
   71213, -5688, -5688, -5688, -5688, -5688, 96641, -5688, 97130,  2099,
    2230, -5688,114636, 67790, -5688,  2238, 97619, 98108, 98597,  1658,
    1976,  1498,  3252, 46549, -5688, -5688, -5688,  2040, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688,   326,   301,   275,
     232,   294, -5688, -5688,   239,   247,   262,   326,  2497,  2497,
   -5688, 89306, -5688, -5688,   301,   872,  2098,  2015,  2015,  2015,
    2229,   662, -5688,  2015,  2171, -5688, -5688, -5688, -5688, 80504,
   -5688,  2019, 82460, 89306, 82949,   491,  2057,  2516,  2179, 60454,
    1370, 89306, -5688, -5688,  2562,  2108,  2393,  2119, -5688, -5688,
   -5688,  2367,  2359,   161,    77,   491,   264, -5688,  2507, -5688,
    2391, 31972, 31972,   491, 83438, 99086,   220, 68768,   491, 83927,
    2199,  1098,  2404, -5688, -5688, -5688,   454, -5688,  2661,  2259,
    2533,  2119,  1510, 48529, -5688, -5688,  2268,  1774, 80504, -5688,
   -5688, -5688, 60454,  2616, 35014, 89306,  2302, -5688,  2321,  2302,
   -5688, -5688,  2424, -5688,  2424,  2424,  2363,  2363,  2514,  2384,
   -5688, -5688, -5688,  2329,  2424,  2363, -5688,115586, -5688,  1591,
    1887, -5688, -5688,  2835, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688,  2400, -5688,   855,  2075, -5688, -5688, -5688, 31972,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688,  2414,  2432,  1493,
   -5688,  7680, 60454, 89306,  1550,  1550,  2849,  1550,  1633,  1923,
   -5688,  3447, -5688,  2746,  2718,  2732, 80504,  2446,   958, -5688,
    1474,  2491,  1831,  2495,  1506,  2498, -5688,   858, 89306,   283,
    2542, 84416,  8755,  2527,  1774,  2546, -5688, -5688, -5688, -5688,
    2677,   376, -5688, -5688, -5688, -5688,  2869,  2879,  5456,   323,
   84905, -5688, -5688, -5688, -5688, 89306, 89306, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688,  2563,  1417, -5688, -5688,
    2566,  2893,  2792,  8818,   865,  2897,  2750,  1830,  9286,  2829,
    1455,  2971,  6635,  1259,  2976,  1860,  2096, 82460, 89306,  2933,
    2978,  4566,  1994,   915,  2841,  1304,  2897,  2969,  2789,  1830,
    2996,  8303, 89306, -5688,  2914,  3036,    91, -5688,   345, -5688,
   24929, 35014, 55575, -5688,  1774, -5688,  1472, -5688, -5688, 59476,
   -5688,  2707,  2866,    74, 69257,  2648, 89306, 89306, -5688,113686,
   69257, -5688,  2874, 53560, 69257, -5688, 69257, -5688, -5688,  2997,
  113686, 89306, 89306, -5688, 89306, -5688, -5688,  2649, -5688, -5688,
   -5688, -5688, -5688,  2015, 89306,  3096,113686,  2887,   143,  1660,
    3131, 89306,  2890,  1660,  2697, 99575, -5688, -5688,  1660, -5688,
   -5688, -5688, 89306, 89306,  2660,  1473,  2880,   794,  1660,  2896,
    3134,  3144,  2899,  2755,  2915,  2321, -5688,  3106,  2886,   922,
     214,  2042,  1660,  2739,100064,100553, 89306,  2742, 89306,  3120,
   69257,  2775, 69257, 69257, 89306,  3043, 89306, -5688,  2881, -5688,
   -5688,   978, -5688, -5688, -5688, -5688, -5688,  3058, -5688,   194,
    3060,  2701,  3064,  1753,  3066,   200, -5688, -5688,  2749, -5688,
    3073,   207, -5688,  3076, -5688,  2703,101042, -5688,101531,102020,
    3077,   213, -5688, 65834,  3078,   207,  3079,  2703,  3082,   207,
    3085,   277,  3087, -5688,   961,  3086,  3091,   200,  3099,  2102,
    2703, -5688,  3101,   228, -5688,  3102,   235, -5688,  3110,  2939,
   -5688, 35014, -5688,  2834, -5688,  1134,  1784,  3252,   301, -5688,
   89306,   301, 89306,   301, 89306,   301, 89306,   301, 89306, 89306,
   89306,   301, -5688, -5688, -5688, 89306,  2754, 89306, -5688, 89306,
   -5688, -5688, -5688, 75614, 65834, 76103, -5688, 89306, -5688,   122,
     491, -5688, -5688, -5688,  1428, -5688,  2119, -5688,113686,  3231,
   65834,  3120,  1893, -5688, -5688,  3120, -5688, -5688,  3120,  3120,
   -5688, -5688, -5688,  3030, 89306,  3104, 75614, 65834,  3105, -5688,
  102509, -5688, 68768,  2979,  2763, -5688, -5688, -5688, -5688, -5688,
    2117,  3273,   248,  3279, 35014,  2772,   248,   248,  2774,  3121,
   -5688, -5688, -5688,   300,  2776,  2779, -5688,   224,   224, -5688,
    2782,  2785, -5688,   244,  2790,  2791,  3291,  3297,   259,  2794,
    2796,  2797,  2801,  2803,  2805,  2807,  2329,   248,  2810, 35014,
   -5688,  2811,   224,  2812,  2813,  2816,  3317,  2818, -5688,  3328,
    2821, -5688,   225,   312,  2823,  2826, -5688,  3055, -5688,   263,
    2840,  2842,  2843,  2845,  2852,  2857,  2858,  2862, 35014, 35014,
   35014, -5688, 29432,  1774,   491, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688,   289, 51528, -5688,  2877, -5688, -5688,  3072,
   -5688, -5688, 35014, -5688, -5688,  3217,   108, -5688,   304, -5688,
   -5688, -5688,  1774,  3162,  2864, -5688, -5688,   325,  2865, -5688,
     429, -5688, -5688, -5688, -5688, -5688, -5688, 68279,  3346, -5688,
     319,   491,   345,  1878,  3283, 58009, 58498, -5688, -5688,  3145,
   -5688, 89306, -5688, -5688,  1774,   198,  1926, -5688,  2040, 19471,
    1958,  2302, 89306, 89306,  3350, -5688,  2875, -5688, -5688, 35014,
   -5688, -5688, -5688,  2497, -5688,  2424,  2424, -5688, -5688,  3353,
    2965,  2967,  2497, -5688,  2497, -5688,  2885,  2888,  2497,  2975,
    2980,  2981, -5688,  2900,  2985,  2497, -5688, -5688, 61433,  2180,
   -5688,  3225,   329, -5688, -5688, -5688,  1962, -5688,  2889, -5688,
    2321, -5688, -5688,  1493,  1493, 35014,  1493,   255,  1299, 32479,
   35521,  3236,  3125,  1288,  1621,  3250, -5688,  3129,  1633,  1923,
   80504, 89306, 80504,102998,  3034, 35014, -5688,  3354,  2993,  2995,
    3056, 57042, -5688,  3002,  2983,  3014,  3070,  2934,  3019,  3021,
    3090, -5688,  3212, -5688, -5688,  3031,  3103,  3381,  3038,103487,
   -5688, -5688,  1431, -5688, -5688, -5688,  1431, -5688,  2958,  1311,
     505,  1338,  3041,   333,  1093,  3373, -5688,  1502, -5688, -5688,
    3100, -5688, 10354, 89306,  3318,  9240,  3179,   323,  3107, -5688,
   -5688, -5688,  3245,  3059, 89306,  3061,  3199,   323,   993,103976,
   -5688, -5688, 89306, -5688, -5688, -5688, -5688,  5474,  3359, 27973,
   -5688,  1944,  3065,  3037,  3075, 89306, 72191,   392,  3181,  3200,
    1806,  2149,   234,  3130, 89306,  1920,  3209, 89306,  2987,  3074,
    3088,  3312,  2991,   712,  3415,  3000, -5688, -5688, -5688,  3392,
   -5688,  2335,  2365,  3210, -5688,  3327,  3372,  9591,  3084,  3092,
  112261, -5688,  3109,    30, 54068, 89306, 89306,  3112,  3113,104465,
    5474,  3400, 76592, 76592,  3114,  3115, 48034,  3416,  1612,  3117,
   -5688, -5688, -5688,  1612,  3119,  3123,104954,  5474,  3403, 89306,
    3126,  3127, 89306,115586,   323, -5688,  3475,   323,   323,  1912,
    3479,  3132,   369,  3284,   636,  1660,  3000,  2436, -5688,  3135,
    3137,   347, -5688,  3249, 89306,  3138,  3139,   757,  3221,   491,
   -5688,  3222, -5688,  3141,  3226,  3142,   707,  2660, -5688, -5688,
    3149, 80504,  3237,  3255,  1920,   252,   990,  3000, -5688,  3151,
    3152,  2991,  2991, 89306, 89306, 89306, 89306, 89306,   266,  3525,
    3530,  3163,   242,    31,  3116, -5688,  1612, 64367,  3167, -5688,
    1612, 89306,   414,  1016,  3000,  1649,  1987, -5688, -5688, -5688,
    1510, -5688, 35014, 35014, 35014,  3093, -5688,  2470, 19471,    92,
   -5688,   305,  6652,  3081, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, 89306, 60454, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   89306, -5688, 89306,  3376,113686,  3383,  3307,  3385,  3386,   323,
   89306, 89306,  3397,  3399,  3401,113686,  3404,  3411,  3412,  3310,
    3193,   187,  3201,  3124,  3602,  3488, 89306, 61433, -5688,  1431,
   -5688,113686,  3352,  3491, -5688, 89306,  3369,   756, -5688,  3531,
    3202, -5688, -5688,   759, 89306, 75125,  2660, -5688, -5688,  3497,
   65834,   359,  3498,   491,  3190,  3501,  3362,   491, 65834,  3410,
   89306, 89306, 89306, 89306,   131, -5688, 64367,  3380, -5688, 89306,
    3382,  2436,  3387,  3623,    99,  2015,105443,  3495, -5688,105932,
    3155, 89306,  3156,  3156,  3627,113686,   361,  3433, -5688, -5688,
    2250, -5688,  3298, -5688, 69257, -5688, -5688, 69257, -5688, -5688,
  113686, 89306,  3158,113686,113686, -5688, -5688, 69257, 69257, -5688,
   65834, 65834,  3533,   228,  3534,  3227,  3535,  3239, 54068, 54068,
   -5688,   237, 69257, -5688, 65834, 69257, -5688, 89306, -5688, 89306,
   -5688, -5688, -5688, -5688,113686,113686, -5688, 65834, 64367,  3538,
   89306, 89306, -5688, 89306, 89306, -5688, 89306, 89306,  1985,106421,
    3252, -5688, 89306, -5688, 89306, -5688, 89306, -5688, 89306, -5688,
   89306, -5688, -5688, -5688, 89306, -5688, 89306,  1992, -5688, -5688,
    2010,  1342, 89306, 89306,   233, 69257, 89306,  3405, 89306, 69257,
   69257, 89306, 89306, 89306, 89306, 89306,  3265,  2865,   126, -5688,
     292,   279, 80504,  3413, -5688, -5688,  2012,  1827,  1237, 89306,
   -5688, 89306, 89306, 89306, -5688, -5688, 74636,  3522,   367, 76103,
   89306, -5688, -5688, 12385, 35014,  1774, 31460, -5688, -5688, 19471,
    3233, 35014, 35014,  3184,  2497,  2497, -5688,  1158, 35014, 35014,
   28925, 35014, 32986, 35014, 35014,  2497,  2497, 35014,  8481, 35014,
   54068, 35014, 40591, 25955, 35014, 35014, 29939,  1292,  2782, 35014,
    3436, 41599, 35014,  1878,  3437, 35014,  1878,  8481,  3690,  3690,
    3384,  4210,  3187,  1774, -5688,  2497,  1445, -5688,   302,113686,
   35014, 35014, 35014, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, 35014, -5688,
   61433, -5688, -5688, -5688, -5688, -5688, -5688,  3280, -5688, -5688,
   -5688, -5688, -5688, -5688,  3461, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, 89306, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, 30446, -5688, -5688, -5688, -5688,  3194, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,  3089, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, 30953,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,  3198,
   -5688, -5688, 35014, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688,  3285, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,   985, 35014,
   35014, 35014, 35014, 35014, 35014, 35014, 35014, 35014, -5688, 35014,
     380, -5688, -5688,  3524,  3217,  1159,   618,  3203,  3408, 85394,
   31972,  3225, 24929, -5688,   290,  3225, -5688, -5688, -5688, 89306,
    3346, -5688, -5688,  3288, -5688, -5688, -5688, -5688, -5688,   306,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688,  3197, -5688, -5688,
   -5688, -5688,  3197, -5688,  3204,  3529,  3536,   277, 89306,  2626,
   35014,  3280,   238, 89306, 35014,  3194,  3089, 35014,  3198, 35014,
    3285, -5688, 35014, -5688,  2028,  2017, 35014,  2036,  3206, -5688,
   -5688,  3213,  2888,  3235,  3238,  3218,  3219,  2497,   217,  3220,
     192,   179,  3347,  2497,  3465,  3223, -5688, 61433, -5688, 43579,
    3264, -5688, -5688, -5688,   390, 89306, 89306, -5688,  3519, -5688,
    3228, -5688,  6993,  3519, -5688, -5688, 41095,  3348,  3510,  3445,
   -5688, -5688, -5688,  3234, 19471, 36028, 36028, -5688,  2196, 19471,
    2445, -5688, -5688, -5688, -5688, -5688, -5688,  1310, -5688, 89306,
     124,  3236,  1621,  3299,  1092,  3716,  3305, 89306, -5688, 49024,
    2038, -5688, 65834, 89306, 89306,  3454, -5688,  3701, -5688,115586,
   -5688,  3246, -5688,115111,111311, -5688, -5688,   104, -5688,   970,
   65834, -5688, 89306, 89306, 65834, 89306, 89306, -5688, 65834,  3300,
   89306, 89306, -5688, -5688, -5688, -5688, -5688, 58987,    69, 74636,
    3394, 73658, -5688, -5688,  3251, 89306,  3316,  3539,  3543,    98,
   -5688, -5688,106910, -5688,  3490, 65834, 89306, 89306, 35014,  3496,
   89306, 89306, -5688,   597,  3355,  3356, -5688, 89306,  3357, 69257,
    3262,113686, 69257, 54576, 69257, 69257,  3612,113686, 89306, 89306,
    1250, 80504,   416,  1051,  3000,  3502, -5688,  1011, -5688, 65834,
   -5688, 89306,  3487, -5688, -5688, -5688, 85883,  3738,  3393, -5688,
   -5688, -5688,107399, -5688, -5688,  3499, -5688,  2045, -5688, 65834,
   65834, 89306, 10292,107888,  1145,  3513, -5688, -5688,113686, -5688,
   89306, 86372, 89306, 89306,  3549, 89306, 77570,108377,108866,  1103,
    1131,  3554, 89306, 78059,  3555, -5688,  3430, 89306, -5688, -5688,
   61922, 65834, 89306,   881, 61433, -5688,  3541, -5688, 89306, -5688,
     913, -5688, 89306,  5034,  3506, -5688, -5688,  3374,  3390, 89306,
     430,  1129,  3000,  3677, 89306, 89306,  3287,  2054, 65834, 89306,
   61433, -5688,  3511,    78, 65834, 89306, 85883, -5688,  3515, -5688,
   80504,  3613, -5688,  3295,  2015,  2268,  1872,  3295, 65834, 89306,
   -5688,  3295, 89306, 99086, -5688, 65834,  1588, -5688, 65834, 89306,
   85883, -5688,  3520,  3466, 65834, 89306, 13149, -5688, -5688, -5688,
     323, -5688, -5688, -5688, -5688, -5688, 89306, 89306,   323, 89306,
   89306,   323,  1376, -5688, 65834, 89306, -5688, -5688, -5688,  3432,
   65834, 89306, 89306,   326, 89306, -5688, 89306, 65834,  3351, 89306,
   89306, -5688, -5688, 89306,  7039, 89306, 89306, 89306, 89306, 89306,
   89306, 65834, 89306, -5688, -5688,  1359,    67,  1202,  1779,  1568,
   89306,  3631, 89306,109355, 65834, 89306, 89306,   491, 89306, 61433,
     419, -5688, -5688,  3441, -5688, 65834,  1588, -5688, 11045, 89306,
   89306, 89306,  3391,  3398,   241,  3492, -5688, -5688, -5688,   813,
     813,  3526, -5688, 35014, 35014, 33493,  3315, -5688, -5688, 35014,
    2707, -5688, -5688, -5688,  1035,  3794,  1035,109844,  1035,  1035,
    3614,  3389,  3395,  1035,  1035,  1035,  3603,  1035,  1035,  1035,
   89306,  3503, -5688, -5688,  3503,   772, 35014,113686, 89306, -5688,
    2055, -5688,  3333, -5688, -5688, 61433, 89306,   349,   844,  3685,
    3552, 72680,  2519,  3675, 89306,  3388, 89306,  3806,  3429,  1432,
   -5688,  2519, 89306, -5688,  2009, 74636, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, 89306, -5688, -5688,  3679, 89306, 44074,  3517,
   -5688,   491,  2660,  2660,  2660,  2660,  3337,  2660, 89306,  3471,
    3704,  2519,  3341,  3710, -5688,  2436,  3711,   682, 89306,  3576,
   72680,  3417,  3396,  3592,  3836,  2015,   491,  3595,  3583, -5688,
   57520, -5688,  2660,  3852, 28449,  7823,  8177,  3588,  3654, -5688,
   -5688,  3599,  1106, 89306,  3703,  3706,  3722, -5688,   194, -5688,
    3855,  1753,  3728,   200, -5688,   207, -5688,  2703, -5688, 89306,
   -5688, 89306, 89306, 89306, 89306,   213, -5688, -5688,   207,  2703,
     207,   277, -5688,  3665,   200,  2703,  3518,  3735,   228, -5688,
     235, -5688,  3616,   277, -5688,  3628,  2015, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688,  2061, -5688, 89306, -5688,  3715,  3721,
    3723,  3726,  3727,  3402,  3409,  3434, 89306,  3418,  3402,   323,
    3425,  3414, -5688,  3418,  3418,  3402,  2865,  2865,  3402,  3409,
   64856,  3867, 61433, -5688, -5688,  3486,  3419,  3760,   829, -5688,
     943,   694,  3673, -5688, -5688, -5688, -5688,113686, -5688, 65834,
    3473, -5688, -5688, -5688,  3650,  3431, 64856,   277,   185, -5688,
   69257, 89306,113686, 69257,  3659, 69257, 69257,113686, 89306, 89306,
    2082, -5688,  1628, -5688,  1759, 35014,   492, -5688, 16131,  2083,
   35014,  3435,  3439, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
    3440,  3777, -5688,  2088,  2090,113686,  2966,  3460, 16273, -5688,
    3442,   222,  3655,  1930,  3505,  2103,  3443,   227, -5688,  1930,
     327,  2110,  3444,  3448,  6307,  6361,  3453, 16878,  3451,  3455,
    3456,  3446, 40591, 40591, 29432,  1378, -5688, 40591,  3457,  3666,
    2118, 14372,  3459,  3462, 16942, 34000, 35014, 34000, 34000, 17260,
    3463,  3467, -5688,  3841, -5688,  2129, 61433,  3663, 17510,  2133,
   -5688, 35014, 61433,  6716, 35014, -5688, 35014,  3469, -5688, -5688,
    5541,  5541,  5541,  8481, -5688,  3494, -5688, 40591, 40591, -5688,
    1007, 29432, -5688, -5688,  3814, -5688, -5688,   309, -5688, -5688,
   -5688, -5688, -5688,  3643, -5688, -5688, -5688,  3712,  2257,  1263,
   54068,  3664, 35014,   276, 35014,  3194, 35014,  3561,  5541,  5541,
    5541,   401,   401,   288,   288,   288,  2176,   618, -5688, -5688,
   -5688,  3476,  3480,  3408,  3481, 35014, -5688,  3528, 49519, -5688,
    2411,  2456, 89306,  4590,  4780,  5821, -5688, -5688, -5688,  3264,
      92,  3264, -5688,  1510,  2497,  1445, 59476, -5688, -5688, -5688,
   -5688, -5688, -5688, 89306, 19471, -5688, -5688,  3741,  3484,  2135,
   -5688, -5688,  2497, -5688, -5688,  2128,  2128,  3500, -5688,  3504,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688,  3485, -5688, -5688,
   -5688, 44569,  3825,  3489, 43084, 86861,  3493,  1590, -5688, 86861,
   87350, 86861, -5688,  3509, -5688, -5688,  1774, 35014,  3822, -5688,
   -5688, -5688, 35014, -5688, -5688,  1810,  3514,   100,   878,  2380,
    2380,  2196,   901, -5688, -5688,  3559, -5688, 35014,  2458, -5688,
    2487, -5688, -5688, -5688, -5688,  2865, -5688,  3763, -5688, -5688,
   -5688, 43579,  3547,  3558,    50, 47539,  3724, -5688, 89306, 43579,
   -5688, 89306,   188, -5688,  3523, -5688, -5688, -5688, -5688, -5688,
   -5688,111311,  2075, -5688,115111, -5688,115111, -5688,  2075,  3959,
   -5688,111311,  1903, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, 65834, 65834,  3729, 89306,
    3725,  3731, 35014,  1001, 89306,  3507,  3521,  1547,  3831,  3532,
   -5688,  3893,   277, -5688, -5688,  3620, -5688, 19471, -5688, -5688,
   -5688, -5688, -5688, 65834, 89306, -5688, 68768, -5688, -5688,113686,
   -5688, -5688, 89306, 89306, -5688, -5688, -5688,113686, -5688, -5688,
   -5688, 89306,   806,  3624,  3625, 89306, -5688,   908,  3249, 11136,
   89306, 89306, 89306,  3845, -5688, -5688, -5688, -5688,  3772, -5688,
    3903, -5688,111311, -5688,  2703,   157,  3634,  3000,  3783, -5688,
    3913,  3667, -5688,  3683,   322, -5688, -5688,  3692, -5688, -5688,
   -5688, -5688,  3917,   277,  3919,   277, 89306, 89306, 89306, 89306,
    3697, -5688, -5688, -5688, -5688,  3699,  3839, -5688, 61433, 61433,
   61433,  2146, -5688, -5688,   491, -5688, -5688, -5688, -5688, -5688,
   -5688,  3880, -5688,  2152, -5688,  1477, 89306, -5688, -5688, -5688,
   -5688, -5688,  3928, 65834, 89306, 11430, 89306, 89306, 89306,  3789,
    1941,  1195,113686, -5688,112736, -5688, -5688,  2154, -5688,  3582,
   89306,  3668, 65834,  3635, -5688, -5688, -5688,  3934,  2015,  3719,
   76592,  3626,  3626,  1939, -5688, -5688, -5688, -5688, -5688,  3854,
    3780, -5688,  1073,  3786, 65834,  3646, -5688, -5688, -5688, -5688,
    3944,  3678, -5688, -5688,  3681,  1238,  3000,  2436, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688,  3708, -5688, -5688,
   -5688, -5688,  1483,  1483, -5688, -5688, -5688,  1483,  1372,   411,
    1319,  3000, -5688,   336,  1086,  3687, -5688,  3688, -5688, -5688,
   -5688,  3858,  3860,  3865,  3693,  3705,  3732,  3709,  3714,  3747,
   -5688,  3720,  3754,  3733,  3756,  3734,  4004,   277,113686,  3856,
     491,  3746,  3980,   277, -5688,  3736, -5688,  3737, -5688,  2164,
    4091, -5688, 89306, -5688,   442,  1331,  3000, -5688,  3748, -5688,
   65834, 89306, -5688, -5688, -5688, 35014,  3636,  3637,  3645, 19471,
   19471, 35014, -5688, -5688, 19471,  3662, -5688, -5688, -5688, -5688,
  113686, -5688, 89306,  3956, -5688, -5688,  1035, 89306, 89306, -5688,
   -5688, -5688, 89306, -5688, -5688, -5688,  3957, -5688,   448,   448,
   -5688, -5688,  3963,  8499,  3669,   362, -5688, 61433, 50512,  3565,
     815,  1660, -5688, 68768, 89306, 68768, -5688,   844,  3881, 89306,
   89306, 89306,  3671,  3661, -5688, -5688, -5688, -5688, 65834,   216,
   65834,  2497, -5688, -5688,  3743, -5688, 89306,  2015,  4179,  4015,
    3351, -5688,  4140,  3144,   359,  1865,   269,  2755,  4078,  2321,
   35014,   337, -5688, -5688,  1774, 89306,  3396, -5688, -5688, -5688,
   -5688,   491, -5688,  3682,  3680, -5688, 89306,  4025, 89306, 89306,
   89306, 89306,  3473,  3689, 89306,  3684,113686, 89306,  2418,  2991,
    4158,  4047,  1827,  3417,  3774,  4051, 80504,  3707,  2165, -5688,
   -5688,  1106, -5688,  2185,   230, -5688,   491, 68768,111786,  4039,
   -5688,   920,  8177, -5688, -5688,   920,   973, 89306, -5688, -5688,
   -5688, -5688,  3920,  2114, -5688,  4023, -5688, -5688,  1827, -5688,
  113686,  3698, -5688,  2189, -5688, -5688, -5688,   228,  3761,   277,
    3764,   277, -5688, -5688, -5688, -5688, 89306, -5688, 89306, 64367,
   -5688, -5688, 89306, -5688,  4061, -5688, -5688,  3844,  3846,  3849,
    3851,  3857, 89306,  3402, -5688,  3700, 89306, 89306, 65834,  1485,
   -5688, -5688, 65834,   371, -5688,   182, -5688, 80504,  3842, -5688,
   -5688, -5688, -5688,  4080,  4082, -5688, -5688, -5688,   919, -5688,
   75614,   385, -5688, 65834,  4010,  4012,  4014,  4017,   323,  4018,
    4019,  4027,  4028,  4029, -5688, -5688, -5688,  3739, 17834, 35014,
   -5688,  4099,113686, -5688,  9482, -5688, -5688, -5688, 35014, -5688,
   -5688,  3460,  4011,  3894, -5688, -5688,  3961,  3962, 35014,  3894,
    4193,   953, 35014, 35014, -5688, -5688,  3965,  3966, 35014,  2257,
    2257, -5688, -5688, -5688, -5688,  2267, 35014, -5688, 35014, -5688,
   -5688, 26468,  4241,  4241,  3740,113686, 40591, 40591, 40591, 40591,
    1415,  2812, 40591, 40591, 40591, 40591, 40591, 40591, 40591, 40591,
   40591, 40591,   560, -5688,  3958, 35014, 35014, 34507, -5688, -5688,
  113686,  3749,  3463,  3751,  3752, 35014, -5688, -5688, -5688,  2193,
   42094,  3753, 61433, -5688, 35014, 14742,  2198,  3800, 17927,  1774,
    9729,   491, 35014,  2474,  2549, 35014,  2200, 35014, -5688, -5688,
   -5688, -5688,  4095, -5688, -5688, -5688, -5688, -5688, -5688,  3992,
    2257, -5688,  3829,  3830, -5688, 35014,  3762,  2838, 40591, 40591,
    4048, -5688,  4366, 35014, 29432, -5688,  3526, -5688, 26981,  3758,
   35014,110822, -5688, -5688,   732,   732,   732,   732, -5688, 89306,
   89306, 89306,  3822,  3765,  3822,   345,  3768, -5688, -5688, -5688,
   -5688,  1827, -5688,  3766, -5688, -5688, -5688, -5688, -5688, 86861,
   87350, 86861,  3775, 42589, 27477,  1590,  3776, 89306, -5688, -5688,
    3778, 43579,  4069,  3989, -5688, 43579,  3989,  1627,  3989,  4071,
    3878, 50014, -5688, -5688,  3785, -5688,  3995, -5688,  1944, 19471,
    4242,  4113, -5688,  3788, -5688,  3514,  1599, -5688, -5688, -5688,
     906, -5688,  3882, -5688, -5688, -5688,  3493, 36535,  3947, -5688,
   -5688, -5688,  3853,  2214, -5688, -5688,  4219,  3947, -5688,   265,
   -5688,  2219, 49024,  3547, 35014,  1774,  2236,  1990, -5688, -5688,
  111311, -5688,  3873,  2703,  2703,  1803,  3402,  4144,  1803,  9800,
   -5688, -5688, 45064, 89306, 89306, -5688, 89306, 89306,  1382, 89306,
   -5688, 89306, -5688, -5688, -5688,  4275,  3862,  3863,  4083, -5688,
    2495, -5688, -5688, 65834, 89306, -5688, -5688, -5688,   449,  1505,
    3000, -5688,  3889, -5688, -5688,  4107, 89306, -5688,  4261,  3905,
   89306,  4168, 89306, 87839, -5688,  4240,  1382,  3925,  4150,  1744,
    2991,   369,  5906, -5688,   747, -5688, -5688,  3895, -5688, 89306,
   -5688, 89306, -5688, -5688, -5688, -5688, -5688, -5688, -5688,  3953,
   -5688, -5688, -5688, -5688, 61922, -5688, -5688, 89306, -5688, 61433,
   50512, 61433, -5688, 89306, -5688,  1424,   450,  1557,  3000, -5688,
    3907, -5688,  4180,  3908,  3916,  3968,   201,  1369,  3918,  3921,
    3974,  3833,  3837,  3838, -5688, 61433, 51020,  4000, 89306,  2703,
    3840,  3884, 89306,  3626, 88328, -5688,  3847, -5688, -5688,  3626,
     326,   491, -5688, -5688,   491,  2703,   491, 89306, 89306, 89306,
   89306,   326, -5688, -5688, -5688,  4297,  3939, 89306, 89306, 89306,
   89306, -5688,  3901, -5688, -5688, -5688, 89306, 89306,  4192,   861,
    2112, 65834, 89306, 89306, 65834, 89306, 89306, 89306, 89306, 89306,
   89306, 89306,  4067, -5688,  4285,  4211,  1108,  4252,  3929, 89306,
   -5688, 89306,   491, -5688,  3249, 89306, 89306, 89306, 89306, -5688,
   -5688, -5688, -5688, -5688,  3526, -5688,  3859,  4145,  1035, -5688,
    4147,  4148,  4149,  1035, -5688, -5688,  1660, -5688,   509, 89306,
   -5688,  2422, 89306, -5688, -5688, -5688,  3788,  2335,  2365, -5688,
   -5688, -5688, -5688, -5688, -5688,  3866, 89306, 89306, 40591, -5688,
    2225,  1769,   955, -5688,  4141, 89306,  3055, -5688, -5688, -5688,
     969, 89306, -5688, -5688, -5688, -5688,  3868, -5688,   856,  3689,
   -5688,  4166, 72680,  2703, 65834, 65834,  2703, -5688,113686,  3869,
    3396, -5688,   363,  3945, -5688, 65834,   359,110333,  3190,  3906,
    4089,  9851, 43579, 44074,  1483, -5688,  3870,  3871, -5688, -5688,
   89306,  3881, 64367,  2237,  2436,  4348,   851,  1976, -5688, 74147,
    4074,  3689,  4166, -5688,  2991,  4094,  4098, -5688,  1827, 89306,
    3473,  3396,   491, 89306,  3316, 50512, -5688,  4391,  2125, -5688,
  111311, 35014, 35014, -5688,  3877, -5688,  3885,  8177, -5688,  3964,
    3883,  4352, 35014, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688,  3972,  3890, 89306, 89306,  1106, 89306, -5688,  3891,  3728,
   -5688,  3728, -5688, 89306, -5688, 89306, -5688,   277, -5688,  4022,
     277, 89306, 89306, 89306, 89306, 89306, 89306,  3402,   323,  3414,
   -5688, -5688,  4227, 64856,  4228, -5688, 61433, -5688, -5688, -5688,
   -5688, -5688,  2242, 89306, -5688, -5688, -5688,  4298,  4238,   277,
     367,  1076,  1076,  1076,  1076,  4194,  1076,  1076,  1076,  1076,
    1076, -5688, 35014, 19471, -5688,  3898, -5688, 19471, -5688,  4271,
    3902,  4131,  4135, -5688,  3909, 35014,  3894, -5688, -5688,  4136,
    4137, -5688,  3894,  3894,  3910, 10091, 18052, -5688,  2243, 35014,
   -5688,  1856,  1856,  1856,  2639,  4249, -5688,  2809,  1856,  1856,
    1856,   389,   389,   280,   280,   280,  4241,   560, 18344, 18638,
   19024,  3911, -5688, -5688, -5688,  3463, -5688, 37042,    84,  4368,
   41599, -5688, -5688, -5688,  3971,  3976,  3915, -5688, 35014, 37549,
    3923,115586,  4121, -5688,  1109, 35014, 35014,  2290, -5688, 10324,
   35014, -5688, -5688,  4202,  4203,  2290,   427, 35014,  2931,  3005,
   35014, 35014,  5075, 10471,  3931, -5688,  2247, 35014, 11027,  4127,
   -5688, 89306, 89306, 89306, 89306, -5688, -5688, -5688,  4113,   491,
    4113,   491,  3932, -5688, -5688, -5688, -5688, 62411,  3935,  3663,
   86861,  3936, 89306,  1590, 43579, -5688, -5688,  1345, -5688, 43579,
    4224, -5688, 43579, 69257, -5688, 89306,  3937, 89306, -5688,  1550,
   35014,  3983, 54068, -5688, -5688, -5688, -5688,  4030, -5688,  4164,
   19471, 31972, -5688,  1827,  2957, 89306,  1774,    86, -5688, 35014,
    3952, 89306, -5688,  3947, 19471, -5688,  4020,  2249, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688,  4031, 74636,  4283, -5688, 35014,
    2254, -5688,  3993,  4382,   357,  2262,  2266,  1382, -5688,  2270,
   -5688,  1783,  4260,   440, -5688,   277, -5688,113686, 89306, 89306,
   89306,  2934, -5688, -5688, 89306, 89306, 89306, 89306, -5688, -5688,
   65834, 89306, -5688, 89306, -5688, -5688, -5688, 88817, -5688,  3881,
     326,  2225,  4274,  4278,  4182, -5688,   323, -5688,  2225,  4186,
     326, -5688, -5688, -5688, -5688,  4081, -5688,113686,   277,   277,
   -5688, -5688, -5688, -5688, -5688,  3969, -5688,  4415,  4056, 89306,
   89306, 89306, 89306, 89306, 65834, 89306, 89306,  2497,  2497,113686,
    3960, -5688,  2497,  2497,  3967, -5688, 65834, 89306, 89306, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
    4049, -5688, 35014,  4404, -5688, -5688, -5688, -5688, -5688, 35014,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   65834, 89306,  4052, -5688,  4054, -5688,   167, -5688, -5688, 89306,
   89306, 89306, 89306,  4329, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688,  4331, 89306, -5688, -5688,   491,
     491,113686,   277,   277, -5688, -5688, -5688,  4063, -5688, -5688,
    3977,  4273,  1035, -5688,  1035,  1035,  1035, -5688,  3981, -5688,
    1660,  4371, -5688,  1382,  1572,  4322, -5688, 35014, -5688,  1979,
    2639, -5688,  4381,  4463, -5688, -5688, -5688, -5688,  3351,  2015,
    3351, -5688, -5688, 69257,   372, -5688,  4304,   349, 61433,  4213,
   72680,   336,  1643,  3990,  4122, -5688,  2703,  2703,  4057, 89306,
    4468, -5688, -5688, -5688, -5688, -5688, -5688, 65834,  3635, -5688,
    4232,   927,  4344, 89306, 44074, -5688,  3493, -5688, -5688, -5688,
     491, -5688, -5688,  4133,  3396, -5688,   684, 89306,  4230, 72680,
    3473,  2275, -5688, -5688, -5688,  4046,  4459,  3417, -5688,   336,
    4074, -5688, -5688,  4437,  4104,  4058,  4489, -5688,  4104,  4354,
    4235,  4024, -5688,  3707, -5688, 89306, -5688, 19471, 19471,   491,
  116061,   920,113686,  4364, -5688, 19471, 89306,   820,  4016,  4187,
   -5688,  4332,   277,  2276, -5688,   277,   277, -5688, 89306, -5688,
    3402,  3402,  3402,  3402,  3402, -5688,  4244, -5688, -5688, -5688,
   -5688,  4320, -5688, 64856, -5688,   277, -5688, -5688, -5688, -5688,
   -5688, -5688,  1076, -5688, -5688, -5688, -5688, -5688, 19471, -5688,
   89306, -5688, -5688, -5688, -5688, -5688,  3228,  4032, -5688, -5688,
    4033,  4035, -5688, -5688, 35014, -5688, 11241, 40591,  4369, -5688,
   35014, 35014, 35014, -5688,  4037,  2292,  2300, -5688, -5688,    84,
   -5688,  4368, -5688, -5688, -5688, 11584,  4105, 19471,  4162,  4050,
    1391,  2290,  2290, 10324, -5688, -5688,  2290, 35014, 35014,  2290,
    2290, 35014, -5688, -5688, -5688, 11948, -5688,  4504,  3526, -5688,
   -5688, -5688, -5688,  3983, -5688,  3983, -5688,  4190, -5688,  2304,
    4529, 39577,  4487, -5688, 89306,  2306, -5688, 35014,  4055, -5688,
   -5688, 43579,  1345,  4059,  2310, 89306,  2325,113686, 38056, 19471,
   89306,  3526,  4060, -5688, 89306,  2864, -5688,    50, -5688, -5688,
    4480, 45064,  4439, 19146, 35014, -5688, -5688, -5688, -5688, 64856,
    4277, 64856,  1382, 12204,  4377, 45064, 55084, 89306, -5688, 89306,
   -5688,  4233,  4377,  4377, -5688, -5688, -5688, -5688, -5688, -5688,
    4064, -5688, -5688, -5688, -5688,  4153, -5688, -5688,   650,  3413,
   -5688, -5688, -5688, -5688, -5688,  4544,  4429,  4430, -5688, -5688,
   -5688, -5688, -5688,  4285, -5688, -5688, 50512, 65834, 89306, -5688,
    4157, -5688, -5688, -5688, -5688, -5688, -5688, 47044, 54068, -5688,
     201,  4072,  4073,  1369, -5688, -5688, -5688, 89306, 12393,  4088,
   12762,   692,  3413, 89306, 89306,  4096,  4097,  4100,  1723,  1347,
    1857,  3402,  4424, 89306, -5688, -5688, -5688,  4285, -5688, -5688,
   89306, -5688,  1035, -5688, -5688, -5688, -5688, 61433, -5688,  3140,
    3981,   491, 69257,  4555,  4555, 12859,  4309, -5688, -5688,   814,
    4151,  4342,  4151,  4101, 89306,   969,  4102,  2326, -5688, 89306,
    4090,  4226,  2783,  2783, 89306, 89306, 89306,  2332,  1827,  2703,
    3884,   359,  4464, 72680,  4505,  3881,   342, -5688, 89306,  4582,
   89306,  3473,  3689, 89306,  4106, -5688, -5688, 74147,  4323,  3565,
   89306,  2418,  4074,  3417,  1368, 89306, -5688,  1480, -5688,  1827,
   -5688, 89306, 80504, 45064,  4449, -5688,115111, -5688,  2339, -5688,
   -5688, -5688,  4188, 20238,  3264,  4231,  4234,  4109,  2062,  4457,
   89306,   735, -5688, -5688, -5688, -5688, -5688, -5688, 89306,   385,
   -5688, -5688, -5688, -5688, -5688, -5688, 19271, -5688,  3080, 40591,
   19471, 19471, 19471, 35014, -5688, 35014, -5688, -5688, -5688, -5688,
     121, -5688, -5688,  4425,  4114,  2290,  2290,  2290, -5688, 35014,
     895, -5688, -5688,  1782,  4519,  3509, 62411,  4118, -5688, 40591,
    2355, -5688,  1119, 89306,  2356, -5688, 19471, 89306, -5688, -5688,
   35014, -5688,  2381, -5688,  4120,    13,  4123, 25442,  4117, -5688,
   -5688, -5688, -5688, -5688, 19471,  4125, -5688,  4598,  1621, -5688,
   -5688,  4181, 89306,  2382, -5688,   109,  1847,  4172, -5688, 19471,
    1485,  1803,   273,  4382,  4126,  3351, -5688,  4130, -5688, -5688,
    1676,  2991, 89306,  3351,  3351, -5688, 89306,  4222, -5688,  3565,
    4454, -5688, -5688,  4195, -5688,  1072,  3413, 89306,113686, -5688,
     129,  4478, -5688,113686,113686, -5688, -5688, -5688, 35014, -5688,
    4229, -5688, -5688, -5688, 35014, 35014, 71702, -5688, -5688, 89306,
   89306, 89306, 89306, 89306, -5688,   277, -5688, -5688,  2387, -5688,
   46054, -5688, -5688,  3131,   491,  3131,  1895, -5688, -5688,  3131,
    3131, -5688,  3264, -5688,  4555,   353, -5688, -5688,  4373,  4143,
   35014,  4447, -5688,   991,  4356, -5688,  4139, -5688, 69257,  4649,
   -5688, 61433,  3689,  4166, 89306, -5688, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688,  2389,  3881,  4497,
    3396,  4058, -5688, 89306,  4184, -5688, 43579,  3881,  1827,  1976,
   -5688,  4074,  3689,  4166, -5688, -5688,  4146,  4098,  3417,  2418,
    4293, -5688,  4296, -5688,  4594,  4370,  4595,  3473, -5688,  3316,
    2394, 89306, -5688, -5688,  8177,116061,113686, -5688, -5688, -5688,
    4152,  4535,  4200,  4205, -5688, -5688, -5688,  2062, -5688,  1647,
    4534,  4214, -5688,  4221, 89306, -5688, -5688,  3881,   277, 35014,
    3080,  2395,  2403,  4225, -5688, -5688, -5688,  3463, 38563, 38563,
   38563,  4163,  4518,  4520, 89306, -5688, -5688, -5688, 89306,  2639,
    4169, 39577, 61433,  2407, -5688,113211, -5688,  2416,  2420, -5688,
   35014,  4175, 35014, -5688, 38056, 89306,  4176,  3236,  1827, -5688,
    3264, 45064, -5688,  4300,  4657,  4438, -5688, -5688,  4523, -5688,
   -5688, 89306,  4151, 54068,  3514,  1676,  2015,  4151,  4151, -5688,
   89306,  4143, 35014, -5688,  4280, -5688, -5688,  2438,  1668,  4358,
    4358,  2449,  2450, 13087, 89306,  2478,  2483, -5688,  2489,  2497,
    3409,  1857,  3409, -5688,  3402, -5688, -5688, 61433, -5688, 65345,
   -5688, -5688, -5688,   491, -5688,   491,  4417, 89306, 56553,   491,
     491, -5688, -5688, -5688, -5688,  4499, -5688,  2436, -5688, 13150,
    4287, -5688, -5688, -5688,   548, -5688,  4412,  4414, -5688,  4196,
   -5688,  2511, -5688,   336,  4328,  3881, -5688, -5688, 89306,  4684,
    4685, -5688,  1207, 89306,  3493, -5688,  4058,  3473,  3417,   336,
    4074,  3565, 45559,  4104,  2418,  4098, -5688, -5688,  4426, -5688,
    4428, -5688,  4215,  4528, -5688,  1726,   920, -5688, -5688, -5688,
     368,  4554,  4556, -5688, -5688, -5688,  3131, -5688,  1094,  4217,
    4581, -5688, -5688, -5688, -5688, 19471, -5688, -5688, -5688, 40084,
    4372,  1327, 15542,  4588, -5688,  4588,  4588, -5688,  4682,  4683,
    1256,  2512, 41599, -5688, -5688, -5688, 89306,  4441,  1552,  4708,
    4395,  2520, 38056,  2524, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688, 49024, 35014,  4324,  4657, 64856,  2530,  3626,  4239, -5688,
    3514,  4342, -5688, -5688,  3413, -5688, 19471, 89306, 69257,  4690,
   -5688, -5688, -5688, -5688, -5688, -5688, -5688,  3413,  4325, -5688,
   -5688, 71702, -5688, 89306, -5688, -5688,  2531, -5688, -5688, -5688,
   89306,  4016, -5688,  4016, -5688, -5688, -5688,  1407,  4350, 89306,
     959,   959,  4626, -5688,  4310, -5688,  4246, -5688,  4753,  4386,
   89306, -5688, -5688,   201,  1827, 72680,  3881, -5688, -5688,  2418,
    4074,  3417, 35014,  2547, -5688,  4382,   357, -5688,  4098,  4104,
   -5688, -5688, 45064,  4251,  3055,  4632, -5688, -5688, -5688,  1879,
   69257, 69257, 89306, -5688, -5688, -5688, 35014,   969,  4739, -5688,
   -5688, -5688, -5688, -5688,   925, -5688, -5688, -5688, 89306, 89306,
   89306, -5688,  3663, -5688, -5688, 40591, 40591,  4490, -5688,  1552,
   -5688, 89306, -5688,  4262, -5688, -5688,  2551, -5688,   -10, 19471,
     517,  4355,   273, -5688, -5688, -5688, -5688,  4356,  1382,  1382,
   -5688,  3413, -5688, 89306, -5688,  4264, -5688, -5688, -5688, 65345,
    4016, -5688, -5688, -5688, -5688,  4757, -5688,   967, -5688, -5688,
   -5688, -5688, 89306,  3881,  3960,  4058, -5688,  4098,  3417,  2418,
   13992, -5688, 45559, 89306, 89306,  4104, -5688,  2558, 45064,  3396,
    4416, -5688,  1955, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
     888,  4267,  4272, -5688, -5688, 14222, 69257, 39070,  4423, -5688,
    4479, -5688,  1260,  1293,  1905,  4711,  2639,  2639, -5688, -5688,
   -5688, 35014, -5688, -5688, -5688,  4512,  4408, -5688, -5688,   952,
   -5688,  1382, -5688, -5688, -5688, 35014, -5688, -5688,  2015,  2015,
    3881, -5688, -5688,  4104,  2418,  4098,  4382, -5688, -5688, -5688,
   -5688,  4528, -5688,  2573,  4104,  4214,  2437, -5688, -5688,  2471,
    2432,  4367,  4622, -5688,  4284, -5688, -5688, -5688, 89306, 89306,
   62900, 89306, 89306, 14320, -5688, 49024,  4516,   563, -5688,  1382,
    2574, -5688, -5688, -5688, -5688,  4098,  4104, 89306,  3055, -5688,
   45064,  3264,  4646, -5688,  1955,  4405,  4406, 60944, -5688, -5688,
     308,  4686, -5688,  2588, -5688,  4286, -5688,  4351,    50,  4292,
   89306, -5688, -5688,  4104, -5688, -5688,  3396, -5688, -5688,   969,
   -5688,  4337,  4339, -5688,  2590, -5688, -5688, -5688, -5688, 35014,
   62900, -5688, -5688,  4359, 35014,  2592, -5688,  4104, 69257,  4635,
    4636, -5688, 60944,   813,  4361,  4357,  2594,  1104,  3264,  4303,
   69257, 69257, -5688,  4308, 89306, -5688, -5688,    50, -5688, -5688,
   60944, -5688, -5688,   491, -5688,  4374,  2602,  4357, -5688, -5688
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1704,  1448,   656,  1536,  1535,  1448,     0,   273,     0,  1547,
       0,  1448,   434,  1106,     0,     0,     0,     0,   656,  1448,
       0,  1704,     0,     0,     0,     0,     0,  1717,     0,     0,
       0,     0,     0,     0,  1246,     0,     0,     0,  1448,     0,
       0,  1724,     0,     0,     0,     0,  1717,     0,  1549,     0,
       0,     0,     0,  1724,     0,     0,     0,     0,     0,     2,
       9,    10,    45,    80,    81,    38,    37,    98,    63,    24,
      71,   133,   132,   134,    50,    46,    88,    33,    35,    47,
      51,    73,    75,    40,    53,    64,   110,    72,    31,    70,
      76,    96,    58,    19,    20,    59,    21,    60,    22,    61,
     106,    82,    99,    43,    69,    30,    52,    78,    79,    12,
      54,    86,    18,    65,    66,    68,    91,    92,    93,   116,
      94,   128,    49,   125,   103,   104,   122,   105,   123,    16,
     107,    62,    23,   119,   118,   120,    89,    55,    90,    77,
      97,   117,    34,   121,    25,    26,    28,    29,    27,    67,
      36,    74,    39,    95,   124,   114,   109,   129,   127,    11,
     135,   111,    83,    14,    15,   100,    13,    32,    57,    17,
      42,    41,    56,    48,   131,    44,  1547,   102,   115,   101,
      84,   108,    87,   112,   130,   113,    85,   126,  1668,  1667,
    1728,  1671,  1703,     0,  1683,  1447,  1446,  1461,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1458,  2368,  2385,  2386,  2387,  2388,
    2389,  2390,  2391,  2392,  2393,  2394,  2395,  2396,  2397,  2398,
    2399,  2401,  2400,  2402,  2403,  2755,  2404,  2405,  2406,  2700,
    2701,  2756,  2702,  2703,  2407,  2408,  2409,  2410,  2411,  2412,
    2413,  2414,  2415,  2704,  2705,  2416,  2417,  2418,  2419,  2420,
    2706,  2757,  2421,  2422,  2423,  2424,  2425,  2426,  2758,  2427,
    2428,  2429,  2430,  2431,  2432,  2433,  2434,  2435,  2759,  2436,
    2437,  2438,  2760,  2439,  2440,  2441,  2442,  2443,  2444,  2707,
    2708,  2445,  2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,
    2454,  2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,  2463,
    2464,  2465,  2466,  2467,  2468,  2469,  2470,  2471,  2472,  2709,
    2473,  2474,  2475,  2476,  2710,  2477,  2478,  2479,  2480,  2711,
    2481,  2482,  2483,  2484,  2761,  2762,  2485,  2486,  2487,  2488,
    2489,  2712,  2713,  2490,  2491,  2492,  2493,  2494,  2495,  2496,
    2763,  2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,  2505,
    2506,  2507,  2508,  2509,  2764,  2714,  2510,  2511,  2512,  2513,
    2715,  2716,  2717,  2514,  2765,  2766,  2515,  2767,  2516,  2718,
    2719,  2720,  2721,  2517,  2518,  2519,  2520,  2521,  2522,  2523,
    2722,  2768,  2524,  2769,  2525,  2526,  2527,  2528,  2529,  2530,
    2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,  2540,
    2541,  2542,  2543,  2544,  2545,  2723,  2770,  2724,  2546,  2547,
    2548,  2549,  2550,  2551,  2552,  2725,  2726,  2553,  2554,  2555,
    2771,  2556,  2727,  2557,  2728,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,  2567,  2729,  2772,  2568,  2773,  2730,
    2569,  2570,  2571,  2572,  2573,  2574,  2575,  2576,  2577,  2578,
    2579,  2580,  2731,  2581,  2732,  2584,  2582,  2583,  2585,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,  2733,  2595,
    2596,  2597,  2598,  2599,  2600,  2601,  2602,  2603,  2604,  2605,
    2606,  2607,  2608,  2609,  2610,  2611,  2612,  2613,  2774,  2614,
    2615,  2616,  2617,  2618,  2734,  2619,  2620,  2621,  2622,  2623,
    2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2632,  2633,
    2634,  2635,  2735,  2636,  2637,  2775,  2638,  2639,  2736,  2640,
    2641,  2642,  2643,  2644,  2645,  2646,  2647,  2648,  2649,  2650,
    2651,  2652,  2653,  2737,  2654,  2655,  2656,  2657,  2776,  2658,
    2659,  2660,  2661,  2662,  2663,  2738,  2739,  2664,  2665,  2740,
    2666,  2741,  2667,  2668,  2669,  2670,  2671,  2672,  2673,  2674,
    2675,  2676,  2677,  2678,  2679,  2680,  2681,  2682,  2683,  2684,
    2742,  2743,  2685,  2777,  2686,  2687,  2688,  2689,  2690,  2691,
    2692,  2693,  2694,  2695,  2696,  2744,  2745,  2746,  2747,  2748,
    2749,  2750,  2751,  2752,  2753,  2754,  2697,  2698,  2699,   146,
       0,     0,  2335,  2369,  2370,  2373,  2368,   406,   405,  1657,
    2332,  2369,  1546,     0,  1525,   656,     0,  1461,   433,  1704,
       0,     0,     0,     0,     0,     0,   872,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   138,
       0,   140,     0,     0,   457,   456,     0,     0,  1078,   462,
       0,     0,     0,     0,     0,   646,  1588,  2582,  1586,  1658,
     274,   277,   278,   275,   276,  2351,     0,  1218,  1219,  1221,
       0,     0,  1231,   912,   913,     0,     0,     0,   926,     0,
       0,     0,   910,     0,     0,     0,   932,     0,   929,     0,
       0,   933,   930,   907,   931,   914,     0,   906,     0,     0,
    1231,   934,     0,     0,   908,     0,     0,     0,     0,  1461,
    1585,   463,  1704,     0,  1569,  1570,  1571,  1547,  1559,  1572,
    1564,  1566,  1565,  1567,  1568,  1563,  2350,  2387,  1002,  1002,
    1002,  1002,   999,  1000,  1002,  1002,  1002,  2602,     0,     0,
     981,     0,   983,  2352,  1002,  1007,  2395,   538,   538,   538,
       0,  1006,  1011,   538,     0,  1429,  1470,  2334,  1716,     0,
     982,  1428,     0,     0,     0,  2664,  1575,     0,     0,     0,
       0,  2621,  1438,   256,  2633,  2738,  2664,   255,   249,   251,
     223,     0,     0,  1006,   538,     0,  1461,  1436,   978,  1723,
    1721,     0,  2319,  2414,  2430,  2527,   246,  2614,  2623,  2633,
    2738,  2664,  2696,   202,   212,   207,     0,   267,  2633,  2738,
    2664,   263,  1458,     0,  1684,  1832,  1831,  2328,     0,  1431,
    1430,  1548,     0,  1551,     0,  2597,  1688,  1691,  1553,  1689,
    2371,  1907,  1936,  1914,  1936,  1936,  1903,  1903,  2460,  1916,
    1904,  1905,  1941,     0,  1936,  1903,  1908,     0,  1906,  1944,
    1944,  1931,     3,  1888,  1889,  1890,  1891,  1917,  1918,  1892,
    1923,  1924,  1928,  1893,  1958,  1903,  2372,  1725,  1726,  2319,
       4,  2365,     5,  2281,  2364,     6,     7,  1680,     0,     0,
       1,  1704,     0,  1558,  1720,  1720,     0,  1720,     0,  1672,
    1680,  1675,  1679,     0,     0,     0,     0,     0,     0,  1432,
       0,     0,     0,   937,     0,  1473,  1063,     0,     0,     0,
       0,     0,  1315,     0,  1115,  1114,  2374,  2357,  2358,  2359,
       0,  2355,  2356,  2375,  2376,  2377,     0,  2496,  1315,     0,
       0,  2197,  2208,  2209,  2210,  2418,  2477,  2205,  2206,  2207,
    2199,  2200,  2201,  2202,  2203,  2204,     0,     0,  1213,  2198,
       0,  2496,     0,  1315,     0,   173,     0,   150,  1315,     0,
       0,  2496,     0,     0,  2496,     0,     0,     0,     0,     0,
    2496,     0,     0,     0,     0,     0,   173,  2532,     0,   150,
    2496,     0,     0,  1452,     0,     0,     0,  1454,  1457,  1444,
       0,  2278,     0,  2279,  2336,  1540,     0,  1539,  1533,  1543,
    1538,  1528,     0,  2328,     0,     0,     0,     0,   920,     0,
       0,   910,     0,     0,     0,   921,     0,   922,   923,     0,
       0,     0,     0,   919,     0,  1442,  1434,     0,  1577,  1579,
    1578,  1580,  1576,   538,     0,     0,     0,  2496,     0,   150,
    1512,     0,  2496,   150,     0,     0,   461,   460,   150,  2355,
     459,   458,  2418,  2477,     0,  1105,     0,  1188,   150,  2496,
       0,   194,  2496,   715,  2496,  1553,   139,     0,   659,     0,
     827,  2532,   150,     0,     0,     0,     0,     0,     0,   142,
       0,     0,     0,     0,     0,     0,     0,   645,   656,  1589,
    1587,     0,  1222,   248,   247,  1220,   924,  2496,  1147,   145,
       0,     0,  2496,  1493,  2496,   145,   941,   925,     0,   911,
    2496,   145,  1111,  2496,  2360,   183,     0,   909,  2418,  2477,
    2496,   145,  1215,     0,  2496,   145,  2496,   179,  2496,   145,
    2496,   145,  2496,   660,     0,     0,  2496,   145,  2496,  2532,
     181,   928,  2496,   145,   935,  2496,   145,  2330,  2496,     0,
    1445,     0,  1581,     0,  1561,  2742,     0,  1704,  1002,  1001,
       0,  1002,     0,  1002,     0,  1002,     0,  1002,     0,     0,
       0,  1002,  2353,  2354,   984,     0,  1008,     0,  1016,     0,
    1015,  1014,  1013,     0,     0,     0,  1017,     0,  1836,  1616,
       0,  1426,   250,   201,     0,   262,   261,  1441,     0,     0,
       0,   142,     0,  1244,  1241,   142,  1243,  1242,   142,   142,
    1437,   254,   252,     0,     0,     0,     0,     0,     0,  1443,
       0,  1435,     0,     0,     0,  2338,  2340,  2341,  2211,  2281,
       0,  2701,  2702,  2703,  2270,     0,  2704,  2705,  2706,  2757,
    2092,  2078,  2087,  2093,  2079,  2081,  2088,  2707,  2708,  2027,
    2709,  2710,  2348,  2711,  2712,  2713,  2715,  2716,  2717,  2718,
    2719,  2720,  2721,  2722,  2083,  2085,  2723,  2724,  2726,     0,
    2349,  2727,  2728,  2563,  2730,  2731,  2733,  2734,  2089,  2736,
    2737,  2090,  2738,  2739,  2740,  2741,  2347,   505,  2091,  2743,
    2745,  2746,  2747,  2748,  2750,  2751,  2752,  2753,     0,     0,
       0,  2325,     0,  2056,     0,  1896,  1897,  1919,  1920,  1898,
    1925,  1926,  1899,     0,  2324,  1961,  2156,  2055,  2073,     0,
    2061,  2062,     0,  2054,  2050,  2158,  1706,  2320,     0,  2051,
    2337,  2339,  2271,  1706,  2318,   215,   269,     0,   270,  2326,
    2633,   203,   245,   217,   244,   218,   216,     0,  2416,   204,
       0,     0,   205,     0,     0,     0,     0,   266,   264,     0,
    1433,     0,  1834,  1833,  2329,   946,     0,  1550,  1547,  2221,
       0,  1690,     0,     0,     0,  1935,  1922,  1930,  1929,     0,
    1912,  1911,  1910,     0,  1909,  1936,  1936,  1934,  1913,  1888,
       0,     0,     0,  1940,     0,  1938,  1884,  1880,     0,  1947,
    1948,  1949,  1946,  1959,  1945,     0,  1894,  1950,     0,  1903,
    1900,  1791,     0,  1670,  1669,     8,     0,  1555,  1557,  1531,
    1553,  1718,  1719,     0,     0,     0,     0,     0,     0,     0,
       0,  1778,  1736,  1737,  1739,  1775,  1779,  1787,     0,  1676,
       0,     0,     0,  1838,     0,     0,  1459,     0,     0,     0,
       0,     0,  1146,     0,     0,     0,     0,   938,     0,     0,
       0,  1479,     0,  1481,  1482,  1483,     0,     0,     0,     0,
    1484,  1485,  1473,   258,  1492,  1489,  1472,  1474,  1487,     0,
       0,     0,     0,     0,     0,     0,  1504,     0,   187,   188,
       0,   672,   656,     0,  2496,     0,     0,     0,     0,  1156,
    1163,  1314,     0,     0,     0,     0,     0,     0,     0,     0,
    1157,  1155,     0,  1158,   260,  1168,  1195,  1198,     0,     0,
    1113,  1116,     0,     0,     0,     0,     0,  1305,     0,     0,
       0,  1305,     0,     0,     0,  1314,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   285,   287,   300,   365,     0,
     637,     0,     0,     0,   640,     0,  2496,  1315,     0,     0,
       0,  1217,     0,     0,     0,     0,     0,     0,     0,     0,
    1198,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     148,   149,   154,     0,     0,     0,     0,  1198,     0,     0,
       0,     0,     0,     0,     0,   623,   636,     0,     0,     0,
       0,     0,   633,     0,     0,   150,   290,   613,   619,     0,
       0,     0,   722,   721,     0,     0,     0,     0,     0,     0,
    1402,     0,  1401,     0,     0,     0,     0,     0,  1502,  1501,
       0,     0,     0,     0,     0,  1305,     0,   279,   281,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   398,   399,     0,     0,     0,   154,
       0,     0,  1305,     0,   292,     0,     0,  1453,  1450,  1451,
       0,  1456,     0,     0,     0,     0,  2064,     0,  2225,  1728,
    2223,  1131,  2277,     0,  2378,  2778,  2779,  2780,  2781,  2782,
    2783,  2784,  2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,
    2793,  2794,  2795,  2796,  2797,  2798,  2799,  2800,  2801,  2802,
    2803,  2804,  2805,  2806,  2807,  2808,  2809,  2810,  2811,  2812,
    2813,  2814,  2815,  2816,  2817,  2818,  2819,  2820,  2821,  2822,
    2823,  2824,  2825,  2826,  2827,  2828,  2829,  2830,  2831,  2832,
    2833,  2834,  2835,  2836,  2837,  2838,  2839,  2840,  2841,  2842,
    2843,  2844,  2845,  2846,  2847,  2848,  2849,  2850,  2851,  2852,
    2853,  2854,  2855,  2274,  2273,  2333,  2379,  2380,  2381,  2382,
    2280,     0,     0,   234,   235,   233,  1541,   236,  1542,  1537,
       0,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
    2418,  2477,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   835,  1473,
    1511,     0,     0,     0,   665,     0,  2496,     0,   152,   873,
       0,   825,   462,     0,     0,     0,     0,  1378,   152,     0,
       0,   190,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   826,     0,     0,   152,     0,
    2496,   616,  2496,     0,   538,   538,     0,     0,   141,   138,
       0,     0,     0,     0,     0,     0,     0,     0,  1662,  1661,
    1664,  1663,     0,  1660,     0,   143,   144,     0,  1205,  1230,
       0,     0,     0,     0,     0,   902,   927,     0,     0,  1199,
       0,     0,  2496,   145,  2496,     0,  2496,     0,     0,     0,
    1207,   145,     0,  1201,     0,     0,  1203,     0,  1404,     0,
     918,   916,   915,   917,     0,     0,   900,     0,     0,     0,
       0,     0,   895,     0,     0,   897,     0,     0,     0,     0,
    1704,  1560,     0,   992,     0,   996,     0,   987,     0,   993,
       0,   988,   985,   986,     0,   991,     0,     0,   539,   541,
       0,     0,  2442,  2459,     0,  2485,  2520,  2521,  2573,  2588,
    2617,  2623,  2629,     0,  2658,  2669,     0,  1022,  1060,  1012,
     731,     0,     0,  1626,  1427,  2230,     0,  1704,     0,     0,
    1245,     0,     0,   138,   253,   224,     0,     0,  1060,     0,
    2621,  1440,   977,   656,     0,  2052,     0,  2059,  2060,  2269,
       0,     0,     0,     0,     0,     0,  2058,     0,     0,     0,
    2291,     0,  2291,     0,     0,     0,     0,     0,  1983,     0,
       0,  2229,     0,     0,  2229,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1984,  1965,  1966,
    2056,  2221,     0,  2057,  2344,     0,  1958,  2383,  2211,     0,
    2208,  2209,  2210,  2856,  2857,  2858,  2859,  2860,  2861,  2862,
    2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,  2872,
       0,  2873,  2874,  2875,  2876,  2877,  2879,  2878,  2880,  2881,
    2882,  2883,  2884,  2885,  2284,  2887,  2888,  2889,  2890,  2891,
    2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,
    2902,  2903,  2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,
    2912,  2913,  2914,  2915,  2916,  2917,  2918,  2919,  2920,  2921,
    2922,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,
    2932,  2933,  2934,  2935,  2936,  2937,  2938,  2939,  2940,  2941,
    2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,  2961,
    2962,  2963,  2964,  2965,  2966,  2967,  2968,  2969,  2970,  2971,
    2972,  2973,  2974,  2975,  2976,  2977,  2978,  2979,  2980,  2981,
    2982,  2983,  2984,  2985,  2986,  2987,  2988,  2989,  2990,  2991,
    2992,  2993,  2994,  2995,  2996,  2997,  2998,  2999,  3000,  3001,
    3002,  3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,  3021,
    3022,  3023,  3024,  3025,  3026,  3027,  3028,  3029,  3030,  3031,
    3032,  3033,  3034,  3035,  3036,  3037,  3038,  3039,  3040,  1998,
    3041,  3042,  3043,  3044,  3045,  3046,  3047,  3048,  3049,  3050,
    3051,  3052,  3053,  3054,  3055,  3056,  3057,  3058,  3059,  3060,
    3061,  3062,  3063,  3064,  3065,  3066,  3067,  3068,  3069,  3070,
    3071,  3072,  3073,  3074,  3075,  3076,  3077,  3078,  3079,  3080,
    3081,  3082,  3083,  3084,  3085,  3086,  3087,  3088,  3089,  3090,
    3091,  3092,  3093,  3094,  3095,  3096,  3097,  2000,  3098,  3099,
    3100,  3101,  3102,  3103,  3104,  3105,  3106,  3107,  3108,  3109,
    3110,  3111,  3112,  3113,  3114,  3115,  3116,  3117,  3118,  3119,
    3120,  3121,  3122,  3123,  3124,  3125,  3126,  3127,  3128,  3129,
    3130,  3131,  3132,  3135,  3133,  3134,  3136,  3137,  3138,  3139,
    3140,  3141,  3142,  3143,  3144,  3145,  3146,  3147,  3148,  3149,
    3150,  3151,  3152,  3153,  3154,  3155,  3156,  3157,  3158,  3159,
    3160,  3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,  3169,
    3170,  3171,  3172,  3173,  3174,  3175,  3176,  3177,  3178,  3179,
    3180,  3181,  3182,  3183,  3184,  3185,  3186,  3187,  3188,  3189,
    3190,  3191,  3193,  3192,  3194,  3195,  3196,  3197,  3198,  3199,
    3200,  3201,  3202,  3203,  3204,  3205,  3206,  3207,  3208,  3209,
    3210,  3211,  3212,  3213,  3214,  3215,  3216,  3217,  3218,  3219,
    3220,  3221,  3222,  3223,  3224,  3225,  3226,  3227,  3228,  3229,
    3230,  3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,  3239,
    3240,  3241,  3242,  3243,  3244,  3245,  3246,  3247,  3248,  3249,
    3250,  3251,  3252,  3253,  3254,  3255,  3256,  3257,  3258,  3259,
    3260,  3261,  3262,  3263,  3264,  3265,  3266,  3267,  3268,  3269,
    3270,  3271,  3272,  3273,  3274,  3275,  3276,  3277,  3278,  3279,
    3280,  3281,  3282,  3283,  3284,  3285,  3286,  3287,     0,  2205,
    2206,  2207,  2199,  2200,  2201,  2202,  2203,  2204,  2215,     0,
       0,  2323,  2384,     0,  2158,     0,  1980,     0,  2166,     0,
       0,  1791,     0,  2342,  2272,  1791,   271,   272,   268,     0,
       0,   220,   219,     0,   238,   242,   243,   214,   241,     0,
     237,   222,  2142,  2141,   221,   213,   210,   208,   225,   227,
     228,   211,   209,   265,     0,     0,     0,   145,  1558,  1545,
       0,     0,  2284,     0,  2219,     0,     0,  2217,     0,     0,
       0,  1788,     0,  1692,     0,  1696,     0,     0,     0,  1933,
    1932,  1885,  1881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   939,     0,  1901,     0,
    1854,  2366,  2367,  2282,  1724,  1558,     0,  1554,  1687,  1686,
    1729,  1730,  1097,  1685,  1758,  1759,     0,     0,     0,     0,
    1784,  1782,  1749,  1740,  1748,     0,     0,  1746,     0,  1750,
    1961,  1777,  1674,  1734,  1735,  1738,  1673,     0,  1780,     0,
    1629,  1778,  1739,  1613,     0,  1591,     0,     0,  1839,     0,
       0,  1460,     0,     0,     0,  1126,  1128,     0,  1127,     0,
    1130,     0,  1139,     0,     0,  1125,  1144,     0,  1133,  1131,
       0,  1500,     0,     0,     0,     0,     0,  1480,     0,     0,
       0,  2658,   257,  1483,  1488,  1475,  1486,     0,     0,     0,
       0,     0,  1062,  1061,     0,     0,  1081,     0,     0,   505,
    1507,   527,     0,   367,     0,     0,     0,     0,     0,     0,
       0,     0,   821,   818,     0,     0,   817,     0,   670,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     695,     0,  1305,     0,   298,     0,  1165,     0,  1164,     0,
    1169,     0,     0,  1166,  1161,  1162,  2623,  2633,  2664,   259,
    1167,  1197,     0,  1196,  1192,     0,  1108,     0,  1109,     0,
       0,     0,     0,     0,  2469,  2496,   306,   329,     0,  1304,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   351,     0,     0,   354,   353,
       0,     0,     0,     0,     0,   359,     0,   337,     0,   338,
       0,   358,     0,     0,     0,   638,   639,     0,     0,     0,
    1305,     0,   294,     0,     0,     0,     0,     0,     0,     0,
       0,  1214,     0,   748,     0,     0,  2623,  1193,     0,  1387,
       0,  2657,  1388,  1391,   538,     0,   538,  1393,     0,     0,
    1390,  1392,     0,     0,   176,     0,   171,   175,     0,     0,
    2623,  1194,     0,     0,     0,     0,     0,   621,   622,   635,
       0,   626,   627,   624,   628,   629,     0,     0,     0,     0,
       0,     0,     0,   620,     0,     0,   717,   716,   720,     0,
       0,     0,     0,     0,     0,  1396,     0,     0,  1188,     0,
       0,  1395,  1403,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1248,  1247,     0,     0,     0,     0,  1315,
       0,   863,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   178,   735,     0,   734,     0,   172,   177,     0,     0,
       0,     0,     0,     0,     0,     0,   232,  1449,  1455,  1728,
    1728,  1728,  2070,     0,     0,     0,     0,  1727,  2275,  2278,
    1528,  1534,  1527,  1526,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   412,   409,   410,   412,     0,     0,     0,     0,   837,
       0,   840,   843,  1471,   489,     0,     0,   662,   695,     0,
       0,   465,   185,     0,     0,     0,     0,   750,     0,  1188,
    1187,   147,   138,   194,   463,     0,   193,   195,   197,   198,
     199,   196,   200,     0,   714,   718,     0,     0,     0,     0,
     658,     0,     0,     0,     0,     0,     0,     0,  1859,     0,
       0,   170,     0,     0,   611,   615,     0,     0,     0,     0,
     465,   577,   378,  2496,     0,   538,     0,  2496,     0,   137,
       0,   824,     0,     0,     0,  1150,  1150,     0,     0,   764,
     763,     0,     0,     0,     0,     0,     0,  1659,   145,  1148,
       0,  1494,     0,   145,   942,   145,  1112,   184,  2361,     0,
     904,     0,     0,     0,     0,   145,  1216,   892,   145,   180,
     145,   145,   661,     0,   145,   182,     0,     0,   145,   936,
     145,  2331,     0,   145,  1584,  2496,   538,  1562,   989,   998,
     997,   995,   994,   990,     0,  1009,     0,   537,     0,     0,
       0,     0,     0,  1030,  1031,     0,     0,  1027,  1032,     0,
    1034,  1018,  1020,  1028,  1029,  1035,  1024,  1023,  1036,  1037,
       0,     0,     0,  1049,   729,     0,     0,     0,     0,  1623,
       0,  1621,     0,  1837,  1625,  1614,  1574,     0,  1573,     0,
     604,  1239,  1238,  1240,     0,  1006,     0,   145,     0,  1439,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2234,     0,  2235,     0,     0,  2268,  2264,     0,     0,
       0,     0,     0,  2238,  2241,  2242,  2243,  2240,  2244,  2239,
       0,     0,  2245,     0,     0,     0,  2056,  2287,  2287,  2312,
       0,  2311,  2317,  2225,  1961,     0,     0,  2308,  2302,     0,
    2308,     0,     0,     0,     0,     0,     0,  2225,  2228,     0,
       0,  2734,     0,     0,     0,     0,  2028,     0,     0,  2192,
       0,  2225,     0,     0,     0,     0,     0,     0,     0,  2221,
    2260,     0,   503,     0,  2018,     0,     0,     0,  2140,     0,
    2137,     0,     0,     0,     0,  2281,     0,     0,  2345,  1962,
    1976,  1977,  1978,  1981,  2322,     0,  2283,     0,     0,  1963,
    1989,     0,  2261,  2014,     0,  2019,  2004,  2292,  2246,  2247,
    2248,  2249,  2021,     0,  1997,  2002,  2006,     0,  2301,  1985,
       0,  1982,     0,  2284,  2220,     0,  2218,     0,  1973,  1974,
    1975,  1967,  1968,  1969,  1970,  1971,  1972,  1979,  2196,  2194,
    2195,     0,     0,  2166,     0,     0,  2001,     0,     0,  2072,
    2488,  2527,     0,  1717,  1717,  1717,  1705,  1715,  2321,  1854,
    1728,  1854,  2327,     0,     0,  1958,     0,  1835,   944,   945,
     943,  1530,  1544,  1558,  2222,  1552,  1694,     0,     0,     0,
    1902,  1915,     0,  1942,  1943,  1944,  1944,     0,  1886,     0,
    1927,  1952,  1953,  1954,  1955,  1956,  1957,     0,  1951,  1895,
     940,     0,  2619,  2754,     0,  1815,  1790,  1792,  1802,  1815,
    1822,  1815,  2074,  1852,  2075,  2076,  2328,     0,  1761,  2363,
    1532,  1556,     0,  1095,  1096,     0,  1100,  2734,  2619,     0,
       0,     0,     0,  1751,  1785,     0,  1776,     0,  2338,  1752,
    2337,  1753,  1756,  1757,  1747,  1786,  1627,     0,  1781,  1678,
    1677,     0,  1857,     0,     0,     0,  1605,  1593,     0,     0,
    1840,     0,  1791,  1631,     0,  2281,  1789,  1354,  1249,  1316,
    1129,     0,  1903,  1140,     0,  1124,     0,  1123,  1903,     0,
    1141,     0,  1903,  1355,  1250,  1317,  1356,  1251,  1318,  1357,
    1491,  1252,  1490,  1478,  1477,  1476,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     802,  2496,   145,  1505,  1358,     0,  1253,   366,  1506,  1319,
    1510,   820,   819,     0,     0,  1320,     0,   671,   676,     0,
     678,   679,  2418,  2477,   680,   683,   684,     0,   686,   675,
     674,     0,     0,     0,     0,     0,   692,   697,     0,     0,
       0,     0,     0,     0,  1159,  1160,  1359,  1256,     0,  1321,
       0,  1107,     0,  1257,   186,     0,     0,   286,  2496,   308,
       0,   487,   802,     0,  1307,   305,   335,     0,   350,   345,
     346,   344,  2496,   145,  2496,   145,     0,     0,     0,     0,
       0,   347,   342,   343,   339,     0,     0,   352,  2390,  2461,
    2634,     0,   703,   705,     0,   710,   355,  1277,   374,   373,
     372,     0,   360,     0,   379,   382,     0,   357,   336,   334,
     331,   301,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1209,     0,  1362,  1322,     0,  1344,     0,
       0,     0,     0,   742,  1365,  1263,  1325,     0,   538,     0,
       0,   553,   553,   538,  1376,  1264,   174,  1294,   163,     0,
       0,   159,     0,     0,     0,     0,   153,  1366,  1265,  1326,
       0,     0,  1367,  1266,     0,     0,   291,   614,   625,   630,
    1271,   634,   631,  1334,   632,  1374,  1267,     0,  1370,  1297,
    1329,   597,  1188,  1188,  1377,  1397,  1268,  1188,     0,  1305,
       0,   280,   282,     0,   142,     0,  1269,     0,  1327,  1369,
    1296,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1513,     0,     0,     0,     0,     0,     0,   145,     0,     0,
       0,  1307,  2496,   145,  1368,     0,  1302,     0,  1342,     0,
       0,   400,     0,  1295,  1305,     0,   293,  1273,     0,  1336,
       0,     0,   230,   229,   231,     0,     0,     0,     0,  2226,
    2227,     0,  2224,  2065,  2277,     0,  1524,   966,   952,   965,
       0,   948,  2459,     0,   951,   953,     0,     0,     0,   954,
     958,   959,     0,   950,   947,   949,     0,   411,     0,     0,
     759,   760,     0,     0,     0,     0,   839,     0,     0,  1503,
       0,   150,   669,     0,     0,     0,   664,   694,   699,     0,
       0,     0,     0,   464,   468,   472,   473,   474,     0,     0,
       0,     0,   164,   151,     0,   881,     0,   538,     0,   752,
    1188,  1380,     0,   194,   189,     0,     0,   715,     0,  1553,
       0,     0,   592,   595,   594,     0,   378,   834,   832,   831,
     833,   855,   830,     0,  1858,  1860,     0,     0,     0,     0,
       0,     0,   604,   467,     0,     0,   541,     0,   580,     0,
       0,     0,     0,   577,     0,     0,     0,  2371,     0,   851,
     823,     0,  1118,     0,  1136,  1119,     0,     0,     0,     0,
    1173,  1180,  1149,  1174,  1151,  1180,     0,     0,   765,   769,
     768,   772,   770,     0,   766,   643,  1665,  1666,     0,  1206,
       0,     0,  1499,     0,  1497,   903,  1200,   145,     0,   145,
       0,   145,  1208,  1202,  1204,  1405,     0,   901,     0,     0,
     894,   896,     0,   898,     0,  1010,   540,     0,     0,     0,
       0,     0,     0,  1026,   641,  1033,     0,     0,     0,  1048,
    1043,  1045,     0,  1060,  1054,     0,   728,     0,     0,  1624,
    1617,  1619,  1618,     0,     0,  1615,  2231,   893,     0,   610,
       0,  1060,  1051,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1722,  2232,  2233,     0,     0,     0,
    2265,     0,     0,  2109,     0,  2080,  2082,  2095,     0,  2110,
    2063,  2287,     0,  2291,  2285,  2129,     0,     0,     0,  2291,
       0,  2311,     0,     0,  2124,  2126,     0,     0,     0,  2301,
    2301,  2111,  2084,  2086,  2096,     0,     0,  2212,     0,  2099,
    2098,     0,  2030,  2031,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2045,  2100,  2191,     0,     0,     0,  2102,  2101,
       0,     0,  2259,     0,     0,     0,  2107,   504,  2112,     0,
       0,     0,     0,  2118,     0,  2148,     0,     0,     0,  2053,
    2222,     0,     0,     0,     0,     0,     0,     0,  2294,  2295,
    2296,  2293,     0,  2020,  2005,  2023,  1999,  2003,  2007,     0,
    2301,  2022,     0,     0,  2025,     0,     0,  1993,     0,     0,
    1991,  2015,  1987,     0,     0,  2016,     0,  2071,     0,     0,
       0,  2169,  2164,  2165,  1717,  1717,  1717,  1717,  1714,     0,
       0,     0,  1761,     0,  1761,   206,     0,   239,   226,  1529,
    1695,  1704,  1921,     0,  1939,  1937,  1882,  1887,  1960,  1815,
    1822,  1815,     0,     0,  1680,     0,  1802,     0,  1814,  1800,
    1813,     0,     0,  1828,  1826,     0,  1828,     0,  1828,     0,
    1794,     0,  1818,  1796,  1813,  1798,     0,  1844,  2329,  1853,
       0,  1774,  1731,     0,  2213,  1100,     0,  1733,  1755,  1754,
       0,  1744,     0,  1783,  1741,  1628,  1612,     0,  1610,  1597,
    1599,  1598,     0,     0,  1600,  2281,     0,  1610,  1592,     0,
    1636,     0,     0,  1857,     0,  1635,     0,  1903,  1121,  1122,
       0,  1145,     0,  1065,  1066,     0,  1064,     0,     0,     0,
     526,  1080,     0,     0,     0,   802,     0,     0,   530,     0,
    1508,     0,  1375,  1293,   673,     0,     0,     0,     0,   688,
     647,   689,   691,     0,     0,   690,   693,   696,  1305,     0,
     299,  1279,     0,  1340,  1153,     0,     0,  1110,     0,     0,
       0,     0,     0,     0,   486,   483,   330,     0,     0,     0,
       0,   387,     0,   310,   322,   385,   328,     0,   362,     0,
     333,     0,   326,   348,   340,   349,   341,   361,   363,     0,
     707,   708,   706,   702,     0,   709,   711,     0,   376,     0,
       0,     0,   356,     0,  1361,     0,  1305,     0,   295,  1275,
       0,  1338,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1343,     0,     0,     0,     0,   747,
       0,   744,     0,   553,     0,  1389,     0,  1386,  1384,   553,
       0,     0,   156,   155,     0,   162,     0,     0,     0,     0,
       0,     0,  1398,  1399,  1400,     0,     0,     0,     0,     0,
       0,   394,     0,   302,   304,   303,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   401,   369,     0,   858,     0,     0,     0,
     403,     0,     0,  1353,     0,     0,     0,     0,     0,  1360,
    1258,  2068,  2069,  2066,  1728,  2276,     0,     0,     0,   963,
       0,     0,     0,     0,   414,   415,   150,   413,   436,     0,
     802,     0,     0,   836,   841,   849,  2563,  2199,  2200,   847,
     842,   844,   846,   848,   845,     0,     0,     0,     0,   508,
       0,     0,     0,   495,     0,     0,   505,   488,   491,   492,
       0,     0,   665,   668,   666,   667,     0,   687,     0,   467,
     515,   567,     0,   166,     0,     0,   167,   165,     0,     0,
     378,   749,     0,   746,  1379,     0,   192,     0,   719,     0,
       0,     0,     0,     0,  1188,   657,     0,   854,   856,   828,
       0,   699,     0,     0,   616,     0,   538,  1585,   599,     0,
     569,   467,   567,   576,     0,     0,   584,   377,     0,     0,
     604,   378,     0,     0,  1081,     0,   850,     0,     0,  1117,
       0,     0,     0,  1170,  1175,  1171,     0,  1150,  1132,     0,
    1172,     0,     0,  1178,  1103,  1152,  1104,  1421,  1422,  1419,
    1420,     0,     0,     0,     0,     0,     0,  1656,     0,     0,
    1495,     0,   905,     0,   888,     0,   890,   145,   736,     0,
     145,     0,     0,     0,     0,     0,     0,  1025,     0,  1019,
    1021,  1046,     0,     0,  1060,  1059,     0,  1050,  1058,  1056,
    1057,  1055,     0,     0,  1622,  1620,   602,     0,     0,   145,
    1060,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2236,     0,  2267,  2263,     0,  2077,  2237,  2290,  2289,
       0,     0,     0,  2313,     0,     0,  2291,  2305,  2304,     0,
       0,  2303,  2291,  2291,     0,     0,     0,  2192,     0,     0,
    2029,  2041,  2042,  2043,  2252,     0,  2048,     0,  2038,  2039,
    2040,  2032,  2033,  2034,  2035,  2036,  2037,  2044,  2256,  2255,
       0,     0,  2104,  2105,  2106,  2258,  2113,     0,  2408,  2149,
       0,  2117,  2139,  2138,     0,     0,     0,  2120,     0,     0,
    2135,     0,  2193,  2346,  1964,     0,     0,  1990,  2262,  2008,
       0,  2024,  2026,  2298,  2300,  1986,  2212,     0,     0,     0,
       0,     0,  1995,     0,     0,  2189,     0,     0,     0,  2171,
    2168,     0,     0,     0,     0,  1708,  1707,  1713,  1774,  2065,
    1774,     0,     0,  1883,  1801,  1797,  1799,     0,  2749,     0,
    1804,  1811,     0,  1793,     0,  1827,  1823,     0,  1824,     0,
       0,  1825,     0,     0,  1795,     0,  1811,     0,  1851,  1720,
       0,  2160,     0,  1732,  1098,  1099,  1742,     0,  1745,  2438,
    1855,     0,  1611,     0,     0,     0,  1602,  1608,  1590,     0,
       0,     0,  1632,  1610,  1633,  1142,     0,     0,  1134,  1071,
    1072,  1075,  1073,  1070,  1074,     0,     0,     0,   802,     0,
       0,   548,     0,  1094,  1094,     0,     0,   532,   589,     0,
     805,     0,     0,     0,   803,   145,  1254,     0,     0,     0,
       0,   648,  1373,  1255,     0,     0,     0,     0,  1154,  1308,
       0,     0,  1278,     0,   307,   485,   484,     0,   482,   699,
       0,     0,   313,   323,     0,   318,     0,  1306,     0,     0,
       0,   317,   320,   319,   389,     0,   386,     0,   145,   145,
     364,   704,   375,   380,   381,   384,  1313,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     882,   865,     0,     0,   883,   884,     0,     0,     0,  1211,
    1212,  1210,  1345,  1346,  1351,  1348,  1347,  1350,  1352,  1349,
       0,  1261,     0,     0,   740,  1309,  1381,  1383,  1382,     0,
    1385,   160,   157,   158,   161,  1310,  1291,  1272,  1335,   598,
       0,     0,     0,  1270,     0,  1328,     0,  1287,  1281,     0,
       0,     0,     0,     0,  1372,  1301,  1333,  1371,  1299,  1331,
    1298,  1330,  1300,  1332,  1292,     0,     0,  1862,   862,     0,
       0,     0,   145,   145,   861,   738,  1274,     0,  1337,  1283,
       0,     0,     0,   955,     0,     0,     0,   957,   419,   437,
     150,     0,   758,   822,     0,     0,   838,     0,   493,     0,
     499,   506,     0,     0,   510,   511,   509,   494,  1188,   538,
    1188,   791,   792,     0,     0,   812,     0,   663,     0,     0,
     465,     0,   512,     0,     0,   469,   169,   168,     0,     0,
       0,   753,   757,   755,   754,   756,   751,     0,   742,   194,
    2496,     0,     0,     0,     0,   596,   590,   593,  1394,   829,
       0,  1861,   732,     0,   378,   612,     0,     0,     0,   465,
     604,     0,   470,   475,   476,   489,     0,   577,   568,     0,
     569,   578,   579,     0,   586,  1469,     0,   605,   586,     0,
       0,     0,   853,     0,   852,     0,  1120,  1137,  1138,     0,
       0,  1180,     0,     0,  1182,  1177,     0,     0,   771,   774,
     767,   650,   145,     0,  1498,   145,   145,  1237,     0,   899,
    1040,  1041,  1042,  1039,  1038,   642,     0,  1044,  1003,  1053,
     730,     0,   603,     0,  1004,   145,   980,   972,   979,   968,
     971,   973,     0,   975,   976,   970,   967,   969,  2266,  2094,
       0,  2286,  2128,  2310,  2309,  2127,  2316,     0,  2307,  2306,
       0,     0,  2097,  2108,     0,  2191,  2222,     0,     0,  2049,
       0,     0,     0,  2103,  2744,     0,     0,  2153,  2154,     0,
    2150,  2151,  2146,  2147,  2119,     0,  2552,  2130,     0,     0,
    2145,  2012,  2010,  2009,  2297,  2299,  1994,     0,     0,  1992,
    1988,     0,  2017,  2155,  2188,  2222,  2157,     0,  1728,  1712,
    1711,  1710,  1709,  2160,  2343,  2160,   240,  1699,  1847,     0,
    1850,     0,     0,  1803,     0,     0,  1805,     0,     0,  1807,
    1809,     0,     0,     0,     0,     0,     0,  2332,     0,  1773,
       0,  1728,     0,  1743,     0,  1609,  1594,     0,  1595,  1601,
       0,     0,     0,     0,     0,  1637,  1630,  1135,  1143,     0,
       0,     0,   528,     0,   543,     0,     0,     0,  1087,   140,
    1086,     0,   543,   543,   807,   806,   809,   804,   808,  1509,
       0,   681,   682,   685,  1280,     0,  1341,  1289,     0,  1626,
     309,   481,   480,   489,   316,     0,     0,     0,   311,   388,
     390,   312,   315,   369,   332,   325,     0,     0,     0,  1276,
       0,  1339,  1285,  1312,  1363,  1259,  1323,     0,     0,   871,
       0,     0,     0,     0,  1364,  1260,  1324,     0,     0,     0,
       0,     0,  1626,     0,     0,     0,     0,     0,     0,     0,
       0,  1518,     0,     0,   368,   860,   859,   369,   402,  1303,
       0,  2067,     0,   956,   961,   962,   960,     0,   408,   416,
     419,     0,     0,  1228,  1228,     0,     0,   490,   507,     0,
     588,   547,   588,     0,     0,     0,     0,     0,   700,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   745,
     744,   191,     0,   465,     0,   699,     0,   857,     0,     0,
       0,   604,   467,     0,     0,  1582,   466,     0,     0,   478,
       0,   580,   569,   577,     0,     0,   601,     0,  1462,     0,
     607,     0,     0,     0,   801,  1176,     0,  1190,     0,  1131,
    1101,  1185,     0,  1704,  1854,     0,     0,     0,     0,   784,
       0,   654,  1229,  1496,   889,   891,   737,  1047,     0,  1060,
    1052,   974,  2288,  2315,  2125,  2314,  2251,  2193,  2046,     0,
    2254,  2253,  2257,     0,  2114,     0,  2115,  2152,  2121,  2131,
       0,  2122,  2143,     0,     0,  2013,  2011,  1996,  2190,     0,
    2175,  1682,  1681,     0,  1702,  1852,     0,     0,  1846,     0,
       0,  1876,     0,     0,     0,  1812,  1830,     0,  1808,  1806,
       0,  1819,     0,  1821,  2437,  2713,  2616,     0,  1760,  1762,
    1765,  1767,  1766,  1768,  1764,  2159,  2161,     0,  1739,  2214,
    1856,     0,     0,     0,  1082,     0,     0,  1638,  1639,  1634,
    1048,     0,   145,  1094,     0,  1188,   549,  2563,   550,  1093,
    1097,   139,     0,  1188,  1188,   677,     0,     0,   288,   477,
       0,   314,   324,   371,   383,     0,  1626,     0,     0,   869,
     878,   878,   866,     0,     0,   885,  1262,   741,     0,   552,
       0,   283,  1288,  1282,     0,     0,     0,  1520,  1521,     0,
       0,     0,     0,     0,  1311,   145,  1284,   964,     0,   439,
     446,   420,   424,  1512,     0,  1512,     0,   421,   425,  1512,
    1512,   418,  1854,   435,  1228,     0,  1225,  1224,   536,   618,
       0,     0,   497,     0,   558,   496,     0,   813,     0,     0,
     698,     0,   467,   567,     0,   525,   516,   517,   518,   519,
     521,   520,   522,   523,   524,   514,   513,     0,   699,   875,
     378,  1469,   739,     0,     0,   712,     0,   699,     0,  1585,
     600,   569,   467,   567,   471,   489,     0,   584,   577,   580,
       0,   581,     0,   585,     0,     0,     0,   604,  1522,  1081,
       0,     0,   802,  1189,  1150,     0,     0,  1179,  1183,  1184,
       0,     0,     0,     0,  1232,   778,   779,   773,   775,     0,
     786,   790,   649,     0,     0,   653,   644,   699,   145,     0,
    2047,     0,     0,  2133,  2132,  2144,  2123,  2170,     0,     0,
       0,     0,     0,     0,     0,  1693,  1845,  1848,     0,  1879,
       0,     0,     0,     0,  1865,     0,  1810,     0,     0,  1820,
       0,     0,     0,  1769,     0,     0,     0,  1778,     0,  1607,
    1854,     0,  1604,     0,  1647,     0,  1640,  1067,     0,  1068,
    1088,     0,   588,     0,  1100,  1097,   538,   588,   588,  1290,
       0,   618,     0,   327,     0,   296,  1286,     0,     0,   880,
     880,     0,     0,     0,     0,     0,     0,   396,     0,     0,
    1514,     0,  1515,  1516,  1519,   404,   417,     0,   444,     0,
     442,   441,   443,     0,   432,     0,     0,     0,     0,     0,
       0,   407,  1223,  1227,  1226,     0,   498,     0,   500,     0,
       0,   544,   545,   546,     0,   502,   554,   555,   810,     0,
     815,     0,   701,     0,     0,   699,   566,   723,     0,     0,
       0,  1463,     0,     0,   591,   733,  1469,   604,   577,     0,
     569,   479,     0,   586,   580,   584,   582,   583,     0,  1466,
       0,   606,     0,  1090,   800,     0,  1180,  1191,  1186,  1181,
    1425,     0,     0,   776,   781,   780,  1512,   785,     0,     0,
       0,   652,   651,   727,  1005,  2250,  2136,  2116,  2134,  2700,
    2438,  2672,     0,  2187,  2176,  2187,  2187,  2167,     0,     0,
       0,     0,     0,  1877,  1878,  1863,     0,     0,  1867,  1817,
    1843,     0,     0,     0,  1763,  2162,  2163,  2362,  1596,  1606,
    1083,     0,     0,     0,  1647,     0,     0,   553,     0,  1084,
    1100,   547,   802,   802,  1626,   321,   370,     0,     0,     0,
     876,   879,   867,   868,   887,   886,   743,  1626,     0,   392,
     391,     0,   395,     0,   440,   449,     0,   447,   422,   427,
       0,   431,   429,   428,   423,   426,   535,     0,     0,     0,
       0,     0,     0,   556,     0,   557,     0,   814,     0,     0,
       0,   725,   874,     0,     0,   465,   699,  1464,  1583,   580,
     569,   577,     0,     0,   571,  1094,  1094,   452,   584,   586,
    1467,  1468,     0,     0,   505,     0,  1102,  1424,  1423,  1704,
       0,     0,     0,   787,   788,   783,     0,     0,     0,  2180,
    2179,  2178,  2182,  2181,     0,  2174,  2172,  2173,     0,     0,
       0,  1849,     0,  1866,  1869,     0,     0,     0,  1875,  1868,
    1870,     0,  1829,     0,  1841,  1771,     0,  1770,  1854,  1646,
       0,     0,   145,   542,   802,   551,  1085,   558,   531,   529,
     289,  1626,   870,     0,   284,     0,   397,  1517,   445,     0,
     430,   617,   501,   587,   563,     0,   562,     0,   560,   559,
     811,   816,     0,   699,   864,  1469,   713,   584,   577,   580,
       0,   570,     0,   140,   140,   586,   450,     0,     0,   378,
       0,  1407,  1704,  1406,  1408,  1416,  1413,  1415,  1414,  1412,
       0,  1235,  1236,   777,   782,     0,     0,     0,     0,  2184,
       0,  2185,     0,     0,     0,     0,  1872,  1873,  1874,  1871,
    1816,     0,  1772,  1603,  1649,     0,     0,  1641,  1642,     0,
    1069,   533,   802,   297,   877,     0,   448,   561,   538,   538,
     699,   724,  1465,   586,   580,   584,  1094,   572,   574,   573,
     454,  1090,  1091,     0,   586,   790,     0,  1417,  1411,  1680,
    1667,     0,     0,   789,     0,  2177,  2183,  2186,     0,     0,
       0,     0,     0,     0,  1644,     0,     0,     0,  1643,   534,
       0,   565,   564,   726,   453,   584,   586,   140,   505,  1089,
       0,  1854,     0,  1409,  1704,     0,     0,   795,  1698,  1697,
       0,     0,  1701,     0,  1842,  1648,  1645,     0,     0,     0,
       0,  1650,   393,   586,   451,   575,   378,  1092,  1076,     0,
    1410,     0,     0,   797,     0,   793,   796,   798,   799,     0,
       0,  1864,  1654,     0,     0,     0,   455,   586,     0,     0,
       0,   761,     0,  1728,     0,     0,     0,     0,  1854,     0,
       0,     0,   794,     0,     0,  1651,  1655,     0,  1652,  1077,
     795,  1233,  1234,     0,  1700,     0,     0,     0,   762,  1653
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5688, -5688, -5688,  3914,  -575, -1710, -5064, -1122,  4079, -5688,
   -5688,  -959,   281,  3143, -2415, -5688, -5688, -5688,  -516, -5688,
   -5688, -5688, -5688,  3875, -5688, -2898, -5688, -5688,   158,  -414,
   -1380,   184,  3438,  1463, -5688, -1004, -5688, -5688,  -645,     1,
   -5688,  -408,   493, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
   -5688,  -824,  1916, -5688,  2011,  1261, -4158, -5688, -5688, -1514,
   -3761, -5688,   527, -5688,   554, -4797, -1064, -5688, -5688, -5688,
    1899, -5688, -5688, -5688,  1846,  1054,  -476, -5688, -5688, -5688,
   -5688, -5688, -5688,  -902, -5688, -5688, -1172,    10,  -652, -2910,
   -4298, -5688, -5688,   377,  -519, -1494, -5688,   568, -5688,   569,
   -5688, -4830, -5688,  -117, -2656, -2941, -5688, -5688, -5688,  -490,
   -1465,  1351, -5688,  -742, -1159,  1719, -2261, -1021, -5688,  -364,
   -3571, -1143,  -911,  -908, -1052, -4358, -4859, -5688, -5688, -1163,
   -3777, -5138, -5395, -4899, -4794,  1373, -5688,  -133,   391, -5688,
      11, -3657, -3725,    14,   364, -5688,    16,    17, -5688,   386,
    -832,  -980, -1608, -5688,  -762, -5688, -5688, -5688, -3445, -5688,
   -5688, -5688,   148, -5688, -5688, -5688, -5688,   435, -5688, -5688,
   -5688, -5688, -5688, -5688, -2500,  1890,  1892, -5688, -4370, -5688,
    -928, -5688,   599, -3466,  1302, -5688, -5688,  1068,  3922,   418,
   -5688, -5688, -5688, -5688, -5688, -5688, -1792, -5688, -5688, -5688,
   -5688,  -101,  -441, -5688, -5688, -5688, -5688, -5688, -5688, -5688,
      18, -5688,  1029,   356, -5688, -5688,  -735, -5688, -5688, -5688,
   -5688, -5688, -5688, -1202, -5171, -1306, -1286, -5688, -3478, -5688,
   -5688, -5688,  -416, -5688, -5688, -5688, -5688, -5688,  -909, -5688,
    1122, -4149, -5688, -5688,   395, -5688, -5688, -5688, -5688, -5688,
   -1010,  -356,  3083, -5688,  -596,  -804, -5688, -5688, -5688,  -355,
   -5688, -5688, -5688, -5688, -5688,  -527, -1282,  4909,  4289, -1103,
   11161,  -838,  -588, -5688, -5688, -5688, -2705, -5688, -5688, -4252,
   -5688,  4902,  2378,   773,    19, -5688,   -24,    89,  3730, -5688,
     992, -1168, -3099,   348,  -554, -5688, -5688, -5688,   351, -5688,
   -1958, -5688, -5688, -5688, -5688, -4089,    21, -5688, -4373, -5165,
   -4553, -4062, -1171, -5688, -4170, -4476, -4082, -5688,  1917, -5688,
   -5688,  -513,  -187,  3046, -5688, -1480,  2260, -1414, -5688, -2521,
     413,  1469,  3063, -3272,  -127,  3047, -2996, -5688,  -698,  1063,
   -5688,  -437, -3762, -5688, -5688, -5688, -2755,  -678, -5688, -5688,
    1414,   665, -5688, -5688, -5688, -5688,  -622,  3040,  -205, -5688,
   -5688,  4265, -5688, -4961, -5688,  4236, -5688, -5688, -5688, -5688,
   -5688, -5688, -5688, -5688, -5688, -1455,  1227, -5688,  -836, -5688,
   -5688,  2020,   629, -5688, -5688, -5688, -5688,  1315, -1235, -5688,
   -5688, -5688, -5688, -5688, -5688, -5688,  -990, -1184, -5688, -5688,
   -5576, -5688, -5688, -5688, -5688, -5688,  2255,  -957,  -741,  4129,
     935,    32, -5348, -5688, -5688,  -893, -5688,  3470, -5688, -5688,
   -5688, -5688, -5688,   420,   412, -5688, -5688, -5688, -5688, -3955,
   -5688, -5688, -5012, -5688, -5688,  2002, -5688, -5688,  -357,     6,
    3173, -5688, -5688, -5688,   -30, -5688, -5688, -1016,  2352, -5688,
   -2380, -5688,  -600, -5688, -5688, -1915,    33, -4352, -5688,     5,
   -5688, -5688, -5047, -1190,   218, -5688, -5688, -3984,    15, -5688,
   -5688, -5688, -5688, -5054, -5688,    22, -5542,   769, -3316, -5688,
       9, -5688,  -503,  -889, -5688, -5688, -5688, -3832,    34,    96,
   -5688, -5688,     4,   370,   -49,   -23,   -14,     2,   133,  3584,
   -5688, -5688, -5688, -4542,  3629, -5688,    -2,  -861,  4946,  4947,
   -5688,  -882,  -152,   373,  1567,  -701, -2586,  3527,  3537, -5688,
    1554,  2357, -2457, -2440, -5688, -1140,  -868,  -699, -5688, -5688,
   -5688, -5688, -1708,  -697, -2597, -5688,  3540, -5688, -5688, -5688,
   -2369, -3353, -3274,  1592, -3282, -3195, -5688,   850,   835, -1085,
    -189,     8, -1482,  -780,  1624, -5688, -5688,  1603,  -439, -5688,
   -5688,  -436, -3284,   797, -5688, -4559, -2815,  1610, -1120,  -843,
   -5688,  -975, -5688,  -665,   553,  3598,  -818, -5688, -5688,  -793,
   13383, -5688, -5688, -5688, 13931, 14075, -5688, -5688, 14604, 15528,
   -5688,  -606, 16029, 12267,  -792, -1938,   132, 17905, -1846,  2447,
     160, -5688, -2915, -2520, -5688, -5688, -5688,  -405,   945,   514,
   -5688, -5688, -4588, -4434, -5688,  2486, -2062, -5688,  -673,  1681,
    -671, -5688, -5688, -5688, -2598, -5472, -2727,  2492, -5688, -5688,
   -5688,  -182, -5688, 18868, -3245, -5688,  -639, -1017, -1599,  2972,
   -3180, -1919, -5688, -5688, -5688, -3120, -5688, -5688, -5688,  -806,
    1703, -5688, -5688,  1823, -5688, -5688, -5688,  -977,  2063,  -761,
   -1189,  1710, -1868, -3038, -5688, -1906,  1722, -2279, -5688, -1935,
    1796,  1026, -5688, -1613, -5688,  4142,  -795,  2499,  -800, 17271,
    -635, 11002, -1290, -5688,  3160, -5687,   968,  7966,    27,  -134,
    3927,  -667,  2419,  3067, -5688, -5688,  5428,  8384,  -603,  -855,
   -5688,    -6, 12732, 11616, -3671, -5688
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    58,    59,    60,    61,  1090,  1095,  1889,  1908,    62,
      63,  1612,  3012,  2866,  3822,  3823,    64,    65,  1608,    66,
      67,    68,    69,  1522,    70,  1861,  3026,    71,  2702,   834,
     835,   836,  2567,  2568,  2957,  2569,  2557,  1373,  1807,  1544,
     808,   809,  1504,  1545,    73,    74,  1367,  2548,    75,    76,
      77,  1575,  1668,  1576,  1577,  1516,  4937,  5723,  3612,  2821,
    3870,  3613,  3614,  4284,  4285,  4373,  5737,  5738,    78,  1684,
    1685,    79,    80,  2994,  3788,  4426,  5318,  5319,  5561,   650,
    4960,  4961,  5548,  5549,  5751,  5906,  5907,  3027,   681,  3865,
    4510,  3813,  5031,  3814,  5032,  3815,  5033,  4828,  4829,  4274,
    4275,  3799,  4457,  4458,  2058,  4973,  4459,  3816,  4992,  5595,
    3817,  2721,  5766,  3061,  1980,  1978,  5495,  5574,  4790,  4791,
    4347,  5775,  5776,  5777,  6028,  4994,  5037,  5038,  5943,  5944,
    3868,  4516,  5044,  5376,  5572,  3510,    82,  3841,  3842,    83,
     744,  1883,  3969,   745,  3064,   682,   746,  3028,    88,  3054,
    5768,  3055,  1638,  2880,  4439,  3945,    89,  1118,  4249,  5401,
    5655,  5656,   735,    90,  1869,    91,    92,  3007,  3806,    93,
    2738,  3527,    94,    95,  3546,  3547,  3548,    96,  4467,  5337,
    1578,  3601,  3602,  3603,  3604,  4305,    97,  1864,  3035,  3036,
      98,    99,   100,  3166,  3167,   101,  2943,   102,   103,   104,
     105,  4341,  4894,  5008,  3643,  3829,  4483,  5006,   106,  3792,
    3029,  3082,  3903,  3904,  5399,  5647,  5648,  5649,  5826,  6063,
    5651,  5828,  5965,  5830,  4983,  6184,  6185,  5632,  4238,  4804,
     108,  4984,  4985,  5781,   109,  2736,   110,   111,  1838,  3000,
    3001,  4440,  3071,  3878,  3879,  4496,  4497,   112,  3730,   113,
    4870,  4871,   683,  5789,  5729,  5892,   114,   115,  4874,  4875,
     116,   117,   118,   119,   120,   736,  1052,  1053,   738,  1173,
    1174,  3482,  1135,   121,  2577,   122,  3768,   123,  1253,  5097,
     124,   770,  1189,  1190,  3030,   126,   780,  3185,   782,  3150,
    3151,  1996,  3949,  3950,  4584,   127,   128,  3953,  3954,  4591,
    3163,   129,  1509,  2712,  2713,  4785,  3031,   684,  3505,  5483,
    5228,  5484,  5954,  6113,  5229,  3426,  4187,   131,   685,  1550,
    2777,  1141,  1142,  3075,  3883,  2682,  2683,  1707,  4537,  2685,
    3885,  2686,  1482,  2687,  1128,  1129,  3891,  3892,  3893,  3894,
    4533,  4543,  4544,  5393,  5640,  4540,  1857,  5387,  5388,   132,
    1547,  2774,   133,   134,   135,  1591,   976,  1151,  1152,   136,
     697,   698,   137,  5566,   138,  1131,   139,  5397,   140,   141,
    1238,  1239,   800,   142,   143,  2791,  4287,   144,  1548,   145,
     146,  3637,  3638,  4886,   147,   148,   149,  2852,  2853,   150,
     151,   152,   153,   154,  6053,  6116,  6117,  6118,  4551,  5959,
     155,  1221,   156,   157,   158,   159,   197,  1017,  1018,  1019,
     929,  3032,  5378,   161,   162,  1505,  1506,  1507,  1508,  2707,
     163,   164,   165,  3913,  3914,   166,   167,   168,   169,  1841,
     170,   171,  5539,   172,   173,  1811,   174,   175,  1026,  1027,
    1028,  1029,  1809,  3373,   644,   853,  1398,  1404,  1447,  1448,
    1449,   177,   748,   178,  1229,  1057,   749,  1182,   180,   750,
    2664,  3456,  4202,  4203,  4204,  4207,  5212,  4762,   751,  3452,
     183,  2003,  3172,  3175,  3448,   752,  3462,  3463,  3464,  4211,
     753,  5487,  5488,  5873,  6087,  6088,  6138,  6171,   754,   772,
    1121,  3086,   755,  1333,   189,   190,   191,   909,   856,   857,
    3378,  5444,  5675,   193,  2541,  3356,   789,  1453,   897,   898,
     899,   918,  2967,  2630,  2631,  2655,  2656,  1462,  1463,  2643,
    2647,  2648,  3439,  3432,  2636,  4181,  5468,  5469,  5470,  5471,
    5472,  5473,  4751,  2651,  2652,  1465,  1466,  1467,  2660,   194,
    2620,  3406,  3407,  3408,  4158,  4159,  5992,  4173,  4169,  4736,
    5189,  3409,   845,  1219,  1474,  4744,  5994,  3410,  5178,  5179,
    5448,  4177,  3418,  4198,  3853,  3854,  3855,  3411,  5683,  5684,
    5989,  5990,  5450,  5451,  2688,  1427,   883,  1334,   884,  1440,
    1335,  1414,   886,  1336,  1337,  1338,   889,  1339,  1340,  1341,
     892,  1406,  1342,  1343,  1423,  1436,  1437,  1399,  5452,  1345,
    1346,  1347,  3413,  1348,  4680,  5149,  5135,  3279,  3280,  2564,
    5434,  4676,  4071,  4670,  2534,  2538,  5201,  5475,  5476,  3349,
    4122,  4709,  5168,  5671,  5843,  5844,  5975,  1349,  1350,  1351,
    3341,  2528,   979,  1352,  4442,  2530,  3270,  3248,  1710,  3249,
    2006,  2028,  3204,  3220,  3221,  3317,  3250,  3258,  3263,  3271,
    3303,  1353,  3206,  3207,  3991,  2030,  1354,  1023,  1713,  1024,
    1442,  3298,  3229,  4003,  5111,  3230,  3318,  4104,  3237,  3238,
    4019,  4009,  3231,  1355,  4011,  1363,  1364,  1357,  1997,   846,
    5185,  1177,  1794,   786,  1358,  1359,  1360,  1361,  1584,   950,
    1144,  1145,   900,   902,   903,  2624,   640,   632,   952,  3605,
    2531,   641,   634,   635,  1799,  2532
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     633,    72,   192,  1709,   187,   181,   176,   977,   908,   185,
      81,    84,  1637,   812,    85,   182,    86,    87,   107,   125,
     942,   130,   184,   192,  1368,  1806,  1356,   747,   983,  2893,
     978,   988,   160,   179,   186,  1210,  1211,  1212,   919,  1468,
    1030,  1216,  1084,  1923,   848,  2720,   896,  1800,  1977,   774,
    1689,  1122,  1157,   844,  1454,   774,  1456,  1439,  2815,  1419,
    3187,  1701,  2786,  3509,  3449,  1642,  1170,  2684,  1395,  2778,
    2025,   930,  1216,  1410,  1411,  4132,  3450,  4134,  2017,  1866,
    3895,  4348,  1418,   986,  3049,  4495,  1394,  3971,  1425,  1183,
    1382,  2787,  3178,  1124,  4276,  1487,  4521,  1008,  4196,  3414,
    4255,  3812,  1176,  4753,   638,  2961,  2798,  3203,  3240,  2009,
    1839,   689,   781,  2011,  1844,  3727,  2012,  2013,  1051,  1848,
    2854,  2854,  1579,  3843,  2854,  3834,   813,  4444,  4172,  1858,
    4155,  5022,  4300,  4546,  4302,  2684,  3236,  4508,  3288,  4787,
    1030,  5182,  1184,  1878,  1167,  4210,   913,  1601,  2616,  5380,
     233,  5051,  1618,  3695,  5040,  5030,  3116,  2923,  2924,  2769,
    5481,  4854,  3475,  3477,  5578,  5500,   629,  1795,  1636,   921,
    4792,  4991,  3359,  3232,  1912,  1851,  3361,  1667,   922,  3068,
    4185,  5373,  1375,  1551,   859,  4209,  5194,  1694,  5196,  3441,
    4004,  1875,   633,  4099,  5341,  5508,  1030,  1583,  3371,  4216,
     833,   633,   953,  4505,  1155,  5369,  3255,  1159,  3444,   633,
    2919,   953,   633,  5039,  4170,  1400,  4175,  1461,  5630,  2769,
     807,  1464,  5803,  4768,  1124,   953,   695,   841,   756,   648,
   -1903, -1944, -2480,  5617,  1001,  5140,  2769,  2950,  5531, -2522,
    2749,  5230,  5372,  4006,  1546,  3420, -2371, -2547,  4016,  1030,
   -1916, -2372,  1874,  5791, -1936, -2371, -2371,  1905,  1407,  1408,
   -2372, -2372, -2585,  1905,  3831, -1941,  2799,  1808,  1417, -1931,
    1905,  3771,  1394,  3774,  3775, -2404,  1905,  3046,  3779,  3780,
    3781,  3296,  3783,  3784,  3785,  1546,   756,  5541,  5542,  2935,
    1546,  1905,  2575,  4035, -2484,   695, -2336,  5728,  1905,   928,
    1905,  2079,  3168,  3183,  1191,   756, -2760,  3161,  1518,  1030,
     695, -2335,   695,  2930,   695, -2760, -2760,  1836, -1944,  3296,
    2001,  1831,  2554,  1195,  1580,   695,  3752,  2539,  1580,  5998,
     756, -2197,  2789,  2581,   756,  1247,  1905,   756, -2197,  1372,
    1905,  5295,  4588,  2917,  2621,  3145,  4088,  4278,  4016,  4531,
    5099,  5100,  5101,   695,  5103,  5104,  5105,  5106,  5107,  3973,
    1111,  2992,  2619,  5567,  4162,  5296,  2583,  5968,  2857, -2332,
     188,  2861,   695,  2854,  -150,  1248,  5052,  4867,  3717,  1223,
    -150,  5210,  3391,  6055,  1222,  2057,  1186,  1698,  3079,  3058,
    5702,   188,  5001,   916, -2545,  5763, -1756,  5663,  5957,  4474,
    5691,  1518,  4035,  2839,  2938,  3479,   762,  5334,  3446,  3338,
    5949,  3080,  3802,   762,  2079,  3059,  3339,  1800,  3718,   819,
    2634,   762,  1519,  5509,  2726,  1701,  1124,   907,  5137,  3641,
     763,  3169,  3496,  1853,  2627,  5227,   762,   763,  2555,  3394,
    4163,  3164,  1232,  6161,  3740,   763,  2581,  2546,  5937,   762,
    1679,  3666,  3392,  3719,   695,  4371, -2216,  3024,  3417,  5253,
     763,  4279,  5725, -2216,  4200,  2623,  1013,  4268,   762,  3047,
     195,  1613,  2789,   763,  4164,   762,  6055,  1377,   645,  2583,
    4589,  5805,   978,  2790,  1410,  1411,  1931,  5002,   784,  4165,
    1686,  2789,   763,  1690,  2789,  1396,  2789,   695,  4868,   763,
    2550,  4201,  4367,  6204,  4372,  4166,  3642,  4007,  4212,  1418,
    2789,  4492,  4017,  5618,   196,  1519,  5606,  3447,  3414,  2547,
    3497,  1425,  2789,  3803,   820,  5335,  2635,  2039,  1078,  2789,
    2789,  3666,   978,  4167,  1088,  3165,  4432,   872,  5575,  3025,
     851,  5138,  1958,  4269,  2840,  2939,  1102,  1998,  3161,  5764,
    3508,  1906,  3161,  6045,  2576,  1446,  1433,  1906,  1680,  5703,
    4769,  5237,   920,  2008,  1906,  2556,  3161,  1699,  1014,  1433,
    1906, -1756,  2073,  4035,  1800,  3081,  5003,  2714,  6055,  4475,
    2018,  1837,  5958,  1795,  1659,  1906,  1021,  1961,  2800,  1658,
    1022,  1209,  1906,  6165,  1906,  6125,  2715,  3162,  4089,   696,
    5211,  2544,  2801,  5762,  2802,   882,  4869,  2022,   690,  2704,
    2965,  5664,  4017,  3060,  4031,  2993,  3146,  4590,  2558,  3480,
    3019,  1568,  3481,  2570,  2570,  1015,  2540,  4168,  1384,  3521,
    1906,  2079,  2896,  3989,  1906,  -438,  5462,   953,  5297,  4444,
    2002,  6084,  6103,  1590,  1921,  3048,  2618,  3170, -2545,  1124,
    3297,   192,  6085,  1062,  1058,  2716,   953,  1837,  1061,  2816,
    1407,  1408,   953,  2581,  1059,  4889,  5948,  2803,  3171,  1520,
    2936,  1060,  5920,  2888,   953,  2717,  2891,  4280,  4281,  1215,
    2918,  4090,  6167,  3753,  1016,  2959,  2960,  6102,  4108,   649,
     953,  1417,  1250,  2072,   908,   633,  2583,  2860, -2197,  2937,
     896,  2754,  1116,  1215,   633,   953,  4212,  5427,  4282,  1405,
    6146,   633,  1907,   953,   633,  2898,  2002,  1187,  1914,  5000,
    1420,  1421,  3804,  2931, -2545,  1918,   896,   953,  1837,  5903,
    3388,  1929,  2552,  1521,  4532,  2816, -2545,   953,  1409,  1422,
    4008,  3199,  5004,  2958,   192,  4018,  1951,  2911,  2912, -2480,
    6173,  2833,  5798,  1954, -2371,  1921, -2522,  4797,  1413, -2372,
    5048,  2727, -1936,  2832, -2547,  2756,  4091,  2661,  2594,  1469,
    2597,  2662,  4896, -1941,  1124,  2763,  3340, -1931,  4900, -2585,
     768,   769,  1124,  1124,  1188,  5801,  1193,  6047,  1197,  5216,
    4050,  4583, -2404,   953,  1201,  5047,  6066,  1218,  2527,   768,
     769,  6037,  1021,  2075, -2336,  2877,  1022,  1420,  1421,  2599,
    2600, -2484,  3805,  5005, -2760,   633,   633,  3134,  2542, -2335,
    3364,   953,  6189, -2216,  1581,  1582,  1424,  2966,  1581,  1582,
    6010,   768,   769,  2622,  2718,  3861,  2670,  5360,  1822,  4368,
    1610,  1021,  2949,  6014,  3550,  1022,   953,  3118,   633,  2773,
    5411,  4424,  4425,  1818,  4444,  4493,  1218,  1823,  3626,  1824,
    4493,   978,  2878,  1700,  1611,  2881,  2882,  1204,  4172,  1021,
    4405,   896,  6168,  1022,  -150,  -150,  1837,  4814,  4859,   852,
    3144,  3414,  1385,  1510,  3414,  1921,   921,  4733,  2817,  4586,
    1602,  4737,  3159,   633,  5238,   922,  4047,  4048,  4049,  4050,
     691,  6105,  2773,  4583,  5947,  4634,   953,  1813,  2524,  2525,
    2526,  2527,    72,   192,  4505,   187,   181,   176,  5877,  2773,
     185,    81,    84,  5882,  5883,    85,   182,    86,    87,   107,
     125,  3414,   130,   184,  1473,  4486,  1503,  4362,  4363,  3414,
    5710,  5941,  4364,   160,   179,   186,  3003,  3020,  4777,  1525,
    2719,  3522,  4963,  4218,  4724,  4219,  4726,  6093,  1386,  3205,
     692,  4959,  1855,  4618,  2817,   923,  6145,  6086,  4460,  1429,
    1244,  4541,  2841,  3441,  4006,  3790,   807,  1224,  1226,  6108,
    6109,  3959,  3002,  1371,  4962,  5605,  5929,  1379,  1401,  3618,
     773,  4190,  4251,  4139,  5395,  2748,   773,  1511,  5921,   693,
    3608,   694,  5940,  1673,  1603,  5569,  3415, -1903,  6198,  2890,
    1870,  5653,   923,  2816,   633,   633,  1796,  2078,  1898,   188,
    2079,  6169,  6024,   953,  5714,  3235,  1476,  6068,   633,  4920,
    3541,  4596,  1899,   896,   633,   940,  5507,  3323,   633,  2816,
     633,   695,   914,  2910,   896,  1430,  1674,  4256,  2623,  1940,
    6046,  1074,  2581,  1871,   924,  2818,  3609,  2980,  1138, -2887,
     896,    41,  3963,    41,  5611,  4045,  4046,  4047,  4048,  4049,
    4050,  4419,  3010,  2714,  2816,  4484,  4976,  6170,  5530,   695,
    5668,  6038,   695,  6175,  2819,  2583,  6098,  6136,  1900, -1903,
    1214,  4887,  1941,  4213,  3541,  3961,  1800,  4547,    45,   925,
      45,   924,  3015,  4281,   633,  5513,   633,   633,  6069,  2820,
     915,  5071,   188,   907,   916,  1431,  2764,  5514,  1432,  5851,
    3542,  6193,  2079,  2522,  2523,  2524,  2525,  2526,  2527,  1258,
    2902,  2818,  4035,  4845,  3554,  4939,  4036,  4037,  4038,  5016,
      49,  5027,    49,  3062,  3964,  4981,  6110,   953,   788,  5545,
    2814,  2716,  2816,    50,  4085,    50,   797,  5682,  4940,  2903,
    2819,  3213,  3610,  4792,   695,  6137,  5771,  5028,  1921,  1512,
    6225,  2717,  4989,  1888, -1757,   633,  1604,    51,  3324,    51,
    1215,   807,  1224,  3325,  3542,  2820,  4548,  2583,  3791,   192,
    1901,  5654,  3156,  3157,   916,  4597,    57,  4191,    57,  1030,
   -2887,  6070,  4756,  1206,  6144, -2887,  3619,  -694,   953,  1513,
    1921,  3453,  2728,  2765,  4921,  6151,  1605,  3058,  3960,  1013,
    4326,  1837,   896,  3016,   953,  5784,  2814,  3326,  5787,  1675,
    3899,  3555,  1433,  5669,  1477,  6025,  1872,  5795,  4007,  5880,
    4977,   953,  2817,  3059,  1514,  3294,   953,  6174,  5396, -2887,
    4374,  1606,  6099,  3097,  1902,  5800,  5812,  5797,   633,  1136,
    5371,  2816,  4252,  5359,  5670,  1856,  1897,  3109,  2817,  3474,
    3011, -1903,  3214,  2078,  6196,  1942,  2079,  4441,  4542,   920,
    3115,   188,  4461,   908,  5783,  1136,  1963,  5833,  1965,  3569,
    1967,   926,  1969,   633,  1971,  1972,  1973,  3551,  6208,  5390,
    3545,  1975,  4982,  2817,  2588,  5365,  5772,  4256,  2581,  2073,
    5222,  1110,  3832,  1515,  5799, -2887,  6026,  4793,  3120,  3900,
    3767,  1014,   633,   633,   633,  3093,   633,  3400,  5570,  1678,
    2718,  3755,  3962,  3611,  4327,  1679,  1676,   917,   926,   941,
    4040,  2583,  2816,  1873,  1434,  6027,   633,  3143,  3215, -1757,
    6071,  3148,  4549,  1903,  2816,  1075,  3155,  3114,  4352,  3158,
    3127,  5096,  1139,  2920,  3545,  5029,  3762,  4538,  2579,  1435,
    4990,   953,  4192,  2729,  1111,  3627,  3327,  4757,  1015,   953,
     953,  2817,  1943,  5773,  3711,  3200,  1207,  3202,  1258,  2951,
    3712,  4035,  2769,  3209,  6075,  4036,  4037,  4038, -2887,  3223,
    3224,  3454,  5708,   633,  3095,  3241,  4032,  4033,   798,  2818,
    4105,  4052,   978,  6217,  3260,  5931,  4041,  6060,  3216,  3108,
    3275,  3217,  3110,  4550,  3552,  3415,  3272,  4137,  3246,  2722,
    2628,  2629,  1796,  2633,  1491,  2818,  3541,  1016,  2819,   922,
     922,  5353,   922,  1680,  4162,  1623,  2719,  2893,  5183,   633,
    1457,  4083,  4084,   633,   633,  5215, -2887,  2723,  5724,  1112,
    5186, -2887,  5963,  2820,  2819,  5190,  2730,  1624,  5192,   633,
    2818,    41,  3147,  3586, -1903,   896,  3153,  3154,  1473,  2708,
    1473,   818, -1903,  1233,  1409, -1903,  1438,  2883, -1903,  2820,
    2817,  2709,  5620,  1381,  5970,  5964,  3198,  5027,  3713,  2819,
   -2887,  3588,  3628,  4800,  2814, -2887,  4328,  5621,    45,  2710,
    6060,   799,  2522,  2523,  2524,  2525,  2526,  2527,  1625,  3138,
    4163,  1492,  5338,  5028,  2820,  3360,  3542,  3344,  2816,  2637,
    2814,  1459,  1192,  1194,  1196,  3218,  3587,  1198,  1199,  1200,
    2637,  5061,  3901,   896,  5624,  4872,  4329,  1205,  2818,  4645,
      49,  4646,  5625,  3721,  4164,  5985,  3902,   188,  1568,  1429,
    2588,  3543,  6169,    50,  3589,  2814,  6036,  1800,   842,  4165,
    1639,  2817,  3273,  1234,  1493,  2638,  4039,  2819,  3843,  1451,
    2816,  4330,  1056,  2817,   896,  4166,  2638,    51,  3722,  4801,
    1921,  3658,  1817,  5432,  3884,  4444,  5619,  3504,  5753,  4040,
    5755,  3544,  2820,  1826,  5759,  5760,  3455,   910,  1626,  1503,
    1640,  4360,  6060,  4167,  1503,  1681,  1113,   896,  2724,  1834,
     927,  4042,  4043,  4044,  4045,  4046,  4047,  4048,  4049,  4050,
    2027,  1013,  5879,  2884,  2732,  1430,  5610,  2885,  2639,  5870,
    5187,  3414,  5980,  2814,  2733,  3414,  6128,  3219,   854,   642,
    2036,  5971,   661,  1114, -2887,  1682,  2684,  2818,  4802, -1081,
    2684,   911,  4803,  6101,  1627,  3179,  4873,  5433,  1628,  2914,
    3714,  5986,  2711,  3345,  1180,  4041,  3139,   661,  3659,  6129,
    1494,   953,  4365,  2892,  1452,  5021,  2819,  1503,  2640,  4162,
    1683,  1503,  4370,   928,  5622,  4647,   633,   633,   633,  2640,
    5540,   643,  2070,  3494,  4407,  1431,  3545,  4168,  1432,  3140,
    3715,  2820,  3414,  4953,  1115,  3423,  1116,  1630,  4957,   663,
    1117,  5935,  1641,  3141,  3106,   773,  5626,   773,  1592,   773,
    6143,  3096,  3660,  1014,  4857,   773,  1202,  1203,  2818,  5018,
    4632,  4633,  2703,  1235,   663,  3716,   978,   978,  5322,  2641,
    2818,  1251,  2814,   646,  -609,  1921, -2887,  2817,  4366,  3142,
    2641,   936,  1795,  1632,  4754,  4163,  1620,  2819,  2522,  2523,
    2524,  2525,  2526,  2527,  3136,  6043,  6044,   815,  3136,  2819,
    3089,  2005,  5323,  1457,  1236,  1478,  1237,  1633,  3415,  4441,
    1015,  3415,  2820,  3661,  5342,  1457,   953,  5188,  6006,  4164,
    4980,  1458,  4163,  1593,  2820,  3424,  1621,  1635,   896,  2817,
    4858,  3136,  5180,  2734,  4165,  4885,  -463,  1488,  5537,   896,
     961,  4692,  1433,   920,   920,  1479,   920,   962,   963,   964,
    4166,  1796,  5987,  2814,  4755,   896,  4164,  5988,  3415,  5790,
    5672,  5804,  5538,  5343,  1531,  2814,  3415,  4800,   959,  1016,
    1500,  4739,  1501,  2735,   953,   195,  1385,  1489,  4167,  3445,
    1480,  1419,   953,  2723,  1459,  1954,  1258,  4166,   978,  4035,
     953,  5962,    41, -2887, -2887, -2887,  1459,   938,  4816,   195,
    4042,  4043,  4044,  4045,  4046,  4047,  4048,  4049,  4050,   896,
    5255,  4974,  1490,   674,  5955,   675,  3677,  5260,   633,   196,
    4832,   633,  5811,  1856,   896,  5234,  3662,   896,   896,    45,
    5673,   633,   633,  1460,   953,   953,   960,  5458,   674,  3725,
     675,  1852,  6021,   196,  2818,  1460,   633,   773,   953,   633,
    4861,  1496,  1386,  4801,  1434,  4833,  6147,  -463,   896,   896,
    2078,   953,   953,  2079,  1244,  3495,   679,  2080,  2081,  2082,
    3650,    49,  4168,  2819,  1856,  5652,  4582,  3379,  3567,  3615,
    2952,  1962,   192,  4975,  1964,  2580,  1966,    36,  1968,  5889,
    1970,  2562,  3414,  3414,  1974,  2581,  2818,  5235,  2820,   633,
    4779,  4310,  2582,   633,   633,  3639,  6112,  1801,   642,  4168,
    1802,  3227,  3184,  4311,  5409,  4587,  3917,   773,  2863,  3508,
    2953,  1954,  4802,  4583,  4441,  2819,  4803,    57,  2583,   192,
    3173,  1062,  1058,  4599,  2563,  5824,  1061,  3720,   633,  2814,
     633,  5939,  1059,  2883,  4834,   633,   633,  1003,  1607,  1060,
    2820,  3663,   633,   633,   633,   633,   633,   633,   633,  3664,
     912,   633,  3665,   633,  5890,   633,   633,   633,   633,   633,
     633,  4445,  3676,   633,  5956,   633,   633,  2684,  3128,   633,
    3129,  4234,  3130,  5825,  3131,  1012,  3132,  2684,  4611,  2893,
    3133,  2814,  5938,   896,   633,   633,   633,  3756,  3757,  3758,
    5340,  2806,  4267,  4631,  3639, -1727,  1420,  1421,  6177,  2806,
    3701, -1727,   633,  3726,  1796,  3653,  4079,  4620,  4448,  3843,
   -1106,  2864,  5704,  4624,  1124,  1422,  2867,  4183,  3188,  1020,
    5641,  5351,  3651,  3564,  3652,  5782,   997,  2807,  3678,  5364,
    5490,  1648,  5492,  2584,  3746,  2807,  3681,  5705,  2585,  3684,
    3723,  1610,  3911,  3847,  3848,  3849,  3850,  4569,  3852,  3021,
    4623,  3985,  1483,  2837,  4627,  4628,  2592,   998,  2684,  -173,
    3800,  2586,  2269,  4041,  5815,  1611,  3762,  4450,  1103,  3051,
    6051,    29,  4414,  3880,  6039,  3724, -1727,  1064,  2854,  2884,
    4780,  1645,  2587,  2885,  2794,  5756,  2795,  4781,  1484,  2941,
    5757, -2355,  1485,  2947,  4782,  -173,  1649,  1066,   661,  2079,
    4641,  4642,  4643,  4644,  5537,  1104,  4648,  4649,  4650,  4651,
    4652,  4653,  4654,  4655,  4656,  4657,    41,  3414,  1103,  5832,
    1876,  1646, -1079,  2327,  3414, -1727,  -173,  1486,  5538,  3414,
    4783,  2581,  3414,  5330,  1610,  5332,  4722,  2588,  1650,  2789,
    2589,  1105,  5758,  1071,  1877,  1651,   633,    29,  1652,  2796,
    2797,  1954,  4784,    45,  4369,  1104,  1647,  5313,  1611,  5314,
    5315,  5316,  4323,  5794,  2583,   663,   792,  4971,    41,  5326,
     234,  6104,  4698,  4699,  4453,  2847,   647,  -150,  1085,  3692,
    1948,  3693,  3986,  3376,   739,  3697,  4215,  3987,  5761,  1106,
    4922,  4487,  2871,   633,  4972,    49,  1021,   793,  6114,  4406,
    1022,   794,  4324,   816,  1949,    45,  4793,  3377,    50,  1960,
    2078,  1610,  1802,  2079,  4923,  1669,  6004,  3955,  4454,   665,
    4793,  1099,   967,   968,   969,   970,   971,   972,   973,   974,
     975,  2590,    51,  3873,  4455,  1611,  2954,  4325,  5537,  1106,
     188,  1126,  5645,  6130,    41,  2581,   633,    49,  5727,  2955,
    2825,    57, -2887,  5731,  5732,  1670,   756,  -608,   773,  1671,
      50,  1107,  5538,   773,   773,  4517,  5646,  6131, -2887, -2887,
   -2887,  4045,  4046,  4047,  4048,  4049,  4050,  2975,  2583,  2956,
    2826,    45,  3835,  6215,    51,  6218,   756,   188,  2986, -2328,
    1672,  2598,  1420,  1421,  1021,  4188,  1209,  3944,  1022,  1108,
    2605,   756,  2606,  6052,  3004,  6229,  2609,  1600,  1415,  1416,
     771,  1424,  1617,  2615,  6008,  6009,   771,  1653,  2010,  4554,
    3226,  1802,  4222,    49,  4555,  6197,  5869,  1409,  1109,  2617,
    5055,  4069,  1130,  2518,  4456,  4555,    50,  4076,  3274,   674,
    1137,   675,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,  2578, -1106,  1654,  1802,  1146, -2329,  1655,  3078,  4012,
      51,  1021,  1147,  1209,   678,  1022,  1021,  1852, -2336,  4061,
    1022,  4063,  4064,  3090,  1153,  2073,  1136,  3094,  4793,    57,
   -1418,  1171, -1418,  2591,  1623,  1164,  2592,  2625,  4133,  1076,
    1802,  1077,  1656, -2887,  1258,  2963,  2964,  4035, -2887,  1657,
    1181,  4036,  4037,  4038,  3414,   773,  1624,  3113,  1136,  4776,
    3124,  1491,   642,  2592,  1409,   773,  2617,  3135,   756,  4685,
    3136,  3943,  1208,   633,   633,   633,   633,   633,   633,   633,
     633,   633,  3658,   633,  1213,  3137,  6091,  3176,  3136,  1209,
    3177,  5180, -2887,  1080,   633,  1081,   633,  1220,  3534,  3308,
    3309,  3310,  3311,  3375,  1217,  3818,  1954,  1625,  3415,  1202,
    1203,  3380,  3415,  3466,  2592,  3531,  2592,  3535,  3536,  1258,
    3561,   978,  4035,  3562,  3442,  3443,  4036,  4037,  4038,  3633,
    3796,  1228,  3634,  3797,   633,  1230,  3935,  3281,   633,  3136,
    3284,   633,  4375,   633,  4686,  3372,   633,  2588,  1492,  1409,
     633,  1438,   773,  4144,  4145,   773,   773,  3984,  3993,  1242,
    2592,  2592,  4970,  3999,  2570,  4000,  2592,  5547,  2592,  3659,
    1241,  1796,  3528,   633,  6139,  4034,  1243,  3302,  4014,  3415,
    4257,  3755,  4135,  1420,  1421,  4021,  5088,  4062,  2592,  2026,
     633,    57,  3289,  4054,  4217,  1244,  2592,  1626,  5816,   633,
     633,  1493,  5095,  1231,  4068,  3563,  4286,  2592,  4073,  1258,
    4142,  4074,  4035,  2592,  1246,  4178,  4036,  4037,  4038,     3,
       4,  4303,  4086,  3660,  4304,  1245,   953,  4308,  3457,  4334,
    4309,  3414,  4335,   896,  4844,  1252,  1800,   896,   896,  4403,
    4526, -2887,  4335,  4527,   953,  3498,  1254,  3501,   953,  2618,
    1380,  3414,   953,  1627,  1409,  4040,  2617,  1628,  4106,  4503,
    4529,   953,  1383,  4530,  4560,  3414,  4119,  4561,  4666,  1387,
    5023,  4667,  2892,  4677,  6083,  4688,  4678,  3819,  2592,   953,
    5117,  3084,   633,  3085,  3661,  4260,  5120,  5121,  4102,  4764,
    4103,  3657,  4765,   633,  4770,   896,   633,  4771,   633,   633,
    5712,   896,  3393,  3395,  3396,  4441,  1630,  1494,  5717,  5718,
    1388,  4775,  5024,   953,  3481,  3136,  1389,  5090,  5125,  3549,
    2002,  2592,  5164,  1124,  5218,  2592,  4835,  3481,  4841,  5224,
    4040,  4041,  5225,   953,   953,  1393,  6002,  5231,  4824,  3412,
    3136,  5232,   896, -2887,  3136,  5233,  4793,   773,  3136,  1397,
    5366,  5403,  1632,  5367,  4561,  2522,  2523,  2524,  2525,  2526,
    2527,  4318,  4598,  4815,  1796,   953,  2684,  5424,  1796,  1495,
    5425,  3743,  5585, -1751, -1751,  5426,  1633,  1496,  2592,  5445,
    1402,  5455,  5446,  4490,  1954,  5461, -1755, -1755,  4500,  4223,
    4224,  4124,   953,  4125,  1796,  1403,  1635,  3662,   953,  1412,
    5463,  5580,  4462,  4500,  5581,  1497,  4041,  5600,  2078,  1498,
    3136,  2079,   953,    36,  5634, -1754, -1754,  5635,  3648,   953,
    4040,  4860,   953,  3414,  4226,  5633,  5586,  6178,   953,  5587,
    5680,  5686,  1426,  5681,  1954,  5588,  4126,  1409,  4127,  3415,
    3415,  4244,  3820,  2581,  1499,  1405,  4433,  5945,   953,  4514,
   -2887,  4515,  5697,  4964,   953,  4965,  5689,  5700,  1413,  4500,
    5701,   953,  5746,  5589,  5786,  5747,  4343,  2549,  1455,  5813,
    5836,  4349,  5701,  4074,  1428,   953,  2583,  1500,  5837,  1501,
    1470,  2592,  5855,  1124,  6219,  5856,  3414, -1680,   953,  1443,
    3691,  5859,  3821,  1796,  1954,  5860,  4041,  1471,  2592,   953,
   -1680,  1258,  3002,  5128,  4035,  5129, -1680,  1444,  4036,  4037,
    4038,  1472,  6153,  5888,  6154,  3302,  3177,   633,   633,   633,
    1475,  5590,  3663,   633,  5894,  5895,  5157,  3177,  3177,  1502,
    3664,  5503,  5504,  3665,  5591,  4339,  4042,  4043,  4044,  4045,
    4046,  4047,  4048,  4049,  4050,  4697,  1443,  5592, -1668,  3405,
     633,   896,  4718,  5898,  4720, -1680,  2592,  4355,  5899,  1796,
    5041,  2592,  3211,  3212,  5900,  1481,  3977,  5901,  3979,  3980,
    5173,  1438,  5175,  3242,  3243,  1258,  4766,  1523,  4035,     3,
       4, -1680,  4036,  4037,  4038,  5364,  5927,  5981,  1552,  5928,
    4500, -2887,   633,  1555,   188,  5995, -2887,  4793,  2592,  5997,
    5158,  1549,  2592,  3287,  5034,  6003,  6018,  1595,  3136,  6019,
    3884,  4042,  4043,  4044,  4045,  4046,  4047,  4048,  4049,  4050,
   -2373,  3862,  6041,  3974,   896,  6042,  6082,  1554,   896,  5694,
   -1680,  5845,  5846,  6111,  4795,  4796,  5701,  1590,  4799, -1680,
   -2887,  4738,  1594,  4741,   741,  4480,  3414,  1596,  6149,  6172,
    1258,  6150,  2592,  4035,  2663,  1607,  2666,  4036,  4037,  4038,
    5867,  1609,  2623,  6191,    15,  6201,  5856,  6207,  6202,  6216,
    4765,  5441,  2592,  5442,  3415, -1680,  2684,  6228,  5976,  5977,
    6202,  3415,   905,   906,  1619,  1622,  3415,  5945, -1680,  3415,
    1644,  1660,  1661,  4793, -1680,  2588,  1677,  1687,   978,    20,
    1688,  4042,  4043,  4044,  4045,  4046,  4047,  4048,  4049,  4050,
    1691,  4473,  4040,  4476,   953,  1696,  1796,  1697,  4463,  1810,
    4465,  1812,  1814,  1819,  1830,  1825,   630,  1835,  1833,  1840,
    1843,   896,  1845,   953,  1837,  1854,  1859,  4592,  1701,  1862,
     953,  3414,  1860, -1680,   633,  5593,   896,   633,  5594,   633,
     633,   896,  -137,  1863,  5551,  1865,  1867,  1868,  3412,   633,
    1124,  1800,  1124,  1879,   633,   908,  1886,  1888,  1891, -1680,
    4494,  1895,  1904,   214,  1909,  1910,  4605,  4672,  1911,   896,
    1913,  1921, -1680,  3304,  1916,  3305,  4040,  1917,  4041, -2887,
    1920,  1928,  1932,  1934,  1957,  4793,  1935,  4844,  2623,  1937,
    5552,  1939,  4535,  4184, -1679,  1945,   633,   633,   633,  3306,
    1959,   633,   908,  1947,  1944,  1950,  1953, -1679, -1680,   633,
     633,   633,   633, -1679,  1956,  5553,  5207, -1680,  1976,  2007,
    1796,  2014,  2016,  2019,  2023,   633,  1796,  2024,   633, -1907,
     633,  5418,  3414,  5554,  1124, -1914,  2031,  5555,  2032,  2033,
    2034,   633,   633,  2035,  3530,   633,    57, -1904,  6049,  2037,
    3538, -2887,  4041, -1905,  2038,  2039,  4600,  4577,  2040,  5556,
    2041,  2042, -1679,  5557,  3307,  2043,   633,  2044,   633,  2045,
     633,  2046,  4836, -1908,  2047,  2049,  2050,  2051,  5558,  5250,
    2052, -2887,  2053,    33, -1906,  2054,    41,  2055, -1679,   633,
    2056,  3571,  2057,  2522,  2523,  2524,  2525,  2526,  2527,  2533,
     741,  4129,  4130,  4131,  2059,   908,  2060,  2061,   931,  2062,
     953,  3308,  3309,  3310,  3311,    41,  2063,   943,  3312,  3313,
      15,  2064,  2065,    45,  3314,   943,  2066,  4041,   943,  2535,
    2537,  2539,  2540,  2549,  2553,  2565,  2573, -1679,  2595,  2596,
    2601,  2603,  4638,  2604,  5068,   633, -1679,  2607,   633,  2619,
    2608,  3415,    45,  2610,  1458,    20,   908,  2626,  2611,  2612,
   -1680,   633,  4811,  2614,  2613,    49,   633,  1460,  2657,  2659,
    2669,  2672,  2671,  2673,  2618,  5559,  4665,   188,    50,  2674,
    2690,   633,  3414,  4042,  4043,  4044,  4045,  4046,  4047,  4048,
    4049,  4050,  2692,  2693,    49,   633,  2691,  2694,   742,  2695,
    2617,  5658,    51,   633,  3615,  2697,  4855,    50,   792,  2698,
    2699, -2886,  2706,  2696,  2731,   896,  2700,  4958,   896,  2725,
     896,    57,  2751,  2737,  2755,   896,  4945,  5560,  1021,  4706,
    3639,    51,  1022,  2758,  2762,  2757,  2775,  2759,  2780,  2761,
     953,   953,  6176,  2779,  2781,  2793,   633,  2792,  2804,  2808,
     743,  2810,  2811,  2813,  3296,  2814,  2822,  4042,  4043,  4044,
    4045,  4046,  4047,  4048,  4049,  4050,  2812,   953,  2823,  2824,
     953,  2827,  3414,   896,  3315,  2828,  2829,  2848,  3414,  2862,
    2872,   896,  4950, -1680,  2879,  3316,  2834,  2838,  2886, -1679,
    2844,  2845,  2858,  2859,  2835,  2865, -1680,  2868,  1568,  2889,
    3794,  2869, -1680,  2915,  2874,  2875,   896,  2904,  2906, -2886,
    2887,  3412,  2908,  2894,  3412,  2895,  2900,  2901,  2913,  2907,
    2909,  2916,  2932,  5660,  4884,  3387,  3389,  2933,  3415,  2921,
    2922,  3397,  4042,  4043,  4044,  4045,  4046,  4047,  4048,  4049,
    4050,  2934,  1796,  1796,  1796,  2945,   914,  2974,  3415,    33,
    2969, -1680,  2977,  5679,  2976,  2990,  2978,  2979,  2962, -1728,
   -2886,  3412,  3415,  3440,  3440, -1728,  4184,   953,  2983,  3412,
    2984,  2991,  2985, -2886,  2070,  2987,   896, -1680,   896, -2886,
    3414,    41,  2988,  2989,  2940, -2886,   953,  4445,  2996,  2995,
    2997, -2886,  2998,  4446, -2886,  3006,  5386,  3005, -2886,  3009,
     656,  3022,  3033,  1641,  3014,  3037,  4447,  3038,   953,  3041,
    3050,  3057,  3053,  3066,   915,  3077,  3083,  3056,    45,  3070,
    3074,  2070,  3092,  3087,  2078,   773, -1680,  2079, -2886,  3102,
   -2886,  2080,  2081,  2082,  4448, -1680,  4449,  3099,  3101,  3103,
   -1728,  3104,  3117,  3160,  3149,  3302,  3186,  3174,  3210,  2580,
    3205,  3276,  3282,  2079, -2886,  3286,  3295,  3342,  3301,  2581,
      49,  4115,  3320,  3322,  3348,  3366,  2582,  3347,  3363,  3367,
    3368,  3381,   896,    50,  1433,  3382,  3383,  3369,  3398,  3384,
    3966,  3955,  3417,  3385,  3386,  3390,   915,  3434,  3399, -1728,
    3435,  3436,  2583,  4450,   953,  3976,  3422,    51,   916,   633,
    3981,  3451,  3437, -2886,  3458,   633, -2886,  3459,  3470,  3573,
    3471,  3473, -2886,  3490,   896,  3502,    57,  3499,  3504,  3506,
    3415,  4149,  4451,  3507,  4154,  3513,  3529,  4092,  4001,  4093,
    3537,  3518,  3558,  3523,  3524,  3526,  1377,  3553,  1381,  2623,
    3577,  1796,   896,  3570,  3560,  3590,  3595,   953,  3596,   953,
    3616,  3622,  3623,  4094,  3629,  3632,  3640,  4996,  4997,  3624,
    3647,  3649,   953,  3650,   953,  3670,  5085,  3671,  3687,  3750,
   -2886,  3405,  1856,  3729,  3742,   907,  3751,   916, -1680,  3405,
    3763,  3754,  3770,  3415,   633,  3776,  3782,  3798,  3787,  3809,
    5347,  3777,  3810,  3824,  3828,  4452,  3830,  3778,   773,  3838,
    4453,  3851,  3826,  3845,  3856,  3858,   773,  2584,  3857,   773,
     896,   931,  2585,  5150,  3859,  3860,  3864,  3869,  3307,  3867,
     943,   773,  3871,  3297,  3872,  3875,  4520,   943,  3876,  3881,
     943,   953,   896,  3896,  4524,  2586,  2269,  3897,  5198,  3898,
    3908,   917,  3906,  3910,  4454,  3907,  1021,  3912,  3926,  1443,
    1022,  3928,  5034,  3929,   896, -2886,  2587,  2650,  3934,  3942,
    4455,  3932,  4557,  3937,  3956,  3308,  3309,  3310,  3311,  3938,
    1954,  3939,  4095,   953,  3940,  3941,  3952,  1951,  4096, -2886,
    3947, -2886, -2886,  3957,  3958,  3965,  1918,  5080,  5081,  5082,
    5083,  5084,   953,  3946,  3968,  3970,   953,  2327,  3978,  1215,
    3995,  3998,  4002, -2886,  3996,  3997,  4010,  4005,  4015,  4022,
    4031,  2588,  4013,  4023,  4704,  1218,  5205,   953,  4027,  3755,
    4029,  4030,  4053, -2189,  4058,  4067, -2886,  4059, -2886, -2886,
    4070,  2592,  4066,   633,  4081,  4082,   896,  5715,  4087,  4113,
    4114,  4101,   633,  3415,  4116,  4118,  4120,  4140,  4141,  4152,
    4148,  5320,   633,  4153,  4176,  4180,   633,   633,  4186,  4193,
    4456,  4161,   633,  4146,  4195,  4197,  4199,  4147,  4220,  4206,
     633,  4232,   633,  4227,  4225,   633,  4228,  4214,  5136,   896,
     633,   633,   633,   633,  4236,  4233,   633,   633,   633,   633,
     633,   633,   633,   633,   633,   633,  4237,  4239,  4241,   633,
     633,   633,  4253,  4254,   896,  2590,  4264,  4265,  2078,   633,
    4266,  2079,  4270,  4271,   633,   908,  1796,  4272,   633,  4277,
    4288,  4289,  4273,  4291,  5259,  4297,   633,  4298,  4097,   633,
    4299,   633,  4245,  4307,  4322,  4313,  4336,  4340,  3415,  4098,
    4248,  4342,  4344,  2581,  4346,  4356,  4338,  4350,  4351,   633,
   -2887,  4357,   633,   633,  4354,  4383,  4358,   633,   633,  4359,
    4361,  4378,   633,  4379,   633,  4376,  4377,   773,  4380,  1623,
    4386,  4381,  4711,  4712,  4713,  4714,  2583,  4388,  4184,  4390,
    5202,  4392,  4397,  4382,  4399,   951,  4395,  4384,  2930,  6076,
    6077,  1624,  4385,   192,   987,  1062,  1058,   633,  4387,  4429,
    1061,  4411,  4412,  5248,  4184,   633,  1059,  2518,  1009,   633,
    4413,  4389,  4391,  1060,  4401,  4402,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,  4415,  4408,  4418,  4423,  4472,
    4466,  4478,  4481,  4482,  4431,  4331,  4471,  4333,  4485,  3415,
    4489,   633,  1625,  4502,   931,  4700,  4518,  4499,  4500,  4512,
     943,  4519,  4522,  4509,   943,  4523,   943,  4539,   633,  4556,
    4553,  4525,  4559,  4563,   896,  4571,  4565,  4572,  4578,  4573,
    2078,  5386,  4574,  2079,  4575,  4593,   633,  2080,  2081,  2082,
    4576,  4601,  4594,  4602,  4595,  4603,  4619,  5331,  4604,  4606,
    4607, -2887,   188,  5291,  4614,  2580, -2887,   953,  4608,  4609,
    4610,  2026,  4625,  3225,  4035,  2581,  4621,  4622,  4639,  4838,
    4629,  4630,  2582,  4679,  4662, -2188,  4663,  4664,  4671,  4690,
    1890,  4691,  1892,  1893,  4693,  4694,  4707,  4696,   188,  4723,
    4719,  4394,  1626,  4721,  5298,  5299,  5440,  5301,  2583,  4727,
   -2887,  4730,  4732,  4734,  4735,  4742,  4743,  4748,  1796,  4747,
    4750,  4749,  4752,  1796,   896,  1796,  4761,  4758,  4767,  2893,
    4763,  4778,  4786,  4807,  4808,  4809,  4810,  4817,  4818,  5478,
    4820,  3412,  4823,  4416,  4821,  3412,  4827,  4830,  4831,  1796,
     896,  4850,  4136,  4847,   773,  4862,  4864,  4863,  1627,  3415,
    5349,  4866,  1628,  4184,  4865,  2588,  4876,  4878,  4879,  4877,
    4143,  4890,  4880,  4881,  4892,  4893,  4910,  2892,  4911,  4916,
    4919,  4899,  4935,  4936,  4837,  4938,  4952,  4941,  4954,  4955,
    4956,  4978,  4993,  5007,  4951,   953,  2078,  4901,   953,  2079,
    4967,  5013,  4988,  4999,  5014,  5019,  5026,  5042,  4909,  5020,
    5036,  1630,  3412,  5043,  5053,  5059,  5064,  4189,  4189,  5060,
    5066,  5063,  5062,  2584,  5067,  5078,  5072,  5086,  2585,  3161,
    5092,  2581,  5093,  5109,  5110,  5102,  5113,  5112, -2887,  3571,
    5114,  5118,  5119,  5127,  5115,  5122,  5133,  5139, -2190,  3415,
    5144,  2586,  2269,  5154,  5155,  3415,  5740,  1632,  5742, -2887,
    5142,  5148,   633,  5167,  2583,  5143,  5163,  5177,  5191,  5181,
    5184,  5195,  2587,  5200,  5204,  5203,  5214,  5221,  5217,  5219,
    5227,  1633,  5550,  4558,  5226,  5236,  5256,  5258,   953,   953,
    5257,  5261,   896,  5266,  5267,  5268,  5289,  5287,  5280,   953,
    5293,  1635,  5294,  5302,  2070,  5283,   633,   633,  5303,  3234,
    3234,  5310,  5311,  2327,  5312,  5317,   953,  5321,  5324,  3256,
    5328,  5329,  5336,  5339,  5344,  5345,  5348,  2588,  3277,  5346,
    2589,   188,  5352,  4701,  5354,  5850,  5358,  5368,  5370,   896,
    5363,  5374,  5045,  5375,   896,   633,   633,  5379,  5381,  5377,
    5382,  3405,  5392,  5398,  3136,  3405,   633,  3415,  5383,  5408,
    5400, -2887,  5407,  5419,  5597,  4615,  5750,  5413,  5414,  5454,
    5415,  5423,  5876,  2522,  2523,  2524,  2525,  2526,  2527, -2887,
    5454,  5430,  5429,  5439, -2887,  5431,  5443,  5447,  5453,  5457,
     978,  5482,  5491,  5460,  5485,  5479,  5494,   953,  5502,  5505,
    1796,  5506,  5510,  5511,  5512,  5517,  5523,  5524,  4640,  1079,
   -2659,  1556,  5543,  5565,  4977,  1079,  5573,  1557,  5911,  5913,
    5515,  2590,  5528,  5571,  5498,  5583,   633,  1079, -2887,  5584,
    5534,  5535,  1662,  4661,  5536,  5576,  5579,  5604,  5603,   633,
    5608,  5613,  5615,  5631,  5644,  5650,  5636,  5665,  5642,  5666,
    5674,  5643,  5678,   633,  5690,  5694,  5696,  5692,  5698,  5486,
    5711,  5720,  1559,  5695,  5713,  5721,  5728,  5722,  5734,  5765,
    5770,  5774,  3412,  3412,  5778,  5780,  5520,  5767,  5788,  5793,
    5802,   633,  5806,  2588,   633,  5807,  5808,  5810,  5809,  5819,
    5820,  5821,   633,   633,  5827,   896,  5822,  5831,  5847,   633,
     633,  5829,  5838,  5848,   633,  5849,  5871,  5852, -2659,  5862,
    4121,   633,  5872,  5874,   633,   633,  1663,  5875,  1560,  5887,
    5891,   633,  5910,  2518,  5916,  1561,  5919,  5922,  1562,  5924,
    5926,  5930,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,   633,  5933,  5934,  5950,  3285,  5951,  5953,   633,  5952,
    5960,  5966,  5961,   633,  5967,  1563,   633,   633,  5974, -2659,
    5969,  5978,  5979,  5984,   633,  5905,  5991,  5993,  6000,  6013,
    5920,  6020, -2659,  6015,  6005,   633,  6022, -2887, -2659,  6031,
    5921,  6030,  5220,   633, -2659,  6048,   773,  5206,  5208,  6032,
   -2659,  1564,  6050, -2659,  6067,  6078,  6081, -2659,  6095,  6089,
   -2661,  6097,  6127,   633,  6115,  6121,  5662,  5917,  5752,  4477,
    6122,  6126,  6132,  6134,  6135,  6155,  6156,  6166,  6157,  6179,
    5667,   896,  6181,  6182,  4212,  6190,  6194, -2659,  6199,  6192,
    6200,  6210,  6211,  6214,   953,  6169,  6205,  6220,  5638,  6072,
    6073,  5688,  5687,  6223,  2572,  1445,  1553,  5854,  2072,  4138,
    3702,  6227,  2946, -2659,  3621,  4283,  4853,  6016,  4846,  3741,
    3789,   896,  1664,  4428,  5562,  5904,  1566,  6096,  5614,  4995,
    4842,  4843,  5327,  5596,  4230,  3936,  1567,  5254,   953, -2887,
    6007,  5496,  3405,   896,  6092,  1568,  5925,  5262,  5923,  6029,
     953,  2522,  2523,  2524,  2525,  2526,  2527,  1569, -2661,  6107,
    4235,  5356, -2659,  5046,  5017, -2659,   633,  3412,   188,  5885,
    5025, -2659,  5550,   633,  3412,  5735,  5736,  4987,  3807,  3412,
    3808,  4301,  3412,  4851,   953,  4488,  5012,  5350,  5744,  5602,
    4528,  5070,  5823,  6152,  6226,  1643,  6212,  1665,  5577,  4434,
    1571,  1572,  5054,  6034,  5522,  5730,  5893,   737,  5525, -2661,
     790,  5087,  3013,  5739,  1054,   896,  5707,  5089,  4579,  3076,
    6148,  3836, -2661,  5056,  3476,  1999,   773,  1124, -2661, -2659,
    4221,  3088,  1666,  3072, -2661,  4545,  5639,  5817,  4398,  3739,
   -2661,   633,  1125, -2661,  4882,  4345,  1165, -2661,  3105,  6054,
    6180,  1390,  3766,  5074,  5881,  2971,  2705,   633,  3421,  5073,
    6195,  4772,  1796,  5209,  5706,  6001,  2593,   821,   822,  4182,
    2654,  4194,  2545,  3431,  5996,  5864,  4156, -2661,  5116,  2653,
    4725,   953,  4740,  5459,  4150,  2658,   788,  5677,   633,  5676,
    4773,  4151,  6163,  5983,  6079,  5905,  5853,  2602,  5661,  4673,
    3343,  1574,  5865, -2661,  4117,  5866,  3262,  3346,  4111,  3990,
    5361,  4998,  3765,  4109, -2659,  4100,  4020,  4626,     0,  3358,
       0,  1441,     0,  3419,   978,     0,     0,     0,     0,     0,
       0,  5861,     0,  5863,   896,     0,   896,     0, -2659,  1556,
   -2659, -2659,     0,     0,   931,  1557,     0,   931,     0,     0,
       0,     0, -2661,  5521,     0, -2661,     0,   943,   943,     0,
       0, -2661, -2659,  3433,  4184,  2078,     0,   953,  2079,     0,
    5519,  5878,   943,     0,     0,   943,   978,     0,     0,     0,
       0,     0, -2659,     0,  3405, -2659, -2659, -2659,     0,  3405,
    1559,     0,  3405,     0,     0,     0,     0,     0,   633,     0,
    2581,   633,     0,     0,   633,   633,   633, -2887,     0,     0,
       0,     0,     0,   188,   188,  5564,     0,     0,     0, -2661,
       0,     0,     0,     0,     0,   943,  1124,     0,     0,   943,
     943,   633,   633,  2583,     0,   633,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1560,     0,     0,     0,
       0,     0,  6203,  1561,  3412,   633,  1562,     0,     0,     0,
       0,   633,     0,     0,     0,   633,     0,     0,     0,     0,
       0,   896,   633,     0,     0,     0,   788,     0,     0,     0,
       0,     0,     0,  1563,     0,   633,     0,     0,   633,     0,
       0,     0,     0,   953,  1915,   953,     0,     0,     0,   633,
    1919,     0,  5161,     0, -2661,     0,     0,     0,     0,     0,
    1930,     0,     0,     0,  1933,     0,     0,     0,  1936,  1564,
    1938,     0,     0,     0,     0,     0,  1946,     0, -2661,     0,
   -2661, -2661,  1952,     0,     0,  1955,     0,     0,     0,     0,
     896,   953,     0,     0,     0,     0,     0,     0, -2887,     0,
       0,   633, -2661, -2887,     0,     0,     0,     0,   773,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2661,     0,     0, -2661, -2661, -2661,  5739,     0,
    5480,     0,  6188,     0,   773,     0,     0,     0,     0,     0,
    1664,  1796,     0,     0,  1566,     0,   633, -2887,   773,     0,
       0,  6213,     0,     0,  1567,     0,     0,     0,     0,   773,
       0,     0,     0,  1568,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1569,     0,  6188,     0,     0,
       0,  3412,  5601,     0,     0,     0,  6141,  6142,     0,     0,
    5240,     0,     0,     0,     0,  6188,     0,     0,     0,     0,
       0,  3412,  2588,     0,     0,     0,     0,   633,     0,     0,
     896,     0,     0,  5627,     0,  3412,     0,     0,  1571,  1572,
    5629,     0,     0,     0,    72,   192,   188,   187,   181,   176,
    5263,     0,   185,    81,    84,  1202,  1203,    85,   182,    86,
      87,   107,   125,   633,   130,   184,  1124,   633,   908,   633,
    1573,     0,  5279,     0,     0,   160,   179,   186,     0,     0,
       0,     0,     0,   633,   631,     0,     0,     0,     0,     0,
     633,     0,     0,   633,     0,     0,     0,     0,     0,     0,
       0,   783,     0,   785,   633,     0,  6140,   791,     0,     0,
       0,   633,     0,   802,   810,   814, -2887,   817,     0,     0,
     810,   810,     0,   847,     0,   850,     0,     0,     0,     0,
       0,  1556,   904,   904,   904,     0,     0,  1557,     0,  1574,
       0,     0,     0,   773,  5307,     0,     0,     0,     0,     0,
       0,     0,  1558,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   896,     0,     0,     0,     0,   896,   896,     0,
       0,     0,   633,     0,     0,     0,     0,     0,   633,   633,
     953,   978,  1559,     0,     0,     0,  1526,     0,     0,     0,
       0,     0,     0,  3412,   953,     0,   773,     0,     0,     0,
       0,  2078,     0,     0,  2079,  6206,     0,     0, -2887, -2887,
   -2887,  3405,     0,     0,   633,     0,     0,     0, -2887,     0,
       0,  1527,   633,     0,     0,  1796,     0,     0,     0,     0,
    2522,  2523,  2524,  2525,  2526,  2527,  2581,     0,  1560,     0,
       0,     0,     0,  2582,     0,  1561,     0,     0,  1562,     0,
     633,     0,     0,     0,     0,     0,  3412,     0,     0,     0,
       0,     0,  5796,     0,  2944,  5391,     0,     0,     0,  2583,
       0,     0,     0,     0,     0,  1563,   631,   933,   933,   896,
     896,   933,  1528,     0,     0,   944,     0,   847,     0,     0,
     980,     0,     0,   944,     0,     0,   944,     0,     0,   847,
       0,   933,     0,   633,   847,     0,     0,     0,   933,     0,
     847,  1564,   633,   633,   633,     0,     0,     0,     0,  1529,
       0,     0,     0,     0,     0,   633,  1796,     0,     0,   896,
       0,     0,     0,     0,   633,     0,   633,     0,   633,     0,
       0,     0,     0,     0,     0,   633,     0,     0,     0,  3256,
    3256,  6012,  5868,     0,  3256,     0,     0,     0,     0,     0,
       0,     0,  1530,     0,     0,     0,   633,     0,   188,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1565,     0,  2584,     0,  1566,     0,     0,  2585,
       0,  1796,     0,   953,  3256,  3256,  1567,     0,     0,   188,
    4394,     0,     0,     0,  1532,  1568,     0,     0,     0,     0,
       0,     0,     0,   188,     0,     0,  3412,  1569,     0,     0,
       0,     0,     0,  6061,  6062,     0,     0,     0,     0,   630,
       0,     0,     0,  2587,     0,     0,  1534,  3023,     0,     0,
       0,     0,     0,  1496,     0,  3040,   633,     0,   773,     0,
       0,     0,     0,  2944,   773,     0,     0,  1570,   773,     0,
    1571,  1572,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2677,     0,     0,     0,     0,     0,     0,     0,    36,
       0,  2771,     0,   633,  1536,  5277,  5278,  2070,  2588,     0,
    5281,  5282,  1573,  1537,     0,     0,   633,     0,  3098,     0,
       0,     0,  1538,     0,     0,     0,   633,     0,     0,     0,
    2772,  3412,     0,     0,     0,     0,   633,     0,     0,   953,
       0,     0,  1540,     0,     0,  2944,     0,     0,     0,     0,
       0,  1541,   633,     0,     0,  1542,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   953,     0,     0,     0,   931,
       0,     0,   943,     0,   943,   943,     0,     0,     0,     0,
       0,  1574,     0,     0,     0,     0,     0,     0,     0, -2677,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2590,     0,     0,     0,   633,     0,  6035,     0,
    1543,     0,     0,     0,  1623,     0,   633,     0,     0,     0,
       0,     0,     0,     0,   633,   633,     0,     0,     0,     0,
     633,   192,  3412,  6059,  6056,     0,  1624,     0,     0,     0,
   -2677,     0,     0,     0,  6057,     0,  3405,     0,   188,   633,
     633,  6058,     0, -2677,     0,     0,     0,     0,     0, -2677,
       0,     0,  4827,     0,     0, -2677,     0,     0,     0,     0,
       0, -2677,  3100,  6120, -2677,     0,     0,     0, -2677,     0,
    3107,     0,     0,   953,     0,     0,     0,  1625,  4837,     0,
       0,     0,     0,  6221,  6222,  2728,     0,     0,     0,     0,
       0,     0,     0,     0,  2518,     0,   633,     0, -2677,     0,
       0,     0,   633, -2887, -2887, -2887,  2522,  2523,  2524,  2525,
    2526,  2527,     0,     0,   192,     0,  6059,  6056,     0,     0,
     633,   633,     0,     0, -2677,     0,     0,  6057,   188,     0,
       0,  2005,  1033,     0,  6058,   633,  2005,  2005,   847,     0,
     933,     0,   933,     0,  4838,   933,     0,     0,     0,   633,
       0,     0,   980,     0,     0,     0,     0,  1091,     0,   933,
       0,     0,     0,     0,     0,   933,     0,  1626,     0,     0,
       0,     0,  3412, -2677,     0,     0, -2677,     0,     0,     0,
       0,     0, -2677,     0,   633,     0,     0,     0,     0,   631,
       0,     0,     0,     0,     0,     0,     0,     0,   944,     0,
       0,     0,   980,     0,   633,   944,     0,     0,   944,     0,
       0,  1796,     0,     0,     0,     0,   192,     0,  6059,  6056,
       0,     0,     0,  1627,   933,     0,     0,  1628,     0,  6057,
       0,     0,     0,     0,     0,     0,  6058,     0,     0,     0,
   -2677,     0,  2892,   633,   633,     0,  4839,     0,   633,  5818,
       0,     0,   633,     0,     0,     0,  1796,     0,   630,     0,
       0,     0,  3412,     0,   633,   633,     0,     0,  3412,     0,
       0,     0,     0,     0,  1796,     0,  1630,   847,     0,     0,
     810,   810,   810,     0,     0,     0,     0,     0,     0,  1240,
       0,     0,     0,     0,   773,     0,     0,   788,  5858,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1362,
    1362,     0,   847,   810,     0,     0,     0,   810,     0,     0,
       0,     0,  1632,     0,     0, -2677,     0,     0,     0,     0,
       0,   847,     0,     0,     0,     0,   847,     0,     0,     0,
       0,     0,  1362,     0,     0,     0,  1633,     0,     0, -2677,
       0, -2677, -2677,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   188,     0,  1635,     0,  4840,     0,
    3412,  4273,     0, -2677,     0,     0,     0,  2078,     0,     0,
    2079,     0,     0,     0,  2080,  2081,  2082,  1362,     0,   188,
       0,     0,     0, -2677,     0,     0, -2677, -2677, -2677,     0,
       0,   847,  2580,     0,     0,     0,     0,     0,     0,     0,
     931,     0,  2581,   943,   847,   943,   943,     0,     0,  2582,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   847,
       0,  2078,     0,     0,  2079,     0,     0,     0,  2080,  2081,
    2082,     0,     0,     0,     0,  2583,     0,     0,   847,     0,
       0,     0,     0,   933,   933,     0,  2580,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2581,     0,     0,     0,
       0,     0,     0,  2582,     0,     0,     0,     0,     0,     0,
    2814,     0,  6119,     0,     0,   810,   810,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2583,
       0,     0,     0,     0,     0,     0,     0,     0,  1362,  1362,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   631,     0,   933,  3234,     0,     0,   944,     0,
       0,   980,   944,     0,   944,     0,     0,     0,     0,   933,
       0,     0,     0,  3256,  3256,  3256,  3256,     0,     0,  3256,
    3256,  3256,  3256,  3256,  3256,  3256,  3256,  3256,  3256,     0,
    2584,     0,     0,   847,     0,  2585,     0,     0,     0,     0,
     933,   933,     0,     0,     0,     0,     0,  4669,   773,     0,
       0,     0,     0,     0,   188,     0,     0,     0,  2586,  2269,
       0,     0,   847,   847,   847,     0,   933,     0,   631,     0,
     631,   631,     0,     0,     0,     0,     0,     0,     0,  2587,
       0,     0,     0,     0,  2584,  3256,  3256,     0,     0,  2585,
       0,   630,     0,     0,   630,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   933,     0,   933,   933,     0,     0,
       0,     0,  2586,  2269,     0,     0,     0,     0,     0,     0,
    2327,     0,     0,     0,     0,     0,     0,     0,     0,  3467,
    4729,     0,     0,  2587,  2588,     0,     0,  2589,     0,  1362,
       0,   630,     0,     0,     0,     0,     0,  3483,     0,   630,
       0,  3486,     0,     0,     0,  3489,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1979,     0,  1979,     0,     0,
       0,   847,     0,   783,  2327,     0,     0,     0,     0,     0,
       0,     0,  3514,     0,     0,     0,  3370,     0,  2588,     0,
    1556,  2589,  2078,     0,     0,  2079,  1557,     0,     0,  2080,
    2081,  2082,  2015,  1623,   847,     0,     0,     0,  2021,     0,
       0,     0,     0,     0,     0,     0,  3556,  2580,     0,     0,
       0,     0,  1362,     0,     0,  1624,     0,  2581,  2590,     0,
       0,     0,     0,     0,  2582,     0,  1079,  5902,     0,     0,
       0,  1559,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2078,  1362,     0,  2079,
    2583,     0,     0,  2080,  2081,  2082,     0,     0,  3606,     0,
       0,     0,     0,     0,     0,     0,  1625,     0,     0,     0,
       0,  2580,  2590,     0,     0,     0,  1362,  1362,  1362,     0,
    1362,  2581,     0,     0,     0,  3635,     0,  1560,  2582,     0,
       0,  3644,     0,     0,  1561,     0,     0,  1562,     0,     0,
    1362,     0,     0,     0,     0,  3654,     0,     0,     0,     0,
       0,     0,  1079,     0,  2583,  3667,     0,     0,     0,     0,
    2518,  3672,     0,     0,  1563,     0,     0,     0,     0,  2519,
    2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,     0,   847,
       0,  3685,  4024,     0,     0,  4025,     0,  3688,     0,     0,
       0,     0,     0,     0,  3694,     0,  1626,  1362,     0,     0,
    1564,     0,     0,     0,     0,  2584,     0,     0,  3709,     0,
    2585,     0,     0,     0,  2518,     0,     0,     0,     0,     0,
       0,  3734,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,  1079,  2586,  2269,     0,     0,     0,     0,  4026,
       0,     0,     0,  1362,     0,     0,     0,  1362,  1362,     0,
       0,     0,  1627,     0,  2587,  3256,  1628,     0,   847,   847,
     847,  2668,     0,  1362,     0,     0,     0,     0,     0,  2584,
       0,  1629,     0,     0,  2585,  1566,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1567,     0,   810,     0,     0,
       0,     0,     0,     0,  1568,  2327,     0,  2586,  2269,     0,
       0,     0,     0,     0,     0,  1630,  1569,     0,     0,  2588,
       0,     0,  2589,     0,     0,     0,     0,     0,  2587,     0,
       0,     0,  2760,     0,     0,     0,     0,   810,     0,     0,
     933,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   847,  2788,     0,  1631,     0,     0,  1571,
    1572,  1632,   847,     0,     0,   933,     0,     0,     0,  2327,
       0,     0,     0,  2078,     0,     0,  2079,     0,     0,     0,
    2080,  2081,  2082,  2588,     0,  1633,  2589,     0,     0,     0,
       0,  1634,   980,     0,   847,     0,     0,   810,  2580,     0,
    2856,  2856,  3423,     0,  2856,  1635,     0,     0,  2581,     0,
       0,     0,     0,  2590,   810,  2582,     0,   847,     0,     0,
     847,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1556,     0,     0,     0,     0,     0,
    1557,  2583,   933,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1662,     0,  3951,     0,   847,
    1574,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   933,   933,   933,   933,   847,  3967,  2590,     0,     0,
       0,     0,     0,  3951,     0,  1559,     0,  5141,     0,   847,
       0,     0,  3424,     0,     0,  6186,     0,     0,     0,     0,
    1362,  1362,  1362,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2518,     0,     0,     0,     0,
       0,     0,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,     0,     0,  2968,     0,  3909,     0,  1663,
    6186,  1560,  3915,     0,  3916,     0,     0,     0,  1561,     0,
       0,  1562,     0,     0,  3922,     0,  2584,  3923,  6186,  3924,
    3925,  2585,     0,  3927,     0,     0,     0,  3930,     0,  3931,
       0,     0,  3933,     0,     0,     0,     0,     0,  1563,  2518,
       0,     0,     0,     0,  2586,  2269,     0,     0,  2519,  2520,
    2521,  2522,  2523,  2524,  2525,  2526,  2527,     0,     0,   847,
       0,     0,     0,     0,  4077,  2587,     0,     0,     0,     0,
     847,     0,     0,     0,  1564,     0,     0,     0,   933,   933,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   933,     0,  3972,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2327,     0,     0,     0,
       0,     0,   847,  2856,     0,     0,     0,     0,     0,     0,
    2588,     0,     0,  2589,     0,     0,     0,     0,   933,   933,
     933,   933,     0,     0,     0,     0,     0,   847,   700,     0,
       0,     0,     0,  1034,   847,  1664,     0,  3069,     0,  1566,
       0,   630,     0,     0,     0,   630,     0,     0,     0,  1567,
       0,     0,   631,     0,     0,   631,     0,     0,  1568,     0,
       0,     0,     0,     0,     0,   944,   944,     0,     0,     0,
    1569,  1035,     0,     0,     0,     0,   980,   980,     0,     0,
     944,     0,     0,   944,   703,  1036,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1037,     0,   933,   933,
     704,     0,     0,     0,  2590,   933,     0,   847,     0,     0,
    3699,     0,   630,  1571,  1572,     0,     0,     0,  1038,     0,
       0,     0,     0,     0,  1979,     0,     0,     0,     0,     0,
       0,   933,     0,   944,     0,     0,  3152,   944,   944,     0,
     847,   847,  1039,   933,     0,  3700,     0,     0,     0,     0,
     847,     0,     0,   707,     0,     0,     0,   847,     0,     0,
     847,  3069,   708,     0,   783,  3425,     0,   783,  3189,     0,
    4242,     0,  1362,     0,  1362,   709,     0,     0,     0,  1362,
    1362,  1040,     0,     0,     0,     0,  1362,  1362,  1362,  1362,
    1362,  1362,  1362,     0,     0,  1362,     0,  1362,   980,  1362,
    1362,  1362,  1362,  1362,  1362,     0,  2518,  1362,  1041,  1362,
    1362,     0,     0,  1362,  1574,  2519,  2520,  2521,  2522,  2523,
    2524,  2525,  2526,  2527,     0,     0,     0,     0,  1362,  1362,
    1362,     0,     0,     0,     0,     0,     0,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,  1362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   713,     0,     0,     0,     0,     0,     0,     0,     0,
    4314,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   933,     0,     0,     0,
       0,     0,     0,     0,  3256,     0,     0,     0,     0,     0,
       0,     0,  1043,     0,     0,     0,     0,     0,     0,     0,
       0,  4240,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   716,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   214,  1044,     0,
       0,   718,     0,     0,     0,     0,     0,     0,  3256,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1045,     0,
       0,  1046,   630,   630,     0,   721,     0,     0,   722,     0,
       0,     0,  4290,     0,  4292,   723,     0,     0,   724,     0,
    1362,     0,     0,     0,     0,     0,     0,  4409,     0,     0,
    -136,     0,     0,     0,     0,     0,     0,   725,     0,   651,
       0,     0,     0,     0,  1047,     0,     0,     0,     0,     0,
       1,   727,     0,     0,  1048,     0,     0,   652,   729,     0,
       0,     2,     0,     3,     4,     0,  1049,  1362,   731,     0,
       0,     0,     0,  1050,     0,     0,     0,     0,     0,     0,
       0,     5,   653,     0,     0,     0,     0,     0,     0,     0,
       0,     6,     0,     0,     0,   654,     0,     0,     0,   734,
       0,     0,     0,     7,     0,     8,     9,     0,     0,     0,
       0,  -873,    10,     0,    11,     0,     0,     0,     0,     0,
    1362,     0,     0,     0,     0,     0,    12,     0,    13,   655,
       0,     0,     0,     0,     0,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    14,     0,     0,    15,     0,
       0,     0,     0,   657,     0,     0,  4393,     0,     0,     0,
       0,     0,  4400,    16,   658,    17,     0,     0,     0,    18,
       0,     0,     0,   659,     0,    19,     0,     0,     0,     0,
       0,     0,     0,    20,     0,    21,   660,     0,     0,     0,
       0,     0,    22,     0,     0,   661,     0,     0,     0,   662,
       0,     0,     0,     0,     0,     0,  2944,     0,     0,     0,
      23,  3886,     0,     0,     0,     0,  3256,     0,     0, -1079,
       0,     0,     0,     0,     0,  4581,     0,    24,     0,  4585,
       0,     0,     0,     0,     0,  1526,     0,   630,     0,     0,
       0,     0,     0,     0,   630,     0,  3256,     0,     0,   630,
       0,     0,   630,  5193,     0,     0,     0,     0,     0,     0,
       0,     0,   663,     0,     0,     0,     0,     0,     0,     0,
    1527,     0,  -609,     0,    25,    26,     0,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,  1362,  1362,  1362,
    1362,  1362,  1362,  1362,  1362,  1362,     0,  1362,     0,     0,
       0,     0,    29,   664,     0,     0,   665,   847,  1362,     0,
    1362,     0,     0,     0,     0,     0,     0,   847,     0,     0,
       0,  1528,     0,   699,     0,     0,     0,     0,   666,     0,
       0,     0,   787,     0,     0,     0,  4562,     0,  4564,    30,
    4566,     0,   667,     0,     0,     0,   847,    31,  1362,  -463,
       0,   933,  1362,     0,     0,  1362,     0,  1362,  1529,     0,
    1362,    32,     0,     0,  1362,     0,     0,    33,    34,   668,
      35,     0,     0,     0,     0,    36,     0,     0,     0,   669,
       0,    37,     0,     0,    38,     0,  -463,  3416,     0,   670,
       0,    39,     0,   847,   847,     0,  3887,     0,    40,    41,
       0,  1530,     0,     0,  1362,     0,    42,     0,   671,     0,
      43,     0,     0,  1362,  1362,   672,     0,     0,     0,     0,
      44,     0,  -463,     0,     0,   673,   674,   847,   675,   676,
       0,     0,     0,     0,     0,  3460,    45,  3465,     0,     0,
       0,     0,     0,  1532,   677,     0,     0,     0,     0,     0,
       0,   678,     0,     0,   679,     0,    46,   680,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    47,  3256,     0,
    -463,     0,     0,    48,     0,  1534,     0,   783,    49,   783,
       0,     0,  1496,  5333,     0,     0,     0,     0,     0,     0,
       0,    50,     0,     0,     0,     0,  1362,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   631,     0,     0,
     944,   980,   944,   944,   630,    51,   933,     0,    36,   847,
    4812,     0,     0,  3888,     0,     0,     0,     0,     0,     0,
       0,     0,  1537,     0,    57,     0,     0,  -136,     0,     0,
     810,  1538,     0,     0,     0,     0,     0,     0,     0,  2772,
       0,  2788,     0,     0,     0,  3886,     0,     0,     0,  3574,
     847,  1540,     0,     0,     0,     0,  3585,     0,     0,     0,
    1541,     0,     0,     0,  1542,   847,     0,     0,     0,  1526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3889,     0,     0,   847,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1527,     0,     0,     0,   847,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1543,
       0,   810,     0,  3890,     0,     0,     0,     0,     0,  5982,
       0,     0,     0,     0,     0,     0,     0,     0,  4924,     0,
       0,  4927,     0,     0,   933,     0,     0,   933,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1556,     0,
       0,     0,     0,     0,  1557,  1528,     0,     0,     0,     0,
       0,     0,     0,   847,   847,     0,     0,     0,     0,     0,
       0,   630,     0,     0,     0,     0,     0,     0,  3728,     0,
    3731,  3733,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   630,  1529,     0,     0,     0,     0,     0,     0,  1559,
       0,     0,     0,     0,     0,   630,     0,     0,     0,     0,
       0,  1362,  1362,  1362,     0,     0,     0,  1362,     0,     0,
       0,     0,     0,     0,     0,   933,     0,     0,     0,     0,
    3887,     0,  5009,     0,     0,  1530,     0,     0,   933,     0,
       0,     0,     0,     0,  1362,     0,   933,     0,     0,  2944,
       0,     0,  3256,  3256,     0,  1560,   895,   943,     0,  2788,
       0,     0,  1561,     0,   847,  1562,     0,     0,     0,     0,
    3833,     0,     0,   783,     0,     0,     0,  1532,     0,     0,
       0,     0,     0,     0,     0,   933,  3844,     0,     0,     0,
       0,     0,  1563,     0,     0,     0,  3728,     0,     0,     0,
       0,     0,   943,     0,     0,     0,   933,     0,  3866,  1534,
       0,  2078,     0,     0,  2079,     0,  1496,     0,  2080,  2081,
    2082,     0,     0,     0,     0,     0,     0,     0,  1564,  2078,
    3951,     0,  2079,     0,     0,     0,  2080,  2081,  2082,     0,
       0,     0,     0,     0,     0,     0,  2581,   933,     0,   933,
       0,   933,    36,  2582,  2580,     0,     0,  1536,     0,     0,
       0,     0,     0,   630,  2581,     0,  1537,     0,     0,     0,
       0,  2582,     0,     0,     0,  1538,     0,     0,     0,  2583,
       0,     0,     0,  2772,  1979,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1540,     0,  2583,     0,  1664,
       0,     0,     0,  1566,  1541,     0,     0,     0,  1542,     0,
       0,     0,     0,  1567,     0,     0,     0,     0,     0,     0,
       0,     0,  1568,     0,     0,     0,   630,     0,  3889,     0,
       0,     0,  1055,     0,  1569,     0,     0,     0,   631,   933,
       0,   944,     0,   944,   944,     0,   933,     0,     0,     0,
       0,     0,     0,  1362,     0,     0,     0,     0,  1362,     0,
       0,     0,     0,  1543,     0,     0,  5077,  3890,     0,  5079,
       0,     0,     0,     0,  1692,     0,     0,  1571,  1572,     0,
       0,     0,  1123,   699,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2584,     0,     0,     0,  5094,  2585,
    1362,  1362,  1362,     0,     0,  1362,     0,     0,     0,  1693,
       0,     0,  2584,  1362,  1362,  1362,  1362,  2585,     0,     0,
       0,     0,  2586,  2269,     0,     0,     0,     0,     0,  1362,
       0,     0,  1362,     0,  1362,     0,     0,     0,     0,     0,
    2586,  2269,     0,  2587,     0,  1362,  1362,     0,     0,  1362,
       0,     0,     0,     0,     0,     0,     0,     0,  5779,     0,
       0,  2587,     0,     0,     0,     0,     0,     0,   980,     0,
    1362,     0,  1362,     0,  1362,     0,     0,     0,  1574,     0,
       0,  1227,     0,     0,  2327,     0,   630,     0,     0,     0,
       0,     0,     0,  1362,     0,     0,  4123,     0,  2588,     0,
     847,  1249,  2327,     0,     0,     0,     0,     0,     0,  1365,
       0,  5274,  1374,  1123,  1376,     0,  2588,     0,     0,  2589,
       0,   847,     0,  5284,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1526,     0,     0,
    -136,     0,     0,     0,     0,     0,     0,     0,     0,   631,
       0,     0,  3416,  4160,     0,     0,     0,  4160,  4174,  4160,
       1,     0,     0,     0,     0,  1362,     0,     0,     0,     0,
    1362,     2,  1527,     3,     4,     0,     0,     0,     0,     0,
       0,   630,     0,     0,     0,  1362,     0,     0,     0,     0,
       0,     5,  2590,     0,     0,     0,     0,     0,     0,  3416,
    1526,     6,     0,  4205,  5239,     0,  4208,  3416,     0,  3465,
    2590,     0,     0,     7,     0,     8,     9,     0,     0,     0,
       0,     0,    10,     0,    11,     0,     0,     0,     0,     0,
       0,     0,     0,  1528,     0,  1527,    12,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,  5264,  5265,     0,
    1362,     0,     0,     0,     0,    14,     0,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1529,     0,     0,    16,     0,    17,     0,     0,     0,    18,
     933,   933,   630,     0,     0,    19,     0,     0,     0,     0,
       0,     0,     0,    20,  2518,    21,  1528,     0,     0,     0,
       0,     0,    22,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,  2518,  1530,     0,  1123,     0,     0,     0,     0,
      23,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,
       0,     0,     0,  1529,  4430,     0,     0,    24,     0,     0,
    3951,  5308,  5309,     0,     0,     0,     0,     0,     0,     0,
       0,  1531,     0,     0,     0,  1532,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,     0,  1530,     0,     0,     0,
       0,     0,     0,     0,    25,    26,  1533,  1534,   847,     0,
      27,     0,     0,     0,  1496,     0,     0,     0,  2856,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,     0,
     895,     0,     0,     0,  1531,     0,     0,     0,  1532,     0,
       0,     0,    29,     0,     0,     0,  1535,     0,     0,     0,
      36,     0,   630,     0,     0,  1536,   895,     0,     0,     0,
     943,   943,     0,     0,  1537,     0,     0,     0,     0,  1597,
    1534,     0,     0,  1538,     0,     0,     0,  1496,     0,    30,
       0,  1539,     0,     0,     0,     0,  3951,    31,  3951,     0,
       0,  5402,     0,  1540,  5404,  5405,     0,     0,     0,     0,
       0,    32,  1541,     0,     0,     0,  1542,    33,    34,  1598,
      35,     0,     0,    36,  5410,    36,     0,     0,  1536,     0,
       0,    37,     0,  1362,    38,     0,  2004,  1537,     0,  1362,
       0,    39,     0,     0,     0,     0,  1538,     0,    40,    41,
     933,     0,   630,     0,  1599,     0,    42,     0,   630,     0,
      43,     0,     0,     0,     0,     0,  1540,     0,  1123,     0,
      44,  1543,     0,     0,     0,  1541,  6124,     0,     0,  1542,
       0,     0,     0,     0,     0,     0,    45,   847,   847,   847,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   847,     0,    46,     0,     0,     0,
       0,   895,     0,     0,     0,  1556,     0,    47,  1362,     0,
       0,  1557,     0,    48,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,  1543,     0,  1979,   847,   847,     0,
    6160,    50,   847,     0,     0,     0,     0,     0,     0,     0,
    2074,     0,     0,     0,   847,     0,     0,     0,     0,  2076,
     630,     0,     0,     0,     0,    51,  1559,    52,    53,    54,
      55,    56,     0,     0,  2543,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    57,     0,     0,  -136,     0,     0,
       0,     0,     0,  1123,     0,     0,  2560,  2561,  1526,     0,
    6160,  1123,  1123,     0,     0,     0,     0,     0,  6209,     0,
     933,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,   943,  1560,     0,  3152,  4580,     0,     0,     0,  1561,
       0,     0,  1562,  1527,     0,   847,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   847,     0,
       0,     0,     0,     0,  1711,     0,     0,     0,     0,  1563,
       0,     0,     0,     0,     0,     0,     0,  1362,     0,     0,
       0,     0,     0,   895,     0,     0,  1362,     0,     0,     0,
       0,     0,     0,     0,   895,     0,  1362,     0,     0,     0,
    1362,  1362,     0,     0,  1528,  1564,  1362,     0,     0,     0,
     895,     0,     0,     0,  1362,     0,  1362,     0,     0,  1362,
       0,     0,     0,     0,  1362,  1362,  1362,  1362,     0,     0,
    1362,  1362,  1362,  1362,  1362,  1362,  1362,  1362,  1362,  1362,
       0,  1529,     0,  1362,  1362,  1362,     0,     0,     0,     0,
       0,     0,  2078,  1362,     0,  2079,     0,     0,  1362,  2080,
    2081,  2082,  1362,     0,     0,     0,     0,     0,     0,     0,
    1362,     0,     0,  1362,     0,  1362,  1664,  2580,     0,     0,
    1566,     0,     0,     0,  1530,     0,     0,  2581,     0,     0,
    1567,     0,     0,  1362,  2582,     0,  1362,  1362,     0,  1568,
       0,  1362,  1362,     0,     0,     0,  1362,     0,  1362,  4710,
       0,  1569,     0,     0,     0,     0,     0,   847,   847,   847,
    2583,     0,  1531,     0,     0,     0,  1532,     0,     0,     0,
       0,  5709,     0,     0,     0,     0,     0,  4160,  4174,  4160,
       0,  1362,  4160,     0,     0,  4731,     0,     0,     0,  3416,
       0,  2752,     0,  3416,  1571,  1572,     0,  1614,  1534,  4746,
       0,     0,     0,     0,     0,  1496,     0,  2897,     0,     0,
       0,     0,   895,     0,     0,  2905,  1556,     0,     0,     0,
       0,     0,  1557,     0,  5745,  1362,  2753,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1615,     0,     0,
    3465,    36,  1362,     0,     0,     0,  1536,     0,     0,     0,
       0,     0,     0,     0,     0,  1537,     0,     0,     0,     0,
    4794,  1979,  1979,     0,  1538,  1979,     0,  1559,     0,     0,
       0,     0,  1616,     0,     0,  2584,     0,     0,     0,     0,
    2585,     0,     0,     0,  1540,     0,     0,     0,     0,     0,
       0,     0,     0,  1541,     0,  1574,     0,  1542,     0,     0,
    2788,  4826,     0,  2586,  2269,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4849,
       0,     0,     0,  1560,  2587,     0,     0,     0,     0,     0,
    1561,     0,     0,  1562,     0,     0,     0,  5834,     0,  2078,
       0,     0,  2079,     0,     0,     0,  2080,  2081,  2082,     0,
       0,     0,  1543,     0,     0,     0,     0,     0,     0,     0,
    1563,     0,     0,     0,  2580,  2327,     0,     0,     0,     0,
       0,     0,  4898,     0,  2581,     0,     0,     0,     0,  2588,
       0,  2582,  2589,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1564,     0,     0,     0,
       0,     0,  3951,     0,     0,     0,     0,  2583,     0,     0,
    2078,     0,     0,  2079,     0,     0,     0,  2080,  2081,  2082,
       0,     0,     0,     0,     0,     0,     0,  4942,     0,  3034,
       0,     0,     0,  3039,     0,  2580,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2581,     0,     0,     0,     0,
       0,     0,  2582,     0,     0,     0,     0,     0,     0,     0,
     933,  2078,     0,     0,  2079,  2689,     0,  1565,  2080,  2081,
    2082,  1566,     0,  2590,   933,     0,  1362,     0,  2583,     0,
       0,  1567,     0,   847,     0,     0,  2580,     0,     0,  4986,
    1568,     0,     0,     0,     0,     0,  2581,     0,     0,     0,
    2788,     0,  1569,  2582,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   847,     0,     0,     0,     0,
    3416,  3844,  2584,     0,     0,     0,     0,  2585,  3728,  2583,
       0,     0,     0,  2689,     0,     0,     0,  5035,     0,     0,
       0,     0,  2830,     0,     0,  1571,  1572,   847,     0,     0,
    2586,  2269,     0,     0,     0,     0,     0,     0,     0,  1362,
    1362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1362,  2587,     0,     0,   895,  2518,     0,  2831,     0,     0,
       0,  1979,   847,     0,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,  2584,     0,     0,     0,  4616,  2585,   847,
       0,     0,     0,  3222,     0,     0,     0,   895,     0,     0,
       0,     0,  2327,     0,     0,     0,     0,     0,     0,     0,
       0,  2586,  2269,     0,     0,     0,  2588,     0,     0,  2589,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1362,     0,  2587,     0,  2584,     0,  1574,     0,     0,  2585,
       0,     0,     0,  1362,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1362,     0,     0,
       0,     0,  2586,  2269,     0,     0,     0,     0,     0,     0,
       0,  6090,     0,  2327,     0,     0,  1711,  1711,  1711,     0,
       0,     0,     0,  2587,     0,  1362,     0,  2588,  1362,     0,
    2589,  2078,     0,     0,  2079,     0,  1362,  1362,  2080,  2081,
    2082,     0,     0,  1362,  1362,     0,     0,     0,  1362,     0,
    2590,     0,     0,     0,     0,  1362,  2580,     0,  1362,  1362,
       0,     0,     0,     0,  2327,  1362,  2581,     0,     0,   847,
     847,   847,   847,  2582,     0,     0,     0,     0,  2588,     0,
       0,  2589,     0,     0,     0,   631,     0,     0,  4160,     0,
       0,     0,  3416,     0,     0,     0,     0,  3416,     0,  2583,
    3416,   631,     0,  3728,     0,  5197,     0,     0,  1362,     0,
     980,     0,     0,     0,     0,     0,     0,     0,     0,  1362,
       0,  2590,     0,  4205,     0,     0,     0,  1362,   895,  3465,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   895,
       0,     0,     0,     0,   783,     0,     0,  1362,     0,     0,
       0,     0,  2518,     0,     0,   895,     0,     0,     0,     0,
       0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,
       0,     0,  2590,     0,  4682,     0,     0,     0,     0,     0,
       0,  2788,     0,     0,     0,  5252,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   895,
       0,     0,     0,     0,  2584,     0,     0,     0,     0,  2585,
       0,     0,     0,  2518,   895,     0,     0,   895,   895,     0,
       0,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,     0,  2586,  2269,     0,  4788,     0,  1556,     0,     0,
    1362,     0,     0,  1557,     0,     0,     0,  1362,   895,   895,
       0,     0,     0,  2587,  2078,     0,     0,  2079,     0,     0,
       0,  2080,  2081,  2082,  2518,     0,     0,     0,     0,   933,
       0,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,     0,     0,   933,     0,  5015,     0,  1559,  2581,
       0,     0,     0,     0,  2327,     0,  2582,   700,     0,     0,
       0,     0,  2739,     0,     0,     0,     0,     0,  2588,     0,
       0,  2589,     0,     0,     0,  1362,     0,     0,     0,     0,
       0,     0,  2583,     0,     0,     0,     0,     0,     0,     0,
       0,   631,     0,     0,     0,     0,     0,     0,  2788,     0,
    2740,     0,     0,     0,  1560,     0,  1711,  1979,     0,     0,
       0,  1561,     0,   703,  1562,  1711,     0,     0,  1711,     0,
       0,     0,  3844,     0,     0,     0,     0,     0,     0,   704,
       0,     0,     0,     0,     0,   933,     0,  3866,     0,     0,
       0,  1563,     0,   895,     0,     0,     0,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2078,  2590,   847,  2079,     0,     0,     0,  2080,  2081,
    2082,  2741,     0,     0,   847,     0,     0,  1564,     0,     0,
       0,     0,   707,     0,     0,     0,  2580,     0,     0,     0,
       0,   708,     0,     0,     0,     0,  2581,  2584,     0,     0,
       0,     0,  2585,  2582,   709,  3365,     0,     0,     0,     0,
    2742,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -2887, -2887,     0,     0,  2583,
       0,     0,  1362,     0,     0,  1362,     0,  1041,  1362,  1362,
    1362,     0,     0,     0,     0,     0,  2587,     0,  1664,     0,
       0,     0,  1566,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1567,     0,  2518,  1362,  1362,     0,     0,  1362,
       0,  1568,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,     0,  1569,     0,     0,  5123, -2887,     0,  1362,
     713,     0,     0,     0,     0,  1362,     0,     0,     0,  3416,
       0,  2588,     0,  5197,     0,     0,  1362,     0,  5477,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4794,
       0,     0,  1362,  3566,     0,     0,  1571,  1572,     0,     0,
       0,  2743,     0,  4794,   980,   933,     0,   933,     0,     0,
       0,     0,     0,     0,  2584,     0,     0,     0,     0,  2585,
       0,     0,     0,  1123,     0,     0,     0,     0,  1573,     0,
       0,     0,     0,     0,     0,     0,   214,  2744,     0,     0,
     718,     0,  2586,  2269,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,   980,     0,     0,     0,
       0,     0,     0,  2587,     0,  2590,     0,  1045,     0,     0,
    2745,     0,     0,     0,     0,     0,     0,   722,     0,     0,
       0,     0,  1376,     0,   723,     0,     0,   724,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1574,     0,     0,
     944,     0,     0,     0,  2327,     0,   725,     0,     0,     0,
       0,     0,  4986,  1047,     0,     0,     0,   847,  2588,     0,
     727,  2589,   847,  1048,     0,     0,     0,   729,     0,     0,
       0,  2788,     0,     0,     0,  2746,     0,     0,     0,     0,
       0,   847,  2747,     0,     0,  5035,     0,     0,  5616,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   933,
     847,  4794,  1376,     0,     0,     0,     0,  2518,   734,     0,
       0,     0,     0,     0,     0,     0,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,     0,  1376,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1362,     0,     0,
       0,  1362,     0,  1362,     0,     0,     0,     0,     0,     0,
       0,     0,  2590,     0,     0,     0,     0,  1362,     0,     0,
       0,     0,     0,     0,   631,     0,     0,  1362,     0,     0,
       0,  5685,     0,     0,     0,     0,     0,     0,  1362,     0,
       0,     0,     0,     0,     0,  1362,     0,     0,     0,     0,
       0,     0,     0,  3737,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1711,     0,     0,     0,
     847,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3769,     0,  3769,     0,  3769,  3769,     0,     0,     0,  3769,
    3769,  3769,     0,  3769,  3769,  3769,  1362,     0,     0,     0,
       0,     0,  1362,  1362,  2518,     0,     0,   933,   933,   933,
     933,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,     0,     0,     0,     0,  5162,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1362,     0,
       0,     0,     0,     0,     0,     0,   631,  3846,     0,     0,
     639,     0,     0,     0,     0,     0,   688,   639,     0,     0,
       0,     0,   740,     0,   639,     0,     0,     0,     0,     0,
     639,   847,  3874,   796,  3416,     0,     0,  2078,     0,     0,
    2079,     0,     0,     0,  2080,  2081,  2082,     0,     0,     0,
       0,     0,   858,   858,     0,     0,     0,     0,     0,   847,
       0,     0,  2580,  3472,     0,     0,     0,  2689,  3478,     0,
    1556,     0,  2581,     0,     0,     0,  1557,     0,     0,  2582,
       0,     0,     0,     0,     0,     0,     0,  1362,     0,     0,
       0,     0,     0,     0,     0,     0,  1362,  1362,  1362,     0,
       0,     0,  1979,     0,     0,  2583,  3728,     0,     0,  1362,
       0,     0,     0,     0,     0,     0,     0,     0,  1362,     0,
    1362,  1559,  1362,  5477,     0,   895,     0,     0,     0,  4794,
       0,   895,     0,     0,     0,     0,     0,     0,     0,  1979,
       0,   980,     0,     0,     0,     0,     0,     0,     0,     0,
    1362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1556,     0,     0,     0,     0,     0,  1557,     0,     0,
       0,     0,   895,     0,     0,     0,     0,  1560,     0,     0,
       0,     0,     0,     0,  1561,  1979,  1979,  1562,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   935,     0,     0,     0,   939,     0,     0,
       0,     0,  1559,     0,  1563,   982,   933,     0,   984,     0,
    2584,   989,   990,     0,   993,  2585,   996,     0,     0,  1002,
    5946,  1004,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2586,  2269,
    1564,  2078,     0,     0,  2079,     0,     0,     0,  2080,  2081,
    2082,     0,     0,     0,     0,     0,     0,  1362,  1560,  2587,
       0,     0,     0,     0,     0,  1561,  2580,     0,  1562,     0,
    1362,     0,     0,     0,  5685,     0,  2581,     0,     0,     0,
    1362,     0,     0,  2582,     0,     0,     0,     0,     0,  3465,
    1362,     0,     0,     0,     0,  1563,     0,     0,     0,     0,
    2327,     0,     0,     0,     0,     0,   944,     0,     0,  2583,
       0,  1664,     0,     0,  2588,  1566,     0,  2589,     0,     0,
       0,   933,  1123,     0,     0,  1567,     0,     0,  1979,     0,
       0,  1564,     0,     0,  1568,     0,     0,     0,     0,  1711,
       0,     0,     0,     0,     0,     0,  1569,     0,     0,     0,
     932,   934,     0,  2788,   937,     0,     0,     0,     0,     0,
    1362,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4794,   895,     0,     0,   995,     0,     0,     0,   944,   944,
    6064,  1005,     0,     0,  1362,     0,  3744,     0,     0,  1571,
    1572,     0,     0,     0,     0,     0,  1979,  1979,  6074,     0,
       0,     0,  1664,  1362,  1362,     0,  1566,     0,  2590,  6080,
       0,     0,     0,     0,     0,     0,  1567,     0,     0,     0,
       0,  3745,     0,     0,  2584,  1568,     0,     0,     0,  2585,
       0,   933,     0,     0,     0,     0,     0,  1569,     0,     0,
       0,     0,     0,     0,  2689,  1556,     0,     0,  2689,     0,
       0,  1557,  2586,  2269,     0,     0,     0,     0,     0,     0,
    5946,   933,   933,     0,     0,     0,  4794,     0,     0,     0,
       0,     0,     0,  2587,     0,     0,     0,  4258,     0,     0,
    1571,  1572,  1123,     0,   631,  1362,     0,     0,     0,     0,
    1574,     0,     0,     0,     0,     0,  1559,     0,     0,  1362,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2518,     0,  4259,  1362,  2327,     0,     0,     0,     0,  2519,
    2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,  2588,     0,
       0,  2589,  5166,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6158,  6159,   631,  6162,
    5685,   895,  1560,  3465,     0,     0,     0,     0,     0,  1561,
    4306,     0,  1562,     0,     0,   933,   895,     0,  4794,     0,
       0,   895,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1574,     0,     0,  2078,     0,     0,  2079,  4205,  1563,
       0,  2080,  2081,  2082,     0,     0,     0,     0,     0,   895,
       0,     0,     0,     0,     0,     0,     0,  1362,   631,  2580,
       0,     0,  1362,     0,     0,     0,   631,     0,  4353,  2581,
       0,     0,  2590,     0,     0,  1564,  2582,     0,   944,   944,
       0,     0,  6224,     0,     0,     0,  1032,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1069,     0,     0,
       0,  1073,  2583,     0,     0,     0,     0,     0,  1086,  1087,
       0,     0,  1093,     0,  1097,  1098,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1120,
       0,     0,     0,     0,     0,     0,  4396,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1664,  1133,     0,     0,
    1566,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1567,     0,     0,     0,     0,     0,     0,     0,  1161,  1568,
    1163,     0,     0,     0,  2518,     0,     0,     0,     0,     0,
    1179,  1569,  3769,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,     0,     0,  4427,  4427,  5417,     0,     0,     0,
       0,     0,     0,     0,  4443,     0,     0,     0,     0,  1123,
       0,  1123,     0,   639,     0,     0,     0,  2584,     0,     0,
       0,  4316,  2585,     0,  1571,  1572,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2586,  2269,     0,     0,     0,
       0,     0,     0,  1065,     0,  1068,  4317,  4498,  1070,     0,
       0,     0,     0,   945,   955,     0,  2587,     0,     0,     0,
       0,   945,  1096,   955,   945,     0,     0,     0,  1100,     0,
       0,     0,     0,     0,     0,     0,     0,   955,     0,     0,
       0,     0,  4534,  1123,     0,  2689,     0,   858,  3478,     0,
    3478,     0,     0,     0,     0,  2689,     0,  2327,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2588,     0,     0,  2589,  1574,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   895,     0,     0,     0,     0,     0,     0,
       0,   895,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1517,     0,     0,     0,     0,     0,  2689,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2078,     0,
       0,  2079,     0,     0,     0,  2080,  2081,  2082,     0,     0,
       0,     0,     0,     0,     0,  2590,     0,     0,     0,     0,
       0,     0,     0,  2580,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2581,     0,     0,     0,     0,     0,     0,
    2582,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1695,     0,   895,     0,   895,     0,
       0,     0,     0,     0,     0,     0,  2583,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1816,
       0,     0,     0,     0,     0,     0,     0,  4683,     0,     0,
       0,     0,     0,     0,  1828,     0,  1829,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1832,     0,     0,     0,
       0,     0,     0,  1842,     0,     0,     0,  2518,     0,     0,
       0,     0,     0,     0,     0,     0,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,     0,     0,     0,     0,  5428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   895,     0,     0,     0,  1894,     0,  1896,     0,
       0,     0,     0,     0,     0,     0,  1588,  1589,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1711,
       0,  2584,     0,     0,     0,  1711,  2585,     0,     0,     0,
       0,     0,     0,     0,   895,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2586,
    2269,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3478,     0,     0,     0,     0,     0,     0,     0,
    2587,     0,   639,     0,   639,     0,   639,  1815,   639,     0,
     639,   639,   639,     0,     0,     0,     0,   639,     0,     0,
       0,     0,  1827,     0,  2078,     0,     0,  2079,     0,  2000,
       0,  2080,  2081,  2082,     0,     0,     0,     0,     0,     0,
       0,  2327,     0,     0,     0,     0,     0,     0,     0,  2580,
       0,     0,     0,  1849,  1850,  2588,     0,     0,  2589,  2581,
     895,     0,     0,     0,     0,     0,  2582,     0,     0,   955,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1887,
       0,     0,  3478,     0,     0,     0,  4443,     0,   955,     0,
       0,     0,  2583,     0,   955,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   895,     0,   955,     0,     0,     0,
       0,     0,  4888,     0,     0,     0,     0,     0,     0,  1925,
    1927,     0,   955,     0,     0,     0,     0,  4902,     0,   894,
    4903,     0,  4904,     0,     0,     0,   945,   955,     0,     0,
       0,     0,     0,   945,     0,   955,   945,     0,     0,  2590,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   955,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   955,
       0,     0,     0,     0,     0,     0,     0,     0,  4944,     0,
       0,     0,     0,     0,     0,     0,   895,     0,     0,     0,
       0,     0,     0,     0,  3769,     0,     0,     0,     0,  3769,
       0,     0,     0,     0,     0,     0,     0,  2584,     0,     0,
       0,     0,  2585,  2078,   858,     0,  2079,     0,   700,     0,
    2080,  2081,  2082,  3190,     0,   955,     0,     0,     0,   895,
       0,     0,     0,     0,     0,  2586,  2269,     0,  2580,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2581,     0,
       0,  2518,     0,   955,   895,  2582,  2587,     0,     0,     0,
    2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,     0,
       0,     0,     0,  5438,   703,  3191,     0,     0,   955,     0,
       0,  2583,     0,     0,     0,     0,     0,     0,     0,     0,
     704,     0,     0,     0,     0,     0,     0,  2327,  5049,     0,
       0,  4443,     0,     0,     0,     0,     0,     0,  1038,     0,
       0,  2588,     0,     0,  2589,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3192,     0,     0,  2750,     0,     0,   955,     0,
       0,     0,     0,   707,     0,     0,     0,     0,     0,     0,
       0,     0,   708,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   709,     0,     0,     0,     0,
       0,  3193,     0,     0,     0,     0,     0,  5098,  5098,  5098,
    5098,     0,  5098,  5098,  5098,  5098,  5098,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2584,     0,  1041,     0,
       0,  2585,     0,     0,     0,  2590,     0,  2842,     0,     0,
       0,     0,     0,     0,  2689,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2586,  2269,     0,     0,     0,  3194,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2587,     0,     0,  1798,     0,
       0,   713,     0,     0,     0,   955,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   945,     0,     0,     0,
     945,     0,   945,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2327,     0,     0,     0,
       0,     0,     0,     0,     0,  5174,     0,  5176,     0,     0,
    2588,     0,     0,  2589,  3478,     0,     0,  2518,     0,     0,
       0,     0,     0,  2770,     0,     0,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,     0,     0,   214,  3195,  5493,
    3478,   718,     0,     0,     0,     0,     0,     0,  2809,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1045,     0,
       0,  3196,     0,     0,     0,     0,     0,     0,   722,     0,
       0,     0,     0,     0,     0,   723,     0,     0,   724,   955,
       0,     0,  2078,     0,     0,  2079,     0,     0,     0,  2080,
    2081,  2082,     0,     0,  2590,     0,     0,   725,     0,     0,
       0,     0,     0,     0,  1047,     0,     0,  2580,     0,     0,
       0,   727,     0,     0,  1048,  2899,     0,  2581,   729,     0,
       0,     0,  2972,     0,  2582,     0,     0,     0,     0,     0,
       0,     0,     0,  3197,     0,     0,     0,     0,     0,     0,
     955,     0,     0,     0,  2925,  2926,  2927,  2928,     0,     0,
    2583,     0,     0,     0,     0,     0,   955,  3008,     0,   734,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   895,   955,     0,     0,     0,     0,   955,  2078,
       0,     0,  2079,     0,     0,     0,  2080,  2081,  2082,     0,
       0,     0,     0,     0,     0,     0,  2518,     0,     0,     0,
       0,     0,     0,  3073,  2580,  2519,  2520,  2521,  2522,  2523,
    2524,  2525,  2526,  2527,  2581,  5305,  5306,     0,  5527,  3478,
       0,  2582,     0,  3091,  2689,     0,     0,     0,  3769,     0,
    3769,  3769,  3769,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2583,     0,  3111,
     954,  3112,     0,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,     0,     0,  2584,  3121,     0,  3122,     0,
    2585,     0,     0,   954,   639,     0,   639,     0,   639,     0,
     639,     0,   639,   894,     0,     0,   639,     0,     0,     0,
       0,  2981,  2982,  2586,  2269,     0,  5357,     0,     0,     0,
       0,     0,     0,   955,     0,     0,     0,  2999,     0,   894,
       0,   955,   955,     0,  2587,     0,     0,     0,     0,     0,
       0,     0,     0,  3181,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5385,     0,     0,     0,     0,
       0,  3042,  3043,  3044,  3045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2327,     0,     0,     0,     0,
       0,     0,  2584,     0,  1798,     0,     0,  2585,     0,  2588,
       0,     0,  2589,     0,     0,   895,     0,     0,  5098,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2586,  2269,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2078,     0,     0,
    2079,  2587,     0,     0,  2080,  2081,  2082,     0,     0,     0,
       0,     0,  3119,     0,     0,     0,     0,     0,  3123,     0,
       0,     0,  2580,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2581,     0,     0,     0,     0,     0,     0,  2582,
       0,     0,  2327,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,  2590,     0,     0,  2588,     0,     0,  2589,
    2078,     0,     0,  2079,     0,  2583,     0,  2080,  2081,  2082,
       0,     0,     0,     0,  1556,     0,     0,     0,     0,     0,
    1557,     0,     0,     0,     0,  2580,     0,  1623,     0,     0,
       0,   895,     0,     0,     0,  2581,     0,     0,     0,     0,
       0,     0,  2582,     0,     0,     0,     0,     0,     0,  1624,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1559,     0,     0,  2583,     0,
       0,   895,  4443,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2590,     0,     0,   895,     0,  2518,     0,     0,     0,     0,
    1625,     0,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,     0,     0,     0,     0,  5529,  3769,     0,
    2584,  1560,     0,     0,     0,  2585,     0,  5563,  1561,     0,
       0,  1562,     0,     0,     0,     0,     0,     0,     0,  3299,
       0,     0,     0,   955,     0,     0,   894,     0,  2586,  2269,
       0,     0,     0,     0,     0,     0,     0,   894,  1563,     0,
       0,     0,     0,     0,     0,   895,     0,     0,     0,  2587,
       0,     0,     0,   894,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2584,     0,     0,     0,     0,  2585,     0,
    1626,     0,  2518,     0,  1564,     0,     0,     0,     0,     0,
       0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,
    2327,  2586,  2269,     0,  5568,   954,     0,     0,     0,     0,
       0,     0,     0,     0,  2588,     0,     0,  2589,     0,     0,
       0,     0,  2587,     0,   954,     0,     0,     0,     0,     0,
     954,     0,     0,     0,     0,     0,  1627,     0,     0,     0,
    1628,     0,   954,     0,     0,     0,     0,     0,   955,     0,
       0,     0,     0,     0,     0,  1629,     0,     0,   954,  1566,
       0,     0,     0,  2327,     0,   885,     0,     0,     0,  1567,
       0,     0,     0,   954,  5389,     0,   895,  2588,  1568,     0,
    2589,   954,     0,  1798,     0,     0,     0,     0,     0,  1630,
    1569,     0,     0,     0,     0,   954,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   954,   955,     0,  2590,     0,
       0,     0,     0,     0,   955,     0,     0,     0,     0,     0,
       0,     0,   955,     0,     0,   894,     0,     0,     0,     0,
    3674,     0,     0,  1571,  1572,  1632,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1123,     0,     0,     0,
    5754,     0,     0,     0,     0,     0,     0,     0,     0,  1633,
       0,   954,     0,   945,   945,  3675,   955,   955,     0,     0,
       0,  2590,     0,     0,     0,     0,     0,     0,   945,  1635,
     955,   945,     0,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,   955,   955,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2518,   895,     0,     0,   954,     0,     0,     0,     0,  2519,
    2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,     0,     0,
       0,   945,  5896,     0,  1574,   945,   945,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2518,   954,     0,     0,  2559,     0,     0,
    3478,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,     0,     0,     0,     0,  5918,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3468,  3469,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3484,  3485,     0,  3487,  3488,     0,
       0,     0,  3491,  3492,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1123,  1798,  3503,     0,  5908,
       0,  5909,     0,     0,  3512,  5914,  5915,     0,  3515,  3516,
       0,     0,  3519,  3520,     0,     0,     0,     0,     0,  3525,
       0,     0,     0,     0,  3299,     0,     0,     0,   894,     0,
       0,  3540,     0,     0,  1797,     0,     0,     0,     0,     0,
       0,   954,     0,  3557,     0,     0,     0,     0,  3559,     0,
    3478,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3565,     0,     0,     0,     0,     0,     0,
       0,     0,  3572,     0,     0,  3576,     0,  3578,  3581,  3583,
       0,     0,     0,     0,  3591,  3594,     0,     0,     0,     0,
       0,     0,     0,     0,  3607,     0,   894,     0,     0,     0,
    3617,     0,     0,     0,  3620,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3630,  3631,     0,     0,
       0,  3636,     0,     0,     0,     0,     0,  3645,  3646,     0,
       0,     0,     0,     0,     0,     0,     0,   894,     0,     0,
       0,  3655,     0,     0,  3656,     0,     0,     0,     0,     0,
       0,  3668,  3669,     0,     0,     0,     0,  3673,     0,     0,
       0,     0,     0,     0,     0,   954,     0,     0,     0,  3680,
     894,     0,  3683,     0,     0,     0,     0,  3686,     0,     0,
       0,     0,   895,  3689,  3690,     0,     0,   895,   895,  3539,
       0,  3696,     0,     0,     0,  3698,     0,     0,     0,  3705,
    3706,  3707,  3708,     0,  3710,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3735,  3736,     0,
    3738,     0,     0,     0,     0,     0,   954,     0,     0,     0,
       0,  3747,  3748,  3749,     0,     0,     0,     0,     0,     0,
       0,     0,   954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,   887,   954,  1123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2078,     0,     0,  2079,     0,     0,  3801,  2080,
    2081,  2082,     0,     0,     0,     0,  3825,     0,     0,  5389,
     895,     0,     0,     0,     0,     0,     0,  2580,     0,     0,
       0,     0,     0,     0,     0,  3837,     0,  2581,     0,     0,
       0,     0,     0,     0,  2582,     0,     0,  3679,     0,     0,
    3682,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   895,
    2583,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   894,     0,     0,     0,  3905,     0,     0,     0,   885,
       0,     0,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3919,     0,  3921,     0,   894,   954,
       0,     0,     0,     0,     0,   885,     0,   954,   954,     0,
       0,     0,     0,  6187,     0,     0,  2543,   888,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3773,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3786,     0,     0,     0,     0,     0,     0,     0,  3795,
       0,     0,   894,     0,     0,     0,     0,     0,  6187,     0,
    1797,     0,     0,     0,     0,     0,     0,   894,     0,     0,
     894,   894,     0,     0,     0,  2584,  6187,     0,     0,  5174,
    2585,     0,     0,     0,     0,     0,     0,     0,  3839,     0,
       0,  3983,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   894,   894,  2586,  2269,     0,     0,     0,     0,  3863,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2078,  1798,  2587,  2079,     0,     0,     0,  2080,
    2081,  2082,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2580,     0,     0,
     885,     0,  3918,     0,  3920,     0,     0,  2581,     0,     0,
       0,     0,     0,     0,  2582,  2327,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   955,  2588,
       0,     0,  2589,     0,     0,     0,     0,     0,     0,     0,
    2583,     0,     0,     0,     0,     0,   955,     0,     0,     0,
     955,     0,     0,     0,   955,     0,     0,     0,     0,     0,
       0,     0,     0,   955,     0,     0,     0,     0,     0,     0,
    2078,     0,     0,  2079,     0,     0,     0,  2080,  2081,  2082,
       0,   955,     0,     0,     0,     0,   894,     0,     0,     0,
       0,     0,  3975,     0,     0,  2580,     0,     0,   945,  3982,
     945,   945,     0,     0,     0,  2581,     0,     0,     0,     0,
       0,     0,  2582,     0,     0,   955,     0,     0,     0,     0,
       0,     0,  2078,  2590,     0,  2079,     0,     0,     0,  2080,
    2081,  2082,     0,     0,     0,   955,   955,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,     0,  2580,     0,     0,
       0,     0,     0,     0,     0,  2584,     0,  2581,     0,   954,
    2585,     0,   885,     0,  2582,     0,  1798,   955,     0,     0,
    1798,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2586,  2269,     0,     0,     0,     0,   885,
    2583,     0,     0,     0,   955,     0,  1798,     0,     0,     0,
     955,     0,     0,     0,  2587,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   955,     0,     0,     0,     0,     0,
       0,   955,     0,     0,   955,  2518,     0,     0,     0,     0,
     955,     0,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,     0,     0,  2327,  4231,  6106,     0,     0,
     955,     0,     0,  2584,     0,     0,   955,     0,  2585,  2588,
       0,     0,  2589,   955,     0,     0,  4243,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,   955,     0,     0,
    4055,  2586,  2269,  4250,     0,     0,  4056,  4250,     0,     0,
     955,     0,  4261,  4262,  4263,  1798,     0,     0,     0,     0,
       0,   955,  2587,     0,     0,  2584,     0,     0,     0,  1797,
    2585,     0,     0,  1711,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4293,  4294,
    4295,  4296,   954,  2586,  2269,     0,     0,     0,     0,     0,
     954,     0,     0,  2327,     0,     0,     0,     0,   954,     0,
       0,   885,     0,  2590,  2587,     0,     0,  2588,  4312,     0,
    2589,  1798,     0,     0,     0,     0,  4315,     0,  4319,  4320,
    4321,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   954,   954,     0,  2327,   890,     0,     0,     0,
       0,     0,     0,   887,     0,     0,   954,     0,     0,  2588,
       0,     0,  2589,     0,     0,     0,     0,     0,     0,   954,
     954,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4246,  4247,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2590,     0,     0,     0,  2518,     0,     0,     0,     0,
       0,     0,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,     0,     0,     0,     0,  6123,     0,     0,
       0,     0,     0,     0,  4404,     0,     0,     0,     0,     0,
       0,     0,  2078,  4410,     0,  2079,     0,     0,     0,  2080,
    2081,  2082,     0,  4057,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   955,  2580,  1798,  4420,
    4421,   888,     0,     0,  4422,     0,     0,  2581,     0,     0,
       0,     0,     0,     0,  2582,   955,     0,     0,     0,     0,
       0,     0,   955,     0,     0,     0,  4464,   888,   887,   945,
       0,   945,   945,  2518,     0,     0,     0,     0,     0,     0,
    2583,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,     0,  1797,     0,     0,  6164,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4501,     0,
       0,     0,     0,  4507,   885,  2518,     0,     0,     0,  4513,
       0,     0,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1798,     0,     0,     0,     0,     0,  1798,  4552,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4567,     0,
    4568,     0,   885,  4417,     0,  2584,     0,     0,     0,     0,
    2585,     0,     0,     0,     0,     0,   894,     0,     0,     0,
     894,   894,   888,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2586,  2269,     0,     0,     0,     0,     0,
     887,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,   887,   955,     0,  2587,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   887,     0,     0,
       0,     0,     0,     0,     0,     0,   885,     0,   894,     0,
       0,     0,     0,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2327,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2588,
       0,     0,  2589,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   894,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4674,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4570,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   955,   955,   888,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   888,     0,     0,     0,     0,
       0,     0,     0,  2590,     0,     0,     0,     0,     0,   955,
       0,   888,   955,     0,     0,     0,     0,     0,     0,     0,
    4675,     0,     0,     0,     0,     0,     0,     0,     0,   887,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,     0,  1798,  1798,  1798,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2518,     0,     0,  4798,   955,
       0,  4805,     0,  4806,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,     0,     0,     0,  4813,     0,   955,     0,
       0,     0,     0,     0,   894,     0,     0,     0,  4819,     0,
       0,     0,  4822,     0,     0,     0,     0,     0,   885,     0,
     955,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4848,     0,   885,     0,     0,   885,   885,     0,     0,
       0,     0,     0,   888,     0,     0,     0,     0,     0,  4852,
     890,     0,     0,     0,     0,  4856,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   885,   885,     0,
       0,     0,     0,     0,     0,     0,   890,   894,     0,     0,
    4891,   894,     0,     0,  4895,     0,     0,     0,     0,  1797,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4905,
    4906,  4907,  4908,     0,     0,     0,   955,     0,     0,  4912,
    4913,  4914,  4915,     0,     0,     0,     0,     0,  4917,  4918,
       0,     0,     0,     0,  4925,  4926,     0,  4928,  4929,  4930,
    4931,  4932,  4933,  4934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4943,   954,     0,     0,  4946,  4947,  4948,
    4949,     0,   887,  1798,     0,     0,     0,     0,     0,   955,
       0,   955,   954,     0,     0,     0,   954,     0,     0,     0,
     954,  4250,     0,     0,   955,     0,   955,     0,     0,   954,
       0,     0,     0,     0,   894,     0,     0,     0,     0,  4969,
       0,     0,     0,     0,     0,     0,     0,   954,     0,   894,
       0,     0,   885,     0,   894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     887,   890,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   954,   894,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   955,     0,     0,     0,     0,     0,     0,
       0,   954,   954,     0,     0,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,  5050,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1797,   954,     0,   955,  1797,     0,     0,     0,
       0,     0,  2078,     0,   887,  2079,   888,     0,  4250,  2080,
    2081,  2082,     0,     0,   955,  5075,     0,  5076,   955,     0,
     954,     0,  1797,     0,     0,     0,   954,  2580,     0,     0,
     891,     0,     0,     0,     0,     0,     0,  2581,     0,   955,
     954,     0,     0,  4966,  2582,  5091,     0,   954,     0,     0,
     954,     0,     0,     0,     0,     0,   954,  4968,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2583,     0,     0,     0,   888,     0,   954,     0,     0,     0,
       0,     0,   954,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   954,   890,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   888,   954,     0,     0,     0,
     890,  1797,     0,     0,     0,     0,     0,   954,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1798,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   888,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5972,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2584,     0,  1797,   894,     0,
    2585,   894,     0,   894,     0,   887,     0,     0,   894,     0,
       0,     0,     0,     0,     0,     0,   887,     0,     0,     0,
       0,     0,     0,  2586,  2269,     0,     0,     0,     0,     0,
       0,     0,   887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2587,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   894,     0,     0,     0,
       0,     0,     0,     0,   894,     0,     0,     0,     0,     0,
    5241,  5242,  5243,     0,     0,     0,  5244,  5245,  5246,  5247,
       0,     0,     0,  5249,     0,  2327,   887,     0,     0,   894,
       0,     0,   890,     0,     0,     0,     0,     0,     0,  2588,
       0,   887,  2589,     0,   887,   887,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5269,  5270,  5271,  5272,  5273,  5973,  5275,  5276,   955,
       0,     0,     0,     0,     0,   887,   887,     0,     0,  5285,
    5286,     0,     0,     0,     0,     0,     0,     0,     0,   888,
       0,     0,   954,     0,  1797,     0,     0,     0,     0,   894,
     888,   894,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   954,     0,  5292,     0,     0,   888,     0,   954,     0,
    1798,     0,     0,     0,     0,  1798,     0,  1798,     0,     0,
       0,     0,     0,  2590,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1798,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     888,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   888,     0,     0,   888,   888,
       0,     0,     0,     0,     0,   894,     0,   955,     0,     0,
     955,     0,     0,     0,     0,     0,     0,     0,  1797,     0,
     887,     0,     0,     0,  1797,  5355,     0,     0,     0,   888,
     888,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2518,     0,   894,     0,     0,
       0,     0,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   885,     0,     0,   894,   885,   885,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5406,   893,  5300,     0,     0,   890,     0,     0,     0,     0,
     955,   955,     0,     0,     0,     0,     0,  5304,   954,     0,
       0,   955,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5412,     0,     0,     0,     0,     0,   955,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
     885,     0,     0,   894,     0,     0,     0,     0,     0,     0,
       0,  2078,     0,     0,  2079,     0,     0,     0,  2080,  2081,
    2082,     0,     0,   890,   888,   894,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2580,     0,     0,  3992,
       0,   885,     0,     0,     0,     0,  2581,   894,     0,     0,
       0,     0,     0,  2582,     0,     0,     0,     0,  5362,     0,
       0,     0,     0,     0,   890,     0,     0,     0,     0,   955,
       0,     0,  1798,     0,     0,     0,   639,     0,     0,  2583,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   890,   954,   954,
       0,     0,     0,     0,   891,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   954,     0,     0,   954,   894,
     891,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5516,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,  2079,     0,     0,  5526,
    2080,  2081,  2082,     0,     0,  5532,  5533,     0,     0,     0,
       0,     0,   894,     0,     0,  5544,     0,     0,  2580,     0,
       0,     0,  5546,     0,     0,     0,     0,     0,  2581,     0,
       0,     0,     0,     0,  2584,  2582,     0,   894,     0,  2585,
    1797,  1797,  1797,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5598,  5599,     0,
       0,  2583,  2586,  2269,     0,   954,     0,     0,     0,     0,
    5607,     0,  5609,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2587,   954,     0,     0,  5623,     0,     0,
     885,     0,     0,     0,     0,     0,     0,     0,  5499,     0,
    5501,     0,     0,     0,     0,     0,   954,     0,     0,     0,
       0,     0,  4250,     0,     0,   891,     0,     0,     0,     0,
    5657,     0,     0,     0,  2327,     0,     0,     0,   890,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2588,   890,
       0,  2589,     0,     0,     0,     0,   955,     0,     0,     0,
       0,     0,     0,     0,     0,   890,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,     0,  2584,     0,     0,     0,
       0,  2585,     0,     0,     0,     0,     0,     0,     0,     0,
     955,     0,   954,     0,  5699,     0,     0,   894,     0,     0,
       0,     0,   955,     0,  2586,  2269,     0,     0,     0,   890,
       0,     0,     0,     0,     0,     0,     0,     0,  5719,     0,
       0,     0,     0,     0,   890,  2587,     0,   890,   890,  5726,
       0,     0,  2590,     0,     0,     0,   955,     0,     0,  1797,
       0,     0,     0,     0,     0,   954,     0,   954,     0,     0,
       0,     0,  5628,     0,     0,     0,     0,     0,   890,   890,
     954,     0,   954,     0,     0,     0,  2327,     0,     0,     0,
     885,     0,     0,     0,     0,     0,     0,   891,     0,     0,
    2588,     0,     0,  2589,     0,   885,     0,   894,   891,     0,
     885,     0,     0,     0,     0,     0,  5785,     0,     0,     0,
       0,     0,     0,     0,   891,     0,     0,     0,     0,     0,
       0,     0,     0,   894,  1798,     0,     0,     0,   885,     0,
     887,     0,     0,     0,   887,   887,     0,     0,     0,   954,
       0,     0,     0,   955,  2518,     0,     0,     0,     0,     0,
       0,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4250,     0,     0,     0,
       0,   954,     0,     0,  2590,     0,     0,     0,     0,     0,
       0,     0,   887,     0,     0,     0,     0,     0,   887,     0,
     954,     0,     0,   890,   954,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5741,     0,  5743,     0,   954,     0,     0,     0,   955,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   887,
       0,     0,  5884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   893,  5897,     0,     0,     0,
       0,     0,     0,     0,     0,   894,     0,     0,     0,     0,
       0,     0,     0,     0,   888,     0,   891,     0,   888,   888,
       0,   893,     0,     0,     0,  4002,  2518,     0,     0,     0,
       0,     0,     0,     0,     0,  2519,  2520,  2521,  2522,  2523,
    2524,  2525,  2526,  2527,     0,     0,     0,     0,     0,     0,
       0,     0,   894,     0,     0,  5936,     0,   894,     0,     0,
       0,     0,     0,     0,  1797,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   888,     0,     0,     0,
       0,     0,   888,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   955,     0,   955,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,   885,     0,   885,
       0,     0,     0,   888,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   955,     0,     0,     0,     0,  2078,  6011,
       0,  2079,     0,   945,     0,  2080,  2081,  2082,     0,     0,
       0,     0,     0,     0,     0,     0,   893,     0,     0,     0,
       0,     0,   885,  2580,     0,     0,     0,     0,     0,     0,
     885,  6023,     0,  2581,     0,     0,     0,     0,   887,     0,
    2582,     0,  6033,  1798,     0,     0,     0,     0,   945,     0,
       0,     0,     0,     0,     0,   885,     0,     0,   894,  5932,
       0,     0,  2078,     0,     0,  2079,  2583,     0,     0,  2080,
    2081,  2082,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2580,     0,     0,
    4060,     0,     0,     0,     0,   954,     0,  2581,     0,     0,
       0,     0,     0,     0,  2582,     0,     0,     0,     0,     0,
       0,   887,     0,     0,     0,   887,     0,     0,     0,   891,
       0,     0,     0,     0,     0,   885,     0,   885,     0,     0,
    2583,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6100,     0,  1797,     0,     0,     0,
       0,  1797,     0,  1797,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6017,     0,     0,  1797,   893,     0,
       0,  2584,   888,     0,   894,     0,  2585,   891,     0,   893,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   893,     0,     0,     0,  2586,
    2269,     0,     0,     0,     0,     0,     0,     0,   887,     0,
       0,   885,     0,   954,   894,     0,   954,     0,   891,     0,
    2587,     0,     0,   887,     0,     0,     0,     0,   887,     0,
       0,     0,     0,     0,     0,  2584,   894,     0,     0,     0,
    2585,     0,     0,     0,     0,   888,     0,     0,     0,   888,
       0,   891,   955,   885,     0,     0,   887,     0,     0,     0,
       0,  2327,     0,  2586,  2269,     0,   955,     0,     0,     0,
       0,     0,     0,     0,  6094,  2588,     0,     0,  2589,     0,
       0,   885,     0,     0,  2587,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1798,  4028,     0,
       0,     0,     0,     0,  1096,  1096,   954,   954,   894,     0,
       0,     0,     0,     0,     0,     0,     0,   954,     0,     0,
       0,     0,     0,     0,     0,  2327,     0,     0,     0,     0,
       0,     0,     0,     0,   954,     0,     0,     0,     0,  2588,
       0,     0,  2589,     0,     0,     0,     0,     0,     0,   885,
       0,     0,   888,     0,     0,     0,     0,   893,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   888,     0,  2590,
    2078,   885,   888,  2079,     0,     0,     0,  2080,  2081,  2082,
       0,     0,     0,   890,     0,     0,     0,   890,   890,     0,
       0,     0,     0,   885,     0,  2580,     0,     0,  1798,     0,
     888,     0,     0,     0,     0,  2581,     0,     0,  1096,     0,
       0,     0,  2582,     0,     0,   954,     0,     0,  1797,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   894,
       0,     0,     0,  2590,     0,     0,     0,     0,  2583,     0,
       0,     0,   891,     0,     0,   890,     0,     0,     0,     0,
       0,   890,     0,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1798,     0,   955,     0,     0,     0,   891,
       0,  2518,     0,     0,     0,   885,     0,     0,     0,     0,
    2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,     0,
       0,     0,   890,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   887,     0,     0,   887,     0,   887,     0,     0,
       0,     0,   887,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4065,  2518,     0,     0,   891,     0,
       0,   891,   891,   885,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,  2584,     0,     0,     0,     0,  2585,     0,
     887,     0,     0,     0,   894,     0,     0,     0,   887,     0,
       0,     0,   891,   891,     0,     0,     0,     0,     0,     0,
     958,  2586,  2269,     0,     0,     0,     0,     0,     0,     0,
       0,   955,   992,   887,     0,     0,     0,     0,     0,     0,
       0,     0,  2587,  1011,   945,     0,     0,     0,     0,     0,
     893,     0,     0,     0,     0,     0,     0,   955,     0,     0,
    2078,     0,     0,  2079,     0,     0,     0,  2080,  2081,  2082,
       0,     0,     0,   894,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2327,     0,  2580,   888,     0,  4072,   888,
       0,   888,   954,     0,     0,  2581,   888,  2588,     0,     0,
    2589,     0,  2582,   887,     0,   887,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   945,   945,   893,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2583,     0,
       0,     0,     0,     0,     0,     0,   954,     0,     0,     0,
       0,   890,     0,   885,   888,     0,     0,   891,   954,     0,
       0,     0,   888,     0,     0,     0,     0,     0,     0,   893,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   955,     0,   888,     0,     0,
       0,     0,   954,     0,     0,     0,     0,     0,     0,     0,
       0,  2590,   893,   894,     0,     0,     0,     0,     0,   887,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   890,     0,     0,     0,   890,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,   887,     0,  2584,     0,     0,     0,   888,  2585,   888,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
    1797,     0,     0,     0,     0,     0,     0,     0,     0,   887,
       0,  2586,  2269,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2587,  2518,     0,     0,     0,     0,     0,     0,
       0,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,     0,     0,  1798,     0,     0,     0,     0,     0,     0,
       0,   890,     0,     0,     0,   894,     0,     0,     0,     0,
     894,   894,     0,  2327,     0,     0,   890,   887,     0,     0,
       0,   890,     0,   888,     0,     0,     0,  2588,     0,     0,
    2589,     0,     0,     0,     0,     0,     0,     0,  1798,   887,
       0,     0,     0,     0,     0,   954,   945,   945,     0,   890,
       0,     0,     0,     0,     0,     0,  1798,     0,     0,     0,
       0,   887,     0,   893,  2078,   888,     0,  2079,     0,     0,
       0,  2080,  2081,  2082,   893,     0,     0,     0,     0,     0,
       0,   885,     0,     0,     0,     0,     0,     0,     0,  2580,
     893,     0,     0,   888,     0,     0,     0,     0,     0,  2581,
       0,     0,     0,     0,     0,     0,  2582,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2590,     0,   894,     0,     0,     0,     0,   885,     0,
       0,     0,  2583,   885,     0,  1031,     0,     0,     0,     0,
       0,  1063,     0,   887,   893,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2078,     0,   893,
    2079,   888,   893,   893,  2080,  2081,  2082,     0,     0,     0,
       0,   954,   894,   954,     0,     0,     0,     0,     0,     0,
       0,     0,  2580,   888,     0,  4681,   887,     0,     0,     0,
       0,     0,  2581,   893,   893,     0,     0,     0,     0,  2582,
       0,     0,     0,     0,     0,   888,     0,     0,     0,     0,
       0,   887,     0,     0,     0,     0,     0,     0,     0,   954,
       0,     0,     0,  2518,     0,  2583,     0,     0,     0,     0,
       0,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,     0,     0,     0,     0,     0,     0,  2584,     0,     0,
       0,     0,  2585,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1797,
       0,     0,     0,     0,     0,  2586,  2269,     0,     0,     0,
       0,     0,  2078,     0,   885,  2079,     0,   888,     0,  2080,
    2081,  2082,     0,     0,     0,   890,  2587,     0,   890,     0,
     890,     0,     0,     0,     0,   890,     0,  2580,     0,     0,
       0,     0,     0,     0,     0,  1369,     0,  2581,     0,     0,
       0,     0,     0,     0,  2582,     0,     0,     0,   893,     0,
     888,     0,     0,     0,  1392,     0,     0,  2327,     0,     0,
    2584,     0,     0,     0,     0,  2585,     0,     0,     0,     0,
    2583,  2588,     0,   890,  2589,   888,     0,     0,     0,     0,
       0,   890,     0,     0,     0,     0,     0,     0,  2586,  2269,
       0,   887,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   890,     0,     0,  2587,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1450,     0,     0,     0,     0,     0,
     885,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   891,     0,     0,
    2327,   891,   891,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2588,  2590,  5124,  2589,     0,     0,
     885,  1587,     0,     0,     0,     0,   890,     0,   890,     0,
       0,   887,     0,     0,     0,  2584,     0,     0,     0,     0,
    2585,     0,   885,     0,     0,     0,     0,     0,  4612,     0,
       0,     0,     0,     0,     0,     0,     0,   887,   954,   891,
       0,     0,     0,  2586,  2269,   891,     0,     0,     0,     0,
       0,     0,   954,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2587,   888,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1797,     0,     0,   891,     0,  2590,     0,
       0,     0,     0,     0,   885,     0,     0,  2518,     0,     0,
       0,     0,   890,     0,     0,  2327,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,     0,  1847,     0,     0,  2588,
       0,     0,  2589,     0,  2078,     0,     0,  2079,     0,     0,
       0,  2080,  2081,  2082,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   890,  1881,  1884,  1885,     0,  2580,
       0,     0,     0,     0,     0,   888,     0,     0,     0,  2581,
       0,     0,     0,     0,     0,     0,  2582,     0,     0,     0,
       0,     0,   890,     0,     0,     0,     0,     0,     0,   887,
       0,   888,     0,     0,  1797,     0,     0,     0,     0,     0,
    2518,     0,  2583,     0,     0,     0,     0,     0,     0,  2519,
    2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,     0,     0,
       0,     0,     0,  2590,     0,   885,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   887,     0,     0,     0,
       0,   887,     0,     0,     0,     0,     0,     0,     0,     0,
     890,     0,     0,     0,     0,     0,     0,     0,     0,  1797,
       0,   954,     0,     0,  1369,     0,     0,     0,     0,     0,
       0,     0,   890,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   890,     0,     0,  1369,  5130,     0,
       0,     0,     0,     0,     0,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2584,     0,     0,
       0,     0,  2585,     0,     0,  2518,     0,     0,     0,     0,
       0,     0,     0,   888,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,     0,     0,  2586,  2269,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,     0,     0,  2587,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   890,     0,   891,     0,
     888,     0,   891,     0,     0,   888,     0,   954,     0,     0,
       0,     0,   887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2327,     0,     0,
       0,     0,     0,   954,     0,     0,     0,     0,     0,   890,
       0,  2588,     0,     0,  2589,     0,     0,     0,  2078,   885,
       0,  2079,     0,     0,     0,  2080,  2081,  2082,     0,     0,
       0,     0,  2574,     0,   890,     0,     0,     0,     0,     0,
       0,     0,     0,  2580,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2581,     0,     0,     0,     0,     0,     0,
    2582,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   891,     0,     0,   893,     0,
       0,     0,   893,   893,     0,     0,  2583,     0,     0,     0,
     891,     0,     0,     0,     0,   891,  1344,  1344,     0,     0,
       0,     0,     0,     0,     0,  2590,     0,     0,   887,     0,
       0,     0,  2665,     0,     0,     0,     0,     0,     0,     0,
       0,   954,     0,   891,     0,     0,   888,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
     893,     0,     0,     0,     0,     0,   893,     0,   887,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     887,     0,     0,     0,  1344,     0,  5131,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   893,     0,     0,
       0,     0,     0,     0,   890,     0,  2782,     0,     0,     0,
       0,  2584,     0,     0,     0,  2805,  2585,  2518,     0,     0,
       0,     0,     0,     0,     0,     0,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,     0,     0,     0,     0,  2586,
    2269,     0,     0,     0,     0,     0,     0,  2843,     0,     0,
       0,     0,   887,  2855,  2855,     0,     0,  2855,     0,     0,
    2587,     0,   888,     0,     0,     0,     0,     0,     0,  1797,
    2873,     0,     0,  2876,     0,     0,     0,     0,     0,     0,
       0,   885,     0,     0,     0,     0,   885,   885,     0,     0,
       0,     0,     0,     0,   890,     0,     0,     0,     0,     0,
       0,  2327,   888,     0,     0,  1708,  1712,     0,     0,     0,
       0,     0,     0,     0,  1797,  2588,     0,     0,  2589,     0,
     890,     0,     0,     0,   888,     0,     0,     0,  2929,     0,
       0,     0,  1797,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2948,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   887,     0,     0,     0,     0,     0,   891,
       0,     0,   891,     0,   891,     0,     0,     0,     0,   891,
       0,     0,     0,     0,     0,     0,   888,     0,     0,   885,
       0,     0,     0,     0,     0,     0,   893,     0,     0,  2590,
       0,     0,     0,     0,  2078,     0,     0,  2079,     0,     0,
       0,  2080,  2081,  2082,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   891,     0,  2580,
       0,     0,     0,     0,     0,   891,     0,     0,   885,  2581,
       0,     0,  2970,     0,     0,     0,  2582,     0,     0,     0,
       0,     0,   890,  2973,     0,     0,     0,     0,     0,     0,
     891,     0,     0,     0,     0,     0,     0,     0,     0,   893,
       0,     0,  2583,   893,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3017,  2855,     0,   887,   890,
       0,  2518,     0,     0,   890,     0,     0,   888,     0,     0,
    2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,     0,
    3052,     0,     0,     0,     0,     0,  2078,  3065,     0,  2079,
     891,     0,   891,  2080,  2081,  2082,     0,     0,     0,  2029,
       0,  5132,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2580,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2581,     0,     0,     0,     0,     0,   887,  2582,     0,
       0,     0,     0,     0,  2048,     0,   893,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2584,     0,     0,
       0,   893,  2585,     0,  2583,     0,   893,     0,     0,     0,
    3126,     0,     0,  2067,  2068,  2069,     0,  2071,     0,     0,
       0,     0,     0,     0,     0,  2586,  2269,     0,     0,     0,
       0,     0,     0,     0,   893,     0,   891,  2536,     0,     0,
       0,     0,     0,  1369,  1369,     0,  2587,     0,     0,     0,
       0,     0,   888,     0,     0,     0,     0,     0,     0,     0,
    3180,  2078,     0,  3182,  2079,   890,     0,     0,  2080,  2081,
    2082,     0,     0,     0,     0,     0,     0,     0,   891,     0,
       0,     0,     0,     0,     0,     0,  2580,  2327,     0,     0,
       0,     0,     0,     0,     0,     0,  2581,   887,     0,     0,
       0,  2588,     0,  2582,  2589,     0,   891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2584,
       0,   888,     0,     0,  2585,     0,     0,     0,     0,  2583,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2632,     0,     0,     0,  2644,  2649,     0,  2586,  2269,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2587,     0,
       0,     0,     0,     0,   891,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   890,     0,     0,     0,  2590,   891,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2327,
       0,     0,     0,     0,     0,     0,     0,     0,   891,  5659,
       0,     0,     0,  2588,     0,     0,  2589,     0,     0,   887,
       0,   890,     0,     0,   887,   887,     0,     0,     0,     0,
       0,   888,     0,     0,  2584,     0,     0,     0,     0,  2585,
       0,     0,     0,   890,     0,     0,     0,     0,     0,     0,
       0,  2078,     0,     0,  2079,     0,     0,     0,  2080,  2081,
    2082,     0,  2586,  2269,     0,     0,     0,     0,     0,     0,
     893,     0,     0,   893,     0,   893,  2580,     0,     0,     0,
     893,     0,     0,  2587,     0,     0,  2581,  2518,     0,     0,
     891,     0,     0,  2582,     0,     0,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,     0,     0,  2590,     0,     0,
       0,     0,     0,     0,     0,   890,     0,     0,     0,  2583,
       0,     0,     0,     0,  2327,     0,     0,     0,   893,     0,
       0,     0,     0,   891,     0,     0,   893,   887,  2588,     0,
       0,  2589,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   891,     0,
       0,   893,     0,   888,     0,     0,     0,     0,   888,   888,
       0,     0,     0,     0,     0,     0,     0,  1708,  1708,  1708,
       0,     0,     0,  5486,     0,     0,   887,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2518,
       0,     0,     0,     0,     0,     0,     0,     0,  2519,  2520,
    2521,  2522,  2523,  2524,  2525,  2526,  2527,     0,     0,     0,
       0,   893,  2590,   893,  2584,     0,   890,     0,     0,  2585,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2586,  2269,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   888,     0,  2587,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   198,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   891,     0,
       0,     0,     0,     0,  2327,     0,     0,   893,     0,     0,
     888,     0,     0,     0,  2518,     0,     0,     0,  2588,     0,
       0,  2589,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,     0,     0,     0,     0,     0,     0,     0,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   893,
       0,   890,     0,     0,     0,   200,     0,     0,     0,     0,
    3357,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3362,     0,     0,   201,     0,     0,     0,   893,     0,   202,
       0,     0,     0,     0,     0,     0,     0,     0,   891,     0,
       0,     0,     0,     0,     0,     0,     0,   203,     0,  1450,
       0,     0,     0,     0,     0,     0,     0,     0,   204,     0,
       0,     0,  2590,     0,   891,     0,     0,   205,     0,     0,
     890,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     206,     0,     0,     0,     0,     0,   207,     0,     0,     0,
       0,     0,     0,   208,     0,   893,  1450,  1450,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   209,     0,     0,     0,   893,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1369,     0,     0,     0,     0,     0,  3208,     0,     0,   893,
       0,     0,     0,     0,   210,  3228,  3228,  3233,  3239,     0,
       0,     0,  3244,     0,  3245,     0,  3247,     0,     0,  3261,
    3264,  3269,     0,     0,  2518,     0,   211,  3278,     0,     0,
    3283,     0,     0,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,     0,     0,     0,  3290,  3291,  3292,     0,     0,
     890,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3293,     0,     0,   891,   212,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   893,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   213,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   214,   215,     0,     0,   216,     0,     0,     0,
       0,     0,     0,   891,     0,     0,     0,     0,   891,     0,
       0,     0,     0,  3575,   893,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,   218,     0,  3597,     0,
     219,     0,     0,   220,     0,     0,     0,     0,     0,   893,
     221,     0,     0,   222,     0,     0,     0,     0,     0,     0,
    3625,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,     0,     0,   224,
       0,     0,   890,     0,   225,     0,   226,   890,   890,   227,
       0,     0,     0,   228,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   229,     0,     0,     0,  3300,   230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   232,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3703,  3704,     0,     0,
       0,     0,     0,     0,  3319,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   891,
       0,     0,  2529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     890,     0,     0,     0,     0,     0,     0,  3321,     0,   893,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,     0,     2,
       0,     3,     4,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3827,     0,   890,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     6,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     7,     0,     8,     9,     0,     0,     0,     0,     0,
      10,     0,    11,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,   891,    13,     0,     0,   893,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    14,     0,     0,    15,     0,     0,     0,
       0,     0,     0,     0,     0,   893,     0,     0,     0,     0,
       0,    16,     0,    17,     0,   891,     0,    18,     0,     0,
       0,     0,     0,  5637,     0,     0,     0,     0,     0,     0,
       0,    20,     0,    21,     0,     0,     0,   891,     0,     0,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   700,     0,     0,     0,    23,   701,
       0,     0,     0,     0,  3328,  3329,  3330,  3331,  3332,  3333,
    3334,  3335,  3336,     0,  3337,    24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1344,     0,  1708,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   702,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   891,
     703,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    25,    26,     0,  3293,   704,     0,    27,  3300,
       0,     0,  3319,     0,  3321,     0,     0,  3374,     0,     0,
       0,     0,    28,     0,   705,     0,     0,   893,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      29,     0,     0,     0,     0,     0,     0,     0,   706,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   707,
       0,     0,     0,     0,     0,     0,     0,     0,   708,     0,
    2068,  2069,     0,     0,   893,     0,     0,    30,     0,   893,
       0,   709,     0,     0,     0,    31,     0,   710,     0,     0,
       0,     0,     0,     0,   711,     0,  2529,     0,     0,    32,
    2529,     0,     0,     0,     0,    33,    34,     0,    35,     0,
     891,     0,     0,    36,   712,     0,  4542,     0,     0,    37,
       0,     0,    38,     0,     0,     0,     0,     0,     0,    39,
       0,     0,     0,     0,     0,     0,    40,    41,     0,     0,
       0,     0,     0,  4128,    42,     0,     0,     0,    43,     0,
       0,     0,     0,  3517,     0,     0,     0,     0,    44,     0,
       0,     0,     0,     0,  1450,     0,     0,   713,     0,     0,
       0,     0,     0,     0,    45,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    47,     0,     0,   714,     0,
       0,    48,     0,     0,     0,     0,    49,     0,     0,     0,
       0,   715,     0,     0,     0,     0,     0,     0,     0,    50,
     893,     0,     0,   716,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   214,   717,   891,     0,   718,     0,     0,
       0,     0,     0,    51,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,     0,   719,  -136,     0,   720,     0,     0,
       0,   721,     0,     0,   722,     0,     0,     0,     0,     0,
       0,   723,     0,     0,   724,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   725,   891,     0,     0,     0,     0,     0,
     726,     0,     0,     0,     0,     0,     0,   727,     0,     0,
     728,     0,     0,     0,   729,     0,     0,     0,     0,     0,
       0,     0,   730,     0,   731,     0,     0,     0,     0,   732,
       0,     0,     0,     0,     0,     0,   893,     0,     0,     0,
       0,     0,   733,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   734,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3759,  3760,
    1708,     0,     0,     0,  3764,     0,   893,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,   893,     0,
       0,  3793,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4337,     0,     0,   891,     0,  2529,     0,     0,     0,
    3257,  2855,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2529,  2529,  2529,     0,  2529,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     893,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   891,     0,     0,     0,
       0,   891,   891,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4468,  4469,  4470,     0,     0,     0,     0,     0,     0,     0,
       0,   893,     0,     0,     0,     0,     0,  4479,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3988,     0,     0,     0,     0,  3994,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4504,  4506,     0,     0,     0,  4511,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2071,
       0,     0,     0,     0,   891,     0,     0,     0,     0,     0,
    3269,     0,  3269,  3269,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4075,     0,     0,  4078,
       0,  4080,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   891,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   893,  4107,     0,  4110,
       0,  4112,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1369,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   893,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4179,     0,     0,     0,     0,  2632,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2649,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4715,  4716,  4717,     0,  2529,     0,     0,  4229,     0,     0,
       0,     0,     0,     0,     0,   893,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2529,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   893,     0,     0,
       0,     0,   893,   893,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1708,     0,     0,     0,     0,   893,  1708,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   893,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4979,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4491,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5011,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5069,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3126,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4613,     0,     0,     0,     0,     0,
       0,     0,     0,  4617,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3228,     0,     0,     0,  3228,  3228,     0,
       0,     0,     0,  3239,     0,     0,     0,     0,     0,     0,
       0,  4635,     0,  4636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4658,  4659,  4660,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3278,
       0,     0,  5169,  5170,  5171,  5172,     0,  4684,     0,     0,
    4687,     0,  4689,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4695,     0,     0,     0,     0,     0,     0,     0,  4702,  4703,
       0,     0,     0,     0,     0,  4708,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2529,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2529,     0,     0,     0,
       0,  2529,  4760,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,  2529,  2529,     0,  2529,     0,     0,     0,  4774,
    3257,  3257,     0,  4051,     0,  3257,     0,     0,     0,  2529,
       0,     0,  2529,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,  2529,     0,     0,     0,
       0,  2529,     0,     0,     0,     0,     0,     0,  2529,  2529,
    2529,  2529,     0,     0,     0,  3257,  3257,     0,  2529,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,     0,  2529,
       0,     0,     0,     0,     0,     0,  2529,  2529,  2529,  2529,
    2529,  2529,  2529,  2529,  2529,  2529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5384,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5394,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5057,  5058,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5065,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2632,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5126,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5145,  5147,     0,     0,     0,     0,     0,
    5151,  5152,     0,     0,     0,  5153,     0,     0,     0,     0,
       0,     0,  5156,     0,     0,  5159,  5160,     0,     0,     0,
    5582,     0,  5165,     0,     0,  1369,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,  2529,     0,
       0,     0,  2529,     0,  5612,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5199,     0,     0,     0,     0,
       0,  2529,     0,     0,     0,     0,  1344,     0,     0,     0,
       0,     0,     0,     0,  5213,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5716,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5288,     0,     0,
       0,     0,     0,     0,  5290,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2529,     0,     0,     0,
       0,     0,  2529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5325,     0,  5792,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4051,  4051,  5814,     0,  3257,  3257,  3257,  3257,     0,     0,
    3257,  3257,  3257,  3257,  3257,  3257,  3257,  3257,  3257,  3257,
    4051,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2529,     0,     0,  2529,     0,  2529,     0,
       0,  4051,  4051,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2529,  3257,  3257,  2529,     0,
    2529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5416,
       0,     0,     0,     0,     0,  5420,  5421,  5422,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5435,  5436,     0,     0,  5437,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5456,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,  5474,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5489,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3257,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2529,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2071,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5733,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5769,     0,     0,     0,     0,
       0,  2529,     0,     0,     0,  2529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2529,  2529,     0,     0,     0,     0,  4051,
    4051,  4051,  4051,     0,     0,     0,  4051,  4051,  4051,  4051,
    4051,  4051,  4051,  4051,  4051,  4051,  2529,  2529,  2529,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2529,     0,     0,  2529,     0,  2529,     0,     0,
       0,     0,     0,  2529,  5835,     0,  4051,  4051,     0,     0,
    2529,  2529,     0,  5842,  5842,  5842,  2529,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5474,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5886,  2529,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5842,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5474,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5999,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4051,     0,
       0,     0,     0,     0,     0,     0,     0,  6040,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6065,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2529,  2529,     0,     0,     0,
       0,     0,     0,  2529,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5842,     0,     0,     0,  2529,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6133,     0,     0,     0,
       0,     0,     0,     0,  2529,  3257,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2529,     0,  2529,     0,     0,     0,  2529,
    2529,  2529,     0,     0,  2529,     0,     0,  2529,  2529,     0,
       0,     0,     0,  2529,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3257,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2529,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2529,     0,     0,  1708,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2529,     0,  2529,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2529,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2529,     0,  4051,  3257,  2529,  2529,
    2529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2529,  2529,  2529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3257,     0,     0,
    4051,     0,     0,     0,  2529,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4051,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4051,     0,  3257,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2529,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2529,     0,     0,     0,     0,     0,     0,
    2529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2529,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3257,  3257,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2529,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,  2529,  1255,   695,     0,  1256,  1257,  1258,
     756,  1259,     0,     0,  4051,  4051,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,  1702,   245,
     246,   247,     0,     0,     0,     0,  1260,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1261,   261,  1262,  1263,     0,   264,   265,   266,
     267,   268,   269,   270,  1264,  1265,   271,   272,  1266,  1267,
     275,  2529,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,  1277,  1278,   311,  1279,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,  1703,     0,   324,   325,   868,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,  1280,   340,   341,   342,   343,  1281,  1282,
     345,     0,   346,   347,   348,  1283,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,  1285,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,  1286,  1287,     0,  1288,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,     0,     0,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,  1296,   436,  1297,   438,
     439,   440,   441,   442,   443,   444,   445,  1298,   447,  1299,
     448,   449,   450,   451,  1300,  1301,   453,  1302,   455,   456,
     457,     0,   458,   459,     0,     0,  1303,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  1306,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,  1307,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,  1309,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,  1312,  1313,     0,     0,   577,
     578,  1314,   580,  1315,  1316,   582,   583,   584,   585,   586,
     587,   588,   589,     0,  1317,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,  1319,  1704,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,   627,
     628,     0,  1328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1329,  1330,  1705,     0,     0,     0,
       0,     0,     0,  1332,  1706,   235,     0,  1255,   695,     0,
    1256,  1257,  1258,   756,  1259,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1260,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1261,   261,  1262,  1263,     0,
     264,   265,   266,   267,   268,   269,   270,  1264,  1265,   271,
     272,  1266,  1267,   275,     0,   276,   277,   278,   279,  1268,
       0,  1269,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1270,  1271,  1272,  1273,  1274,
    1275,  1276,   303,   304,   305,   306,   307,   308,  1277,  1278,
     311,  1279,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     868,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,  1280,   340,   341,   342,
     343,  1281,  1282,   345,     0,   346,   347,   348,  1283,   350,
       0,   351,     0,   352,   353,   354,     0,   355,   356,   357,
     358,   359,     0,   360,  1284,     0,  1285,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,  1286,  1287,     0,
    1288,     0,   393,   394,   395,   396,   397,   398,  1289,  1290,
    1291,  1292,   403,   404,   405,   406,   407,   408,     0,     0,
     409,  1293,   411,   412,   413,     0,   414,   415,   416,  1294,
    1295,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,  1296,
     436,  1297,   438,   439,   440,   441,   442,   443,   444,   445,
    1298,   447,  1299,   448,   449,   450,   451,  1300,  1301,   453,
    1302,   455,   456,   457,     0,   458,   459,     0,     0,  1303,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
    1304,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,  1305,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,  1306,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
    1307,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,    41,   535,   536,   537,   538,   539,  1308,   540,   541,
     542,   543,   544,   545,   546,   547,  1309,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,  1310,   564,     0,   565,   566,  1311,    45,   567,
     568,   569,   570,   571,   572,   573,     0,   574,  1312,  1313,
       0,     0,   577,   578,  1314,   580,  1315,  1316,   582,   583,
     584,   585,   586,   587,   588,   589,     0,  1317,   590,   591,
     592,   593,   594,  1318,     0,   595,   596,   597,   598,   599,
    1185,  1319,     0,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,    50,   609,   610,   611,   612,   613,   614,
     615,  1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,
     625,   626,   627,   628,     0,  1328,     0,    51,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1329,  1330,     0,
       0,     0,     0,     0,     0,     0,  1332,  5693,   235,     0,
    1255,   695,     0,  1256,  1257,  1258,   756,  1259,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,  1260,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1261,   261,
    1262,  1263,     0,   264,   265,   266,   267,   268,   269,   270,
    1264,  1265,   271,   272,  1266,  1267,   275,     0,   276,   277,
     278,   279,  1268,     0,  1269,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1270,  1271,
    1272,  1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,
     308,  1277,  1278,   311,  1279,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   868,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,  1280,
     340,   341,   342,   343,  1281,  1282,   345,     0,   346,   347,
     348,  1283,   350,     0,   351,     0,   352,   353,   354,     0,
     355,   356,   357,   358,   359,     0,   360,  1284,     0,  1285,
     363,   364,     0,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
    1286,  1287,     0,  1288,     0,   393,   394,   395,   396,   397,
     398,  1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,
     408,     0,     0,   409,  1293,   411,   412,   413,     0,   414,
     415,   416,  1294,  1295,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,  1296,   436,  1297,   438,   439,   440,   441,   442,
     443,   444,   445,  1298,   447,  1299,   448,   449,   450,   451,
    1300,  1301,   453,  1302,   455,   456,   457,     0,   458,   459,
       0,     0,  1303,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,  1304,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,  1305,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,  1306,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,  1307,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
    1308,   540,   541,   542,   543,   544,   545,   546,   547,  1309,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,  1310,   564,     0,   565,   566,
    1311,     0,   567,   568,   569,   570,   571,   572,   573,     0,
     574,  1312,  1313,     0,     0,   577,   578,  1314,   580,  1315,
    1316,   582,   583,   584,   585,   586,   587,   588,   589,     0,
    1317,   590,   591,   592,   593,   594,  1318,     0,   595,   596,
     597,   598,   599,   600,  1319,     0,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,
    1325,  1326,  1327,   625,   626,   627,   628,     0,  1328,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1329,  1330,     0,     0,     0,     0,     0,     0,     0,  1332,
    3259,   235,     0,  1255,   695,     0,  1256,  1257,  1258,   756,
    1259,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,  1260,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1261,   261,  1262,  1263,     0,   264,   265,   266,   267,
     268,   269,   270,  1264,  1265,   271,   272,  1266,  1267,   275,
       0,   276,   277,   278,   279,  1268,     0,  1269,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,   304,
     305,   306,   307,   308,  1277,  1278,   311,  1279,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   868,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,  1280,   340,   341,   342,   343,  1281,  1282,   345,
       0,   346,   347,   348,  1283,   350,     0,   351,     0,   352,
     353,   354,     0,   355,   356,   357,   358,   359,     0,   360,
    1284,     0,  1285,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,  1286,  1287,     0,  1288,     0,   393,   394,
     395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,   404,
     405,   406,   407,   408,     0,     0,   409,  1293,   411,   412,
     413,     0,   414,   415,   416,  1294,  1295,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,  1296,   436,  1297,   438,   439,
     440,   441,   442,   443,   444,   445,  1298,   447,  1299,   448,
     449,   450,   451,  1300,  1301,   453,  1302,   455,   456,   457,
       0,   458,   459,     0,     0,  1303,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,  1304,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,  1305,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,  1306,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,  1307,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,  1308,   540,   541,   542,   543,   544,   545,
     546,   547,  1309,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,  1310,   564,
       0,   565,   566,  1311,     0,   567,   568,   569,   570,   571,
     572,   573,     0,   574,  1312,  1313,     0,     0,   577,   578,
    1314,   580,  1315,  1316,   582,   583,   584,   585,   586,   587,
     588,   589,     0,  1317,   590,   591,   592,   593,   594,  1318,
       0,   595,   596,   597,   598,   599,   600,  1319,     0,   602,
     603,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,  1320,  1321,  1322,
    1323,   620,  1324,  1325,  1326,  1327,   625,   626,   627,   628,
       0,  1328,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1329,  1330,     0,     0,     0,     0,     0,
       0,     0,  1332,  4637,   235,     0,  1255,   695,     0,  1256,
    1257,  1258,   756,  1259,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1260,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1261,   261,  1262,  1263,     0,   264,
     265,   266,   267,   268,   269,   270,  1264,  1265,   271,   272,
    1266,  1267,   275,     0,   276,   277,   278,   279,  1268,     0,
    1269,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1270,  1271,  1272,  1273,  1274,  1275,
    1276,   303,   304,   305,   306,   307,   308,  1277,  1278,   311,
    1279,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   868,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,  1280,   340,   341,   342,   343,
    1281,  1282,   345,     0,   346,   347,   348,  1283,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,  1284,     0,  1285,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,  1286,  1287,     0,  1288,
       0,   393,   394,   395,   396,   397,   398,  1289,  1290,  1291,
    1292,   403,   404,   405,   406,   407,   408,     0,     0,   409,
    1293,   411,   412,   413,     0,   414,   415,   416,  1294,  1295,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,  1296,   436,
    1297,   438,   439,   440,   441,   442,   443,   444,   445,  1298,
     447,  1299,   448,   449,   450,   451,  1300,  1301,   453,  1302,
     455,   456,   457,     0,   458,   459,     0,     0,  1303,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,  1304,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,  1305,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,  1306,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,  1307,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,  1308,   540,   541,   542,
     543,   544,   545,   546,   547,  1309,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,  1310,   564,     0,   565,   566,  1311,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,  1312,  1313,     0,
       0,   577,   578,  1314,   580,  1315,  1316,   582,   583,   584,
     585,   586,   587,   588,   589,     0,  1317,   590,   591,   592,
     593,   594,  1318,     0,   595,   596,   597,   598,   599,   600,
    1319,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
    1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,   625,
     626,   627,   628,     0,  1328,     0,     0,     0,     0,     0,
     636,     0,     0,     0,     0,     0,  1329,  1330,     0,     0,
       0,     0,     0,     0,     0,  1332,  4705,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,  4157,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0, -1815,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
       0,     0, -1815,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383, -1815,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396, -1815,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410, -1815,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435, -1815,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517, -1815,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,     0,
       0,     0,     0,     0,     0,     0,   860,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1443,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,     0,   861,   261,   862,   863,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   864,   865,   275,     0,   276,   277,   278,   279,
       0,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   866,
     867,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   868,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,     0,   340,   341,
     342,   343,     0,     0,   345,     0,   346,   347,   348,   869,
     350,     0,   351,     0,   352,   353,   354,     0,   355,   356,
     357,   358,   359,     0,   360,     0,     0,     0,   363,   364,
       0,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,  2675,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,  2676,   386,   387,   388,   389,   870,   871,
       0,   872,     0,   393,   394,   395,   396,   397,   398,     0,
       0,     0,     0,   403,   404,   405,   406,   407,   408,     0,
       0,   409,     0,   411,   412,   413,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     873,   436,   874,   438,   439,   440,   441,   442,   443,   444,
       0,     0,   447,     0,   448,   449,   450,   451,     0,     0,
     453,   875,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,  2678,   466,   467,
     468,     0,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,     0,   483,     0,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   876,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,     0,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,  2679,   543,   544,   545,   546,   547,   878,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,     0,   564,     0,   565,   566,     0,     0,
     567,   568,   569,   570,   571,   572,   573,     0,   574,   879,
     880,     0,     0,   577,   578,     0,   580,     0,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,     0,   881,  2680,   602,   603,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,     0,   860,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   626,   627,   628,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,  2776,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   861,   261,   862,   863,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   864,   865,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   866,   867,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   868,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,     0,   340,   341,   342,   343,     0,     0,
     345,     0,   346,   347,   348,   869,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,     0,     0,     0,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,  2675,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,  2676,
     386,   387,   388,   389,   870,   871,     0,   872,     0,   393,
     394,   395,   396,   397,   398,     0,     0,     0,     0,   403,
     404,   405,   406,   407,   408,     0,     0,   409,     0,   411,
     412,   413,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   873,   436,   874,   438,
     439,   440,   441,   442,   443,   444,     0,     0,   447,     0,
     448,   449,   450,   451,     0,     0,   453,   875,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,  2678,   466,   467,   468,     0,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,     0,   483,     0,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   876,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,     0,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,  2679,   543,   544,
     545,   546,   547,   878,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,     0,
     564,     0,   565,   566,     0,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,   879,   880,     0,     0,   577,
     578,     0,   580,     0,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,     0,   881,  2680,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,     0,   235,     0,
    1255,   695,     0,  1256,  1257,  1258,   756,  1259,   626,   627,
     628,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,  1260,     0,  3882,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1261,   261,
    1262,  1263,     0,   264,   265,   266,   267,   268,   269,   270,
    1264,  1265,   271,   272,  1266,  1267,   275,     0,   276,   277,
     278,   279,  1268,     0,  1269,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1270,  1271,
    1272,  1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,
     308,  1277,  1278,   311,  1279,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   868,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,  1280,
     340,   341,   342,   343,  1281,  1282,   345,     0,   346,   347,
     348,  1283,   350,     0,   351,     0,   352,   353,   354,     0,
     355,   356,   357,   358,   359,     0,   360,  1284,     0,  1285,
     363,   364,     0,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
    1286,  1287,     0,  1288,     0,   393,   394,   395,   396,   397,
     398,  1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,
     408,     0,     0,   409,  1293,   411,   412,   413,     0,   414,
     415,   416,  1294,  1295,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,  1296,   436,  1297,   438,   439,   440,   441,   442,
     443,   444,   445,  1298,   447,  1299,   448,   449,   450,   451,
    1300,  1301,   453,  1302,   455,   456,   457,     0,   458,   459,
       0,     0,  1303,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,  1304,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,  1305,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,  1306,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  3225,   516,   517,   518,   519,   520,
     521,   522,   523,  1307,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,    41,   535,   536,   537,   538,   539,
    1308,   540,   541,   542,   543,   544,   545,   546,   547,  1309,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,  1310,   564,     0,   565,   566,
    1311,    45,   567,   568,   569,   570,   571,   572,   573,     0,
     574,  1312,  1313,     0,     0,   577,   578,  1314,   580,  1315,
    1316,   582,   583,   584,   585,   586,   587,   588,   589,     0,
    1317,   590,   591,   592,   593,   594,  1318,     0,   595,   596,
     597,   598,   599,  1185,  1319,     0,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,    50,   609,   610,   611,
     612,   613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,
    1325,  1326,  1327,   625,   626,   627,   628,     0,  1328,     0,
      51,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1329,  1330,     0,     0,     0,   235,     0,  1255,   695,  1332,
    1256,  1257,  1258,   756,  1259,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1260,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1261,   261,  1262,  1263,     0,
     264,   265,   266,   267,   268,   269,   270,  1264,  1265,   271,
     272,  1266,  1267,   275,     0,   276,   277,   278,   279,  1268,
       0,  1269,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1270,  1271,  1272,  1273,  1274,
    1275,  1276,   303,   304,   305,   306,   307,   308,  1277,  1278,
     311,  1279,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     868,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,  1280,   340,   341,   342,
     343,  1281,  1282,   345,     0,   346,   347,   348,  1283,   350,
       0,   351,     0,   352,   353,   354,     0,   355,   356,   357,
     358,   359,     0,   360,  1284,     0,  1285,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,  1286,  1287,     0,
    1288,     0,   393,   394,   395,   396,   397,   398,  1289,  1290,
    1291,  1292,   403,   404,   405,   406,   407,   408,     0,     0,
     409,  1293,   411,   412,   413,     0,   414,   415,   416,  1294,
    1295,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,  1296,
     436,  1297,   438,   439,   440,   441,   442,   443,   444,   445,
    1298,   447,  1299,   448,   449,   450,   451,  1300,  1301,   453,
    1302,   455,   456,   457,     0,   458,   459,     0,     0,  1303,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
    1304,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,  1305,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,  1306,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
    1307,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,    41,   535,   536,   537,   538,   539,  1308,   540,   541,
     542,   543,   544,   545,   546,   547,  1309,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,  1310,   564,     0,   565,   566,  1311,    45,   567,
     568,   569,   570,   571,   572,   573,     0,   574,  1312,  1313,
       0,     0,   577,   578,  1314,   580,  1315,  1316,   582,   583,
     584,   585,   586,   587,   588,   589,     0,  1317,   590,   591,
     592,   593,   594,  1318,     0,   595,   596,   597,   598,   599,
    1185,  1319,     0,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,    50,   609,   610,   611,   612,   613,   614,
     615,  1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,
     625,   626,   627,   628,     0,  1328,     0,    51,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1329,  1330,     0,
       0,     0,   235,     0,  1255,   695,  1332,  1256,  1257,  1258,
     756,  1259,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1260,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1261,   261,  1262,  1263,  3265,   264,   265,   266,
     267,   268,   269,   270,  1264,  1265,   271,   272,  1266,  1267,
     275,     0,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,  1277,  1278,   311,  1279,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   868,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,  1280,   340,   341,   342,   343,  1281,  1282,
     345,     0,   346,   347,   348,  1283,   350,     0,   351,     0,
     352,   353,   354,  3266,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,  1285,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,  1286,  1287,     0,  1288,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,     0,  3267,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,  1296,   436,  1297,   438,
     439,   440,   441,   442,   443,   444,   445,  1298,   447,  1299,
     448,   449,   450,   451,  1300,  1301,   453,  1302,   455,   456,
     457,     0,   458,   459,     0,     0,  1303,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  1306,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,  1307,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,  1309,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,  1312,  1313,     0,  3268,   577,
     578,  1314,   580,  1315,  1316,   582,   583,   584,   585,   586,
     587,   588,   589,     0,  1317,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,  1319,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,   627,
     628,     0,  1328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1329,  1330,     0,     0,     0,   235,
       0,  1255,   695,  1332,  1256,  1257,  1258,   756,  1259,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244, -2219,   245,   246,   247,     0,
       0,     0, -2219,  1260,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,  1261,
     261,  1262,  1263,     0,   264,   265,   266,   267,   268,   269,
     270,  1264,  1265,   271,   272,  1266,  1267,   275,     0,   276,
     277,   278,   279,  1268,     0,  1269,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,   303,   304,   305,   306,
     307,   308,  1277,  1278,   311,  1279,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   868,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
    1280,   340,   341,   342,   343,  1281,  1282,   345,     0,   346,
     347,   348,  1283,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,  1284,     0,
    1285,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,  1286,  1287,     0,  1288,     0,   393,   394,   395,   396,
     397,   398,  1289,  1290,  1291,  1292,   403,   404,   405,   406,
     407,   408,     0,     0,   409,  1293,   411,   412,   413,     0,
     414,   415,   416,  1294,  1295,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,  1296,   436,  1297,   438,   439,   440,   441,
     442,   443,   444,   445,  1298,   447,  1299,   448,   449,   450,
     451,  1300,  1301,   453,  1302,   455,   456,   457,     0,   458,
     459,     0,     0,  1303,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,  1304,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,  1305,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,  1306,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,  1307,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,  1308,   540,   541,   542,   543,   544,   545,   546,   547,
    1309,   549, -2219,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,  1310,   564,     0,   565,
     566,  1311,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,  1312,  1313,     0,     0,   577,   578,  1314,   580,
    1315,  1316,   582,   583,   584,   585,   586,   587,   588,   589,
       0,  1317,   590,   591,   592,   593,   594,  1318,     0,   595,
     596,   597,   598,   599,   600,  1319,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,  1320,  1321,  1322,  1323,   620,
    1324,  1325,  1326,  1327,   625,   626,   627,   628,     0,  1328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1329,  1330,     0,     0,     0,   235,     0,  1255,   695,
    1332,  1256,  1257,  1258,   756,  1259,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244, -2217,   245,   246,   247,     0,     0,     0, -2217,
    1260,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,  1261,   261,  1262,  1263,
       0,   264,   265,   266,   267,   268,   269,   270,  1264,  1265,
     271,   272,  1266,  1267,   275,     0,   276,   277,   278,   279,
    1268,     0,  1269,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1270,  1271,  1272,  1273,
    1274,  1275,  1276,   303,   304,   305,   306,   307,   308,  1277,
    1278,   311,  1279,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   868,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,  1280,   340,   341,
     342,   343,  1281,  1282,   345,     0,   346,   347,   348,  1283,
     350,     0,   351,     0,   352,   353,   354,     0,   355,   356,
     357,   358,   359,     0,   360,  1284,     0,  1285,   363,   364,
       0,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,  1286,  1287,
       0,  1288,     0,   393,   394,   395,   396,   397,   398,  1289,
    1290,  1291,  1292,   403,   404,   405,   406,   407,   408,     0,
       0,   409,  1293,   411,   412,   413,     0,   414,   415,   416,
    1294,  1295,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
    1296,   436,  1297,   438,   439,   440,   441,   442,   443,   444,
     445,  1298,   447,  1299,   448,   449,   450,   451,  1300,  1301,
     453,  1302,   455,   456,   457,     0,   458,   459,     0,     0,
    1303,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,  1304,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,  1305,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,  1306,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,  1307,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,  1308,   540,
     541,   542,   543,   544,   545,   546,   547,  1309,   549, -2217,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,  1310,   564,     0,   565,   566,  1311,     0,
     567,   568,   569,   570,   571,   572,   573,     0,   574,  1312,
    1313,     0,     0,   577,   578,  1314,   580,  1315,  1316,   582,
     583,   584,   585,   586,   587,   588,   589,     0,  1317,   590,
     591,   592,   593,   594,  1318,     0,   595,   596,   597,   598,
     599,   600,  1319,     0,   602,   603,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,
    1327,   625,   626,   627,   628,     0,  1328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1329,  1330,
       0,     0,     0,   235,     0,  1255,   695,  1332,  1256,  1257,
    1258,   756,  1259,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,  1260,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1261,   261,  1262,  1263,     0,   264,   265,
     266,   267,   268,   269,   270,  1264,  1265,   271,   272,  1266,
    1267,   275,     0,   276,   277,   278,   279,  1268,     0,  1269,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,
     303,   304,   305,   306,   307,   308,  1277,  1278,   311,  1279,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   868,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,  1280,   340,   341,   342,   343,  1281,
    1282,   345,     0,   346,   347,   348,  1283,   350,     0,   351,
       0,   352,   353,   354,     0,   355,   356,   357,   358,   359,
       0,   360,  1284,     0,  1285,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,  1286,  1287,     0,  1288,     0,
     393,   394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,
     403,   404,   405,   406,   407,   408,     0,     0,   409,  1293,
     411,   412,   413,     0,   414,   415,   416,  1294,  1295,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,  1296,   436,  1297,
     438,   439,   440,   441,   442,   443,   444,   445,  1298,   447,
    1299,   448,   449,   450,   451,  1300,  1301,   453,  1302,   455,
     456,   457,     0,   458,   459,     0,     0,  1303,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,  1304,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,  1305,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
    1306,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,  1307,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,  1308,   540,   541,   542,   543,
     544,   545,   546,   547,  1309,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
    1310,   564,     0,   565,   566,  1311,     0,   567,   568,   569,
     570,   571,   572,   573,     0,   574,  1312,  1313,     0,     0,
     577,   578,  1314,   580,  1315,  1316,   582,   583,   584,   585,
     586,   587,   588,   589,     0,  1317,   590,   591,   592,   593,
     594,  1318,     0,   595,   596,   597,   598,   599,   600,  1319,
       0,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,  1320,
    1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,
     627,   628,     0,  1328,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1329,  1330,     0,     0,     0,
       0,     0,  2026,  3201,  1332,   235,     0,  1255,   695,     0,
    1256,  1257,  1258,   756,  1259,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1260,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1261,   261,  1262,  1263,     0,
     264,   265,   266,   267,   268,   269,   270,  1264,  1265,   271,
     272,  1266,  1267,   275,     0,   276,   277,   278,   279,  1268,
       0,  1269,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1270,  1271,  1272,  1273,  1274,
    1275,  1276,   303,   304,   305,   306,   307,   308,  1277,  1278,
     311,  1279,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     868,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,  1280,   340,   341,   342,
     343,  1281,  1282,   345,     0,   346,   347,   348,  1283,   350,
       0,   351,     0,   352,   353,   354,     0,   355,   356,   357,
     358,   359,     0,   360,  1284,     0,  1285,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,  1286,  1287,     0,
    1288,     0,   393,   394,   395,   396,   397,   398,  1289,  1290,
    1291,  1292,   403,   404,   405,   406,   407,   408,     0,     0,
     409,  1293,   411,   412,   413,     0,   414,   415,   416,  1294,
    1295,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,  1296,
     436,  1297,   438,   439,   440,   441,   442,   443,   444,   445,
    1298,   447,  1299,   448,   449,   450,   451,  1300,  1301,   453,
    1302,   455,   456,   457,     0,   458,   459,     0,     0,  1303,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
    1304,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,  1305,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,  1306,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
    1307,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,  1308,   540,   541,
     542,   543,   544,   545,   546,   547,  1309,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,  1310,   564,     0,   565,   566,  1311,     0,   567,
     568,   569,   570,   571,   572,   573,     0,   574,  1312,  1313,
       0,     0,   577,   578,  1314,   580,  1315,  1316,   582,   583,
     584,   585,   586,   587,   588,   589,     0,  1317,   590,   591,
     592,   593,   594,  1318,     0,   595,   596,   597,   598,   599,
     600,  1319,     0,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,  1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,
     625,   626,   627,   628,     0,  1328,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1329,  1330,  1331,
       0,     0,   235,     0,  1255,   695,  1332,  1256,  1257,  1258,
     756,  1259,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,  2642,   245,
     246,   247,     0,     0,     0,     0,  1260,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1261,   261,  1262,  1263,     0,   264,   265,   266,
     267,   268,   269,   270,  1264,  1265,   271,   272,  1266,  1267,
     275,     0,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,  1277,  1278,   311,  1279,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   868,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,  1280,   340,   341,   342,   343,  1281,  1282,
     345,     0,   346,   347,   348,  1283,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,  1285,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,  1286,  1287,     0,  1288,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,     0,     0,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,  1296,   436,  1297,   438,
     439,   440,   441,   442,   443,   444,   445,  1298,   447,  1299,
     448,   449,   450,   451,  1300,  1301,   453,  1302,   455,   456,
     457,     0,   458,   459,     0,     0,  1303,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  1306,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,  1307,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,  1309,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,  1312,  1313,     0,     0,   577,
     578,  1314,   580,  1315,  1316,   582,   583,   584,   585,   586,
     587,   588,   589,     0,  1317,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,  1319,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,   627,
     628,     0,  1328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1329,  1330,     0,     0,     0,   235,
       0,  1255,   695,  1332,  1256,  1257,  1258,   756,  1259,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,  1260,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,  1261,
     261,  1262,  1263,     0,   264,   265,   266,   267,   268,   269,
     270,  1264,  1265,   271,   272,  1266,  1267,   275,     0,   276,
     277,   278,   279,  1268,     0,  1269,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,   303,   304,   305,   306,
     307,   308,  1277,  1278,   311,  1279,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   868,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
    1280,   340,   341,   342,   343,  1281,  1282,   345,     0,   346,
     347,   348,  1283,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,  1284,     0,
    1285,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,  1286,  1287,     0,  1288,     0,   393,   394,   395,   396,
     397,   398,  1289,  1290,  1291,  1292,   403,   404,   405,   406,
     407,   408,     0,     0,   409,  1293,   411,   412,   413,     0,
     414,   415,   416,  1294,  1295,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,  1296,   436,  1297,   438,   439,   440,   441,
     442,   443,   444,   445,  1298,   447,  1299,   448,   449,   450,
     451,  1300,  1301,   453,  1302,   455,   456,   457,     0,   458,
     459,     0,     0,  1303,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,  1304,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,  1305,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,  1306,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,  3225,   516,   517,   518,   519,
     520,   521,   522,   523,  1307,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,  1308,   540,   541,   542,   543,   544,   545,   546,   547,
    1309,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,  1310,   564,     0,   565,
     566,  1311,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,  1312,  1313,     0,     0,   577,   578,  1314,   580,
    1315,  1316,   582,   583,   584,   585,   586,   587,   588,   589,
       0,  1317,   590,   591,   592,   593,   594,  1318,     0,   595,
     596,   597,   598,   599,   600,  1319,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,  1320,  1321,  1322,  1323,   620,
    1324,  1325,  1326,  1327,   625,   626,   627,   628,     0,  1328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1329,  1330,     0,     0,     0,   235,     0,  1255,   695,
    1332,  1256,  1257,  1258,   756,  1259,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
    1260,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,  1261,   261,  1262,  1263,
       0,   264,   265,   266,   267,   268,   269,   270,  1264,  1265,
     271,   272,  1266,  1267,   275,     0,   276,   277,   278,   279,
    1268,     0,  1269,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,  1270,  1271,  1272,  1273,
    1274,  1275,  1276,   303,   304,   305,   306,   307,   308,  1277,
    1278,   311,  1279,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   868,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,  1280,   340,   341,
     342,   343,  1281,  1282,   345,     0,   346,   347,   348,  1283,
     350,     0,   351,     0,   352,   353,   354,     0,   355,   356,
     357,   358,   359,     0,   360,  1284,     0,  1285,   363,   364,
       0,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,  1286,  1287,
       0,  1288,     0,   393,   394,   395,   396,   397,   398,  1289,
    1290,  1291,  1292,   403,   404,   405,   406,   407,   408,     0,
       0,   409,  1293,   411,   412,   413,     0,   414,   415,   416,
    1294,  1295,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
    1296,   436,  1297,   438,   439,   440,   441,   442,   443,   444,
     445,  1298,   447,  1299,   448,   449,   450,   451,  1300,  1301,
     453,  1302,   455,   456,   457,     0,   458,   459,     0,     0,
    1303,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,  1304,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,  1305,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,  1306,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,  1307,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,  1308,   540,
     541,   542,   543,   544,   545,   546,   547,  1309,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,  1310,   564,     0,   565,   566,  1311,     0,
     567,   568,   569,   570,   571,   572,   573,     0,   574,  1312,
    1313,     0,     0,   577,   578,  1314,   580,  1315,  1316,   582,
     583,   584,   585,   586,   587,   588,   589,     0,  1317,   590,
     591,   592,   593,   594,  1318,     0,   595,   596,   597,   598,
     599,   600,  1319,  3761,   602,   603,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,
    1327,   625,   626,   627,   628,     0,  1328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1329,  1330,
       0,     0,     0,   235,     0,  1255,   695,  1332,  1256,  1257,
    1258,   756,  1259,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,  1260,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1261,   261,  1262,  1263,     0,   264,   265,
     266,   267,   268,   269,   270,  1264,  1265,   271,   272,  1266,
    1267,   275,     0,   276,   277,   278,   279,  1268,     0,  1269,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,
     303,   304,   305,   306,   307,   308,  1277,  1278,   311,  1279,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   868,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,  1280,   340,   341,   342,   343,  1281,
    1282,   345,     0,   346,   347,   348,  1283,   350,     0,   351,
       0,   352,   353,   354,  3266,   355,   356,   357,   358,   359,
       0,   360,  1284,     0,  1285,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,  1286,  1287,     0,  1288,     0,
     393,   394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,
     403,   404,   405,   406,   407,   408,     0,     0,   409,  1293,
     411,   412,   413,     0,   414,   415,   416,  1294,  1295,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,  1296,   436,  1297,
     438,   439,   440,   441,   442,   443,   444,   445,  1298,   447,
    1299,   448,   449,   450,   451,  1300,  1301,   453,  1302,   455,
     456,   457,     0,   458,   459,     0,     0,  1303,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,  1304,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,  1305,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
    1306,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,  1307,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,  1308,   540,   541,   542,   543,
     544,   545,   546,   547,  1309,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
    1310,   564,     0,   565,   566,  1311,     0,   567,   568,   569,
     570,   571,   572,   573,     0,   574,  1312,  1313,     0,     0,
     577,   578,  1314,   580,  1315,  1316,   582,   583,   584,   585,
     586,   587,   588,   589,     0,  1317,   590,   591,   592,   593,
     594,  1318,     0,   595,   596,   597,   598,   599,   600,  1319,
       0,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,  1320,
    1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,
     627,   628,     0,  1328,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1329,  1330,     0,     0,     0,
     235,     0,  1255,   695,  1332,  1256,  1257,  1258,   756,  1259,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,  1260,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1261,   261,  1262,  1263,     0,   264,   265,   266,   267,   268,
     269,   270,  1264,  1265,   271,   272,  1266,  1267,   275,     0,
     276,   277,   278,   279,  1268,     0,  1269,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,   304,   305,
     306,   307,   308,  1277,  1278,   311,  1279,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   868,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,  1280,   340,   341,   342,   343,  1281,  1282,   345,     0,
     346,   347,   348,  1283,   350,     0,   351,     0,   352,   353,
     354,     0,   355,   356,   357,   358,   359,     0,   360,  1284,
       0,  1285,   363,   364,     0,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,  1286,  1287,     0,  1288,     0,   393,   394,   395,
     396,   397,   398,  1289,  1290,  1291,  1292,   403,   404,   405,
     406,   407,   408,     0,     0,   409,  1293,   411,   412,   413,
       0,   414,   415,   416,  1294,  1295,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,  1296,   436,  1297,   438,   439,   440,
     441,   442,   443,   444,   445,  1298,   447,  1299,   448,   449,
     450,   451,  1300,  1301,   453,  1302,   455,   456,   457,     0,
     458,   459,     0,     0,  1303,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,  1304,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
    1305,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,  1306,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,  1307,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,  1308,   540,   541,   542,   543,   544,   545,   546,
     547,  1309,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,  1310,   564,     0,
     565,   566,  1311,     0,   567,   568,   569,   570,   571,   572,
     573,     0,   574,  1312,  1313,  3322,     0,   577,   578,  1314,
     580,  1315,  1316,   582,   583,   584,   585,   586,   587,   588,
     589,     0,  1317,   590,   591,   592,   593,   594,  1318,     0,
     595,   596,   597,   598,   599,   600,  1319,     0,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,  1320,  1321,  1322,  1323,
     620,  1324,  1325,  1326,  1327,   625,   626,   627,   628,     0,
    1328,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1329,  1330,     0,     0,     0,   235,     0,  1255,
     695,  1332,  1256,  1257,  1258,   756,  1259,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1260,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1261,   261,  1262,
    1263,     0,   264,   265,   266,   267,   268,   269,   270,  1264,
    1265,   271,   272,  1266,  1267,   275,     0,   276,   277,   278,
     279,  1268,     0,  1269,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,   308,
    1277,  1278,   311,  1279,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   868,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,  1280,   340,
     341,   342,   343,  1281,  1282,   345,     0,   346,   347,   348,
    1283,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,  1284,     0,  1285,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,  1286,
    1287,     0,  1288,     0,   393,   394,   395,   396,   397,   398,
    1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,   408,
       0,     0,   409,  1293,   411,   412,   413,     0,   414,   415,
     416,  1294,  1295,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,  1296,   436,  1297,   438,   439,   440,   441,   442,   443,
     444,   445,  1298,   447,  1299,   448,   449,   450,   451,  1300,
    1301,   453,  1302,   455,   456,   457,     0,   458,   459,     0,
       0,  1303,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,  1304,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,  1305,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,  1306,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,  1307,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,  1308,
     540,   541,   542,   543,   544,   545,   546,   547,  1309,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,  1310,   564,     0,   565,   566,  1311,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
    1312,  1313,     0,     0,   577,   578,  1314,   580,  1315,  1316,
     582,   583,   584,   585,   586,   587,   588,   589,     0,  1317,
     590,   591,   592,   593,   594,  1318,     0,   595,   596,   597,
     598,   599,   600,  1319,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,
    1326,  1327,   625,   626,   627,   628,     0,  1328,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1329,
    1330,     0,     0,     0,   235,     0,  1255,   695,  1332,  1256,
    1257,  1258,   756,  1259,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1260,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1261,   261,  1262,  1263,     0,   264,
     265,   266,   267,   268,   269,   270,  1264,  1265,   271,   272,
    1266,  1267,   275,     0,   276,   277,   278,   279,  1268,     0,
    1269,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1270,  1271,  1272,  1273,  1274,  1275,
    1276,   303,   304,   305,   306,   307,   308,  1277,  1278,   311,
    1279,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   868,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,  1280,   340,   341,   342,   343,
    1281,  1282,   345,     0,   346,   347,   348,  1283,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,  1284,     0,  1285,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,  1286,  1287,     0,  1288,
       0,   393,   394,   395,   396,   397,   398,  1289,  1290,  1291,
    1292,   403,   404,   405,   406,   407,   408,     0,     0,   409,
    1293,   411,   412,   413,     0,   414,   415,   416,  1294,  1295,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,  1296,   436,
    1297,   438,   439,   440,   441,   442,   443,   444,   445,  1298,
     447,  1299,   448,   449,   450,   451,  1300,  1301,   453,  1302,
     455,   456,   457,     0,   458,   459,     0,     0,  1303,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,  1304,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,  1305,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,  1306,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,  1307,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,  1308,   540,   541,   542,
     543,   544,   545,   546,   547,  1309,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,  1310,   564,     0,   565,   566,  1311,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,  1312,  1313,     0,
       0,   577,   578,  1314,   580,  1315,  1316,   582,   583,   584,
     585,   586,   587,   588,   589,     0,  1317,   590,   591,   592,
     593,   594,  1318,     0,   595,   596,   597,   598,   599,   600,
    1319,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
    1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,   625,
     626,   627,   628,     0,  1328,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2645,  2646,     0,     0,
       0,   235,     0,  3438,   695,  1332,  1256,  1257,  1258,   756,
    1259,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,  1260,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1261,   261,  1262,  1263,     0,   264,   265,   266,   267,
     268,   269,   270,  1264,  1265,   271,   272,  1266,  1267,   275,
       0,   276,   277,   278,   279,  1268,     0,  1269,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,   304,
     305,   306,   307,   308,  1277,  1278,   311,  1279,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   868,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,  1280,   340,   341,   342,   343,  1281,  1282,   345,
       0,   346,   347,   348,  1283,   350,     0,   351,     0,   352,
     353,   354,     0,   355,   356,   357,   358,   359,     0,   360,
    1284,     0,  1285,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,  1286,  1287,     0,  1288,     0,   393,   394,
     395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,   404,
     405,   406,   407,   408,     0,     0,   409,  1293,   411,   412,
     413,     0,   414,   415,   416,  1294,  1295,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,  1296,   436,  1297,   438,   439,
     440,   441,   442,   443,   444,   445,  1298,   447,  1299,   448,
     449,   450,   451,  1300,  1301,   453,  1302,   455,   456,   457,
       0,   458,   459,     0,     0,  1303,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,  1304,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,  1305,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,  1306,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,  1307,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,  1308,   540,   541,   542,   543,   544,   545,
     546,   547,  1309,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,  1310,   564,
       0,   565,   566,  1311,     0,   567,   568,   569,   570,   571,
     572,   573,     0,   574,  1312,  1313,     0,     0,   577,   578,
    1314,   580,  1315,  1316,   582,   583,   584,   585,   586,   587,
     588,   589,     0,  1317,   590,   591,   592,   593,   594,  1318,
       0,   595,   596,   597,   598,   599,   600,  1319,     0,   602,
     603,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,  1320,  1321,  1322,
    1323,   620,  1324,  1325,  1326,  1327,   625,   626,   627,   628,
       0,  1328,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1329,  1330,     0,     0,     0,   235,     0,
    1255,   695,  1332,  1256,  1257,  1258,   756,  1259,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,  1260,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1261,   261,
    1262,  1263,     0,   264,   265,   266,   267,   268,   269,   270,
    1264,  1265,   271,   272,  1266,  1267,   275,     0,   276,   277,
     278,   279,  1268,     0,  1269,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,  4759,  1270,  1271,
    1272,  1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,
     308,  1277,  1278,   311,  1279,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   868,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,  1280,
     340,   341,   342,   343,  1281,  1282,   345,     0,   346,   347,
     348,  1283,   350,     0,   351,     0,   352,   353,   354,     0,
     355,   356,   357,   358,   359,     0,   360,  1284,     0,  1285,
     363,   364,     0,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
    1286,  1287,     0,  1288,     0,   393,   394,   395,   396,   397,
     398,  1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,
     408,     0,     0,   409,  1293,   411,   412,   413,     0,   414,
     415,   416,  1294,  1295,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,  1296,   436,  1297,   438,   439,   440,   441,   442,
     443,   444,   445,  1298,   447,  1299,   448,   449,   450,   451,
    1300,  1301,   453,  1302,   455,   456,   457,     0,   458,   459,
       0,     0,  1303,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,  1304,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,  1305,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,  1306,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,  1307,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
    1308,   540,   541,   542,   543,   544,   545,   546,   547,  1309,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,  1310,   564,     0,   565,   566,
    1311,     0,   567,   568,   569,   570,   571,   572,   573,     0,
     574,  1312,  1313,     0,     0,   577,   578,  1314,   580,  1315,
    1316,   582,   583,   584,   585,   586,   587,   588,   589,     0,
    1317,   590,   591,   592,   593,   594,  1318,     0,   595,   596,
     597,   598,   599,   600,  1319,     0,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,
    1325,  1326,  1327,   625,   626,   627,   628,     0,  1328,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1329,  1330,     0,     0,     0,   235,     0,  1255,   695,  1332,
    1256,  1257,  1258,   756,  1259,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1260,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1261,   261,  1262,  1263,     0,
     264,   265,   266,   267,   268,   269,   270,  1264,  1265,   271,
     272,  1266,  1267,   275,     0,   276,   277,   278,   279,  1268,
       0,  1269,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,  1270,  1271,  1272,  1273,  1274,
    1275,  1276,   303,   304,   305,   306,   307,   308,  1277,  1278,
     311,  1279,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     868,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,  1280,   340,   341,   342,
     343,  1281,  1282,   345,     0,   346,   347,   348,  1283,   350,
       0,   351,     0,   352,   353,   354,     0,   355,   356,   357,
     358,   359,     0,   360,  1284,     0,  1285,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,  1286,  1287,     0,
    1288,     0,   393,   394,   395,   396,   397,   398,  1289,  1290,
    1291,  1292,   403,   404,   405,   406,   407,   408,     0,     0,
     409,  1293,   411,   412,   413,     0,   414,   415,   416,  1294,
    1295,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,  1296,
     436,  1297,   438,   439,   440,   441,   442,   443,   444,   445,
    1298,   447,  1299,   448,   449,   450,   451,  1300,  1301,   453,
    1302,   455,   456,   457,     0,   458,   459,     0,     0,  1303,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
    1304,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,  1305,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,  1306,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
    1307,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,  1308,   540,   541,
     542,   543,   544,   545,   546,   547,  1309,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,  1310,   564,     0,   565,   566,  1311,     0,   567,
     568,   569,   570,   571,   572,   573,     0,   574,  1312,  1313,
       0,     0,   577,   578,  1314,   580,  1315,  1316,   582,   583,
     584,   585,   586,   587,   588,   589,     0,  1317,   590,   591,
     592,   593,   594,  1318,     0,   595,   596,   597,   598,   599,
     600,  1319,     0,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
    5134,  1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,
     625,   626,   627,   628,     0,  1328,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1329,  1330,     0,
       0,     0,   235,     0,  1255,   695,  1332,  1256,  1257,  1258,
     756,  1259,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1260,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1261,   261,  1262,  1263,     0,   264,   265,   266,
     267,   268,   269,   270,  1264,  1265,   271,   272,  1266,  1267,
     275,     0,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,  1277,  1278,   311,  1279,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   868,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,  1280,   340,   341,   342,   343,  1281,  1282,
     345,     0,   346,   347,   348,  1283,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,  1285,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,  1286,  1287,     0,  1288,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,     0,     0,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,  1296,   436,  1297,   438,
     439,   440,   441,   442,   443,  5146,   445,  1298,   447,  1299,
     448,   449,   450,   451,  1300,  1301,   453,  1302,   455,   456,
     457,     0,   458,   459,     0,     0,  1303,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  1306,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,  1307,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,  1309,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,  1312,  1313,     0,     0,   577,
     578,  1314,   580,  1315,  1316,   582,   583,   584,   585,   586,
     587,   588,   589,     0,  1317,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,  1319,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,   627,
     628,     0,  1328,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1329,  1330,     0,     0,     0,   235,
       0,  1255,   695,  1332,  1256,  1257,  1258,   756,  1259,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,  1260,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,  1261,
     261,  1262,  1263,     0,   264,   265,   266,   267,   268,   269,
     270,  1264,  1265,   271,   272,  1266,  1267,   275,     0,   276,
     277,   278,   279,  1268,     0,  1269,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,  5464,   301,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,   303,   304,   305,   306,
     307,   308,  1277,  1278,   311,  1279,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   868,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
    1280,   340,   341,   342,   343,  1281,  1282,   345,     0,   346,
     347,   348,  1283,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,  1284,     0,
    5465,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,  1286,  1287,     0,  1288,     0,   393,   394,   395,   396,
     397,   398,  1289,  1290,  1291,  1292,   403,   404,   405,   406,
     407,   408,     0,     0,   409,  1293,   411,   412,   413,     0,
     414,   415,   416,  1294,  1295,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,  1296,   436,  1297,   438,   439,   440,   441,
     442,   443,   444,   445,  1298,   447,  1299,   448,   449,   450,
     451,  1300,  1301,   453,  1302,   455,   456,   457,     0,   458,
     459,     0,     0,  1303,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,  1304,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,  1305,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,  1306,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,  5466,   522,   523,  1307,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,  1308,   540,   541,   542,   543,   544,   545,   546,   547,
    1309,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,  1310,   564,     0,   565,
     566,  1311,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,  1312,  1313,     0,     0,   577,   578,  1314,   580,
    1315,  1316,   582,   583,   584,   585,   586,   587,   588,   589,
       0,  1317,   590,   591,   592,   593,   594,  1318,     0,   595,
     596,   597,   598,   599,   600,  1319,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,  1320,  1321,  1322,  1323,   620,
    1324,  1325,  1326,  1327,   625,   626,   627,   628,     0,  1328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1329,  1330,     0,     0,     0,   235,     0,  1255,   695,
    5467,  1256,  1257,  1258,   756,  1259,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
    1260,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,  5839,  1261,   261,  1262,  1263,
       0,   264,   265,   266,   267,   268,   269,   270,  1264,  1265,
     271,   272,  1266,  1267,   275,     0,   276,   277,   278,   279,
    1268,     0,  1269,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,  5840,  1270,  1271,  1272,  1273,
    1274,  1275,  1276,   303,   304,   305,   306,   307,   308,  1277,
    1278,   311,  1279,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   868,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,  1280,   340,   341,
     342,   343,  1281,  1282,   345,     0,   346,   347,   348,  1283,
     350,     0,   351,     0,   352,   353,   354,     0,   355,   356,
     357,   358,   359,     0,   360,  1284,     0,  1285,   363,   364,
       0,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,  1286,  1287,
       0,  1288,     0,   393,   394,   395,   396,   397,   398,  1289,
    1290,  1291,  1292,   403,   404,   405,   406,   407,   408,     0,
       0,   409,  1293,   411,   412,   413,     0,   414,   415,   416,
    1294,  1295,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
    1296,   436,  1297,   438,   439,   440,   441,   442,   443,   444,
     445,  1298,   447,  1299,   448,   449,   450,   451,  1300,  1301,
     453,  1302,   455,   456,   457,     0,   458,   459,     0,     0,
    1303,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,  1304,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,  1305,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,  1306,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,  1307,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,  1308,   540,
     541,   542,   543,   544,   545,   546,   547,  1309,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,  1310,   564,     0,   565,   566,  1311,     0,
     567,   568,   569,   570,   571,   572,   573,     0,   574,  1312,
    1313,     0,     0,   577,   578,  1314,   580,  1315,  1316,   582,
     583,   584,   585,   586,  5841,   588,   589,     0,  1317,   590,
     591,   592,   593,   594,  1318,     0,   595,   596,   597,   598,
     599,   600,  1319,     0,   602,   603,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,
    1327,   625,   626,   627,   628,     0,  1328,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1329,  1330,
       0,     0,     0,   235,     0,  1255,   695,  1332,  1256,  1257,
    1258,   756,  1259,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,  1260,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1261,   261,  1262,  1263,     0,   264,   265,
     266,   267,   268,   269,   270,  1264,  1265,   271,   272,  1266,
    1267,   275,     0,   276,   277,   278,   279,  1268,     0,  1269,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,  5840,  1270,  1271,  1272,  1273,  1274,  1275,  1276,
     303,   304,   305,   306,   307,   308,  1277,  1278,   311,  1279,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   868,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,  1280,   340,   341,   342,   343,  1281,
    1282,   345,     0,   346,   347,   348,  1283,   350,     0,   351,
       0,   352,   353,   354,     0,   355,   356,   357,   358,   359,
       0,   360,  1284,     0,  1285,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,  1286,  1287,     0,  1288,     0,
     393,   394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,
     403,   404,   405,   406,   407,   408,     0,     0,   409,  1293,
     411,   412,   413,     0,   414,   415,   416,  1294,  1295,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,  1296,   436,  1297,
     438,   439,   440,   441,   442,   443,   444,   445,  1298,   447,
    1299,   448,   449,   450,   451,  1300,  1301,   453,  1302,   455,
     456,   457,     0,   458,   459,     0,     0,  1303,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,  1304,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,  1305,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
    1306,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,  1307,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,  1308,   540,   541,   542,   543,
     544,   545,   546,   547,  1309,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
    1310,   564,     0,   565,   566,  1311,     0,   567,   568,   569,
     570,   571,   572,   573,     0,   574,  1312,  1313,     0,     0,
     577,   578,  1314,   580,  1315,  1316,   582,   583,   584,   585,
     586,  5841,   588,   589,     0,  1317,   590,   591,   592,   593,
     594,  1318,     0,   595,   596,   597,   598,   599,   600,  1319,
       0,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,  1320,
    1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,
     627,   628,     0,  1328,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1329,  1330,     0,     0,     0,
     235,     0,  1255,   695,  1332,  1256,  1257,  1258,   756,  1259,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,  1260,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1261,   261,  1262,  1263,     0,   264,   265,   266,   267,   268,
     269,   270,  1264,  1265,   271,   272,  1266,  1267,   275,     0,
     276,   277,   278,   279,  1268,     0,  1269,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
    1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,   304,   305,
     306,   307,   308,  1277,  1278,   311,  5449,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   868,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,  1280,   340,   341,   342,   343,  1281,  1282,   345,     0,
     346,   347,   348,  1283,   350,     0,   351,     0,   352,   353,
     354,     0,   355,   356,   357,   358,   359,     0,   360,  1284,
       0,  1285,   363,   364,     0,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,  1286,  1287,     0,  1288,     0,   393,   394,   395,
     396,   397,   398,  1289,  1290,  1291,  1292,   403,   404,   405,
     406,   407,   408,     0,     0,   409,  1293,   411,   412,   413,
       0,   414,   415,   416,  1294,  1295,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,  1296,   436,  1297,   438,   439,   440,
     441,   442,   443,   444,   445,  1298,   447,     0,   448,   449,
     450,   451,  1300,  1301,   453,  1302,   455,   456,   457,     0,
     458,   459,     0,     0,  1303,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,  1304,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
    1305,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,  1306,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,  3251,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,  1308,   540,   541,   542,   543,   544,   545,   546,
     547,  1309,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,  1310,   564,     0,
     565,   566,  1311,     0,   567,   568,   569,   570,   571,   572,
     573,     0,   574,  1312,  1313,     0,     0,   577,   578,  1314,
     580,  1315,  1316,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,  1318,     0,
     595,   596,   597,   598,   599,   600,  1319,     0,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,  1320,  1321,  1322,  1323,
     620,  1324,  1325,  1326,  1327,   625,   626,   627,   628,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3252,  3253,     0,     0,     0,   235,     0,  1255,
     695,  3254,  1256,  1257,  1258,   756,  1259,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1260,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258, -2887,  1261,   261,  1262,
    1263,     0,   264,   265,   266,   267,   268,   269,   270,  1264,
    1265,   271,   272,  1266,  1267,   275,     0,   276,   277,   278,
     279,  1268,     0,  1269,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,  5840,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,   308,
    1277,  1278,   311,  1279,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   868,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,  1280,   340,
     341,   342,   343,  1281,  1282,   345,     0,   346,   347,   348,
    1283,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,  1284,     0,  1285,   363,
     364,     0,   365,   366,   367,   368,   369, -2887,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,  1286,
    1287,     0,  1288,     0,   393,     0,     0,   396,   397,   398,
    1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,   408,
       0,     0,   409,  1293,   411,   412, -2887,     0,   414,   415,
     416,  1294,  1295,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,  1296,   436,  1297,   438,   439,   440,   441,   442,   443,
     444,   445,  1298,   447,  1299,   448,   449,     0,   451,  1300,
    1301,   453,  1302,   455,   456,   457,     0,   458,   459,     0,
       0,  1303,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,  1304,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,  1305,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,  1306,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,  1307,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,  1308,
     540,   541,   542,   543,   544, -2887,   546,   547,  1309,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,  1310,   564,     0,   565,   566,  1311,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
    1312,  1313,     0,     0,   577,   578,  1314,   580,  1315,  1316,
     582,   583,   584,   585,   586,  5841,   588,   589,     0,  1317,
     590,   591,   592,   593,   594,  1318,     0,   595,   596,   597,
     598,   599,   600,  1319,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,
    1326,  1327,   625,   626,   627,   628,     0, -2887,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1329,
    1330,     0,     0,     0,   235,     0,  1255,   695,  1332,  1256,
    1257,  1258,   756,  1259,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1260,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1261,   261,  1262,  1263,     0,   264,
     265,   266,   267,   268,   269,   270,  1264,  1265,   271,   272,
    1266,  1267,   275,     0,   276,   277,   278,   279,  1268,     0,
    1269,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1270,  1271,  1272,  1273,  1274,  1275,
    1276,   303,   304,   305,   306,   307,   308,  1277,  1278,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   868,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,  1280,   340,   341,   342,   343,
    1281,  1282,   345,     0,   346,   347,   348,  1283,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,  1284,     0,  1285,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,  1286,  1287,     0,  1288,
       0,   393,   394,   395,   396,   397,   398,  1289,  1290,  1291,
    1292,   403,   404,   405,   406,   407,   408,     0,     0,   409,
    1293,   411,   412,   413,     0,   414,   415,   416,  1294,  1295,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,  1296,   436,
    1297,   438,   439,   440,   441,   442,   443,   444,   445,  1298,
     447,     0,   448,   449,   450,   451,  1300,  1301,   453,  1302,
     455,   456,   457,     0,   458,   459,     0,     0,  1303,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,  1304,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,  1305,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,  1306,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,  3251,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,  1308,   540,   541,   542,
     543,   544,   545,   546,   547,  1309,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,  1310,   564,     0,   565,   566,  1311,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,  1312,  1313,     0,
       0,   577,   578,  1314,   580,  1315,  1316,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,  1318,     0,   595,   596,   597,   598,   599,   600,
    1319,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
    1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,   625,
     626,   627,   628,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3252,  3253,   235,     0,
    1255,   695,     0,  1256,  1257,  3254,   756,  1259,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,  1260,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1261,   261,
    1262,  1263,     0,   264,   265,   266,   267,   268,   269,   270,
    1264,  1265,   271,   272,  1266,  1267,   275,     0,   276,   277,
     278,   279,  1268,     0,  1269,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,  1270,  1271,
    1272,  1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,
     308,  1277,  1278,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   868,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,  1280,
     340,   341,   342,   343,  1281,  1282,   345,     0,   346,   347,
     348,  1283,   350,     0,   351,     0,   352,   353,   354,     0,
     355,   356,   357,   358,   359,     0,   360,  1284,     0,  1285,
     363,   364,     0,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
    1286,  1287,     0,  1288,     0,   393,   394,   395,   396,   397,
     398,  1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,
     408,     0,     0,   409,  1293,   411,   412,   413,     0,   414,
     415,   416,  1294,  1295,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,  1296,   436,  1297,   438,   439,   440,   441,   442,
     443,   444,   445,  1298,   447,     0,   448,   449,   450,   451,
    1300,  1301,   453,  1302,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,  1304,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,  1305,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,  1306,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,  3427,  3428,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
    1308,   540,   541,   542,   543,   544,   545,   546,   547,  1309,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,  1310,   564,     0,   565,   566,
    1311,     0,   567,   568,   569,   570,   571,   572,   573,     0,
     574,  1312,  1313,     0,     0,   577,   578,  1314,   580,  1315,
    1316,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,  1318,     0,   595,   596,
     597,   598,   599,   600,  1319,     0,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,
    1325,  1326,  1327,   625,   626,   627,   628,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3429,  3430,   235,     0,  1255,   695,     0,  1256,  1257,  3254,
     756,  1259,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1260,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1261,   261,  1262,  1263,     0,   264,   265,   266,
     267,   268,   269,   270,  1264,  1265,   271,   272,  1266,  1267,
     275,     0,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,  1277,  1278,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   868,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,  1280,   340,   341,   342,   343,  1281,  1282,
     345,     0,   346,   347,   348,  1283,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,  1285,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,  1286,  1287,     0,  1288,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,     0,     0,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,  1296,   436,  1297,   438,
     439,   440,   441,   442,   443,   444,   445,  1298,   447,     0,
     448,   449,   450,   451,  1300,  1301,   453,  1302,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  1306,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,  3251,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,  1309,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,  1312,  1313,     0,     0,   577,
     578,  1314,   580,  1315,  1316,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,  1319,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,   627,
     628,     0,     0,     0,     0,     0,     0,   235,     0,  1255,
     695,     0,  1256,  1257,     0,   756,  1259,     0,     0,     0,
       0,     0,     0,  3254,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1260,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1261,   261,  1262,
    1263,     0,   264,  4668,   266,   267,   268,   269,   270,  1264,
    1265,   271,   272,  1266,  1267,   275,     0,   276,   277,   278,
     279,  1268,     0,  1269,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,   308,
    1277,  1278,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   868,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,  1280,   340,
     341,   342,   343,  1281,  1282,   345,     0,   346,   347,   348,
    1283,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,  1284,     0,  1285,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,  1286,
    1287,     0,  1288,     0,   393,   394,   395,   396,   397,   398,
    1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,   408,
       0,     0,   409,  1293,   411,   412,   413,     0,   414,   415,
     416,  1294,  1295,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,  1296,   436,  1297,   438,   439,   440,   441,   442,   443,
     444,   445,  1298,   447,     0,   448,   449,   450,   451,  1300,
    1301,   453,  1302,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,  1304,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,  1305,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,  1306,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,  3251,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,  1308,
     540,   541,   542,   543,   544,   545,   546,   547,  1309,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,  1310,   564,     0,   565,   566,  1311,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
    1312,  1313,     0,     0,   577,   578,  1314,   580,  1315,  1316,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,  1318,     0,   595,   596,   597,
     598,   599,   600,  1319,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,
    1326,  1327,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,   235,     0,  1255,   695,     0,  1256,  1257,     0,
     756,  1259,     0,     0,     0,     0,     0,     0,  3254,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1260,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1261,   261,  1262,  1263,     0,   264,   265,   266,
     267,   268,   269,   270,  1264,  1265,   271,   272,  1266,  1267,
     275,     0,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,  1277,  1278,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   868,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,  1280,   340,   341,   342,   343,  1281,  1282,
     345,     0,   346,   347,   348,  1283,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,  1285,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,  1286,  1287,     0,  1288,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,     0,     0,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,  1296,   436,  1297,   438,
     439,   440,   441,   442,   443,   444,   445,  1298,   447,     0,
     448,   449,   450,   451,  1300,  1301,   453,  1302,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,  1306,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,  3251,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,  1309,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,  1312,  1313,     0,     0,   577,
     578,  1314,   580,  1315,  1316,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,  1319,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,  4728,  1324,  1325,  1326,  1327,   625,   626,   627,
     628,     0,     0,     0,     0,     0,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3254,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
    1265,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,  1268,     0,  1269,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1281,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,  1284,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,   394,   395,   396,   397,   398,
    1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,   408,
    3401,     0,   409,  1293,   411,   412,   413,     0,   414,   415,
     416,  1294,  1295,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,  1298,   447,     0,   448,   449,   450,   451,     0,
    1301,   453,   454,   455,   456,   457,     0,   458,   459,     0,
     843,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,  1304,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,  1305,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,  3402,   526,   527,   528,   529,   530,   531,
     532,   533,   534,    41,   535,   536,   537,   538,   539,  1308,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,  1310,   564,     0,   565,   566,  1311,
      45,   567,   568,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,  1314,   580,  1315,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,  1318,     0,   595,   596,   597,
     598,   599,  1185,   601,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,    50,   609,   610,   611,   612,
     613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,
    1326,  1327,  3403,   626,   627,   628,     0,     0,     0,    51,
       0,     0,   235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3404,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,  1265,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,  1281,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,  3401,     0,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,  1298,   447,     0,
     448,   449,   450,   451,     0,  1301,   453,   454,   455,   456,
     457,     0,   458,   459,     0,   843,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,  3402,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,  1314,   580,  1315,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,   620,  1324,  1325,  1326,  1327,  3403,   626,   627,
     628,     0,     0,     0,     0,     0,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3404,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
    1265,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,  1268,     0,  1269,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1281,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,  1284,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,   394,   395,   396,   397,   398,
    1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,   408,
       0,     0,   409,  1293,   411,   412,   413,     0,   414,   415,
     416,  1294,  1295,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,  1298,   447,     0,   448,   449,   450,   451,     0,
    1301,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,  1304,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,  1305,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,  1308,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,  1310,   564,     0,   565,   566,  1311,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,  1314,   580,  1315,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,  1318,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,
    1326,  1327,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,   235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3840,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,  1265,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,  1281,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,     0,     0,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,  1298,   447,     0,
     448,   449,   450,   451,     0,  1301,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,  3402,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,  1314,   580,  1315,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,   620,  1324,  1325,  1326,  1327,  3403,   626,   627,
     628,     0,     0,     0,     0,     0,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
    1265,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,  1268,     0,  1269,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,  1281,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,  1284,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,   394,   395,   396,   397,   398,
    1289,  1290,  1291,  1292,   403,   404,   405,   406,   407,   408,
       0,     0,   409,  1293,   411,   412,   413,     0,   414,   415,
     416,  1294,  1295,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,  1298,   447,     0,   448,   449,   450,   451,     0,
    1301,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,  1304,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,  1305,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,  1308,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,  1310,   564,     0,   565,   566,  1311,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,  1314,   580,  1315,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,  1318,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,  1320,  1321,  1322,  1323,   620,  1324,  1325,
    1326,  1327,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,   235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4789,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,  1265,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,  1268,     0,  1269,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,  1270,  1271,  1272,  1273,  1274,  1275,  1276,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,  1281,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,  1284,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
     394,   395,   396,   397,   398,  1289,  1290,  1291,  1292,   403,
     404,   405,   406,   407,   408,     0,     0,   409,  1293,   411,
     412,   413,     0,   414,   415,   416,  1294,  1295,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,  1298,   447,     0,
     448,   449,   450,   451,     0,  1301,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,  1304,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,  1305,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,  1308,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,  1310,
     564,     0,   565,   566,  1311,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,  1314,   580,  1315,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
    1318,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,  1320,  1321,
    1322,  1323,   620,  1324,  1325,  1326,  1327,   625,   626,   627,
     628,     0,     0,     0,     0,     0,     0,   946,     0,  1580,
     695,     0,     0,     0,     0,   756,     0,     0,     0,     0,
       0,     0,     0,  5942,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,  1803,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,   411,   412,   413,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,  1804,
       0,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,  1805,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,   946,     0,     0,     0,     0,     0,     0,  1581,
    1582,  5748,     0,     0,     0,     0,     0,     0,  5749,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     3,     4,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,   411,
     412,   413,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,   450,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,    41,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,    45,   567,   568,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,  1185,   601,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
      50,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,  1025,     0,     0,    51,     0,     0,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,   411,   412,   413,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5518,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,    41,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,    45,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,  1185,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
      50,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,     0,     0,     0,    51,     0,     0,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
    2849,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
     843,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
    2850,  2851,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1837,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,     0,     0,     0,     0,     0,     0,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1391,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3461,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,     0,     0,     0,     0,     0,     0,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4121,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   860,     0,  1580,   695,     0,
       0,     0,   961,   756,     0,     0,     0,     0,  4745,   962,
     963,   964,   236,   237,   238,   239,   240,   241,   242,   243,
     244,  1715,   245,   246,   247,  1716,  1717,  1718,  1719,  1720,
    1721,  1722,   248,   249,   250,  1723,   251,   252,   253,   254,
     255,   256,   257,   258,     0,   861,   261,   862,   863,  1724,
     264,   265,   266,   267,   268,   269,   270,  1725,  1726,   271,
     272,   864,   865,   275,  1727,   276,   277,   278,   279,     0,
    1728,   281,  1729,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,  1730,   292,   293,   294,   295,   296,   297,
    1731,   298,   299,   300,   301,  1732,  1733,  1734,   302,  1735,
    1736,  1737,   303,   304,   305,   306,   307,   308,   866,   867,
     311,  1738,   312,  1739,   313,   314,   315,   316,   317,   318,
     319,  1740,   320,   321,   322,   323,  1741,  1742,   324,   325,
     868,   327,   328,  1743,   329,   330,   331,  1744,   332,   333,
     334,  1745,   335,   336,   337,   338,     0,   340,   341,   342,
     343,     0,  1746,   345,  1747,   346,   347,   348,   869,   350,
    1748,   351,  1749,   352,   353,   354,  1750,   355,   356,   357,
     358,   359,  1751,   360,     0,  1752,     0,   363,   364,  1753,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
    1754,   375,   376,   377,   378,   379,   380,   381,   382,  1755,
     383,   384,     0,   386,   387,   388,   389,   870,   871,  1756,
     872,  1757,   393,   394,   395,   396,   397,   398,     0,     0,
       0,     0,   403,   404,   405,   406,   407,   408,  1758,  1759,
     409,     0,   411,   412,   413,  1760,   414,   415,   416,  1761,
    1762,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   873,
     436,   874,   438,   439,   440,   441,   442,   443,   444,  4435,
       0,   447,  1763,   448,   449,   450,   451,  1764,     0,   453,
     875,   455,   456,   457,  1765,   458,   459,  1766,  1767,  4436,
     461,   462,  1768,  1769,   463,   464,     0,   466,   467,   468,
       0,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,  1770,   480,   481,     0,   483,     0,   485,   486,
     487,  1771,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   876,   499,   500,   501,   502,  1772,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,  1773,   516,   517,   518,   519,   520,   521,   522,   523,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,  1774,   535,   536,   537,   538,   539,  1775,   540,   541,
    2679,   543,   544,   545,   546,   547,   878,   549,  1776,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,     0,   564,  1777,   565,   566,  1778,  1779,   567,
     568,   569,   570,   571,   572,   573,  1780,   574,   879,   880,
    1781,  1782,   577,   578,     0,   580,     0,  1783,   582,   583,
     584,   585,   586,   587,   588,   589,  1784,  1785,   590,   591,
     592,   593,   594,  1786,  1787,   595,   596,   597,   598,   599,
       0,   881,  1788,   602,   603,   604,   605,   606,   607,  1789,
    1790,   608,  1791,  1792,   609,   610,   611,   612,   613,   614,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   626,   627,   628,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   967,   968,   969,  4437,  4438,   972,
     973,   974,   975,   860,     0,  1580,   695,     0,     0,     0,
     961,   756,     0,     0,     0,     0,     0,   962,   963,   964,
     236,   237,   238,   239,   240,   241,   242,   243,   244,  1715,
     245,   246,   247,  1716,  1717,  1718,  1719,  1720,  1721,  1722,
     248,   249,   250,  1723,   251,   252,   253,   254,   255,   256,
     257,   258,     0,   861,   261,   862,   863,  1724,   264,   265,
     266,   267,   268,   269,   270,  1725,  1726,   271,   272,   864,
     865,   275,  1727,   276,   277,   278,   279,     0,  1728,   281,
    1729,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,  1730,   292,   293,   294,   295,   296,   297,  1731,   298,
     299,   300,   301,  1732,  1733,  1734,   302,  1735,  1736,  1737,
     303,   304,   305,   306,   307,   308,   866,   867,   311,  1738,
     312,  1739,   313,   314,   315,   316,   317,   318,   319,  1740,
     320,   321,   322,   323,  1741,  1742,   324,   325,   868,   327,
     328,  1743,   329,   330,   331,  1744,   332,   333,   334,  1745,
     335,   336,   337,   338,     0,   340,   341,   342,   343,     0,
    1746,   345,  1747,   346,   347,   348,   869,   350,  1748,   351,
    1749,   352,   353,   354,  1750,   355,   356,   357,   358,   359,
    1751,   360,     0,  1752,     0,   363,   364,  1753,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,  1754,   375,
     376,   377,   378,   379,   380,   381,   382,  1755,   383,   384,
       0,   386,   387,   388,   389,   870,   871,  1756,   872,  1757,
     393,   394,   395,   396,   397,   398,     0,     0,     0,     0,
     403,   404,   405,   406,   407,   408,  1758,  1759,   409,     0,
     411,   412,   413,  1760,   414,   415,   416,  1761,  1762,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   873,   436,   874,
     438,   439,   440,   441,   442,   443,   444,  4883,     0,   447,
    1763,   448,   449,   450,   451,  1764,     0,   453,   875,   455,
     456,   457,  1765,   458,   459,  1766,  1767,  4436,   461,   462,
    1768,  1769,   463,   464,     0,   466,   467,   468,     0,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
    1770,   480,   481,     0,   483,     0,   485,   486,   487,  1771,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     876,   499,   500,   501,   502,  1772,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,  1773,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,  1774,
     535,   536,   537,   538,   539,  1775,   540,   541,  2679,   543,
     544,   545,   546,   547,   878,   549,  1776,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
       0,   564,  1777,   565,   566,  1778,  1779,   567,   568,   569,
     570,   571,   572,   573,  1780,   574,   879,   880,  1781,  1782,
     577,   578,     0,   580,     0,  1783,   582,   583,   584,   585,
     586,   587,   588,   589,  1784,  1785,   590,   591,   592,   593,
     594,  1786,  1787,   595,   596,   597,   598,   599,     0,   881,
    1788,   602,   603,   604,   605,   606,   607,  1789,  1790,   608,
    1791,  1792,   609,   610,   611,   612,   613,   614,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   626,
     627,   628,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   967,   968,   969,  4437,  4438,   972,   973,   974,
     975,  2077,     0,     0,     0,     0,     0,     0,  2078,     0,
       0,  2079,     0,     0,     0,  2080,  2081,  2082,  2083,  2084,
    2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,
    2095,  2096,  2097,  2098,  2099,     0,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,     0,     0,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,
    2152,  2153,  2154,  2155,  2156,  2157,     0,  2158,  2159,  2160,
    2161,  2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,
    2171,  2172,     0,  2173,  2174,  2175,  2176,  2177,  2178,  2179,
    2180,  2181,  2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,
    2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,  2199,
    2200,  2201,  2202,  2203,  2204,  2205,  2206,     0,  2207,  2208,
    2209,  2210,  2211,  2212,  2213,  2214,  2215,  2216,  2217,  2218,
       0,     0,  2219,  2220,  2221,  2222,     0,  2223,  2224,  2225,
    2226,  2227,     0,  2228,  2229,  2230,  2231,  2232,     0,  2233,
    2234,     0,  2235,  2236,  2237,     0,  2238,  2239,     0,  2240,
    2241,  2242,  2243,  2244,  2245,  2246,  2247,  2248,  2249,  2250,
    2251,  2252,  2253,  2254,  2255,  2256,  2257,  2258,  2259,  2260,
    2261,  2262,  2263,  2264,  2265,     0,  2266,     0,  2267,  2268,
    2269,  2270,  2271,  2272,  2273,  2274,  2275,  2276,  2277,  2278,
    2279,  2280,  2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,
    2289,     0,  2290,  2291,  2292,  2293,  2294,  2295,  2296,  2297,
    2298,  2299,  2300,  2301,  2302,  2303,  2304,  2305,     0,  2306,
    2307,     0,  2308,  2309,  2310,  2311,  2312,  2313,  2314,  2315,
    2316,  2317,  2318,  2319,  2320,  2321,  2322,  2323,  2324,  2325,
    2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,  2334,  2335,
       0,  2336,  2337,     0,  2338,  2339,  2340,  2341,  2342,     0,
    2343,  2344,  2345,  2346,     0,     0,  2347,  2348,  2349,  2350,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,     0,  2358,  2359,
    2360,  2361,  2362,     0,  2363,  2364,  2365,  2366,  2367,  2368,
    2369,  2370,  2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,
    2379,  2380,  2381,  2382,  2383,  2384,  2385,  2386,  2387,  2388,
    2389,  2390,  2391,  2392,  2393,  2394,  2395,     0,  2396,  2397,
    2398,  2399,  2400,  2401,  2402,  2403,  2404,  2405,  2406,  2407,
    2408,  2409,  2410,  2411,  2412,     0,  2413,  2414,  2415,  2416,
    2417,  2418,  2419,  2420,  2421,  2422,  2423,  2424,  2425,  2426,
    2427,  2428,  2429,  2430,  2431,  2432,  2433,  2434,  2435,  2436,
    2437,  2438,  2439,  2440,  2441,  2442,  2443,  2444,  2445,  2446,
    2447,  2448,  2449,  2450,  2451,  2452,  2453,  2454,  2455,  2456,
    2457,  2458,  2459,  2460,  2461,  2462,     0,  2463,  2464,  2465,
    2466,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
    2476,  2477,     0,  2478,  2479,  2480,  2481,  2482,  2483,  2484,
    2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2493,     0,
    2494,  2495,  2496,  2497,  2498,  2499,     0,  2500,     0,     0,
       0,     0,  2501,  2502,  2503,  2504,  2505,  2506,  2507,  2508,
    2509,  2510,  2511,  2512,  2513,  2514,  2515,     0,  2516,  2517,
       0,  2518,     0,     0,     0,     0,     0,     0,     0,     0,
    2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,   636,
       0,     0,     0,     0,     0,     0,   961,     0,     0,     0,
       0,     0,     0,   962,   963,   964,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     965,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   966,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,   369,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   636,     0,     0,
       0,     0,     0,     0,   961,     0,     0,     0,     0,     0,
       0,   962,   963,   964,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,  1082,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,  1083,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   636,     0,     0,     0,     0,
       0,     0,   961,     0,     0,     0,     0,     0,     0,   962,
     963,   964,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,  1148,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,  1149,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,  1150,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   636,     0,     0,     0,     0,     0,     0,
     961,     0,     0,     0,     0,     0,     0,   962,   963,   964,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,  1820,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,  1821,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,   369,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,     0,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   636,     0,     0,     0,     0,     0,     0,   961,     0,
       0,     0,     0,     0,     0,   962,   963,   964,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   636,
       0,     0,     0,     0,     0,     0,   961,     0,     0,     0,
       0,     0,     0,   962,   963,   964,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
    3532,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,  3533,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,   369,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   636,     0,     0,
       0,     0,     0,     0,   961,     0,     0,     0,     0,     0,
       0,   962,   963,   964,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,  5497,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,     0,  1714,     0,
       0,     0,     0,     0,     0,     0,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   236,   237,   238,   239,   240,
     241,   242,   243,   244,  1715,   245,   246,   247,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,   248,   249,   250,  1723,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,  1724,   264,   265,   266,   267,   268,   269,   270,
    1725,  1726,   271,   272,   273,   274,   275,  1727,   276,   277,
     278,   279,   280,  1728,   281,  1729,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,  1730,   292,   293,   294,
     295,   296,   297,  1731,   298,   299,   300,   301,  1732,  1733,
    1734,   302,  1735,  1736,  1737,   303,   304,   305,   306,   307,
     308,   309,   310,   311,  1738,   312,  1739,   313,   314,   315,
     316,   317,   318,   319,  1740,   320,   321,   322,   323,  1741,
    1742,   324,   325,   326,   327,   328,  1743,   329,   330,   331,
    1744,   332,   333,   334,  1745,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,  1746,   345,  1747,   346,   347,
     348,   349,   350,  1748,   351,  1749,   352,   353,   354,  1750,
     355,   356,   357,   358,   359,  1751,   360,   361,  1752,   362,
     363,   364,  1753,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,  1754,   375,   376,   377,   378,   379,   380,
     381,   382,  1755,   383,   384,   385,   386,   387,   388,   389,
     390,   391,  1756,   392,  1757,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,  1758,  1759,   409,   410,   411,   412,   413,  1760,   414,
     415,   416,  1761,  1762,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,  1763,   448,   449,   450,   451,
    1764,   452,   453,   454,   455,   456,   457,  1765,   458,   459,
    1766,  1767,   460,   461,   462,  1768,  1769,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,  1770,   480,   481,   482,   483,
     484,   485,   486,   487,  1771,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
    1772,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,  1773,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,  1774,   535,   536,   537,   538,   539,
    1775,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,  1776,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,  1777,   565,   566,
    1778,  1779,   567,   568,   569,   570,   571,   572,   573,  1780,
     574,   575,   576,  1781,  1782,   577,   578,   579,   580,   581,
    1783,   582,   583,   584,   585,   586,   587,   588,   589,  1784,
    1785,   590,   591,   592,   593,   594,  1786,  1787,   595,   596,
     597,   598,   599,   600,   601,  1788,   602,   603,   604,   605,
     606,   607,  1789,  1790,   608,  1791,  1792,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1793,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   849,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,   369,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   860,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5912,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,     0,   861,   261,   862,   863,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   864,   865,   275,     0,   276,   277,   278,   279,     0,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   866,   867,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     868,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,     0,   340,   341,   342,
     343,     0,     0,   345,     0,   346,   347,   348,   869,   350,
       0,   351,     0,   352,   353,   354,     0,   355,   356,   357,
     358,   359,     0,   360,     0,     0,     0,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
    2675,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,  2676,   386,   387,   388,   389,   870,   871,     0,
     872,     0,   393,   394,   395,   396,   397,   398,     0,     0,
       0,     0,   403,   404,   405,   406,   407,   408,     0,     0,
     409,     0,   411,   412,   413,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   873,
     436,   874,   438,   439,   440,   441,   442,   443,   444,     0,
       0,   447,     0,   448,   449,   450,   451,     0,     0,   453,
     875,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,  2677,   463,   464,  2678,   466,   467,   468,
       0,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,     0,   483,     0,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   876,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
       0,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
    2679,   543,   544,   545,   546,   547,   878,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,     0,   564,     0,   565,   566,     0,     0,   567,
     568,   569,   570,   571,   572,   573,     0,   574,   879,   880,
       0,     0,   577,   578,     0,   580,     0,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
       0,   881,  2680,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
       0,     0,     0,  3877,     0,     0,     0,     0,     0,     0,
       0,   626,   627,   628,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,  2681,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,     0,   861,   261,   862,   863,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   864,
     865,   275,     0,   276,   277,   278,   279,     0,     0,   281,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   866,   867,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   868,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,     0,   340,   341,   342,   343,     0,
       0,   345,     0,   346,   347,   348,   869,   350,     0,   351,
       0,   352,   353,   354,     0,   355,   356,   357,   358,   359,
       0,   360,     0,     0,     0,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,  2675,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
    2676,   386,   387,   388,   389,   870,   871,     0,   872,     0,
     393,   394,   395,   396,   397,   398,     0,     0,     0,     0,
     403,   404,   405,   406,   407,   408,     0,     0,   409,     0,
     411,   412,   413,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   873,   436,   874,
     438,   439,   440,   441,   442,   443,   444,     0,     0,   447,
       0,   448,   449,   450,   451,     0,     0,   453,   875,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,  2677,   463,   464,  2678,   466,   467,   468,     0,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,     0,   483,     0,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     876,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,     0,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,  2679,   543,
     544,   545,   546,   547,   878,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
       0,   564,     0,   565,   566,     0,     0,   567,   568,   569,
     570,   571,   572,   573,     0,   574,   879,   880,     0,     0,
     577,   578,     0,   580,     0,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,     0,   881,
    2680,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   626,
     627,   628,   946,     0,  1580,   695,     0,     0,     0,     0,
     756,     0,     0,     0,     0,     0,     0,  2681,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  2566,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,  1803,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,   411,
     412,   413,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,   450,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,  1804,     0,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,  1805,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   946,     0,  1580,   695,     0,     0,     0,     0,   756,
       0,     0,     0,     0,  1581,  1582,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,  2571,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,  1803,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,   354,     0,   355,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,   411,   412,
     413,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,  1804,     0,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,   568,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,  1805,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     946,     0,  1580,   695,     0,     0,     0,     0,   756,     0,
       0,     0,     0,  1581,  1582,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,     0,   302,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,  3493,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,  1803,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
     354,     0,   355,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,   411,   412,   413,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
     450,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,  1804,     0,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,   568,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,  1805,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   946,
       0,  1580,   695,     0,     0,     0,     0,   756,     0,     0,
       0,     0,  1581,  1582,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,  1803,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,   411,   412,   413,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,  1804,     0,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,  1805,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,   756,     0,     0,     0,
       0,  1581,  1582,     0,     0,   236,   237,   757,   239,   240,
     241,   242,   243,   244,   758,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   759,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     760,   349,   350,     0,   351,     0,   352,   761,     0,   762,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,   369,     0,   371,
     372,   373,   374,   763,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     764,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   765,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   766,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   767,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,     0,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   577,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   946,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     768,   769,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     3,     4,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,   411,   412,   413,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,  1025,  1714,     0,  6183,
     695,     0,     0,     0,     0,   756,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,  1715,   245,   246,   247,  1716,  1717,  1718,
    1719,  1720,  1721,  1722,   248,   249,   250,  1723,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,  1724,   264,   265,   266,   267,   268,   269,   270,  1725,
    1726,   271,   272,   273,   274,   275,  1727,   276,   277,   278,
     279,   280,  1728,   281,  1729,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,  1730,   292,   293,   294,   295,
     296,   297,  1731,   298,   299,   300,   301,  1732,  1733,  1734,
     302,  1735,  1736,  1737,   303,   304,   305,   306,   307,   308,
     309,   310,   311,  1738,   312,  1739,   313,   314,   315,   316,
     317,   318,   319,  1740,   320,   321,   322,   323,  1741,  1742,
     324,   325,   326,   327,   328,  1743,   329,   330,   331,  1744,
     332,   333,   334,  1745,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,  1746,   345,  1747,   346,   347,   348,
     349,   350,  1748,   351,  1749,   352,   353,   354,  1750,   355,
     356,   357,   358,   359,  1751,   360,   361,  1752,   362,   363,
     364,  1753,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,  1754,   375,   376,   377,   378,   379,   380,   381,
     382,  1755,   383,   384,   385,   386,   387,   388,   389,   390,
     391,  1756,   392,  1757,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
    1758,  1759,   409,   410,   411,   412,   413,  1760,   414,   415,
     416,  1761,  1762,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,  1763,   448,   449,   450,   451,  1764,
     452,   453,   454,   455,   456,   457,  1765,   458,   459,  1766,
    1767,   460,   461,   462,  1768,  1769,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,  1770,   480,   481,   482,   483,   484,
     485,   486,   487,  1771,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,  1772,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,  1773,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,  1774,   535,   536,   537,   538,   539,  1775,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
    1776,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,  1777,   565,   566,  1778,
    1779,   567,   568,   569,   570,   571,   572,   573,  1780,   574,
     575,   576,  1781,  1782,   577,   578,   579,   580,   581,  1783,
     582,   583,   584,   585,   586,   587,   588,   589,  1784,  1785,
     590,   591,   592,   593,   594,  1786,  1787,   595,   596,   597,
     598,   599,   600,   601,  1788,   602,   603,   604,   605,   606,
     607,  1789,  1790,   608,  1791,  1792,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,  1714,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,  1715,   245,   246,   247,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,   248,   249,   250,  1723,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
    1724,   264,   265,   266,   267,   268,   269,   270,  1725,  1726,
     271,   272,   273,   274,   275,  1727,   276,   277,   278,   279,
     280,  1728,   281,  1729,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,  1730,   292,   293,   294,   295,   296,
     297,  1731,   298,   299,   300,   301,  1732,  1733,  1734,   302,
    1735,  1736,  1737,   303,   304,   305,   306,   307,   308,   309,
     310,   311,  1738,   312,  1739,   313,   314,   315,   316,   317,
     318,   319,  1740,   320,   321,   322,   323,  1741,  1742,   324,
     325,   326,   327,   328,  1743,   329,   330,   331,  1744,   332,
     333,   334,  1745,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,  1746,   345,  1747,   346,   347,   348,   349,
     350,  1748,   351,  1749,   352,   353,   354,  1750,   355,   356,
     357,   358,   359,  1751,   360,   361,  1752,   362,   363,   364,
    1753,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,  1754,   375,   376,   377,   378,   379,   380,   381,   382,
    1755,   383,   384,   385,   386,   387,   388,   389,   390,   391,
    1756,   392,  1757,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,  1758,
    1759,   409,   410,   411,   412,   413,  1760,   414,   415,   416,
    1761,  1762,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,  1763,   448,   449,   450,   451,  1764,   452,
     453,   454,   455,   456,   457,  1765,   458,   459,  1766,  1767,
     460,   461,   462,  1768,  1769,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,  1770,   480,   481,   482,   483,   484,   485,
     486,   487,  1771,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,  1772,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,  1773,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,  1774,   535,   536,   537,   538,   539,  1775,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,  1776,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,  1777,   565,   566,  1778,  1779,
     567,   568,   569,   570,   571,   572,   573,  1780,   574,   575,
     576,  1781,  1782,   577,   578,   579,   580,   581,  1783,   582,
     583,   584,   585,   586,   587,   588,   589,  1784,  1785,   590,
     591,   592,   593,   594,  1786,  1787,   595,   596,   597,   598,
     599,   600,   601,  1788,   602,   603,   604,   605,   606,   607,
    1789,  1790,   608,  1791,  1792,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,  1714,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,  3598,   242,   243,
     244,  1715,   245,   246,   247,  1716,  1717,  1718,  1719,  1720,
    1721,  1722,   248,   249,   250,  1723,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,  1724,
     264,   265,   266,   267,   268,   269,   270,  1725,  1726,   271,
     272,   273,   274,   275,  1727,   276,   277,   278,   279,   280,
    1728,   281,  1729,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,  1730,   292,   293,   294,   295,   296,   297,
    1731,   298,   299,   300,   301,  1732,  1733,  1734,   302,  1735,
    1736,  1737,   303,   304,   305,   306,   307,   308,   309,   310,
     311,  1738,   312,  1739,   313,   314,   315,   316,   317,   318,
     319,  1740,   320,   321,   322,   323,  1741,  1742,   324,   325,
     326,  3599,   328,  1743,   329,   330,   331,  1744,   332,   333,
     334,  1745,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,  1746,   345,  1747,   346,   347,   348,   349,   350,
    1748,   351,  1749,   352,   353,   354,  1750,   355,   356,   357,
     358,   359,  1751,   360,   361,  1752,   362,   363,   364,  1753,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
    1754,   375,   376,   377,   378,   379,   380,   381,   382,  1755,
     383,   384,   385,   386,   387,   388,   389,   390,   391,  1756,
     392,  1757,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,  1758,  1759,
     409,   410,   411,   412,   413,  1760,   414,   415,   416,  1761,
    1762,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,  1763,   448,   449,   450,   451,  1764,   452,   453,
     454,   455,   456,   457,  1765,   458,   459,  1766,  1767,   460,
     461,   462,  1768,  1769,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,  1770,   480,   481,   482,   483,   484,   485,   486,
     487,  1771,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,  1772,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,  1773,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,  1774,   535,   536,   537,   538,   539,  1775,  3600,   541,
     542,   543,   544,   545,   546,   547,   548,   549,  1776,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,  1777,   565,   566,  1778,  1779,   567,
     568,   569,   570,   571,   572,   573,  1780,   574,   575,   576,
    1781,  1782,   577,   578,   579,   580,   581,  1783,   582,   583,
     584,   585,   586,   587,   588,   589,  1784,  1785,   590,   591,
     592,   593,   594,  1786,  1787,   595,   596,   597,   598,   599,
     600,   601,  1788,   602,   603,   604,   605,   606,   607,  1789,
    1790,   608,  1791,  1792,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,  1265,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,  1268,     0,
    1269,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,  1270,  1271,  1272,  1273,  1274,  1275,
    1276,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
    1281,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,  1284,     0,   362,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,   394,   395,   396,   397,   398,  1289,  1290,  1291,
    1292,   403,   404,   405,   406,   407,   408,     0,     0,   409,
    1293,   411,   412,   413,     0,   414,   415,   416,  1294,  1295,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,  1298,
     447,     0,   448,   449,   450,   451,     0,  1301,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,  1304,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,  1305,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,  1308,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,  1310,   564,     0,   565,   566,  1311,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,  1314,   580,  1315,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,  1318,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
    1320,  1321,  1322,  1323,   620,  1324,  1325,  1326,  1327,   625,
     626,   627,   628,   235,     0,  1255,   695,     0,  1256,  1257,
       0,   756,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1261,   261,  1262,  1263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,  1266,
    1267,   275,     0,   276,   277,   278,   279,   280,     0,   281,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,     0,   302,     0,     0,     0,
     303,   304,   305,   306,   307,   308,  1277,  1278,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   868,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
    1282,   345,     0,   346,   347,   348,  1283,   350,     0,   351,
       0,   352,   353,   354,     0,   355,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,  1286,  1287,     0,  1288,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
     411,   412,   413,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,  1296,   436,  1297,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,   450,   451,  1300,   452,   453,  1302,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
    1306,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,   545,   546,   547,  1309,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,   568,   569,
     570,   571,   572,   573,     0,   574,  1312,  1313,     0,     0,
     577,   578,   579,   580,   581,  1316,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,  1319,
       0,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   946,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   985,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,   947,   302,     0,     0,   948,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,   411,
     412,   413,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,   450,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,   949,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   946,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,  1006,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,   947,   302,     0,     0,   948,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,   354,     0,   355,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,   411,   412,
     413,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,  1007,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,   949,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,   568,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     946,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,   947,   302,     0,     0,   948,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
     354,     0,   355,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,   411,   412,   413,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
     450,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,   949,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,   568,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,  2942,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   946,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,   947,   302,     0,     0,   948,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,   361,  3948,
     362,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,   411,   412,   413,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,   949,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   946,     0,
       0,   695,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
       0,   302,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,  1803,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,   354,     0,
     355,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,   411,   412,   413,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,   450,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
    1804,     0,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,   568,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   577,   578,   579,   580,   581,
    1805,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   946,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,   947,
     302,     0,     0,   948,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,   411,   412,   413,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,   949,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   946,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,   947,   302,
       0,     0,   948,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,   354,     0,   355,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,   411,   412,   413,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,  1101,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,   450,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,   949,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,   568,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   946,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,   947,   302,     0,
       0,   948,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,   354,     0,   355,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,  1143,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,   411,   412,   413,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,   949,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
     568,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   946,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,   947,   302,     0,     0,
     948,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,  1156,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,   411,   412,   413,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,   450,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,   949,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,   281,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,     0,     0,   947,   302,     0,     0,   948,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,   354,     0,   355,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,  1168,   370,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
     411,   412,   413,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,  1169,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,   949,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,   568,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   946,     0,     0,   695,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,   298,   299,
     300,   301,     0,     0,     0,   302,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  2551,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,   354,     0,   355,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,   411,
     412,   413,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,   450,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,   568,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   946,     0,     0,   695,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     301,     0,     0,     0,   302,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,   354,     0,   355,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,   411,   412,
     413,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,   568,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     235,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
       0,     0,     0,   302,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
     354,     0,   355,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,   411,   412,   413,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
     450,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,   568,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,  1127,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,   411,   412,   413,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,   298,   299,   300,   301,     0,     0,
       0,   302,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,   354,     0,
     355,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,  1140,   370,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,   384,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,   411,   412,   413,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,   450,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,   568,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   577,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,   298,   299,   300,   301,     0,     0,     0,
     302,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,   354,     0,   355,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,  1154,   370,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,   411,   412,   413,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,   568,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,   298,   299,   300,   301,     0,     0,     0,   302,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,   354,     0,   355,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,  1158,   370,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,   384,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,   411,   412,   413,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,   450,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,   568,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   946,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,     0,     0,     0,   302,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,   354,     0,   355,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,   411,   412,   413,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
     568,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,  2714,   276,   277,   278,   279,   280,     0,
       0,  2783,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,  2715,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,  2784,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,  2717,   352,   353,     0,     0,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,  2785,     0,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
       0,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,     0,     0,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,     0,   412,     0,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,     0,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
    2718,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,     0,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,  2719,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,     0,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,  2714,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,  2715,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
    2784,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
    2717,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,   369,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,  3811,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,  2718,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,  2719,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   775,   245,
     776,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,   777,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,   811,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   778,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   779,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   775,   245,   776,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,   777,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,  3500,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   778,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   779,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,  2714,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,  2715,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,  2784,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,  2717,   352,   353,
       0,     0,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,     0,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,  2718,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,  2719,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   775,   245,   776,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,   777,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,   369,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   778,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   779,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,  3018,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,  2849,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,     0,     0,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,   369,     0,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,   843,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,  2850,  2851,     0,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   577,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,  1981,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,  1982,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,  1983,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,  1984,   352,   353,     0,     0,     0,
    1985,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,  1986,  1987,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,  1988,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,  1989,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
    1990,   523,   524,   525,   526,   527,   528,  1991,   530,   531,
     532,   533,   534,     0,  1992,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
    1993,   567,     0,  1994,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,  1995,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   776,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,   777,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,   369,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   778,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   779,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,  2849,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,   369,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,   843,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,  2850,  2851,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     999,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,     0,     0,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,  1000,     0,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
       0,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,     0,     0,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,     0,   412,     0,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,   843,   460,   461,
     462,     0,     0,   463,   464,   465,     0,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,     0,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,     0,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,  3579,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,   369,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,     0,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,  3580,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,  3592,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
    3593,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   637,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   686,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
       0,     0,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,     0,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   687,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   803,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,   369,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     804,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   805,   576,     0,     0,   806,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   837,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,     0,     0,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,   369,     0,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   838,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,     0,   569,   570,   571,   572,   573,     0,
     574,   839,   576,     0,     0,   840,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
     843,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,     0,
       0,     0,     0,     0,     0,   901,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,   369,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   956,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,   957,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
    1119,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,     0,     0,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,   369,     0,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
       0,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,     0,     0,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,     0,   412,     0,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,     0,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,     0,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,     0,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   803,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,   369,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,     0,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,  1225,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,  1366,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,  1377,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   823,   272,   273,   274,  1378,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
       0,     0,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,     0,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   826,   435,     0,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,     0,
     827,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     828,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,  1370,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,   569,   570,   571,   572,
     573,     0,   574,   830,   576,     0,     0,   831,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   832,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,  1524,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,   843,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,  1585,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,     0,     0,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,  1586,     0,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,     0,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   577,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,  3350,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
    3351,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
    3352,   567,     0,   569,  3353,   571,  3354,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,  3355,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,   695,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,   369,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   636,     0,     0,     0,     0,
       0,     0,     0,   756,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,   369,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,  4157,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,     0,     0,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,   369,     0,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
       0,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,     0,     0,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,     0,   412,     0,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,     0,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,     0,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,     0,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,  4171,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,   369,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,     0,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,  4825,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,  4897,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,  5251,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
       0,     0,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,     0,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,   369,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,     0,     0,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,   369,     0,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,     0,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   795,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   801,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     823,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   824,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,   369,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   825,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   826,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   827,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   828,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   829,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   830,
     576,     0,     0,   831,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     832,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,   369,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   855,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,     0,     0,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,   981,     0,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
       0,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,     0,     0,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,     0,   412,     0,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,     0,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,     0,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,     0,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,   991,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,     0,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   994,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
    1010,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
       0,     0,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,  1067,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,     0,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,  1072,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,     0,     0,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,  1089,     0,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,     0,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   577,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,  1092,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,  1094,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,  1132,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,     0,     0,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,  1160,     0,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
       0,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,     0,     0,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,     0,   412,     0,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,     0,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,     0,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,     0,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,  1162,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,     0,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,  1172,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
    1175,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
       0,     0,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,  1178,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,     0,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   823,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,   369,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   826,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   827,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   828,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
    1370,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   830,   576,     0,     0,   831,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   832,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,     0,     0,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,  1846,     0,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,     0,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   577,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,  1880,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,  1882,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,  1922,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,     0,     0,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,  1924,     0,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
       0,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,     0,     0,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,     0,   412,     0,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,     0,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,     0,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,     0,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,  1926,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,     0,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   519,   520,   521,   522,   523,   524,   525,   526,
    2020,   528,   529,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,   539,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   575,   576,     0,     0,   577,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,  2667,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
     369,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,     0,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   823,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
       0,     0,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,   369,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,     0,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   826,   435,     0,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,     0,
     827,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     828,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,  1370,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,  2701,   570,   571,   572,
     573,     0,   574,   830,   576,     0,     0,   831,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   832,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   823,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,   369,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   826,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   827,
     520,   521,   522,   523,   524,   525,   526,   527,   528,  2766,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
    2767,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   830,   576,     0,     0,  2768,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   832,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   823,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,     0,     0,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,   369,     0,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   826,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   827,   520,
     521,   522,   523,   524,   525,   526,   527,   528,  2846,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,  2767,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,     0,   569,   570,   571,   572,   573,     0,
     574,   830,   576,     0,     0,  2768,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   832,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   823,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,   325,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     826,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   827,   520,   521,
     522,   523,   524,   525,   526,   527,   528,  2870,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,  2767,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     830,   576,     0,     0,  2768,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   832,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,  3063,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,   363,   364,     0,
     365,   366,   367,   368,  3067,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   636,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
       0,   299,   300,   301,     0,     0,     0,     0,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   309,   310,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,     0,   345,     0,   346,   347,   348,   349,   350,     0,
     351,     0,   352,   353,     0,     0,     0,   356,   357,   358,
     359,     0,   360,   361,     0,   362,   363,   364,     0,   365,
     366,   367,   368,  3125,     0,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
       0,   385,   386,   387,   388,   389,   390,   391,     0,   392,
       0,   393,     0,     0,   396,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     0,     0,   409,
     410,     0,   412,     0,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,     0,   448,   449,     0,   451,     0,   452,   453,   454,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,   465,     0,   467,     0,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,   482,   483,   484,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   542,
     543,   544,     0,   546,   547,   548,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,     0,   565,   566,     0,     0,   567,     0,
     569,   570,   571,   572,   573,     0,   574,   575,   576,     0,
       0,   577,   578,   579,   580,   581,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,     0,   602,     0,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   636,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,     0,   292,   293,   294,   295,   296,   297,     0,     0,
     299,   300,   301,     0,     0,     0,     0,     0,     0,     0,
     303,   304,   305,   306,   307,   308,   309,   310,   311,     0,
     312,     0,   313,   314,   315,   316,   317,   318,   319,     0,
     320,   321,   322,   323,     0,     0,   324,   325,   326,   327,
     328,     0,   329,   330,   331,     0,   332,   333,   334,     0,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
       0,   345,     0,   346,   347,   348,   349,   350,     0,   351,
       0,   352,   353,     0,     0,     0,   356,   357,   358,   359,
       0,   360,   361,     0,   362,   363,   364,     0,   365,   366,
     367,   368,  3511,     0,   371,   372,   373,   374,     0,   375,
     376,   377,   378,   379,   380,   381,   382,     0,   383,     0,
     385,   386,   387,   388,   389,   390,   391,     0,   392,     0,
     393,     0,     0,   396,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,     0,     0,   409,   410,
       0,   412,     0,     0,   414,   415,   416,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
       0,   448,   449,     0,   451,     0,   452,   453,   454,   455,
     456,   457,     0,   458,   459,     0,     0,   460,   461,   462,
       0,     0,   463,   464,   465,     0,   467,     0,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
       0,   480,   481,   482,   483,   484,   485,   486,   487,     0,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,     0,
     516,   517,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,     0,
     535,   536,   537,   538,   539,     0,   540,   541,   542,   543,
     544,     0,   546,   547,   548,   549,     0,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,     0,   565,   566,     0,     0,   567,     0,   569,
     570,   571,   572,   573,     0,   574,   575,   576,     0,     0,
     577,   578,   579,   580,   581,     0,   582,   583,   584,   585,
     586,   587,   588,   589,     0,     0,   590,   591,   592,   593,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
       0,   602,     0,   604,   605,   606,   607,     0,     0,   608,
       0,     0,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   823,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
       0,   292,   293,   294,   295,   296,   297,     0,     0,   299,
     300,   301,     0,     0,     0,     0,     0,     0,     0,   303,
     304,   305,   306,   307,   308,   309,   310,   311,     0,   312,
       0,   313,   314,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   323,     0,     0,   324,   325,   326,   327,   328,
       0,   329,   330,   331,     0,   332,   333,   334,     0,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,     0,
     345,     0,   346,   347,   348,   349,   350,     0,   351,     0,
     352,   353,     0,     0,     0,   356,   357,   358,   359,     0,
     360,   361,     0,   362,   363,   364,     0,   365,   366,   367,
     368,   369,     0,   371,   372,   373,   374,     0,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   383,     0,   385,
     386,   387,   388,   389,   390,   391,     0,   392,     0,   393,
       0,     0,   396,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     0,     0,   409,   410,     0,
     412,     0,     0,   414,   415,   416,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   826,   435,     0,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,     0,
     448,   449,     0,   451,     0,   452,   453,   454,   455,   456,
     457,     0,   458,   459,     0,     0,   460,   461,   462,     0,
       0,   463,   464,   465,     0,   467,     0,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,     0,
     480,   481,   482,   483,   484,   485,   486,   487,     0,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,     0,   516,
     517,     0,   827,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   828,   530,   531,   532,   533,   534,     0,   535,
     536,   537,   538,  2767,     0,   540,   541,   542,   543,   544,
       0,   546,   547,   548,   549,     0,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,     0,   565,   566,     0,     0,   567,     0,   569,   570,
     571,   572,   573,     0,   574,   830,   576,     0,     0,  2768,
     578,   579,   580,   581,     0,   582,   583,   584,   585,   586,
     587,   588,   589,     0,     0,   590,   591,   592,   593,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,     0,
     602,     0,   604,   605,   606,   607,     0,     0,   608,     0,
       0,   609,   610,   611,   612,   613,   832,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   636,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,     0,
     292,   293,   294,   295,   296,   297,     0,     0,   299,   300,
     301,     0,     0,     0,     0,     0,     0,     0,   303,   304,
     305,   306,   307,   308,   309,   310,   311,     0,   312,     0,
     313,   314,   315,   316,   317,   318,   319,     0,   320,   321,
     322,   323,     0,     0,   324,   325,   326,   327,   328,     0,
     329,   330,   331,     0,   332,   333,   334,     0,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,     0,   345,
       0,   346,   347,   348,   349,   350,     0,   351,     0,   352,
     353,     0,     0,     0,   356,   357,   358,   359,     0,   360,
     361,     0,   362,   363,   364,     0,   365,   366,   367,   368,
    3568,     0,   371,   372,   373,   374,     0,   375,   376,   377,
     378,   379,   380,   381,   382,     0,   383,     0,   385,   386,
     387,   388,   389,   390,   391,     0,   392,     0,   393,     0,
       0,   396,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     0,     0,   409,   410,     0,   412,
       0,     0,   414,   415,   416,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,     0,   448,
     449,     0,   451,     0,   452,   453,   454,   455,   456,   457,
       0,   458,   459,     0,     0,   460,   461,   462,     0,     0,
     463,   464,   465,     0,   467,     0,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,     0,     0,   480,
     481,   482,   483,   484,   485,   486,   487,     0,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,     0,   516,   517,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,     0,   535,   536,
     537,   538,   539,     0,   540,   541,   542,   543,   544,     0,
     546,   547,   548,   549,     0,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
       0,   565,   566,     0,     0,   567,     0,   569,   570,   571,
     572,   573,     0,   574,   575,   576,     0,     0,   577,   578,
     579,   580,   581,     0,   582,   583,   584,   585,   586,   587,
     588,   589,     0,     0,   590,   591,   592,   593,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,     0,   602,
       0,   604,   605,   606,   607,     0,     0,   608,     0,     0,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,     0,   292,
     293,   294,   295,   296,   297,     0,     0,   299,   300,   301,
       0,     0,     0,     0,     0,     0,     0,   303,   304,   305,
     306,   307,   308,   309,   310,   311,     0,   312,     0,   313,
     314,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     323,     0,     0,   324,   325,   326,   327,   328,     0,   329,
     330,   331,     0,   332,   333,   334,     0,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,     0,   345,     0,
     346,   347,   348,   349,   350,     0,   351,     0,   352,   353,
       0,     0,     0,   356,   357,   358,   359,     0,   360,   361,
       0,   362,   363,   364,     0,   365,   366,   367,   368,  3582,
       0,   371,   372,   373,   374,     0,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   383,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   392,     0,   393,     0,     0,
     396,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     0,     0,   409,   410,     0,   412,     0,
       0,   414,   415,   416,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,     0,   448,   449,
       0,   451,     0,   452,   453,   454,   455,   456,   457,     0,
     458,   459,     0,     0,   460,   461,   462,     0,     0,   463,
     464,   465,     0,   467,     0,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,     0,   480,   481,
     482,   483,   484,   485,   486,   487,     0,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,     0,   516,   517,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,     0,   535,   536,   537,
     538,   539,     0,   540,   541,   542,   543,   544,     0,   546,
     547,   548,   549,     0,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,     0,
     565,   566,     0,     0,   567,     0,   569,   570,   571,   572,
     573,     0,   574,   575,   576,     0,     0,   577,   578,   579,
     580,   581,     0,   582,   583,   584,   585,   586,   587,   588,
     589,     0,     0,   590,   591,   592,   593,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,     0,   602,     0,
     604,   605,   606,   607,     0,     0,   608,     0,     0,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,     0,   299,   300,   301,     0,
       0,     0,     0,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   309,   310,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   326,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,     0,   345,     0,   346,
     347,   348,   349,   350,     0,   351,     0,   352,   353,     0,
       0,     0,   356,   357,   358,   359,     0,   360,   361,     0,
     362,   363,   364,     0,   365,   366,   367,   368,  3584,     0,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,     0,   385,   386,   387,   388,
     389,   390,   391,     0,   392,     0,   393,     0,     0,   396,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,     0,     0,   409,   410,     0,   412,     0,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,     0,   448,   449,     0,
     451,     0,   452,   453,   454,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
     465,     0,   467,     0,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,   482,
     483,   484,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   542,   543,   544,     0,   546,   547,
     548,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,     0,   565,
     566,     0,     0,   567,     0,   569,   570,   571,   572,   573,
       0,   574,   575,   576,     0,     0,   577,   578,   579,   580,
     581,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,     0,   602,     0,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   636,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,     0,   292,   293,   294,
     295,   296,   297,     0,     0,   299,   300,   301,     0,     0,
       0,     0,     0,     0,     0,   303,   304,   305,   306,   307,
     308,   309,   310,   311,     0,   312,     0,   313,   314,   315,
     316,   317,   318,   319,     0,   320,   321,   322,   323,     0,
       0,   324,   325,   326,   327,   328,     0,   329,   330,   331,
       0,   332,   333,   334,     0,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,     0,   345,     0,   346,   347,
     348,   349,   350,     0,   351,     0,   352,   353,     0,     0,
       0,   356,   357,   358,   359,     0,   360,   361,     0,   362,
     363,   364,     0,   365,   366,   367,   368,  3732,     0,   371,
     372,   373,   374,     0,   375,   376,   377,   378,   379,   380,
     381,   382,     0,   383,     0,   385,   386,   387,   388,   389,
     390,   391,     0,   392,     0,   393,     0,     0,   396,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     0,     0,   409,   410,     0,   412,     0,     0,   414,
     415,   416,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,     0,   448,   449,     0,   451,
       0,   452,   453,   454,   455,   456,   457,     0,   458,   459,
       0,     0,   460,   461,   462,     0,     0,   463,   464,   465,
       0,   467,     0,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,     0,   480,   481,   482,   483,
     484,   485,   486,   487,     0,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,     0,   516,   517,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,     0,   535,   536,   537,   538,   539,
       0,   540,   541,   542,   543,   544,     0,   546,   547,   548,
     549,     0,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,     0,   565,   566,
       0,     0,   567,     0,   569,   570,   571,   572,   573,     0,
     574,   575,   576,     0,     0,   577,   578,   579,   580,   581,
       0,   582,   583,   584,   585,   586,   587,   588,   589,     0,
       0,   590,   591,   592,   593,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,     0,   602,     0,   604,   605,
     606,   607,     0,     0,   608,     0,     0,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,     0,   292,   293,   294,   295,
     296,   297,     0,     0,   299,   300,   301,     0,     0,     0,
       0,     0,     0,     0,   303,   304,   305,   306,   307,   308,
     309,   310,   311,     0,   312,     0,   313,   314,   315,   316,
     317,   318,   319,     0,   320,   321,   322,   323,     0,     0,
     324,  3772,   326,   327,   328,     0,   329,   330,   331,     0,
     332,   333,   334,     0,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,     0,   345,     0,   346,   347,   348,
     349,   350,     0,   351,     0,   352,   353,     0,     0,     0,
     356,   357,   358,   359,     0,   360,   361,     0,   362,   363,
     364,     0,   365,   366,   367,   368,   369,     0,   371,   372,
     373,   374,     0,   375,   376,   377,   378,   379,   380,   381,
     382,     0,   383,     0,   385,   386,   387,   388,   389,   390,
     391,     0,   392,     0,   393,     0,     0,   396,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
       0,     0,   409,   410,     0,   412,     0,     0,   414,   415,
     416,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,     0,   448,   449,     0,   451,     0,
     452,   453,   454,   455,   456,   457,     0,   458,   459,     0,
       0,   460,   461,   462,     0,     0,   463,   464,   465,     0,
     467,     0,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,     0,     0,   480,   481,   482,   483,   484,
     485,   486,   487,     0,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,     0,   516,   517,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,     0,   535,   536,   537,   538,   539,     0,
     540,   541,   542,   543,   544,     0,   546,   547,   548,   549,
       0,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,     0,   565,   566,     0,
       0,   567,     0,   569,   570,   571,   572,   573,     0,   574,
     575,   576,     0,     0,   577,   578,   579,   580,   581,     0,
     582,   583,   584,   585,   586,   587,   588,   589,     0,     0,
     590,   591,   592,   593,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,     0,   602,     0,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   636,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,     0,   292,   293,   294,   295,   296,
     297,     0,     0,   299,   300,   301,     0,     0,     0,     0,
       0,     0,     0,   303,   304,   305,   306,   307,   308,   309,
     310,   311,     0,   312,     0,   313,   314,   315,   316,   317,
     318,   319,     0,   320,   321,   322,   323,     0,     0,   324,
     325,   326,   327,   328,     0,   329,   330,   331,     0,   332,
     333,   334,     0,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,     0,   345,     0,   346,   347,   348,   349,
     350,     0,   351,     0,   352,   353,     0,     0,     0,   356,
     357,   358,   359,     0,   360,   361,     0,   362,   363,   364,
       0,   365,   366,   367,   368,  5010,     0,   371,   372,   373,
     374,     0,   375,   376,   377,   378,   379,   380,   381,   382,
       0,   383,     0,   385,   386,   387,   388,   389,   390,   391,
       0,   392,     0,   393,     0,     0,   396,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     0,
       0,   409,   410,     0,   412,     0,     0,   414,   415,   416,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,     0,   448,   449,     0,   451,     0,   452,
     453,   454,   455,   456,   457,     0,   458,   459,     0,     0,
     460,   461,   462,     0,     0,   463,   464,   465,     0,   467,
       0,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,     0,   480,   481,   482,   483,   484,   485,
     486,   487,     0,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,     0,   516,   517,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,     0,   535,   536,   537,   538,   539,     0,   540,
     541,   542,   543,   544,     0,   546,   547,   548,   549,     0,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,     0,   565,   566,     0,     0,
     567,     0,   569,   570,   571,   572,   573,     0,   574,   575,
     576,     0,     0,   577,   578,   579,   580,   581,     0,   582,
     583,   584,   585,   586,   587,   588,   589,     0,     0,   590,
     591,   592,   593,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,     0,   602,     0,   604,   605,   606,   607,
       0,     0,   608,     0,     0,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   636,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,     0,   292,   293,   294,   295,   296,   297,
       0,     0,   299,   300,   301,     0,     0,     0,     0,     0,
       0,     0,   303,   304,   305,   306,   307,   308,   309,   310,
     311,     0,   312,     0,   313,   314,   315,   316,   317,   318,
     319,     0,   320,   321,   322,   323,     0,     0,   324,   325,
     326,   327,   328,     0,   329,   330,   331,     0,   332,   333,
     334,     0,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,     0,   345,     0,   346,   347,   348,   349,   350,
       0,   351,     0,   352,   353,     0,     0,     0,   356,   357,
     358,   359,     0,   360,   361,     0,   362,     0,   364,     0,
     365,   366,   367,   368,   369,     0,   371,   372,   373,   374,
       0,   375,   376,   377,   378,   379,   380,   381,   382,     0,
     383,     0,   385,   386,   387,   388,   389,   390,   391,     0,
     392,     0,   393,     0,     0,   396,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     0,     0,
     409,   410,     0,   412,     0,     0,   414,   415,   416,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,     0,   448,   449,     0,   451,     0,   452,   453,
     454,   455,   456,   457,     0,   458,   459,     0,     0,   460,
     461,   462,     0,     0,   463,   464,   465,     0,   467,     0,
     469,   470,   471,   472,   473,   474,   475,   476,     0,   478,
     479,     0,     0,   480,   481,   482,   483,   484,   485,   486,
     487,     0,   488,   489,   490,   491,   492,   493,   494,   495,
       0,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,     0,   516,   517,     0,   519,   520,   521,   522,   523,
     524,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,     0,   535,   536,   537,   538,   539,     0,   540,   541,
     542,   543,   544,     0,   546,   547,   548,   549,     0,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,     0,   565,   566,     0,     0,   567,
       0,   569,   570,   571,   572,   573,     0,   574,   575,   576,
       0,     0,   577,   578,   579,   580,   581,     0,   582,   583,
     584,   585,   586,   587,   588,   589,     0,     0,   590,   591,
     592,   593,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,     0,   602,     0,   604,   605,   606,   607,     0,
       0,   608,     0,     0,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   860,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,     0,   861,   261,   862,   863,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     864,   865,   275,     0,   276,   277,   278,   279,     0,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   866,   867,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   868,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   340,   341,   342,   343,
       0,     0,   345,     0,   346,   347,   348,   869,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,     0,     0,     0,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,  2675,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,  2676,   386,   387,   388,   389,   870,   871,     0,   872,
       0,   393,   394,   395,   396,   397,   398,     0,     0,     0,
       0,   403,   404,   405,   406,   407,   408,     0,     0,   409,
       0,   411,   412,   413,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   873,   436,
     874,   438,   439,   440,   441,   442,   443,   444,     0,     0,
     447,     0,   448,   449,   450,   451,     0,     0,   453,   875,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,  2678,   466,   467,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,     0,   483,     0,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   876,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,  2679,
     543,   544,   545,   546,   547,   878,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   564,     0,   565,   566,     0,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,   879,   880,     0,
       0,   577,   578,     0,   580,     0,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,     0,
     881,  2680,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   860,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     626,   627,   628,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,     0,   861,
     261,   862,   863,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   864,   865,   275,     0,   276,
     277,   278,   279,     0,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   866,   867,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   868,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
       0,   340,   341,   342,   343,     0,     0,   345,     0,   346,
     347,   348,   869,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,     0,     0,
       0,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,     0,   386,   387,   388,
     389,   870,   871,     0,   872,     0,   393,   394,   395,   396,
     397,   398,     0,     0,     0,     0,   403,   404,   405,   406,
     407,   408,     0,     0,   409,     0,   411,   412,   413,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   873,   436,   874,   438,   439,   440,   441,
     442,   443,   444,     0,     0,   447,     0,   448,   449,   450,
     451,  2762,     0,   453,   875,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
       0,   466,   467,   468,     0,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,     0,
     483,     0,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   876,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,  2679,   543,   544,   545,   546,   547,
     878,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   564,     0,   565,
     566,     0,  4536,   567,   568,   569,   570,   571,   572,   573,
       0,   574,   879,   880,     0,     0,   577,   578,     0,   580,
       0,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,     0,   881,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   860,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   626,   627,   628,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,     0,   861,   261,   862,   863,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     864,   865,   275,     0,   276,   277,   278,   279,     0,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   866,   867,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   868,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   340,   341,   342,   343,
       0,     0,   345,     0,   346,   347,   348,   869,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,     0,     0,     0,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,     0,   386,   387,   388,   389,   870,   871,     0,   872,
       0,   393,   394,   395,   396,   397,   398,     0,     0,     0,
       0,   403,   404,   405,   406,   407,   408,     0,     0,   409,
       0,   411,   412,   413,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   873,   436,
     874,   438,   439,   440,   441,   442,   443,   444,  2836,     0,
     447,     0,   448,   449,   450,   451,     0,     0,   453,   875,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,     0,   466,   467,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,     0,   483,     0,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   876,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   877,
     543,   544,   545,   546,   547,   878,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   564,     0,   565,   566,     0,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,   879,   880,     0,
       0,   577,   578,     0,   580,     0,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,     0,
     881,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   860,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     626,   627,   628,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,     0,   861,
     261,   862,   863,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   864,   865,   275,     0,   276,
     277,   278,   279,     0,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   866,   867,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   868,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
       0,   340,   341,   342,   343,     0,     0,   345,     0,   346,
     347,   348,   869,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,     0,     0,
       0,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,     0,   386,   387,   388,
     389,   870,   871,     0,   872,     0,   393,   394,   395,   396,
     397,   398,     0,     0,     0,     0,   403,   404,   405,   406,
     407,   408,     0,     0,   409,     0,   411,   412,   413,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   873,   436,   874,   438,   439,   440,   441,
     442,   443,   444,  4332,     0,   447,     0,   448,   449,   450,
     451,     0,     0,   453,   875,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
       0,   466,   467,   468,     0,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,     0,
     483,     0,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   876,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   877,   543,   544,   545,   546,   547,
     878,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   564,     0,   565,
     566,     0,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,   879,   880,     0,     0,   577,   578,     0,   580,
       0,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,     0,   881,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   860,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   626,   627,   628,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,     0,   861,   261,   862,   863,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     864,   865,   275,     0,   276,   277,   278,   279,     0,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   866,   867,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   868,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   340,   341,   342,   343,
       0,     0,   345,     0,   346,   347,   348,   869,   350,  5857,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,     0,     0,     0,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,     0,   386,   387,   388,   389,   870,   871,     0,   872,
       0,   393,   394,   395,   396,   397,   398,     0,     0,     0,
       0,   403,   404,   405,   406,   407,   408,     0,     0,   409,
       0,   411,   412,   413,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   873,   436,
     874,   438,   439,   440,   441,   442,   443,   444,     0,     0,
     447,     0,   448,   449,   450,   451,     0,     0,   453,   875,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,     0,   466,   467,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,     0,   483,     0,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   876,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   877,
     543,   544,   545,   546,   547,   878,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   564,     0,   565,   566,     0,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,   879,   880,     0,
       0,   577,   578,     0,   580,     0,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,     0,
     881,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   860,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     626,   627,   628,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,     0,   861,
     261,   862,   863,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   864,   865,   275,     0,   276,
     277,   278,   279,     0,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   866,   867,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   868,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
       0,   340,   341,   342,   343,     0,     0,   345,     0,   346,
     347,   348,   869,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,     0,     0,
       0,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,     0,   386,   387,   388,
     389,   870,   871,     0,   872,     0,   393,   394,   395,   396,
     397,   398,     0,     0,     0,     0,   403,   404,   405,   406,
     407,   408,     0,     0,   409,     0,   411,   412,   413,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   873,   436,   874,   438,   439,   440,   441,
     442,   443,   444,     0,     0,   447,     0,   448,   449,   450,
     451,     0,     0,   453,   875,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
       0,   466,   467,   468,     0,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,     0,
     483,     0,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   876,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   877,   543,   544,   545,   546,   547,
     878,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   564,     0,   565,
     566,     0,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,   879,   880,     0,     0,   577,   578,     0,   580,
       0,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,     0,   881,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   860,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   626,   627,   628,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,     0,   861,   261,   862,   863,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     864,   865,   275,     0,   276,   277,   278,   279,     0,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   866,   867,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   868,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   340,   341,   342,   343,
       0,     0,   345,     0,   346,   347,   348,   869,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,     0,     0,     0,   363,   364,     0,   365,
     366,   367,   368,  1134,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,     0,   386,   387,   388,   389,   870,   871,     0,   872,
       0,   393,   394,   395,   396,   397,   398,     0,     0,     0,
       0,   403,   404,   405,   406,   407,   408,     0,     0,   409,
       0,   411,   412,   413,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   873,   436,
     874,   438,   439,   440,   441,   442,   443,   444,     0,     0,
     447,     0,   448,   449,   450,   451,     0,     0,   453,   875,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,     0,   466,   467,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,     0,   483,     0,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   876,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,   877,
     543,   544,   545,   546,   547,   878,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   564,     0,   565,   566,     0,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,   879,   880,     0,
       0,   577,   578,     0,   580,     0,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,     0,
     881,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   860,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     626,   627,   628,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,     0,   861,
     261,   862,   863,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   864,   865,   275,     0,   276,
     277,   278,   279,     0,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   866,   867,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   868,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
       0,   340,   341,   342,   343,     0,     0,   345,     0,   346,
     347,   348,   869,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,     0,     0,
       0,   363,   364,     0,   365,   366,   367,   368,  1166,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,     0,   386,   387,   388,
     389,   870,   871,     0,   872,     0,   393,   394,   395,   396,
     397,   398,     0,     0,     0,     0,   403,   404,   405,   406,
     407,   408,     0,     0,   409,     0,   411,   412,   413,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   873,   436,   874,   438,   439,   440,   441,
     442,   443,   444,     0,     0,   447,     0,   448,   449,   450,
     451,     0,     0,   453,   875,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
       0,   466,   467,   468,     0,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,     0,
     483,     0,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   876,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,   877,   543,   544,   545,   546,   547,
     878,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   564,     0,   565,
     566,     0,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,   879,   880,     0,     0,   577,   578,     0,   580,
       0,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,     0,   881,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   860,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   626,   627,   628,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,     0,   861,   261,   862,   863,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     864,   865,   275,     0,   276,   277,   278,   279,     0,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,   866,   867,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   868,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   340,   341,   342,   343,
       0,     0,   345,     0,   346,   347,   348,   869,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,     0,     0,     0,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,     0,   386,   387,   388,   389,   870,   871,     0,   872,
       0,   393,   394,   395,   396,   397,   398,     0,     0,     0,
       0,   403,   404,   405,   406,   407,   408,     0,     0,   409,
       0,   411,   412,   413,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   873,   436,
     874,   438,   439,   440,   441,   442,   443,   444,     0,     0,
     447,     0,   448,   449,   450,   451,     0,     0,   453,   875,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,     0,   466,   467,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,     0,   483,     0,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   876,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,  2679,
     543,   544,   545,   546,   547,   878,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   564,     0,   565,   566,     0,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,   879,   880,     0,
       0,   577,   578,     0,   580,     0,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,     0,
     881,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,   860,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     626,   627,   628,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,     0,   861,
     261,   862,   863,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   864,   865,   275,     0,   276,
     277,   278,   279,     0,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,     0,   292,   293,
     294,   295,   296,   297,     0,   298,   299,   300,   301,     0,
       0,     0,   302,     0,     0,     0,   303,   304,   305,   306,
     307,   308,   866,   867,   311,     0,   312,     0,   313,   314,
     315,   316,   317,   318,   319,     0,   320,   321,   322,   323,
       0,     0,   324,   325,   868,   327,   328,     0,   329,   330,
     331,     0,   332,   333,   334,     0,   335,   336,   337,   338,
       0,   340,   341,   342,   343,     0,     0,   345,     0,   346,
     347,   348,   869,   350,     0,   351,     0,   352,   353,   354,
       0,   355,   356,   357,   358,   359,     0,   360,     0,     0,
       0,   363,   364,     0,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,     0,   375,   376,   377,   378,   379,
     380,   381,   382,     0,   383,   384,     0,   386,   387,   388,
     389,   870,   871,     0,   872,     0,   393,   394,   395,   396,
     397,   398,     0,     0,     0,     0,   403,   404,   405,   406,
     407,   408,     0,     0,   409,     0,   411,   412,   413,     0,
     414,   415,   416,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   873,   436,   874,   438,   439,   440,   441,
     442,   443,   444,     0,     0,   447,     0,   448,   449,   450,
     451,     0,     0,   453,   875,   455,   456,   457,     0,   458,
     459,     0,     0,   460,   461,   462,     0,     0,   463,   464,
       0,   466,   467,   468,     0,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,     0,     0,   480,   481,     0,
     483,     0,   485,   486,   487,     0,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   876,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,     0,   516,   517,   518,   519,
     520,   521,   522,   523,     0,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,     0,   535,   536,   537,   538,
     539,     0,   540,   541,     0,   543,   544,   545,   546,   547,
     878,   549,     0,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,     0,   564,     0,   565,
     566,     0,     0,   567,   568,   569,   570,   571,   572,   573,
       0,   574,   879,   880,     0,     0,   577,   578,     0,   580,
       0,     0,   582,   583,   584,   585,   586,   587,   588,   589,
       0,     0,   590,   591,   592,   593,   594,     0,     0,   595,
     596,   597,   598,   599,     0,   881,     0,   602,   603,   604,
     605,   606,   607,     0,     0,   608,     0,     0,   609,   610,
     611,   612,   613,   614,   860,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   626,   627,   628,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,     0,     0,   261,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
       0,     0,   275,     0,   276,   277,   278,   279,     0,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,     0,   292,   293,   294,   295,   296,   297,     0,
     298,   299,   300,   301,     0,     0,     0,   302,     0,     0,
       0,   303,   304,   305,   306,   307,   308,     0,     0,   311,
       0,   312,     0,   313,   314,   315,   316,   317,   318,   319,
       0,   320,   321,   322,   323,     0,     0,   324,   325,   326,
     327,   328,     0,   329,   330,   331,     0,   332,   333,   334,
       0,   335,   336,   337,   338,     0,   340,   341,   342,   343,
       0,     0,   345,     0,   346,   347,   348,     0,   350,     0,
     351,     0,   352,   353,   354,     0,   355,   356,   357,   358,
     359,     0,   360,     0,     0,     0,   363,   364,     0,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,     0,
     375,   376,   377,   378,   379,   380,   381,   382,     0,   383,
     384,     0,   386,   387,   388,   389,     0,     0,     0,     0,
       0,   393,   394,   395,   396,   397,   398,     0,     0,     0,
       0,   403,   404,   405,   406,   407,   408,     0,     0,   409,
       0,   411,   412,   413,     0,   414,   415,   416,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,     0,   436,
       0,   438,   439,   440,   441,   442,   443,   444,     0,     0,
     447,     0,   448,   449,   450,   451,     0,     0,   453,     0,
     455,   456,   457,     0,   458,   459,     0,     0,   460,   461,
     462,     0,     0,   463,   464,     0,   466,   467,   468,     0,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,     0,   480,   481,     0,   483,     0,   485,   486,   487,
       0,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,     0,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
       0,   516,   517,   518,   519,   520,   521,   522,   523,     0,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
       0,   535,   536,   537,   538,   539,     0,   540,   541,     0,
     543,   544,   545,   546,   547,     0,   549,     0,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,     0,   564,     0,   565,   566,     0,     0,   567,   568,
     569,   570,   571,   572,   573,     0,   574,     0,     0,     0,
       0,   577,   578,     0,   580,     0,     0,   582,   583,   584,
     585,   586,   587,   588,   589,     0,     0,   590,   591,   592,
     593,   594,     0,     0,   595,   596,   597,   598,   599,     0,
       0,     0,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,   609,   610,   611,   612,   613,   614,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     626,   627,   628
};

static const yytype_int16 yycheck[] =
{
       6,     0,     0,  1020,     0,     0,     0,   212,    57,     0,
       0,     0,   992,    37,     0,     0,     0,     0,     0,     0,
     207,     0,     0,    21,   824,  1029,   821,    21,   215,  1637,
     212,   218,     0,     0,     0,   777,   778,   779,   190,   921,
     643,   783,   664,  1146,    46,  1510,    52,  1024,  1207,    22,
    1009,   696,   719,    45,   915,    28,   917,   895,  1572,   877,
    2018,  1018,  1556,  2719,  2661,   993,   733,  1481,   848,  1549,
    1259,   198,   814,   866,   867,  3359,  2662,  3361,  1246,  1095,
    3076,  3652,   875,   217,  1876,  3846,   847,  3186,   880,   741,
     831,  1556,  2007,   696,  3572,   933,  3873,   231,  3451,  2619,
    3545,  3011,   737,  4185,     8,  1704,  1561,  2026,  2043,  1231,
    1069,    15,    23,  1235,  1073,  2930,  1238,  1239,   645,  1078,
    1602,  1603,   958,  3038,  1606,  3023,    37,  3798,  3410,  1088,
    3404,  4501,  3598,  3895,  3600,  1549,  2042,  3862,  2076,  4228,
     743,  4729,   742,  1102,   732,  3461,   176,   983,  1438,  5048,
       2,  4524,   988,  2908,  4512,  4507,  1948,  1671,  1672,  1539,
    5207,  4310,  2683,  2684,  5335,  5229,     6,  1022,   992,   192,
    4232,  4469,  2541,  2041,  1133,  1084,  2545,  1001,   192,  1889,
    3425,  5040,   827,   944,    51,  3459,  4745,  1011,  4747,  2646,
    3228,  1100,   198,  3313,  4991,  5249,   799,   959,  2578,  3471,
      42,   207,   208,  3860,   717,  5035,  2052,   720,  2648,   215,
    1665,   217,   218,  4511,  3409,   854,  3411,   918,  5383,  1599,
      36,   918,  5617,  4207,   827,   231,     6,    43,    11,    54,
       6,     6,     0,  5371,   226,  4669,  1616,  1692,  5292,     0,
    1522,  4794,  5039,    21,   942,  2625,     6,     0,    21,   852,
       6,     6,    38,  5601,     6,    15,    16,    63,   864,   865,
      15,    16,     0,    63,  3019,     6,    32,  1029,   874,     6,
      63,  2976,  1033,  2978,  2979,     0,    63,   146,  2983,  2984,
    2985,    43,  2987,  2988,  2989,   983,    11,  5299,  5300,    47,
     988,    63,    94,    13,     0,     6,     6,   168,    63,    35,
      63,    13,    23,  2013,    29,    11,     6,   181,    25,   912,
       6,     6,     6,    47,     6,    15,    16,   174,     6,    43,
     198,  1063,     3,    29,     5,     6,    85,   219,     5,  5871,
      11,    29,    80,    45,    11,   174,    63,    11,    36,   119,
      63,   174,   160,    91,    15,   112,    37,    25,    21,   119,
    4602,  4603,  4604,     6,  4606,  4607,  4608,  4609,  4610,   174,
      91,   174,   174,  5324,    99,   198,    78,  5839,  1603,   295,
       0,  1606,     6,  1855,     5,   298,  4525,   176,   311,   793,
      11,   295,   190,  5959,   792,   287,   743,   296,    27,   290,
     281,    21,    29,   301,   174,    42,   296,   276,    30,   183,
     387,    25,    13,   373,   373,   301,   174,    35,   284,    29,
    5805,    50,    63,   174,    13,   316,    36,  1394,   351,    29,
     165,   174,   139,  5253,    91,  1382,  1029,    57,   344,   351,
     198,   152,   363,  1085,  1450,    78,   174,   198,   119,   260,
     175,   149,   799,  6130,    25,   198,    45,   122,  5796,   174,
      31,  2866,   260,   386,     6,   119,    29,    98,   468,  4829,
     198,   139,  5516,    36,   414,  1442,   121,   310,   174,   338,
     430,   987,    80,   198,   209,   174,  6052,    48,   295,    78,
     298,  5619,   664,    91,  1277,  1278,  1153,   124,   170,   224,
    1006,    80,   198,  1009,    80,   852,    80,     6,   297,   198,
      71,   451,    91,  6190,   168,   240,   428,   285,   518,  1302,
      80,   174,   285,  5372,   474,   139,   174,   393,  3038,   194,
     451,  1313,    80,   174,   134,   153,   271,   514,   662,    80,
      80,  2946,   714,   268,   668,   243,   174,   218,  5332,   180,
     175,   457,  1181,   386,   514,   514,   680,  1214,   181,   196,
     452,   357,   181,  5948,   356,   912,   377,   357,   139,   450,
     295,   121,   192,  1230,   357,   246,   181,   476,   223,   377,
     357,   471,  1333,    13,  1551,   214,   213,    72,  6154,   363,
    1247,   514,   214,  1438,   998,   357,   512,  1187,   354,   997,
     516,   514,   357,  6135,   357,  6067,    91,   471,   289,   233,
     514,  1362,   368,  5564,   370,    52,   405,  1252,    29,  1502,
     518,   490,   285,   514,   514,   428,   383,   435,  1380,   515,
    1855,   299,   518,  1385,  1386,   280,   518,   362,   174,    32,
     357,    13,   285,   141,   357,   126,  5195,   643,   471,  4310,
     518,   124,  6037,   514,   518,   514,  1439,   368,   428,  1252,
     412,   649,   135,   649,   649,   150,   662,   514,   649,    23,
    1266,  1267,   668,    45,   649,  4336,  5804,   433,   389,   386,
     428,   649,   124,  1632,   680,   170,  1635,   355,   356,   518,
     428,   372,   119,   442,   339,  1702,  1703,  6035,   412,   514,
     696,  1297,   428,  1332,   743,   701,    78,  1606,   396,   457,
     706,  1525,   433,   518,   710,   711,   518,  5141,   386,   461,
    6105,   717,   518,   719,   720,  1643,   518,   747,   518,  4480,
     495,   496,   373,   457,   504,   518,   732,   733,   514,  5741,
     513,   518,  1377,   450,   504,    23,   516,   743,   514,   514,
     518,  2023,   379,  1700,   742,   518,   518,  1656,  1657,   517,
    6145,  1587,  5611,   518,   514,   518,   517,  4235,   514,   514,
    4521,   428,   514,  1587,   517,  1527,   457,  1468,  1403,   921,
    1409,  1468,  4343,   514,  1377,  1537,   396,   514,  4349,   517,
     505,   506,  1385,  1386,   757,  5615,   759,  5952,   761,  4773,
     510,   518,   517,   799,   767,  4520,  5967,   789,   510,   505,
     506,  5939,   512,   514,   514,  1623,   516,   495,   496,  1415,
    1416,   517,   463,   450,   514,   821,   822,  1976,   514,   514,
     514,   827,   514,   396,   505,   506,   514,  1709,   505,   506,
    5884,   505,   506,   504,   329,   153,  1475,   153,  1043,   428,
     471,   512,   428,  5897,   428,   516,   852,  1950,   854,  1547,
    5102,   403,   404,  1040,  4525,   518,   848,  1044,   428,  1046,
     518,  1043,  1624,   518,   495,  1627,  1628,   771,  4150,   512,
     428,   877,   309,   516,   505,   506,   514,   428,   428,   514,
    1983,  3401,   428,    25,  3404,   518,   909,  4161,   252,   518,
      25,  4165,  1995,   899,   454,   909,   507,   508,   509,   510,
     321,  6039,  1600,   518,  5803,  4025,   912,  1034,   507,   508,
     509,   510,   911,   911,  4571,   911,   911,   911,  5712,  1617,
     911,   911,   911,  5717,  5718,   911,   911,   911,   911,   911,
     911,  3451,   911,   911,   926,  3833,   935,  3692,  3693,  3459,
    5493,  5800,  3697,   911,   911,   911,  1839,  1856,  4220,   941,
     445,   354,  4430,  3474,  4149,  3476,  4151,  6011,   504,   467,
     381,   452,   168,  4001,   252,   124,  6104,   450,   153,   114,
     516,    51,  1594,  3430,    21,   203,   792,   793,   794,  6043,
    6044,   152,  1837,   825,  4429,  5355,  5783,   829,   855,    76,
      22,  3431,   186,  3373,   174,  1522,    28,   139,   450,   420,
     119,   422,  5799,    88,   139,   191,  2619,    37,  6179,   373,
      88,   276,   124,    23,  1020,  1021,  1022,    10,    40,   649,
      13,   458,    63,  1029,  5500,  2042,    68,   102,  1034,   168,
     186,   112,    54,  1039,  1040,   112,   386,    52,  1044,    23,
    1046,     6,   149,   336,  1050,   190,   131,  3547,  2025,    88,
    5949,   112,    45,   131,   213,   419,   175,  1819,   112,    52,
    1066,   379,   368,   379,  5362,   505,   506,   507,   508,   509,
     510,  3776,   316,    72,    23,  3830,   121,   514,   386,     6,
     185,  5940,     6,  6147,   448,    78,   119,   135,   110,   119,
     428,  4336,   131,  3462,   186,   152,  2073,   124,   416,   258,
     416,   213,   343,   356,  1110,  5263,  1112,  1113,   183,   473,
     217,  4556,   742,   743,   301,   260,   123,  5266,   263,  5678,
     276,  6168,    13,   505,   506,   507,   508,   509,   510,    10,
     373,   419,    13,   386,   123,    27,    17,    18,    19,  4492,
     458,   290,   458,  1885,   450,   176,  6045,  1153,   416,  5307,
     514,   150,    23,   471,   147,   471,   310,    38,    50,   402,
     448,     3,   281,  5225,     6,   213,   175,   316,   518,   311,
    6217,   170,   316,    87,   296,  1181,   311,   495,   193,   495,
     518,   997,   998,   198,   276,   473,   213,    78,   416,  1187,
     212,   456,  1992,  1993,   301,   276,   514,   296,   514,  1802,
     193,   276,   296,   331,  6103,   198,   293,   299,  1214,   351,
     518,   119,   119,   220,   353,  6114,   351,   290,   389,   121,
      25,   514,  1228,   464,  1230,  5583,   514,   242,  5598,   314,
     124,   220,   377,   338,   276,   276,   314,  5607,   285,  5715,
     285,  1247,   252,   316,   386,  2100,  1252,  6146,   428,   242,
     164,   386,   285,  1920,   276,  5613,  5629,  5609,  1264,   706,
    5037,    23,   456,  5024,   369,   471,  1118,  1934,   252,  2683,
     514,   301,   114,    10,  6173,   314,    13,  3798,   358,   909,
    1947,   911,   467,  1332,  5582,   732,  1190,  5657,  1192,  2783,
    1194,   450,  1196,  1299,  1198,  1199,  1200,  2752,  6197,  5061,
     456,  1205,   333,   252,   297,  5030,   315,  3807,    45,  2070,
    4788,    28,  3022,   455,  5612,    52,   357,  4232,  1953,   213,
     285,   223,  1328,  1329,  1330,  1913,  1332,  2617,   514,    25,
     329,   518,   389,   452,   139,    31,   421,   444,   450,   416,
     221,    78,    23,   421,   489,   386,  1352,  1982,   190,   471,
     425,  1986,   379,   375,    23,   416,  1991,  1945,   285,  1994,
    1960,   285,   416,   373,   456,   514,  2965,  3888,  1398,   514,
     514,  1377,   471,   280,    91,  2830,   391,   471,   280,  1385,
    1386,   252,   421,   392,    25,  2024,   514,  2026,    10,   373,
      31,    13,  2772,  2032,  5982,    17,    18,    19,   391,  2038,
    2039,   309,  5491,  1409,  1917,  2044,  3252,  3253,   256,   419,
     147,  3257,  1594,   309,  2053,  5785,   297,  5959,   260,  1932,
    2059,   263,  1935,   450,   373,  3038,   134,  3365,  2050,    91,
    1453,  1454,  1438,  1456,     3,   419,   186,   339,   448,  1453,
    1454,   514,  1456,   139,    99,    38,   445,  3055,  4730,  1455,
     162,  3297,  3298,  1459,  1460,  4771,   193,   119,   386,   176,
    4734,   198,   368,   473,   448,  4739,   373,    60,  4742,  1475,
     419,   379,  1985,   370,   504,  1481,  1989,  1990,  1470,   168,
    1472,   232,   512,   113,   514,   515,   516,   111,   518,   473,
     252,   180,   124,   395,   167,   401,  2023,   290,   139,   448,
     493,   370,   373,   121,   514,   242,   311,   139,   416,   198,
    6052,   514,   505,   506,   507,   508,   509,   510,   111,   177,
     175,    90,  4988,   316,   473,  2542,   276,   368,    23,   230,
     514,   243,   759,   760,   761,   377,   433,   764,   765,   766,
     230,  4537,   436,  1549,    64,   176,   351,   774,   419,   134,
     458,   136,    72,   351,   209,     3,   450,  1187,   299,   114,
     297,   311,   458,   471,   433,   514,  5936,  2544,   430,   224,
     311,   252,   280,   203,   143,   276,   198,   448,  4493,    29,
      23,   386,   647,   252,  1590,   240,   276,   495,   386,   207,
     518,     3,  1039,   202,  3074,  5266,  5373,   452,  5553,   221,
    5555,   351,   473,  1050,  5559,  5560,   514,     0,   201,  1608,
     351,   373,  6154,   268,  1613,   311,   333,  1623,   280,  1066,
     518,   502,   503,   504,   505,   506,   507,   508,   509,   510,
    1260,   121,  5714,   257,   132,   190,  5361,   261,   339,  5701,
     295,  4161,   386,   514,   142,  4165,   386,   489,   514,   462,
    1280,   324,   179,   370,   391,   351,  3070,   419,   276,   514,
    3074,   517,   280,  6033,   257,   428,   297,   276,   261,  1661,
     311,   119,   361,   514,   739,   297,   334,   179,    90,   386,
     249,  1687,   310,   276,   134,  4500,   448,  1686,   389,    99,
     386,  1690,   373,    35,   326,   280,  1702,  1703,  1704,   389,
     353,   514,  1332,  2707,   373,   260,   456,   362,   263,   367,
     351,   473,  4232,  4418,   431,    39,   433,   310,  4423,   246,
     437,   514,   463,   381,  1929,   757,   246,   759,   311,   761,
    6100,  1918,   144,   223,   310,   767,   768,   769,   419,  4494,
    4019,  4020,   311,   373,   246,   386,  1928,  1929,   176,   450,
     419,   816,   514,   328,   256,   518,   493,   252,   386,   417,
     450,   331,  2617,   356,   165,   175,   311,   448,   505,   506,
     507,   508,   509,   510,   518,  5945,  5946,   328,   518,   448,
    1907,  1228,   210,   162,   414,   311,   416,   380,  3401,  4310,
     280,  3404,   473,   205,   151,   162,  1802,   452,  5880,   209,
    4456,   168,   175,   386,   473,   129,   351,   400,  1814,   252,
     386,   518,  4727,   311,   224,  4336,   343,   311,   471,  1825,
      10,  4100,   377,  1453,  1454,   351,  1456,    17,    18,    19,
     240,  1837,   280,   514,   235,  1841,   209,   285,  3451,  5600,
      58,  5618,   495,   200,   276,   514,  3459,   121,   289,   339,
     419,   224,   421,   351,  1860,   430,   428,   351,   268,  2659,
     386,  2679,  1868,   119,   243,   518,    10,   240,  2050,    13,
    1876,  5826,   379,    17,    18,    19,   243,   433,   373,   430,
     502,   503,   504,   505,   506,   507,   508,   509,   510,  1895,
    4831,   122,   386,   420,   168,   422,  2876,  4838,  1904,   474,
     156,  1907,  5627,   471,  1910,   122,   318,  1913,  1914,   416,
     128,  1917,  1918,   292,  1920,  1921,   464,  5191,   420,   351,
     422,   448,   515,   474,   419,   292,  1932,   959,  1934,  1935,
     373,   319,   504,   207,   489,   191,  6106,   464,  1944,  1945,
      10,  1947,  1948,    13,   516,  2707,   448,    17,    18,    19,
     518,   458,   362,   448,   471,  5400,   471,  2596,  2782,  2814,
     311,  1188,  1960,   194,  1191,    35,  1193,   355,  1195,   301,
    1197,    93,  4492,  4493,  1201,    45,   419,   194,   473,  1985,
     177,   504,    52,  1989,  1990,  2840,  6048,   515,   462,   362,
     518,  2040,  2016,   516,  5093,  3953,  3099,  1029,   386,   452,
     351,   518,   276,   518,  4525,   448,   280,   514,    78,  2007,
    2002,  2007,  2007,  3971,   136,   368,  2007,  2926,  2024,   514,
    2026,  5798,  2007,   111,   280,  2031,  2032,   376,   198,  2007,
     473,   443,  2038,  2039,  2040,  2041,  2042,  2043,  2044,   451,
     514,  2047,   454,  2049,   376,  2051,  2052,  2053,  2054,  2055,
    2056,    72,  2876,  2059,  5816,  2061,  2062,  3471,  1962,  2065,
    1964,   514,  1966,   416,  1968,   233,  1970,  3481,  3987,  3677,
    1974,   514,  5797,  2079,  2080,  2081,  2082,  2959,  2960,  2961,
    4990,   169,  3562,  4018,  2939,   162,   495,   496,  6150,   169,
    2914,   168,  2098,  2929,  2100,  2856,  3285,  4003,   119,  5014,
      91,  1608,   255,  4009,  2707,   514,  1613,   297,  2019,   514,
    5394,  5009,  2854,  2780,  2856,  5581,   355,   205,  2880,  5029,
    5219,    25,  5221,   193,  2948,   205,  2888,   280,   198,  2891,
     351,   471,  3091,  3042,  3043,  3044,  3045,  3929,  3047,  1858,
    4008,   513,   311,  1590,  4012,  4013,   518,   386,  3562,   319,
    3005,   221,   222,   297,  5632,   495,  3755,   178,   343,  1878,
     281,   282,  3761,  3072,  5941,   386,   243,   259,  3650,   257,
     367,   311,   242,   261,   368,   280,   370,   374,   347,  1686,
     285,   351,   351,  1690,   381,   355,    90,   514,   179,    13,
    4036,  4037,  4038,  4039,   471,   380,  4042,  4043,  4044,  4045,
    4046,  4047,  4048,  4049,  4050,  4051,   379,  4727,   343,  5654,
     168,   351,   203,   283,  4734,   292,   386,   386,   495,  4739,
     417,    45,  4742,  4978,   471,  4980,  4141,   297,   132,    80,
     300,   416,   337,   433,   192,   139,  2242,   282,   142,   433,
      91,   518,   439,   416,  3699,   380,   386,  4952,   495,  4954,
    4955,  4956,   311,  5606,    78,   246,   355,    32,   379,   280,
       5,  6038,  4108,  4109,   285,  1600,    11,   514,   353,  2904,
     168,  2906,   513,   256,    19,  2910,  3465,   518,  5562,   464,
     168,   416,  1617,  2289,    59,   458,   512,   386,  6049,  3744,
     516,   390,   351,    38,   192,   416,  5211,   280,   471,   515,
      10,   471,   518,    13,   192,   311,  5877,  3162,   329,   300,
    5225,   376,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   391,   495,  3065,   345,   495,   339,   386,   471,   464,
    1960,   259,   270,   428,   379,    45,  2342,   458,  5518,   352,
       5,   514,    52,  5523,  5524,   351,    11,   256,  1380,   355,
     471,   256,   495,  1385,  1386,  3869,   294,   452,   502,   503,
     504,   505,   506,   507,   508,   509,   510,  1814,    78,   382,
       5,   416,  3024,  6205,   495,  6207,    11,  2007,  1825,   507,
     386,  1413,   495,   496,   512,     5,   514,  3149,   516,    95,
    1422,    11,  1424,   514,  1841,  6227,  1428,   983,    69,    70,
      22,   514,   988,  1435,  5882,  5883,    28,   311,   515,   295,
    2040,   518,   509,   458,   300,  6176,  5700,   514,   203,   516,
     295,  3276,   192,   493,   445,   300,   471,  3282,  2058,   420,
     433,   422,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   515,   433,   347,   518,    87,   507,   351,  1895,   519,
     495,   512,   464,   514,   445,   516,   512,   448,   514,  3265,
     516,  3267,  3268,  1910,    59,  3226,  1913,  1914,  5383,   514,
     515,   233,   517,   515,    38,   376,   518,   515,  3360,   420,
     518,   422,   386,   193,    10,    15,    16,    13,   198,   393,
     514,    17,    18,    19,  5014,  1527,    60,  1944,  1945,   509,
     515,     3,   462,   518,   514,  1537,   516,   515,    11,    35,
     518,  3146,   414,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,     3,  2529,   295,   515,  6004,   515,   518,   514,
     518,  5446,   242,   420,  2540,   422,  2542,   518,  2743,   272,
     273,   274,   275,   515,   373,    26,   518,   111,  4161,  1581,
    1582,   515,  4165,   515,   518,  2742,   518,  2744,  2745,    10,
     515,  2743,    13,   518,   368,   369,    17,    18,    19,   515,
     515,   514,   518,   518,  2580,    59,   515,  2063,  2584,   518,
    2066,  2587,  3704,  2589,    35,  2579,  2592,   297,    90,   514,
    2596,   516,  1624,  3385,  3386,  1627,  1628,   515,   515,   491,
     518,   518,  4448,   515,  3366,   515,   518,  5312,   518,    90,
      48,  2617,  2739,  2619,  6092,  3254,   223,  2247,   515,  4232,
    3548,   518,  3363,   495,   496,   515,  4584,  3266,   518,   512,
    2636,   514,  2079,   515,  3472,   516,   518,   201,  5634,  2645,
    2646,   143,  4600,   464,   515,  2779,  3574,   518,   515,    10,
     515,   518,    13,   518,   295,  3416,    17,    18,    19,    33,
      34,   515,  3301,   144,   518,   298,  2672,   515,  2664,   515,
     518,  5191,   518,  2679,  4282,   168,  3653,  2683,  2684,   515,
     515,   391,   518,   518,  2690,  2709,   295,  2711,  2694,  3482,
     491,  5211,  2698,   257,   514,   221,   516,   261,  3320,  3858,
     515,  2707,   298,   518,   515,  5225,  3345,   518,   515,    48,
    4502,   518,   276,   515,  5998,   515,   518,   198,   518,  2725,
    4626,   471,  2728,   473,   205,  3549,  4632,  4633,   471,   515,
     473,  2865,   518,  2739,   515,  2741,  2742,   518,  2744,  2745,
    5495,  2747,  2610,  2611,  2612,  5266,   310,   249,  5503,  5504,
     491,   515,   515,  2759,   518,   518,   223,   515,   515,  2751,
     518,   518,   515,  3366,   515,   518,  4280,   518,  4282,   515,
     221,   297,   518,  2779,  2780,   507,  5875,   515,  4272,  2619,
     518,   515,  2788,   493,   518,   515,  5701,  1819,   518,   173,
     515,   515,   356,   518,   518,   505,   506,   507,   508,   509,
     510,  3625,  3970,  4258,  2810,  2811,  4220,   515,  2814,   311,
     518,  2945,    29,   368,   369,   515,   380,   319,   518,   515,
     518,   515,   518,  3839,   518,   515,   368,   369,   518,  3496,
    3497,   420,  2838,   422,  2840,   514,   400,   318,  2844,   325,
     515,   515,  3801,   518,   518,   347,   297,   515,    10,   351,
     518,    13,  2858,   355,   515,   368,   369,   518,  2850,  2865,
     221,  4316,  2868,  5383,  3499,  5386,    83,  6151,  2874,    86,
     515,   515,    37,   518,   518,    92,   420,   514,   422,  4492,
    4493,  3526,   363,    45,   386,   461,  3795,  5802,  2894,   471,
      52,   473,  5478,   471,  2900,   473,   515,   515,   514,   518,
     518,  2907,   515,   120,   515,   518,  3648,   518,    59,   515,
     515,  3653,   518,   518,   514,  2921,    78,   419,   515,   421,
     174,   518,   515,  3526,  6208,   518,  5446,   149,  2934,   515,
    2903,   515,   413,  2939,   518,   515,   297,   219,   518,  2945,
     162,    10,  3797,   134,    13,   136,   168,   515,    17,    18,
      19,   219,   515,   515,   517,  2585,   518,  2963,  2964,  2965,
     514,   178,   443,  2969,   515,   515,    35,   518,   518,   471,
     451,  5232,  5233,   454,   191,  3642,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   147,   515,   204,   517,  2619,
    2996,  2997,  4132,   515,  4134,   217,   518,  3664,   515,  3005,
    4514,   518,  2034,  2035,   515,   514,  3193,   518,  3195,  3196,
    4718,   516,  4720,  2045,  2046,    10,  4205,   475,    13,    33,
      34,   243,    17,    18,    19,  5935,   515,   515,   351,   518,
     518,   193,  3038,   154,  2664,   515,   198,  5952,   518,   515,
      35,   514,   518,  2075,  4509,   515,   515,   154,   518,   518,
    4530,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     514,  3057,   515,  3190,  3070,   518,   515,   198,  3074,   518,
     292,  5669,  5670,   515,  4233,  4234,   518,   514,  4237,   301,
     242,  4166,   516,  4168,    98,  3827,  5606,   295,   515,   515,
      10,   518,   518,    13,  1470,   198,  1472,    17,    18,    19,
    5697,   351,  4079,   515,   118,   515,   518,   515,   518,   515,
     518,  5173,   518,  5175,  4727,   149,  4530,   515,  5845,  5846,
     518,  4734,    55,    56,   295,   154,  4739,  6042,   162,  4742,
     154,   198,   154,  6048,   168,   297,   295,   168,  3320,   153,
     351,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     154,  3818,   221,  3820,  3160,   241,  3162,   121,  3803,   452,
    3805,   295,   514,   289,   515,   168,     6,   280,    72,    38,
     280,  3177,   475,  3179,   514,   295,   280,  3957,  4135,   280,
    3186,  5701,    48,   217,  3190,   402,  3192,  3193,   405,  3195,
    3196,  3197,    48,   438,    54,   280,    90,   311,  3038,  3205,
    3803,  4178,  3805,   464,  3210,  3254,   464,    87,   433,   243,
    3845,   168,   154,   332,   154,   514,  3978,  4072,   154,  3225,
     154,   518,   444,   134,   475,   136,   221,   154,   297,   391,
     154,   154,   154,   154,   295,  6150,   154,  4845,  4215,   154,
     100,   154,  3887,  3425,   149,   154,  3252,  3253,  3254,   160,
     416,  3257,  3301,   154,   168,   154,   154,   162,   292,  3265,
    3266,  3267,  3268,   168,   154,   125,   309,   301,   514,    38,
    3276,   241,   168,   168,   295,  3281,  3282,   514,  3284,     6,
    3286,  5127,  5802,   143,  3887,     6,   514,   147,   514,   168,
     514,  3297,  3298,   514,  2741,  3301,   514,     6,  5954,   514,
    2747,   221,   297,     6,   514,   514,  3973,  3942,   514,   169,
     514,   514,   217,   173,   225,   514,  3322,   514,  3324,   514,
    3326,   514,  4281,     6,   514,   514,   514,   514,   188,  4823,
     514,   493,   514,   347,     6,   514,   379,   514,   243,  3345,
     514,  2788,   287,   505,   506,   507,   508,   509,   510,   472,
      98,  3353,  3354,  3355,   514,  3404,   514,   514,   198,   514,
    3366,   272,   273,   274,   275,   379,   514,   207,   279,   280,
     118,   514,   514,   416,   285,   215,   514,   297,   218,   307,
     163,   219,   518,   518,    38,   102,   241,   292,    38,   514,
      37,   426,  4031,   426,  4553,  3401,   301,   512,  3404,   174,
     512,  5014,   416,   428,   168,   153,  3455,   518,   428,   428,
     444,  3417,  4250,   428,   514,   458,  3422,   292,   168,   290,
     386,   428,    68,   428,  4217,   285,  4065,  3057,   471,   373,
     428,  3437,  5952,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   428,   373,   458,  3451,   463,   428,   462,   428,
     516,  5409,   495,  3459,  4309,   243,  4311,   471,   355,   428,
      79,     0,   504,   373,    91,  3471,   428,  4426,  3474,   428,
    3476,   514,   154,   373,   295,  3481,  4404,   337,   512,  4118,
    4335,   495,   516,   238,   285,   378,   127,   428,   451,   428,
    3496,  3497,  6148,   428,   419,   295,  3502,   316,   368,   290,
     514,   514,   428,   191,    43,   514,    91,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   428,  3523,   518,   127,
    3526,   311,  6042,  3529,   435,   198,   154,   127,  6048,   113,
     127,  3537,  4414,   149,    59,   446,   452,   428,    59,   444,
     428,   428,   428,   428,   452,   428,   162,   428,   299,   265,
    2997,   428,   168,   316,   428,   428,  3562,   336,   336,    98,
     428,  3401,   336,   428,  3404,   428,   428,   428,   419,   428,
     428,   316,    47,  5419,  4336,  2607,  2608,    47,  5191,   428,
     428,  2613,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   428,  3598,  3599,  3600,   428,   149,   221,  5211,   347,
     519,   217,   295,  5449,   221,   295,   221,   221,   515,   162,
     149,  3451,  5225,  2645,  2646,   168,  3798,  3623,   221,  3459,
     221,   428,   221,   162,  3254,   221,  3632,   243,  3634,   168,
    6150,   379,   221,   221,   518,   174,  3642,    72,   514,   438,
      38,   180,   154,    78,   183,   154,  5060,   295,   187,   280,
     119,   154,   154,   463,   452,   154,    91,   295,  3664,   249,
     280,    38,   280,   168,   217,    38,   233,   280,   416,   514,
     514,  3301,   514,   375,    10,  2707,   292,    13,   217,   452,
     219,    17,    18,    19,   119,   301,   121,   154,   154,   154,
     243,   452,   154,   428,   289,  3325,   174,   284,   514,    35,
     467,   265,   265,    13,   243,   518,   426,   183,   514,    45,
     458,  3341,   514,   428,   306,   518,    52,   514,   430,   515,
     191,   515,  3728,   471,   377,   512,   491,   191,   263,   491,
    3177,  4586,   468,   515,   515,   515,   217,   389,   515,   292,
     230,   296,    78,   178,  3750,  3192,   518,   495,   301,  3755,
    3197,   452,   518,   292,    38,  3761,   295,   452,   304,  2791,
      59,   515,   301,   463,  3770,   514,   514,   373,   452,   230,
    5383,  3401,   207,   230,  3404,   285,   514,   134,  3225,   136,
     168,   285,   295,   428,   428,   428,    48,   285,   395,  4766,
     241,  3797,  3798,   280,   295,   241,   241,  3803,   368,  3805,
     259,   295,   428,   160,   127,   518,   295,  4474,  4475,   419,
     295,   198,  3818,   518,  3820,   295,  4578,   351,   386,   428,
     359,  3451,   471,   192,   383,  3455,   428,   301,   444,  3459,
     515,   339,    38,  5446,  3840,   221,   233,   504,   335,   154,
    4999,   452,   290,   168,    38,   280,   417,   452,  2880,   170,
     285,   514,   464,   336,   383,   514,  2888,   193,   154,  2891,
    3866,   701,   198,  4681,   154,   154,   290,   471,   225,   452,
     710,  2903,   280,   412,    38,   280,  3872,   717,   295,    27,
     720,  3887,  3888,   295,  3876,   221,   222,   233,  4749,   290,
     168,   444,   189,    38,   329,   189,   512,   169,   233,   515,
     516,   383,  5367,   168,  3910,   444,   242,  1460,   280,   475,
     345,   295,  3908,   198,   428,   272,   273,   274,   275,   198,
     518,   198,   279,  3929,   198,   198,    59,   518,   285,   468,
     516,   470,   471,   514,   174,   262,   518,  4572,  4573,  4574,
    4575,  4576,  3948,   518,   471,   295,  3952,   283,   289,   518,
     515,   174,   492,   492,   515,   515,   301,   515,   515,   515,
     514,   297,   457,   515,  4116,  3957,  4761,  3973,   515,   518,
     515,   515,   515,   307,   515,   134,   515,   515,   517,   518,
     317,   518,   515,  3989,   515,   491,  3992,  5501,   174,   428,
     514,   279,  3998,  5606,   514,   514,   468,   256,   514,   174,
     515,  4960,  4008,   514,   495,   183,  4012,  4013,   494,   450,
     445,   518,  4018,   513,   251,   468,   458,   513,    59,   295,
    4026,   514,  4028,   298,   295,  4031,   295,   504,  4667,  4035,
    4036,  4037,  4038,  4039,   203,   514,  4042,  4043,  4044,  4045,
    4046,  4047,  4048,  4049,  4050,  4051,   514,   154,   428,  4055,
    4056,  4057,   428,   428,  4060,   391,   211,   285,    10,  4065,
     157,    13,   428,   280,  4070,  4114,  4072,   154,  4074,   386,
     378,   154,   405,   154,  4836,   378,  4082,   378,   435,  4085,
     241,  4087,  3529,   203,   295,   157,   504,   452,  5701,   446,
    3537,   157,   373,    45,   468,   449,   428,   243,   318,  4105,
      52,   157,  4108,  4109,   318,   373,   428,  4113,  4114,   428,
     402,   253,  4118,   253,  4120,   428,   428,  3149,   253,    38,
     373,   428,  4124,  4125,  4126,  4127,    78,   373,  4310,   373,
    4752,   127,   386,   428,   154,   208,   280,   428,    47,  5985,
    5986,    60,   428,  4141,   217,  4141,  4141,  4153,   428,   186,
    4141,   515,   515,  4820,  4336,  4161,  4141,   493,   231,  4165,
     515,   428,   428,  4141,   428,   428,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   513,   428,   221,   221,   518,
     299,   438,     3,   168,   515,  3632,   515,  3634,    48,  5802,
     112,  4197,   111,   168,  1034,   147,    38,   515,   518,   515,
    1040,   154,   428,   514,  1044,   154,  1046,   168,  4214,   186,
     290,   504,   514,   452,  4220,   154,   452,   373,   518,   373,
      10,  5635,   373,    13,   373,   383,  4232,    17,    18,    19,
     373,   221,   152,   221,   152,   221,   225,  4979,   221,   221,
     221,   193,  3872,  4910,   145,    35,   198,  4253,   221,   221,
     221,   512,    59,   359,    13,    45,   295,   295,   518,   178,
     295,   295,    52,   463,   515,   307,   515,   515,   515,   174,
    1110,   279,  1112,  1113,   445,   445,   518,   515,  3908,   513,
     515,  3728,   201,   515,  4919,  4920,  5168,  4922,    78,   514,
     242,   515,   514,   224,   305,   224,   418,   302,  4304,   514,
     187,    59,   514,  4309,  4310,  4311,   359,   425,    89,  5917,
     457,   438,   168,    38,   452,   452,   233,   428,   211,  5201,
      59,  4161,   154,  3770,   419,  4165,    86,   402,   178,  4335,
    4336,   378,  3364,   438,  3366,   428,   428,   157,   257,  5952,
    5007,   373,   261,  4525,   428,   297,   428,   373,   515,   428,
    3382,   351,   515,   515,   514,   471,    59,   276,   419,   458,
     168,   514,   295,    78,   112,   154,   221,   438,   221,   221,
     221,   230,   206,   428,   515,  4381,    10,  4350,  4384,    13,
     514,   475,   514,   514,   295,   515,    38,   293,  4361,   518,
     316,   310,  4232,   295,     3,   518,    44,  3429,  3430,   514,
     428,   518,   438,   193,   514,   383,   515,   180,   198,   181,
     112,    45,   174,   515,   143,   221,   285,   515,    52,  3866,
     285,   285,   285,   174,   515,   515,   515,    59,   307,  6042,
     515,   221,   222,   231,   231,  6048,  5539,   356,  5541,   391,
     469,   518,  4448,   316,    78,   469,   515,   515,   224,   514,
     514,   514,   242,   470,   290,   425,   504,   174,   438,   428,
      78,   380,  5317,  3910,   471,   205,   192,   285,  4474,  4475,
     192,   285,  4478,   504,    59,   419,    72,   428,   518,  4485,
     428,   400,   428,   154,  4114,   518,  4492,  4493,   157,  2042,
    2043,   428,   515,   283,   221,   514,  4502,   126,   176,  2052,
     119,    38,   198,   290,   514,   383,    38,   297,  2061,   452,
     300,  4141,   280,   147,   170,  5674,   383,   471,    59,  4525,
     290,    84,  4518,   419,  4530,  4531,  4532,    38,   174,   471,
     295,  4161,   168,   346,   518,  4165,  4542,  6150,   514,   219,
     208,   493,   298,   174,  5344,  3992,  5550,   515,   515,  5184,
     515,   514,  5711,   505,   506,   507,   508,   509,   510,   193,
    5195,   399,   457,    59,   198,   515,   376,    38,    81,   514,
    4752,    91,   295,   514,   135,   515,   199,  4583,   345,   515,
    4586,   428,    38,   154,   154,   428,   514,   514,  4035,   662,
       0,    25,   168,    38,   285,   668,   254,    31,  5757,  5758,
    5267,   391,   514,   452,  5226,   515,  4612,   680,   242,   383,
     514,   514,    46,  4060,   514,   514,   514,   112,   154,  4625,
      38,   515,   299,   174,   515,   168,   438,   202,   397,   515,
     111,   397,   514,  4639,   514,   518,    38,   514,   457,   467,
     514,   419,    76,   518,   514,   191,   168,   452,   419,   276,
     203,   295,  4492,  4493,   515,     6,  5278,   514,   161,   475,
     514,  4667,   369,   297,  4670,   369,    72,    72,   298,   517,
     135,   471,  4678,  4679,   140,  4681,   471,   456,   515,  4685,
    4686,   467,   457,   165,  4690,   165,   386,   518,    98,   514,
     514,  4697,    35,   255,  4700,  4701,   130,   174,   132,   419,
     342,  4707,   285,   493,   205,   139,   419,   295,   142,   295,
     514,   383,   502,   503,   504,   505,   506,   507,   508,   509,
     510,  4727,    38,    38,   298,   515,   298,   199,  4734,   514,
     176,   514,   176,  4739,   153,   169,  4742,  4743,   150,   149,
     368,    59,    59,   302,  4750,  5749,    38,   352,   424,    59,
     124,  5910,   162,   428,   515,  4761,   406,   391,   168,     6,
     450,   515,  4786,  4769,   174,   514,  3798,  4763,  4764,   383,
     180,   205,   140,   183,    35,   285,   514,   187,   514,   424,
       0,    24,   303,  4789,   368,   518,  5425,  5767,  5550,  3821,
     518,   368,    81,   281,   386,   428,   174,   281,   514,   153,
    5439,  4807,   397,   397,   518,   119,   514,   217,   471,   458,
     471,   176,   176,   452,  4820,   458,   457,   514,  5393,  5978,
    5979,  5460,  5457,   515,  1386,   911,   951,  5682,  5467,  3366,
    2914,   457,  1689,   243,  2823,  3574,  4309,  5901,  4284,  2940,
    2994,  4847,   276,  3789,  5320,  5747,   280,  6019,  5367,  4472,
    4282,  4282,  4969,  5343,  3503,  3136,   290,  4830,  4864,   493,
    5881,  5225,  4492,  4869,  6007,   299,  5777,  4840,  5776,  5921,
    4876,   505,   506,   507,   508,   509,   510,   311,    98,  6042,
    3507,  5014,   292,  4519,  4493,   295,  4892,  4727,  4518,  5721,
    4504,   301,  5747,  4899,  4734,  5534,  5535,  4462,  3008,  4739,
    3008,  3599,  4742,  4304,  4910,  3837,  4488,  5008,  5543,  5350,
    3881,  4555,  5647,  6115,  6220,   993,  6202,   351,  5334,  3797,
     354,   355,  4527,  5933,  5280,  5521,  5730,    18,  5283,   149,
      28,  4583,  1849,  5536,   645,  4941,  5490,  4586,  3946,  1893,
    6111,  3024,   162,  4530,  2684,  1215,  3978,  5550,   168,   359,
    3481,  1904,   386,  1890,   174,  3892,  5393,  5635,  3731,  2939,
     180,  4967,   697,   183,  4335,  3650,   730,   187,  1928,  5959,
    6154,   842,  2970,  4561,  5716,  1802,  1506,  4983,  2626,  4559,
    6170,  4212,  4988,  4765,  5487,  5874,  1402,    41,    41,  3422,
    1463,  3437,  1363,  2636,  5862,  5694,  3404,   217,  4625,  1462,
    4150,  5007,  4167,  5192,  3401,  1465,   416,  5446,  5014,  5445,
    4213,  3401,  6132,  5856,  5989,  6019,  5681,  1419,  5423,  4074,
    2534,   455,  5695,   243,  3343,  5696,  2054,  2535,  3325,  3206,
    5026,  4478,  2969,  3323,   444,  3313,  3240,  4011,    -1,  2540,
      -1,   899,    -1,  2624,  5226,    -1,    -1,    -1,    -1,    -1,
      -1,  5690,    -1,  5692,  5060,    -1,  5062,    -1,   468,    25,
     470,   471,    -1,    -1,  1904,    31,    -1,  1907,    -1,    -1,
      -1,    -1,   292,  5278,    -1,   295,    -1,  1917,  1918,    -1,
      -1,   301,   492,  2636,  5266,    10,    -1,  5093,    13,    -1,
    5277,  5713,  1932,    -1,    -1,  1935,  5278,    -1,    -1,    -1,
      -1,    -1,   512,    -1,  4734,   515,   516,   517,    -1,  4739,
      76,    -1,  4742,    -1,    -1,    -1,    -1,    -1,  5124,    -1,
      45,  5127,    -1,    -1,  5130,  5131,  5132,    52,    -1,    -1,
      -1,    -1,    -1,  4763,  4764,  5322,    -1,    -1,    -1,   359,
      -1,    -1,    -1,    -1,    -1,  1985,  5749,    -1,    -1,  1989,
    1990,  5157,  5158,    78,    -1,  5161,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,    -1,    -1,
      -1,    -1,  6189,   139,  5014,  5181,   142,    -1,    -1,    -1,
      -1,  5187,    -1,    -1,    -1,  5191,    -1,    -1,    -1,    -1,
      -1,  5197,  5198,    -1,    -1,    -1,   416,    -1,    -1,    -1,
      -1,    -1,    -1,   169,    -1,  5211,    -1,    -1,  5214,    -1,
      -1,    -1,    -1,  5219,  1135,  5221,    -1,    -1,    -1,  5225,
    1141,    -1,   147,    -1,   444,    -1,    -1,    -1,    -1,    -1,
    1151,    -1,    -1,    -1,  1155,    -1,    -1,    -1,  1159,   205,
    1161,    -1,    -1,    -1,    -1,    -1,  1167,    -1,   468,    -1,
     470,   471,  1173,    -1,    -1,  1176,    -1,    -1,    -1,    -1,
    5266,  5267,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,
      -1,  5277,   492,   198,    -1,    -1,    -1,    -1,  4310,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   512,    -1,    -1,   515,   516,   517,  5901,    -1,
    5204,    -1,  6157,    -1,  4336,    -1,    -1,    -1,    -1,    -1,
     276,  5317,    -1,    -1,   280,    -1,  5322,   242,  4350,    -1,
      -1,  6203,    -1,    -1,   290,    -1,    -1,    -1,    -1,  4361,
      -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   311,    -1,  6202,    -1,    -1,
      -1,  5191,  5348,    -1,    -1,    -1,  6098,  6099,    -1,    -1,
    4807,    -1,    -1,    -1,    -1,  6220,    -1,    -1,    -1,    -1,
      -1,  5211,   297,    -1,    -1,    -1,    -1,  5383,    -1,    -1,
    5386,    -1,    -1,  5379,    -1,  5225,    -1,    -1,   354,   355,
    5382,    -1,    -1,    -1,  5393,  5393,  5026,  5393,  5393,  5393,
    4847,    -1,  5393,  5393,  5393,  4437,  4438,  5393,  5393,  5393,
    5393,  5393,  5393,  5419,  5393,  5393,  6019,  5423,  5467,  5425,
     386,    -1,  4869,    -1,    -1,  5393,  5393,  5393,    -1,    -1,
      -1,    -1,    -1,  5439,     6,    -1,    -1,    -1,    -1,    -1,
    5446,    -1,    -1,  5449,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    25,  5460,    -1,  6095,    29,    -1,    -1,
      -1,  5467,    -1,    35,    36,    37,   391,    39,    -1,    -1,
      42,    43,    -1,    45,    -1,    47,    -1,    -1,    -1,    -1,
      -1,    25,    54,    55,    56,    -1,    -1,    31,    -1,   455,
      -1,    -1,    -1,  4525,  4941,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5518,    -1,    -1,    -1,    -1,  5523,  5524,    -1,
      -1,    -1,  5528,    -1,    -1,    -1,    -1,    -1,  5534,  5535,
    5536,  5713,    76,    -1,    -1,    -1,    62,    -1,    -1,    -1,
      -1,    -1,    -1,  5383,  5550,    -1,  4578,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,  6194,    -1,    -1,    17,    18,
      19,  5191,    -1,    -1,  5570,    -1,    -1,    -1,   493,    -1,
      -1,    97,  5578,    -1,    -1,  5581,    -1,    -1,    -1,    -1,
     505,   506,   507,   508,   509,   510,    45,    -1,   132,    -1,
      -1,    -1,    -1,    52,    -1,   139,    -1,    -1,   142,    -1,
    5606,    -1,    -1,    -1,    -1,    -1,  5446,    -1,    -1,    -1,
      -1,    -1,  5608,    -1,  1687,  5062,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,   169,   198,   199,   200,  5635,
    5636,   203,   158,    -1,    -1,   207,    -1,   209,    -1,    -1,
     212,    -1,    -1,   215,    -1,    -1,   218,    -1,    -1,   221,
      -1,   223,    -1,  5659,   226,    -1,    -1,    -1,   230,    -1,
     232,   205,  5668,  5669,  5670,    -1,    -1,    -1,    -1,   195,
      -1,    -1,    -1,    -1,    -1,  5681,  5682,    -1,    -1,  5685,
      -1,    -1,    -1,    -1,  5690,    -1,  5692,    -1,  5694,    -1,
      -1,    -1,    -1,    -1,    -1,  5701,    -1,    -1,    -1,  3252,
    3253,  5888,  5698,    -1,  3257,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,  5722,    -1,  5348,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   276,    -1,   193,    -1,   280,    -1,    -1,   198,
      -1,  5747,    -1,  5749,  3297,  3298,   290,    -1,    -1,  5379,
    5197,    -1,    -1,    -1,   280,   299,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5393,    -1,    -1,  5606,   311,    -1,    -1,
      -1,    -1,    -1,  5960,  5961,    -1,    -1,    -1,    -1,  2619,
      -1,    -1,    -1,   242,    -1,    -1,   312,  1860,    -1,    -1,
      -1,    -1,    -1,   319,    -1,  1868,  5802,    -1,  4830,    -1,
      -1,    -1,    -1,  1876,  4836,    -1,    -1,   351,  4840,    -1,
     354,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     0,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,
      -1,   357,    -1,  5839,   360,  4867,  4868,  5467,   297,    -1,
    4872,  4873,   386,   369,    -1,    -1,  5852,    -1,  1921,    -1,
      -1,    -1,   378,    -1,    -1,    -1,  5862,    -1,    -1,    -1,
     386,  5701,    -1,    -1,    -1,    -1,  5872,    -1,    -1,  5875,
      -1,    -1,   398,    -1,    -1,  1948,    -1,    -1,    -1,    -1,
      -1,   407,  5888,    -1,    -1,   411,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5901,    -1,    -1,    -1,  2739,
      -1,    -1,  2742,    -1,  2744,  2745,    -1,    -1,    -1,    -1,
      -1,   455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   391,    -1,    -1,    -1,  5942,    -1,  5934,    -1,
     466,    -1,    -1,    -1,    38,    -1,  5952,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5960,  5961,    -1,    -1,    -1,    -1,
    5966,  5959,  5802,  5959,  5959,    -1,    60,    -1,    -1,    -1,
     149,    -1,    -1,    -1,  5959,    -1,  5606,    -1,  5608,  5985,
    5986,  5959,    -1,   162,    -1,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    86,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,   180,  1923,  6052,   183,    -1,    -1,    -1,   187,    -1,
    1931,    -1,    -1,  6019,    -1,    -1,    -1,   111,   112,    -1,
      -1,    -1,    -1,  6210,  6211,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   493,    -1,  6042,    -1,   217,    -1,
      -1,    -1,  6048,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,    -1,  6052,    -1,  6052,  6052,    -1,    -1,
    6066,  6067,    -1,    -1,   243,    -1,    -1,  6052,  5698,    -1,
      -1,  5518,   644,    -1,  6052,  6081,  5523,  5524,   650,    -1,
     652,    -1,   654,    -1,   178,   657,    -1,    -1,    -1,  6095,
      -1,    -1,   664,    -1,    -1,    -1,    -1,   669,    -1,   671,
      -1,    -1,    -1,    -1,    -1,   677,    -1,   201,    -1,    -1,
      -1,    -1,  5952,   292,    -1,    -1,   295,    -1,    -1,    -1,
      -1,    -1,   301,    -1,  6130,    -1,    -1,    -1,    -1,   701,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   710,    -1,
      -1,    -1,   714,    -1,  6150,   717,    -1,    -1,   720,    -1,
      -1,  6157,    -1,    -1,    -1,    -1,  6154,    -1,  6154,  6154,
      -1,    -1,    -1,   257,   736,    -1,    -1,   261,    -1,  6154,
      -1,    -1,    -1,    -1,    -1,    -1,  6154,    -1,    -1,    -1,
     359,    -1,   276,  6189,  6190,    -1,   280,    -1,  6194,  5636,
      -1,    -1,  6198,    -1,    -1,    -1,  6202,    -1,  3038,    -1,
      -1,    -1,  6042,    -1,  6210,  6211,    -1,    -1,  6048,    -1,
      -1,    -1,    -1,    -1,  6220,    -1,   310,   789,    -1,    -1,
     792,   793,   794,    -1,    -1,    -1,    -1,    -1,    -1,   801,
      -1,    -1,    -1,    -1,  5266,    -1,    -1,   416,  5685,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   821,
     822,    -1,   824,   825,    -1,    -1,    -1,   829,    -1,    -1,
      -1,    -1,   356,    -1,    -1,   444,    -1,    -1,    -1,    -1,
      -1,   843,    -1,    -1,    -1,    -1,   848,    -1,    -1,    -1,
      -1,    -1,   854,    -1,    -1,    -1,   380,    -1,    -1,   468,
      -1,   470,   471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5934,    -1,   400,    -1,   402,    -1,
    6150,   405,    -1,   492,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,   899,    -1,  5959,
      -1,    -1,    -1,   512,    -1,    -1,   515,   516,   517,    -1,
      -1,   913,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3190,    -1,    45,  3193,   926,  3195,  3196,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   941,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    78,    -1,    -1,   960,    -1,
      -1,    -1,    -1,   965,   966,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
     514,    -1,  6052,    -1,    -1,   997,   998,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1020,  1021,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1034,    -1,  1036,  4018,    -1,    -1,  1040,    -1,
      -1,  1043,  1044,    -1,  1046,    -1,    -1,    -1,    -1,  1051,
      -1,    -1,    -1,  4036,  4037,  4038,  4039,    -1,    -1,  4042,
    4043,  4044,  4045,  4046,  4047,  4048,  4049,  4050,  4051,    -1,
     193,    -1,    -1,  1075,    -1,   198,    -1,    -1,    -1,    -1,
    1082,  1083,    -1,    -1,    -1,    -1,    -1,  4070,  5550,    -1,
      -1,    -1,    -1,    -1,  6154,    -1,    -1,    -1,   221,   222,
      -1,    -1,  1104,  1105,  1106,    -1,  1108,    -1,  1110,    -1,
    1112,  1113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,    -1,   193,  4108,  4109,    -1,    -1,   198,
      -1,  3401,    -1,    -1,  3404,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1146,    -1,  1148,  1149,    -1,    -1,
      -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,
     283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2672,
    4153,    -1,    -1,   242,   297,    -1,    -1,   300,    -1,  1181,
      -1,  3451,    -1,    -1,    -1,    -1,    -1,  2690,    -1,  3459,
      -1,  2694,    -1,    -1,    -1,  2698,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1207,    -1,  1209,    -1,    -1,
      -1,  1213,    -1,  1215,   283,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2725,    -1,    -1,    -1,  2577,    -1,   297,    -1,
      25,   300,    10,    -1,    -1,    13,    31,    -1,    -1,    17,
      18,    19,  1244,    38,  1246,    -1,    -1,    -1,  1250,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2759,    35,    -1,    -1,
      -1,    -1,  1264,    -1,    -1,    60,    -1,    45,   391,    -1,
      -1,    -1,    -1,    -1,    52,    -1,  2779,  5739,    -1,    -1,
      -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,  1299,    -1,    13,
      78,    -1,    -1,    17,    18,    19,    -1,    -1,  2811,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,
      -1,    35,   391,    -1,    -1,    -1,  1328,  1329,  1330,    -1,
    1332,    45,    -1,    -1,    -1,  2838,    -1,   132,    52,    -1,
      -1,  2844,    -1,    -1,   139,    -1,    -1,   142,    -1,    -1,
    1352,    -1,    -1,    -1,    -1,  2858,    -1,    -1,    -1,    -1,
      -1,    -1,  2865,    -1,    78,  2868,    -1,    -1,    -1,    -1,
     493,  2874,    -1,    -1,   169,    -1,    -1,    -1,    -1,   502,
     503,   504,   505,   506,   507,   508,   509,   510,    -1,  1391,
      -1,  2894,   515,    -1,    -1,   518,    -1,  2900,    -1,    -1,
      -1,    -1,    -1,    -1,  2907,    -1,   201,  1409,    -1,    -1,
     205,    -1,    -1,    -1,    -1,   193,    -1,    -1,  2921,    -1,
     198,    -1,    -1,    -1,   493,    -1,    -1,    -1,    -1,    -1,
      -1,  2934,    -1,   502,   503,   504,   505,   506,   507,   508,
     509,   510,  2945,   221,   222,    -1,    -1,    -1,    -1,   518,
      -1,    -1,    -1,  1455,    -1,    -1,    -1,  1459,  1460,    -1,
      -1,    -1,   257,    -1,   242,  4448,   261,    -1,  1470,  1471,
    1472,  1473,    -1,  1475,    -1,    -1,    -1,    -1,    -1,   193,
      -1,   276,    -1,    -1,   198,   280,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   290,    -1,  1499,    -1,    -1,
      -1,    -1,    -1,    -1,   299,   283,    -1,   221,   222,    -1,
      -1,    -1,    -1,    -1,    -1,   310,   311,    -1,    -1,   297,
      -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,  1534,    -1,    -1,    -1,    -1,  1539,    -1,    -1,
    1542,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1555,  1556,    -1,   351,    -1,    -1,   354,
     355,   356,  1564,    -1,    -1,  1567,    -1,    -1,    -1,   283,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,   297,    -1,   380,   300,    -1,    -1,    -1,
      -1,   386,  1594,    -1,  1596,    -1,    -1,  1599,    35,    -1,
    1602,  1603,    39,    -1,  1606,   400,    -1,    -1,    45,    -1,
      -1,    -1,    -1,   391,  1616,    52,    -1,  1619,    -1,    -1,
    1622,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      31,    78,  1644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,  3160,    -1,  1661,
     455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1673,  1674,  1675,  1676,  1677,  3179,   391,    -1,    -1,
      -1,    -1,    -1,  3186,    -1,    76,    -1,  4670,    -1,  1691,
      -1,    -1,   129,    -1,    -1,  6157,    -1,    -1,    -1,    -1,
    1702,  1703,  1704,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,    -1,    -1,   513,    -1,  3088,    -1,   130,
    6202,   132,  3093,    -1,  3095,    -1,    -1,    -1,   139,    -1,
      -1,   142,    -1,    -1,  3105,    -1,   193,  3108,  6220,  3110,
    3111,   198,    -1,  3114,    -1,    -1,    -1,  3118,    -1,  3120,
      -1,    -1,  3123,    -1,    -1,    -1,    -1,    -1,   169,   493,
      -1,    -1,    -1,    -1,   221,   222,    -1,    -1,   502,   503,
     504,   505,   506,   507,   508,   509,   510,    -1,    -1,  1801,
      -1,    -1,    -1,    -1,   518,   242,    -1,    -1,    -1,    -1,
    1812,    -1,    -1,    -1,   205,    -1,    -1,    -1,  1820,  1821,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1836,    -1,  3187,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,  1854,  1855,    -1,    -1,    -1,    -1,    -1,    -1,
     297,    -1,    -1,   300,    -1,    -1,    -1,    -1,  1870,  1871,
    1872,  1873,    -1,    -1,    -1,    -1,    -1,  1879,    23,    -1,
      -1,    -1,    -1,    28,  1886,   276,    -1,  1889,    -1,   280,
      -1,  4161,    -1,    -1,    -1,  4165,    -1,    -1,    -1,   290,
      -1,    -1,  1904,    -1,    -1,  1907,    -1,    -1,   299,    -1,
      -1,    -1,    -1,    -1,    -1,  1917,  1918,    -1,    -1,    -1,
     311,    66,    -1,    -1,    -1,    -1,  1928,  1929,    -1,    -1,
    1932,    -1,    -1,  1935,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    -1,  1950,  1951,
      95,    -1,    -1,    -1,   391,  1957,    -1,  1959,    -1,    -1,
     351,    -1,  4232,   354,   355,    -1,    -1,    -1,   113,    -1,
      -1,    -1,    -1,    -1,  1976,    -1,    -1,    -1,    -1,    -1,
      -1,  1983,    -1,  1985,    -1,    -1,  1988,  1989,  1990,    -1,
    1992,  1993,   137,  1995,    -1,   386,    -1,    -1,    -1,    -1,
    2002,    -1,    -1,   148,    -1,    -1,    -1,  2009,    -1,    -1,
    2012,  2013,   157,    -1,  2016,   452,    -1,  2019,  2020,    -1,
    3523,    -1,  2024,    -1,  2026,   170,    -1,    -1,    -1,  2031,
    2032,   176,    -1,    -1,    -1,    -1,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,    -1,    -1,  2047,    -1,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,    -1,   493,  2059,   203,  2061,
    2062,    -1,    -1,  2065,   455,   502,   503,   504,   505,   506,
     507,   508,   509,   510,    -1,    -1,    -1,    -1,  2080,  2081,
    2082,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,
      -1,    -1,    -1,    -1,    -1,    -1,  2098,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3623,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2138,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5127,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   332,   333,    -1,
      -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,  5181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,
      -1,   366,  4492,  4493,    -1,   370,    -1,    -1,   373,    -1,
      -1,    -1,  3583,    -1,  3585,   380,    -1,    -1,   383,    -1,
    2242,    -1,    -1,    -1,    -1,    -1,    -1,  3750,    -1,    -1,
       0,    -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,    23,
      -1,    -1,    -1,    -1,   409,    -1,    -1,    -1,    -1,    -1,
      20,   416,    -1,    -1,   419,    -1,    -1,    41,   423,    -1,
      -1,    31,    -1,    33,    34,    -1,   431,  2289,   433,    -1,
      -1,    -1,    -1,   438,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    79,    -1,    -1,    -1,   464,
      -1,    -1,    -1,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    95,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
    2342,    -1,    -1,    -1,    -1,    -1,    96,    -1,    98,   113,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,   118,    -1,
      -1,    -1,    -1,   137,    -1,    -1,  3727,    -1,    -1,    -1,
      -1,    -1,  3733,   133,   148,   135,    -1,    -1,    -1,   139,
      -1,    -1,    -1,   157,    -1,   145,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   153,    -1,   155,   170,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,   179,    -1,    -1,    -1,   183,
      -1,    -1,    -1,    -1,    -1,    -1,  3929,    -1,    -1,    -1,
     180,    38,    -1,    -1,    -1,    -1,  5419,    -1,    -1,   203,
      -1,    -1,    -1,    -1,    -1,  3948,    -1,   197,    -1,  3952,
      -1,    -1,    -1,    -1,    -1,    62,    -1,  4727,    -1,    -1,
      -1,    -1,    -1,    -1,  4734,    -1,  5449,    -1,    -1,  4739,
      -1,    -1,  4742,  4743,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      97,    -1,   256,    -1,   244,   245,    -1,    -1,    -1,    -1,
     250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,  2519,  2520,  2521,
    2522,  2523,  2524,  2525,  2526,  2527,    -1,  2529,    -1,    -1,
      -1,    -1,   282,   297,    -1,    -1,   300,  2539,  2540,    -1,
    2542,    -1,    -1,    -1,    -1,    -1,    -1,  2549,    -1,    -1,
      -1,   158,    -1,    17,    -1,    -1,    -1,    -1,   322,    -1,
      -1,    -1,    26,    -1,    -1,    -1,  3917,    -1,  3919,   319,
    3921,    -1,   336,    -1,    -1,    -1,  2578,   327,  2580,   343,
      -1,  2583,  2584,    -1,    -1,  2587,    -1,  2589,   195,    -1,
    2592,   341,    -1,    -1,  2596,    -1,    -1,   347,   348,   363,
     350,    -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,   373,
      -1,   361,    -1,    -1,   364,    -1,   380,  2619,    -1,   383,
      -1,   371,    -1,  2625,  2626,    -1,   233,    -1,   378,   379,
      -1,   238,    -1,    -1,  2636,    -1,   386,    -1,   402,    -1,
     390,    -1,    -1,  2645,  2646,   409,    -1,    -1,    -1,    -1,
     400,    -1,   416,    -1,    -1,   419,   420,  2659,   422,   423,
      -1,    -1,    -1,    -1,    -1,  2667,   416,  2669,    -1,    -1,
      -1,    -1,    -1,   280,   438,    -1,    -1,    -1,    -1,    -1,
      -1,   445,    -1,    -1,   448,    -1,   436,   451,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,  5681,    -1,
     464,    -1,    -1,   453,    -1,   312,    -1,  2709,   458,  2711,
      -1,    -1,   319,  4983,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   471,    -1,    -1,    -1,    -1,  2728,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2739,    -1,    -1,
    2742,  2743,  2744,  2745,  5014,   495,  2748,    -1,   355,  2751,
    4253,    -1,    -1,   360,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   369,    -1,   514,    -1,    -1,   517,    -1,    -1,
    2772,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   386,
      -1,  2783,    -1,    -1,    -1,    38,    -1,    -1,    -1,  2791,
    2792,   398,    -1,    -1,    -1,    -1,  2798,    -1,    -1,    -1,
     407,    -1,    -1,    -1,   411,  2807,    -1,    -1,    -1,    62,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   431,    -1,    -1,  2829,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,  2850,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
      -1,  2863,    -1,   470,    -1,    -1,    -1,    -1,    -1,  5852,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4381,    -1,
      -1,  4384,    -1,    -1,  2886,    -1,    -1,  2889,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    -1,    31,   158,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2915,  2916,    -1,    -1,    -1,    -1,    -1,
      -1,  5191,    -1,    -1,    -1,    -1,    -1,    -1,  2930,    -1,
    2932,  2933,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5211,   195,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      -1,    -1,    -1,    -1,    -1,  5225,    -1,    -1,    -1,    -1,
      -1,  2963,  2964,  2965,    -1,    -1,    -1,  2969,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2977,    -1,    -1,    -1,    -1,
     233,    -1,  4485,    -1,    -1,   238,    -1,    -1,  2990,    -1,
      -1,    -1,    -1,    -1,  2996,    -1,  2998,    -1,    -1,  4502,
      -1,    -1,  5985,  5986,    -1,   132,    52,  5277,    -1,  3011,
      -1,    -1,   139,    -1,  3016,   142,    -1,    -1,    -1,    -1,
    3022,    -1,    -1,  3025,    -1,    -1,    -1,   280,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3037,  3038,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,  3048,    -1,    -1,    -1,
      -1,    -1,  5322,    -1,    -1,    -1,  3058,    -1,  3060,   312,
      -1,    10,    -1,    -1,    13,    -1,   319,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    10,
    4583,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,  3099,    -1,  3101,
      -1,  3103,   355,    52,    35,    -1,    -1,   360,    -1,    -1,
      -1,    -1,    -1,  5383,    45,    -1,   369,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,   378,    -1,    -1,    -1,    78,
      -1,    -1,    -1,   386,  3136,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   398,    -1,    78,    -1,   276,
      -1,    -1,    -1,   280,   407,    -1,    -1,    -1,   411,    -1,
      -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   299,    -1,    -1,    -1,  5446,    -1,   431,    -1,
      -1,    -1,   646,    -1,   311,    -1,    -1,    -1,  3190,  3191,
      -1,  3193,    -1,  3195,  3196,    -1,  3198,    -1,    -1,    -1,
      -1,    -1,    -1,  3205,    -1,    -1,    -1,    -1,  3210,    -1,
      -1,    -1,    -1,   466,    -1,    -1,  4567,   470,    -1,  4570,
      -1,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,    -1,
      -1,    -1,   696,   697,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   193,    -1,    -1,    -1,  4599,   198,
    3252,  3253,  3254,    -1,    -1,  3257,    -1,    -1,    -1,   386,
      -1,    -1,   193,  3265,  3266,  3267,  3268,   198,    -1,    -1,
      -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,  3281,
      -1,    -1,  3284,    -1,  3286,    -1,    -1,    -1,    -1,    -1,
     221,   222,    -1,   242,    -1,  3297,  3298,    -1,    -1,  3301,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5578,    -1,
      -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,  3320,    -1,
    3322,    -1,  3324,    -1,  3326,    -1,    -1,    -1,   455,    -1,
      -1,   795,    -1,    -1,   283,    -1,  5606,    -1,    -1,    -1,
      -1,    -1,    -1,  3345,    -1,    -1,  3348,    -1,   297,    -1,
    3352,   815,   283,    -1,    -1,    -1,    -1,    -1,    -1,   823,
      -1,  4864,   826,   827,   828,    -1,   297,    -1,    -1,   300,
      -1,  3373,    -1,  4876,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,
       0,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3401,
      -1,    -1,  3404,  3405,    -1,    -1,    -1,  3409,  3410,  3411,
      20,    -1,    -1,    -1,    -1,  3417,    -1,    -1,    -1,    -1,
    3422,    31,    97,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,  5701,    -1,    -1,    -1,  3437,    -1,    -1,    -1,    -1,
      -1,    51,   391,    -1,    -1,    -1,    -1,    -1,    -1,  3451,
      62,    61,    -1,  3455,  4805,    -1,  3458,  3459,    -1,  3461,
     391,    -1,    -1,    73,    -1,    75,    76,    -1,    -1,    -1,
      -1,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   158,    -1,    97,    96,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4848,  4849,    -1,
    3502,    -1,    -1,    -1,    -1,   115,    -1,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     195,    -1,    -1,   133,    -1,   135,    -1,    -1,    -1,   139,
    3532,  3533,  5802,    -1,    -1,   145,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   153,   493,   155,   158,    -1,    -1,    -1,
      -1,    -1,   162,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   493,   238,    -1,  1029,    -1,    -1,    -1,    -1,
     180,   502,   503,   504,   505,   506,   507,   508,   509,   510,
      -1,    -1,    -1,   195,   515,    -1,    -1,   197,    -1,    -1,
    5093,  4942,  4943,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   276,    -1,    -1,    -1,   280,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5888,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   244,   245,   311,   312,  3640,    -1,
     250,    -1,    -1,    -1,   319,    -1,    -1,    -1,  3650,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,
     706,    -1,    -1,    -1,   276,    -1,    -1,    -1,   280,    -1,
      -1,    -1,   282,    -1,    -1,    -1,   351,    -1,    -1,    -1,
     355,    -1,  5952,    -1,    -1,   360,   732,    -1,    -1,    -1,
    5960,  5961,    -1,    -1,   369,    -1,    -1,    -1,    -1,   311,
     312,    -1,    -1,   378,    -1,    -1,    -1,   319,    -1,   319,
      -1,   386,    -1,    -1,    -1,    -1,  5219,   327,  5221,    -1,
      -1,  5072,    -1,   398,  5075,  5076,    -1,    -1,    -1,    -1,
      -1,   341,   407,    -1,    -1,    -1,   411,   347,   348,   351,
     350,    -1,    -1,   355,  5095,   355,    -1,    -1,   360,    -1,
      -1,   361,    -1,  3755,   364,    -1,  1220,   369,    -1,  3761,
      -1,   371,    -1,    -1,    -1,    -1,   378,    -1,   378,   379,
    3772,    -1,  6042,    -1,   386,    -1,   386,    -1,  6048,    -1,
     390,    -1,    -1,    -1,    -1,    -1,   398,    -1,  1252,    -1,
     400,   466,    -1,    -1,    -1,   407,  6066,    -1,    -1,   411,
      -1,    -1,    -1,    -1,    -1,    -1,   416,  3809,  3810,  3811,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3826,    -1,   436,    -1,    -1,    -1,
      -1,   877,    -1,    -1,    -1,    25,    -1,   447,  3840,    -1,
      -1,    31,    -1,   453,    -1,    -1,    -1,    -1,   458,    -1,
      -1,    -1,    -1,    -1,   466,    -1,  3858,  3859,  3860,    -1,
    6130,   471,  3864,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1334,    -1,    -1,    -1,  3876,    -1,    -1,    -1,    -1,  1343,
    6150,    -1,    -1,    -1,    -1,   495,    76,   497,   498,   499,
     500,   501,    -1,    -1,  1358,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   514,    -1,    -1,   517,    -1,    -1,
      -1,    -1,    -1,  1377,    -1,    -1,  1380,  1381,    62,    -1,
    6190,  1385,  1386,    -1,    -1,    -1,    -1,    -1,  6198,    -1,
    3932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6210,  6211,   132,    -1,  3946,  3947,    -1,    -1,    -1,   139,
      -1,    -1,   142,    97,    -1,  3957,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3970,    -1,
      -1,    -1,    -1,    -1,  1020,    -1,    -1,    -1,    -1,   169,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3989,    -1,    -1,
      -1,    -1,    -1,  1039,    -1,    -1,  3998,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1050,    -1,  4008,    -1,    -1,    -1,
    4012,  4013,    -1,    -1,   158,   205,  4018,    -1,    -1,    -1,
    1066,    -1,    -1,    -1,  4026,    -1,  4028,    -1,    -1,  4031,
      -1,    -1,    -1,    -1,  4036,  4037,  4038,  4039,    -1,    -1,
    4042,  4043,  4044,  4045,  4046,  4047,  4048,  4049,  4050,  4051,
      -1,   195,    -1,  4055,  4056,  4057,    -1,    -1,    -1,    -1,
      -1,    -1,    10,  4065,    -1,    13,    -1,    -1,  4070,    17,
      18,    19,  4074,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4082,    -1,    -1,  4085,    -1,  4087,   276,    35,    -1,    -1,
     280,    -1,    -1,    -1,   238,    -1,    -1,    45,    -1,    -1,
     290,    -1,    -1,  4105,    52,    -1,  4108,  4109,    -1,   299,
      -1,  4113,  4114,    -1,    -1,    -1,  4118,    -1,  4120,  4121,
      -1,   311,    -1,    -1,    -1,    -1,    -1,  4129,  4130,  4131,
      78,    -1,   276,    -1,    -1,    -1,   280,    -1,    -1,    -1,
      -1,  5492,    -1,    -1,    -1,    -1,    -1,  4149,  4150,  4151,
      -1,  4153,  4154,    -1,    -1,  4157,    -1,    -1,    -1,  4161,
      -1,   351,    -1,  4165,   354,   355,    -1,   311,   312,  4171,
      -1,    -1,    -1,    -1,    -1,   319,    -1,  1641,    -1,    -1,
      -1,    -1,  1228,    -1,    -1,  1649,    25,    -1,    -1,    -1,
      -1,    -1,    31,    -1,  5545,  4197,   386,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   351,    -1,    -1,
    4212,   355,  4214,    -1,    -1,    -1,   360,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   369,    -1,    -1,    -1,    -1,
    4232,  4233,  4234,    -1,   378,  4237,    -1,    76,    -1,    -1,
      -1,    -1,   386,    -1,    -1,   193,    -1,    -1,    -1,    -1,
     198,    -1,    -1,    -1,   398,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   407,    -1,   455,    -1,   411,    -1,    -1,
    4272,  4273,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4291,
      -1,    -1,    -1,   132,   242,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,   142,    -1,    -1,    -1,  5658,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,   466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    35,   283,    -1,    -1,    -1,    -1,
      -1,    -1,  4344,    -1,    45,    -1,    -1,    -1,    -1,   297,
      -1,    52,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,
      -1,    -1,  5875,    -1,    -1,    -1,    -1,    78,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4399,    -1,  1863,
      -1,    -1,    -1,  1867,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4432,    10,    -1,    -1,    13,  1481,    -1,   276,    17,    18,
      19,   280,    -1,   391,  4446,    -1,  4448,    -1,    78,    -1,
      -1,   290,    -1,  4455,    -1,    -1,    35,    -1,    -1,  4461,
     299,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
    4472,    -1,   311,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4487,    -1,    -1,    -1,    -1,
    4492,  4493,   193,    -1,    -1,    -1,    -1,   198,  4500,    78,
      -1,    -1,    -1,  1549,    -1,    -1,    -1,  4509,    -1,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,  4519,    -1,    -1,
     221,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4531,
    4532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4542,   242,    -1,    -1,  1590,   493,    -1,   386,    -1,    -1,
      -1,  4553,  4554,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   193,    -1,    -1,    -1,   515,   198,  4571,
      -1,    -1,    -1,  2037,    -1,    -1,    -1,  1623,    -1,    -1,
      -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   221,   222,    -1,    -1,    -1,   297,    -1,    -1,   300,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4612,    -1,   242,    -1,   193,    -1,   455,    -1,    -1,   198,
      -1,    -1,    -1,  4625,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4639,    -1,    -1,
      -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6002,    -1,   283,    -1,    -1,  1702,  1703,  1704,    -1,
      -1,    -1,    -1,   242,    -1,  4667,    -1,   297,  4670,    -1,
     300,    10,    -1,    -1,    13,    -1,  4678,  4679,    17,    18,
      19,    -1,    -1,  4685,  4686,    -1,    -1,    -1,  4690,    -1,
     391,    -1,    -1,    -1,    -1,  4697,    35,    -1,  4700,  4701,
      -1,    -1,    -1,    -1,   283,  4707,    45,    -1,    -1,  4711,
    4712,  4713,  4714,    52,    -1,    -1,    -1,    -1,   297,    -1,
      -1,   300,    -1,    -1,    -1,  4727,    -1,    -1,  4730,    -1,
      -1,    -1,  4734,    -1,    -1,    -1,    -1,  4739,    -1,    78,
    4742,  4743,    -1,  4745,    -1,  4747,    -1,    -1,  4750,    -1,
    4752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4761,
      -1,   391,    -1,  4765,    -1,    -1,    -1,  4769,  1814,  4771,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1825,
      -1,    -1,    -1,    -1,  4786,    -1,    -1,  4789,    -1,    -1,
      -1,    -1,   493,    -1,    -1,  1841,    -1,    -1,    -1,    -1,
      -1,   502,   503,   504,   505,   506,   507,   508,   509,   510,
      -1,    -1,   391,    -1,   515,    -1,    -1,    -1,    -1,    -1,
      -1,  4823,    -1,    -1,    -1,  4827,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1895,
      -1,    -1,    -1,    -1,   193,    -1,    -1,    -1,    -1,   198,
      -1,    -1,    -1,   493,  1910,    -1,    -1,  1913,  1914,    -1,
      -1,    -1,   502,   503,   504,   505,   506,   507,   508,   509,
     510,    -1,   221,   222,    -1,   515,    -1,    25,    -1,    -1,
    4892,    -1,    -1,    31,    -1,    -1,    -1,  4899,  1944,  1945,
      -1,    -1,    -1,   242,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,   493,    -1,    -1,    -1,    -1,  4921,
      -1,    -1,    -1,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,    -1,  4936,    -1,   515,    -1,    76,    45,
      -1,    -1,    -1,    -1,   283,    -1,    52,    23,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,   297,    -1,
      -1,   300,    -1,    -1,    -1,  4967,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4983,    -1,    -1,    -1,    -1,    -1,    -1,  4990,    -1,
      66,    -1,    -1,    -1,   132,    -1,  2042,  4999,    -1,    -1,
      -1,   139,    -1,    79,   142,  2051,    -1,    -1,  2054,    -1,
      -1,    -1,  5014,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      -1,    -1,    -1,    -1,    -1,  5027,    -1,  5029,    -1,    -1,
      -1,   169,    -1,  2079,    -1,    -1,    -1,   113,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,   391,  5055,    13,    -1,    -1,    -1,    17,    18,
      19,   137,    -1,    -1,  5066,    -1,    -1,   205,    -1,    -1,
      -1,    -1,   148,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,   157,    -1,    -1,    -1,    -1,    45,   193,    -1,    -1,
      -1,    -1,   198,    52,   170,  2559,    -1,    -1,    -1,    -1,
     176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    78,
      -1,    -1,  5124,    -1,    -1,  5127,    -1,   203,  5130,  5131,
    5132,    -1,    -1,    -1,    -1,    -1,   242,    -1,   276,    -1,
      -1,    -1,   280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   290,    -1,   493,  5157,  5158,    -1,    -1,  5161,
      -1,   299,    -1,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,   311,    -1,    -1,   515,   283,    -1,  5181,
     256,    -1,    -1,    -1,    -1,  5187,    -1,    -1,    -1,  5191,
      -1,   297,    -1,  5195,    -1,    -1,  5198,    -1,  5200,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5211,
      -1,    -1,  5214,   351,    -1,    -1,   354,   355,    -1,    -1,
      -1,   297,    -1,  5225,  5226,  5227,    -1,  5229,    -1,    -1,
      -1,    -1,    -1,    -1,   193,    -1,    -1,    -1,    -1,   198,
      -1,    -1,    -1,  2707,    -1,    -1,    -1,    -1,   386,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   332,   333,    -1,    -1,
     336,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5277,  5278,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,   391,    -1,   363,    -1,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,    -1,
      -1,    -1,  2766,    -1,   380,    -1,    -1,   383,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   455,    -1,    -1,
    5322,    -1,    -1,    -1,   283,    -1,   402,    -1,    -1,    -1,
      -1,    -1,  5334,   409,    -1,    -1,    -1,  5339,   297,    -1,
     416,   300,  5344,   419,    -1,    -1,    -1,   423,    -1,    -1,
      -1,  5353,    -1,    -1,    -1,   431,    -1,    -1,    -1,    -1,
      -1,  5363,   438,    -1,    -1,  5367,    -1,    -1,  5370,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5381,
    5382,  5383,  2846,    -1,    -1,    -1,    -1,   493,   464,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,   503,   504,   505,
     506,   507,   508,   509,   510,    -1,  2870,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5419,    -1,    -1,
      -1,  5423,    -1,  5425,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   391,    -1,    -1,    -1,    -1,  5439,    -1,    -1,
      -1,    -1,    -1,    -1,  5446,    -1,    -1,  5449,    -1,    -1,
      -1,  5453,    -1,    -1,    -1,    -1,    -1,    -1,  5460,    -1,
      -1,    -1,    -1,    -1,    -1,  5467,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2937,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2542,    -1,    -1,    -1,
    5502,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2974,    -1,  2976,    -1,  2978,  2979,    -1,    -1,    -1,  2983,
    2984,  2985,    -1,  2987,  2988,  2989,  5528,    -1,    -1,    -1,
      -1,    -1,  5534,  5535,   493,    -1,    -1,  5539,  5540,  5541,
    5542,    -1,    -1,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,    -1,    -1,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5570,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5578,  3041,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    -1,    -1,
      -1,    -1,    20,    -1,    22,    -1,    -1,    -1,    -1,    -1,
      28,  5603,  3066,    31,  5606,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    -1,  5631,
      -1,    -1,    35,  2679,    -1,    -1,    -1,  2683,  2684,    -1,
      25,    -1,    45,    -1,    -1,    -1,    31,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5659,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5668,  5669,  5670,    -1,
      -1,    -1,  5674,    -1,    -1,    78,  5678,    -1,    -1,  5681,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5690,    -1,
    5692,    76,  5694,  5695,    -1,  2741,    -1,    -1,    -1,  5701,
      -1,  2747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5711,
      -1,  5713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5722,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      -1,    -1,  2788,    -1,    -1,    -1,    -1,   132,    -1,    -1,
      -1,    -1,    -1,    -1,   139,  5757,  5758,   142,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,   205,    -1,    -1,
      -1,    -1,    76,    -1,   169,   213,  5788,    -1,   216,    -1,
     193,   219,   220,    -1,   222,   198,   224,    -1,    -1,   227,
    5802,   229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,
     205,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,  5839,   132,   242,
      -1,    -1,    -1,    -1,    -1,   139,    35,    -1,   142,    -1,
    5852,    -1,    -1,    -1,  5856,    -1,    45,    -1,    -1,    -1,
    5862,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,  5871,
    5872,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
     283,    -1,    -1,    -1,    -1,    -1,  5888,    -1,    -1,    78,
      -1,   276,    -1,    -1,   297,   280,    -1,   300,    -1,    -1,
      -1,  5903,  3366,    -1,    -1,   290,    -1,    -1,  5910,    -1,
      -1,   205,    -1,    -1,   299,    -1,    -1,    -1,    -1,  2965,
      -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,
     199,   200,    -1,  5935,   203,    -1,    -1,    -1,    -1,    -1,
    5942,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5952,  2997,    -1,    -1,   223,    -1,    -1,    -1,  5960,  5961,
    5962,   230,    -1,    -1,  5966,    -1,   351,    -1,    -1,   354,
     355,    -1,    -1,    -1,    -1,    -1,  5978,  5979,  5980,    -1,
      -1,    -1,   276,  5985,  5986,    -1,   280,    -1,   391,  5991,
      -1,    -1,    -1,    -1,    -1,    -1,   290,    -1,    -1,    -1,
      -1,   386,    -1,    -1,   193,   299,    -1,    -1,    -1,   198,
      -1,  6013,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,
      -1,    -1,    -1,    -1,  3070,    25,    -1,    -1,  3074,    -1,
      -1,    31,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,
    6042,  6043,  6044,    -1,    -1,    -1,  6048,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   351,    -1,    -1,
     354,   355,  3526,    -1,  6066,  6067,    -1,    -1,    -1,    -1,
     455,    -1,    -1,    -1,    -1,    -1,    76,    -1,    -1,  6081,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,    -1,   386,  6095,   283,    -1,    -1,    -1,    -1,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   297,    -1,
      -1,   300,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6128,  6129,  6130,  6131,
    6132,  3177,   132,  6135,    -1,    -1,    -1,    -1,    -1,   139,
    3604,    -1,   142,    -1,    -1,  6147,  3192,    -1,  6150,    -1,
      -1,  3197,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   455,    -1,    -1,    10,    -1,    -1,    13,  6170,   169,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,  3225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6189,  6190,    35,
      -1,    -1,  6194,    -1,    -1,    -1,  6198,    -1,  3662,    45,
      -1,    -1,   391,    -1,    -1,   205,    52,    -1,  6210,  6211,
      -1,    -1,  6214,    -1,    -1,    -1,   644,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   655,    -1,    -1,
      -1,   659,    78,    -1,    -1,    -1,    -1,    -1,   666,   667,
      -1,    -1,   670,    -1,   672,   673,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   687,
      -1,    -1,    -1,    -1,    -1,    -1,  3730,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   276,   705,    -1,    -1,
     280,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   726,   299,
     728,    -1,    -1,    -1,   493,    -1,    -1,    -1,    -1,    -1,
     738,   311,  3776,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,    -1,  3788,  3789,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3798,    -1,    -1,    -1,    -1,  3803,
      -1,  3805,    -1,   771,    -1,    -1,    -1,   193,    -1,    -1,
      -1,   351,   198,    -1,   354,   355,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    -1,
      -1,    -1,    -1,   652,    -1,   654,   386,  3851,   657,    -1,
      -1,    -1,    -1,   207,   208,    -1,   242,    -1,    -1,    -1,
      -1,   215,   671,   217,   218,    -1,    -1,    -1,   677,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,    -1,
      -1,    -1,  3886,  3887,    -1,  3471,    -1,   855,  3474,    -1,
    3476,    -1,    -1,    -1,    -1,  3481,    -1,   283,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,   300,   455,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3529,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     938,    -1,    -1,    -1,    -1,    -1,  3562,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1012,    -1,  3632,    -1,  3634,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1037,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4081,    -1,    -1,
      -1,    -1,    -1,    -1,  1052,    -1,  1054,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1064,    -1,    -1,    -1,
      -1,    -1,    -1,  1071,    -1,    -1,    -1,   493,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,   503,   504,   505,
     506,   507,   508,   509,   510,    -1,    -1,    -1,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3728,    -1,    -1,    -1,  1114,    -1,  1116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   965,   966,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3755,
      -1,   193,    -1,    -1,    -1,  3761,   198,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3770,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,
     222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,  1190,    -1,  1192,    -1,  1194,  1036,  1196,    -1,
    1198,  1199,  1200,    -1,    -1,    -1,    -1,  1205,    -1,    -1,
      -1,    -1,  1051,    -1,    10,    -1,    -1,    13,    -1,  1217,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    -1,  1082,  1083,   297,    -1,    -1,   300,    45,
    3866,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,   643,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1108,
      -1,    -1,  3888,    -1,    -1,    -1,  4310,    -1,   662,    -1,
      -1,    -1,    78,    -1,   668,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3910,    -1,   680,    -1,    -1,    -1,
      -1,    -1,  4336,    -1,    -1,    -1,    -1,    -1,    -1,  1148,
    1149,    -1,   696,    -1,    -1,    -1,    -1,  4351,    -1,    52,
    4354,    -1,  4356,    -1,    -1,    -1,   710,   711,    -1,    -1,
      -1,    -1,    -1,   717,    -1,   719,   720,    -1,    -1,   391,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   733,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   743,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4402,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3992,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4418,    -1,    -1,    -1,    -1,  4423,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,
      -1,    -1,   198,    10,  1402,    -1,    13,    -1,    23,    -1,
      17,    18,    19,    28,    -1,   799,    -1,    -1,    -1,  4035,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,   493,    -1,   827,  4060,    52,   242,    -1,    -1,    -1,
     502,   503,   504,   505,   506,   507,   508,   509,   510,    -1,
      -1,    -1,    -1,   515,    79,    80,    -1,    -1,   852,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    -1,    -1,    -1,    -1,    -1,    -1,   283,  4522,    -1,
      -1,  4525,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,
      -1,   297,    -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   137,    -1,    -1,  1523,    -1,    -1,   912,    -1,
      -1,    -1,    -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,
      -1,   176,    -1,    -1,    -1,    -1,    -1,  4601,  4602,  4603,
    4604,    -1,  4606,  4607,  4608,  4609,  4610,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,   203,    -1,
      -1,   198,    -1,    -1,    -1,   391,    -1,  1595,    -1,    -1,
      -1,    -1,    -1,    -1,  4220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    -1,   234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,  1022,    -1,
      -1,   256,    -1,    -1,    -1,  1029,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1040,    -1,    -1,    -1,
    1044,    -1,  1046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4719,    -1,  4721,    -1,    -1,
     297,    -1,    -1,   300,  4310,    -1,    -1,   493,    -1,    -1,
      -1,    -1,    -1,  1542,    -1,    -1,   502,   503,   504,   505,
     506,   507,   508,   509,   510,    -1,    -1,   332,   333,   515,
    4336,   336,    -1,    -1,    -1,    -1,    -1,    -1,  1567,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,
      -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,
      -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,   383,  1153,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,   391,    -1,    -1,   402,    -1,    -1,
      -1,    -1,    -1,    -1,   409,    -1,    -1,    35,    -1,    -1,
      -1,   416,    -1,    -1,   419,  1644,    -1,    45,   423,    -1,
      -1,    -1,  1810,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   438,    -1,    -1,    -1,    -1,    -1,    -1,
    1214,    -1,    -1,    -1,  1673,  1674,  1675,  1676,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,  1230,  1845,    -1,   464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4478,  1247,    -1,    -1,    -1,    -1,  1252,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   493,    -1,    -1,    -1,
      -1,    -1,    -1,  1891,    35,   502,   503,   504,   505,   506,
     507,   508,   509,   510,    45,  4939,  4940,    -1,   515,  4525,
      -1,    52,    -1,  1911,  4530,    -1,    -1,    -1,  4952,    -1,
    4954,  4955,  4956,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,  1937,
     208,  1939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,
      -1,    -1,    -1,    -1,    -1,   193,  1954,    -1,  1956,    -1,
     198,    -1,    -1,   231,  1962,    -1,  1964,    -1,  1966,    -1,
    1968,    -1,  1970,   706,    -1,    -1,  1974,    -1,    -1,    -1,
      -1,  1820,  1821,   221,   222,    -1,  5020,    -1,    -1,    -1,
      -1,    -1,    -1,  1377,    -1,    -1,    -1,  1836,    -1,   732,
      -1,  1385,  1386,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2011,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5059,    -1,    -1,    -1,    -1,
      -1,  1870,  1871,  1872,  1873,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,    -1,   193,    -1,  1438,    -1,    -1,   198,    -1,   297,
      -1,    -1,   300,    -1,    -1,  4681,    -1,    -1,  5102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     221,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,   242,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,  1951,    -1,    -1,    -1,    -1,    -1,  1957,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,   283,    -1,   877,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   391,    -1,    -1,   297,    -1,    -1,   300,
      10,    -1,    -1,    13,    -1,    78,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    -1,    -1,    -1,    35,    -1,    38,    -1,    -1,
      -1,  4807,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    76,    -1,    -1,    78,    -1,
      -1,  4847,  5266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     391,    -1,    -1,  4869,    -1,   493,    -1,    -1,    -1,    -1,
     111,    -1,    -1,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,    -1,    -1,    -1,    -1,   515,  5312,    -1,
     193,   132,    -1,    -1,    -1,   198,    -1,  5321,   139,    -1,
      -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2138,
      -1,    -1,    -1,  1687,    -1,    -1,  1039,    -1,   221,   222,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1050,   169,    -1,
      -1,    -1,    -1,    -1,    -1,  4941,    -1,    -1,    -1,   242,
      -1,    -1,    -1,  1066,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   193,    -1,    -1,    -1,    -1,   198,    -1,
     201,    -1,   493,    -1,   205,    -1,    -1,    -1,    -1,    -1,
      -1,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     283,   221,   222,    -1,   515,   643,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   297,    -1,    -1,   300,    -1,    -1,
      -1,    -1,   242,    -1,   662,    -1,    -1,    -1,    -1,    -1,
     668,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,    -1,
     261,    -1,   680,    -1,    -1,    -1,    -1,    -1,  1802,    -1,
      -1,    -1,    -1,    -1,    -1,   276,    -1,    -1,   696,   280,
      -1,    -1,    -1,   283,    -1,    52,    -1,    -1,    -1,   290,
      -1,    -1,    -1,   711,  5060,    -1,  5062,   297,   299,    -1,
     300,   719,    -1,  1837,    -1,    -1,    -1,    -1,    -1,   310,
     311,    -1,    -1,    -1,    -1,   733,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   743,  1860,    -1,   391,    -1,
      -1,    -1,    -1,    -1,  1868,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1876,    -1,    -1,  1228,    -1,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5550,    -1,    -1,    -1,
    5554,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,
      -1,   799,    -1,  1917,  1918,   386,  1920,  1921,    -1,    -1,
      -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,  1932,   400,
    1934,  1935,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   827,
      -1,    -1,    -1,  1947,  1948,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,  5197,    -1,    -1,   852,    -1,    -1,    -1,    -1,   502,
     503,   504,   505,   506,   507,   508,   509,   510,    -1,    -1,
      -1,  1985,   515,    -1,   455,  1989,  1990,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   912,    -1,    -1,  1380,    -1,    -1,
    5266,    -1,   502,   503,   504,   505,   506,   507,   508,   509,
     510,    -1,    -1,    -1,    -1,   515,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2673,  2674,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2692,  2693,    -1,  2695,  2696,    -1,
      -1,    -1,  2700,  2701,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5749,  2100,  2715,    -1,  5753,
      -1,  5755,    -1,    -1,  2722,  5759,  5760,    -1,  2726,  2727,
      -1,    -1,  2730,  2731,    -1,    -1,    -1,    -1,    -1,  2737,
      -1,    -1,    -1,    -1,  2583,    -1,    -1,    -1,  1481,    -1,
      -1,  2749,    -1,    -1,  1022,    -1,    -1,    -1,    -1,    -1,
      -1,  1029,    -1,  2761,    -1,    -1,    -1,    -1,  2766,    -1,
    5386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2781,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2790,    -1,    -1,  2793,    -1,  2795,  2796,  2797,
      -1,    -1,    -1,    -1,  2802,  2803,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2812,    -1,  1549,    -1,    -1,    -1,
    2818,    -1,    -1,    -1,  2822,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2834,  2835,    -1,    -1,
      -1,  2839,    -1,    -1,    -1,    -1,    -1,  2845,  2846,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1590,    -1,    -1,
      -1,  2859,    -1,    -1,  2862,    -1,    -1,    -1,    -1,    -1,
      -1,  2869,  2870,    -1,    -1,    -1,    -1,  2875,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1153,    -1,    -1,    -1,  2887,
    1623,    -1,  2890,    -1,    -1,    -1,    -1,  2895,    -1,    -1,
      -1,    -1,  5518,  2901,  2902,    -1,    -1,  5523,  5524,  2748,
      -1,  2909,    -1,    -1,    -1,  2913,    -1,    -1,    -1,  2917,
    2918,  2919,  2920,    -1,  2922,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2935,  2936,    -1,
    2938,    -1,    -1,    -1,    -1,    -1,  1214,    -1,    -1,    -1,
      -1,  2949,  2950,  2951,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1230,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1247,
      -1,    -1,    -1,    52,  1252,  6019,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,  3006,    17,
      18,    19,    -1,    -1,    -1,    -1,  3014,    -1,    -1,  5635,
    5636,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3033,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,  2886,    -1,    -1,
    2889,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5685,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1814,    -1,    -1,    -1,  3083,    -1,    -1,    -1,   706,
      -1,    -1,  1825,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3102,    -1,  3104,    -1,  1841,  1377,
      -1,    -1,    -1,    -1,    -1,   732,    -1,  1385,  1386,    -1,
      -1,    -1,    -1,  6157,    -1,    -1,  6160,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2977,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2990,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2998,
      -1,    -1,  1895,    -1,    -1,    -1,    -1,    -1,  6202,    -1,
    1438,    -1,    -1,    -1,    -1,    -1,    -1,  1910,    -1,    -1,
    1913,  1914,    -1,    -1,    -1,   193,  6220,    -1,    -1,  6223,
     198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3037,    -1,
      -1,  3199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1944,  1945,   221,   222,    -1,    -1,    -1,    -1,  3058,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,  2617,   242,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
     877,    -1,  3101,    -1,  3103,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,   283,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2672,   297,
      -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,  2690,    -1,    -1,    -1,
    2694,    -1,    -1,    -1,  2698,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2707,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,  2725,    -1,    -1,    -1,    -1,  2079,    -1,    -1,    -1,
      -1,    -1,  3191,    -1,    -1,    35,    -1,    -1,  2742,  3198,
    2744,  2745,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,  2759,    -1,    -1,    -1,    -1,
      -1,    -1,    10,   391,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,  2779,  2780,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   193,    -1,    45,    -1,  1687,
     198,    -1,  1039,    -1,    52,    -1,  2810,  2811,    -1,    -1,
    2814,    -1,    -1,  1050,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,  1066,
      78,    -1,    -1,    -1,  2838,    -1,  2840,    -1,    -1,    -1,
    2844,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2858,    -1,    -1,    -1,    -1,    -1,
      -1,  2865,    -1,    -1,  2868,   493,    -1,    -1,    -1,    -1,
    2874,    -1,    -1,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,    -1,    -1,   283,  3504,   515,    -1,    -1,
    2894,    -1,    -1,   193,    -1,    -1,  2900,    -1,   198,   297,
      -1,    -1,   300,  2907,    -1,    -1,  3524,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1802,    -1,    -1,  2921,    -1,    -1,
     168,   221,   222,  3541,    -1,    -1,   174,  3545,    -1,    -1,
    2934,    -1,  3550,  3551,  3552,  2939,    -1,    -1,    -1,    -1,
      -1,  2945,   242,    -1,    -1,   193,    -1,    -1,    -1,  1837,
     198,    -1,    -1,  6189,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3586,  3587,
    3588,  3589,  1860,   221,   222,    -1,    -1,    -1,    -1,    -1,
    1868,    -1,    -1,   283,    -1,    -1,    -1,    -1,  1876,    -1,
      -1,  1228,    -1,   391,   242,    -1,    -1,   297,  3616,    -1,
     300,  3005,    -1,    -1,    -1,    -1,  3624,    -1,  3626,  3627,
    3628,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1920,  1921,    -1,   283,    52,    -1,    -1,    -1,
      -1,    -1,    -1,   732,    -1,    -1,  1934,    -1,    -1,   297,
      -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,    -1,  1947,
    1948,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3532,  3533,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   391,    -1,    -1,    -1,   493,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,    -1,    -1,    -1,    -1,   515,    -1,    -1,
      -1,    -1,    -1,    -1,  3742,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,  3751,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3160,    35,  3162,  3777,
    3778,   706,    -1,    -1,  3782,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,  3179,    -1,    -1,    -1,    -1,
      -1,    -1,  3186,    -1,    -1,    -1,  3804,   732,   877,  3193,
      -1,  3195,  3196,   493,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,   502,   503,   504,   505,   506,   507,   508,   509,
     510,    -1,  2100,    -1,    -1,   515,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3856,    -1,
      -1,    -1,    -1,  3861,  1481,   493,    -1,    -1,    -1,  3867,
      -1,    -1,    -1,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3276,    -1,    -1,    -1,    -1,    -1,  3282,  3897,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3926,    -1,
    3928,    -1,  1549,  3772,    -1,   193,    -1,    -1,    -1,    -1,
     198,    -1,    -1,    -1,    -1,    -1,  2679,    -1,    -1,    -1,
    2683,  2684,   877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
    1039,    -1,    -1,  1590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1050,  3366,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1066,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1623,    -1,  2741,    -1,
      -1,    -1,    -1,    -1,  2747,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,
      -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2788,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3932,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3496,  3497,  1039,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1050,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,  3523,
      -1,  1066,  3526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1814,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1825,    -1,
      -1,    -1,    -1,    -1,  3598,  3599,  3600,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1841,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,    -1,    -1,  4236,  3623,
      -1,  4239,    -1,  4241,   502,   503,   504,   505,   506,   507,
     508,   509,   510,    -1,    -1,    -1,  4254,    -1,  3642,    -1,
      -1,    -1,    -1,    -1,  2997,    -1,    -1,    -1,  4266,    -1,
      -1,    -1,  4270,    -1,    -1,    -1,    -1,    -1,  1895,    -1,
    3664,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4289,    -1,  1910,    -1,    -1,  1913,  1914,    -1,    -1,
      -1,    -1,    -1,  1228,    -1,    -1,    -1,    -1,    -1,  4307,
     706,    -1,    -1,    -1,    -1,  4313,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1944,  1945,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   732,  3070,    -1,    -1,
    4338,  3074,    -1,    -1,  4342,    -1,    -1,    -1,    -1,  2617,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4357,
    4358,  4359,  4360,    -1,    -1,    -1,  3750,    -1,    -1,  4367,
    4368,  4369,  4370,    -1,    -1,    -1,    -1,    -1,  4376,  4377,
      -1,    -1,    -1,    -1,  4382,  4383,    -1,  4385,  4386,  4387,
    4388,  4389,  4390,  4391,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4401,  2672,    -1,    -1,  4405,  4406,  4407,
    4408,    -1,  1481,  3797,    -1,    -1,    -1,    -1,    -1,  3803,
      -1,  3805,  2690,    -1,    -1,    -1,  2694,    -1,    -1,    -1,
    2698,  4429,    -1,    -1,  3818,    -1,  3820,    -1,    -1,  2707,
      -1,    -1,    -1,    -1,  3177,    -1,    -1,    -1,    -1,  4447,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2725,    -1,  3192,
      -1,    -1,  2079,    -1,  3197,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1549,   877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2759,  3225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3887,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2779,  2780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1590,    -1,    -1,    -1,  4523,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2810,  2811,    -1,  3929,  2814,    -1,    -1,    -1,
      -1,    -1,    10,    -1,  1623,    13,  1481,    -1,  4556,    17,
      18,    19,    -1,    -1,  3948,  4563,    -1,  4565,  3952,    -1,
    2838,    -1,  2840,    -1,    -1,    -1,  2844,    35,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,  3973,
    2858,    -1,    -1,  4432,    52,  4593,    -1,  2865,    -1,    -1,
    2868,    -1,    -1,    -1,    -1,    -1,  2874,  4446,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    -1,  1549,    -1,  2894,    -1,    -1,    -1,
      -1,    -1,  2900,    -1,    -1,    -1,    -1,    -1,    -1,  2907,
      -1,    -1,    -1,  1039,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2921,  1050,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1590,  2934,    -1,    -1,    -1,
    1066,  2939,    -1,    -1,    -1,    -1,    -1,  2945,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4072,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1623,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   193,    -1,  3005,  3471,    -1,
     198,  3474,    -1,  3476,    -1,  1814,    -1,    -1,  3481,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1825,    -1,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3529,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3537,    -1,    -1,    -1,    -1,    -1,
    4808,  4809,  4810,    -1,    -1,    -1,  4814,  4815,  4816,  4817,
      -1,    -1,    -1,  4821,    -1,   283,  1895,    -1,    -1,  3562,
      -1,    -1,  1228,    -1,    -1,    -1,    -1,    -1,    -1,   297,
      -1,  1910,   300,    -1,  1913,  1914,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4859,  4860,  4861,  4862,  4863,   324,  4865,  4866,  4253,
      -1,    -1,    -1,    -1,    -1,  1944,  1945,    -1,    -1,  4877,
    4878,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1814,
      -1,    -1,  3160,    -1,  3162,    -1,    -1,    -1,    -1,  3632,
    1825,  3634,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3179,    -1,  4911,    -1,    -1,  1841,    -1,  3186,    -1,
    4304,    -1,    -1,    -1,    -1,  4309,    -1,  4311,    -1,    -1,
      -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4335,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1895,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1910,    -1,    -1,  1913,  1914,
      -1,    -1,    -1,    -1,    -1,  3728,    -1,  4381,    -1,    -1,
    4384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3276,    -1,
    2079,    -1,    -1,    -1,  3282,  5013,    -1,    -1,    -1,  1944,
    1945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,    -1,  3770,    -1,    -1,
      -1,    -1,    -1,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2679,    -1,    -1,  3798,  2683,  2684,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5078,    52,  4921,    -1,    -1,  1481,    -1,    -1,    -1,    -1,
    4474,  4475,    -1,    -1,    -1,    -1,    -1,  4936,  3366,    -1,
      -1,  4485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5110,    -1,    -1,    -1,    -1,    -1,  4502,    -1,
      -1,    -1,    -1,    -1,  2741,    -1,    -1,    -1,    -1,    -1,
    2747,    -1,    -1,  3866,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,  1549,  2079,  3888,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    38,
      -1,  2788,    -1,    -1,    -1,    -1,    45,  3910,    -1,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,  5027,    -1,
      -1,    -1,    -1,    -1,  1590,    -1,    -1,    -1,    -1,  4583,
      -1,    -1,  4586,    -1,    -1,    -1,  5204,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1623,  3496,  3497,
      -1,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3523,    -1,    -1,  3526,  3992,
     732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,  5287,
      17,    18,    19,    -1,    -1,  5293,  5294,    -1,    -1,    -1,
      -1,    -1,  4035,    -1,    -1,  5303,    -1,    -1,    35,    -1,
      -1,    -1,  5310,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    -1,    -1,   193,    52,    -1,  4060,    -1,   198,
    3598,  3599,  3600,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5345,  5346,    -1,
      -1,    78,   221,   222,    -1,  3623,    -1,    -1,    -1,    -1,
    5358,    -1,  5360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   242,  3642,    -1,    -1,  5375,    -1,    -1,
    2997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5227,    -1,
    5229,    -1,    -1,    -1,    -1,    -1,  3664,    -1,    -1,    -1,
      -1,    -1,  5400,    -1,    -1,   877,    -1,    -1,    -1,    -1,
    5408,    -1,    -1,    -1,   283,    -1,    -1,    -1,  1814,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   297,  1825,
      -1,   300,    -1,    -1,    -1,    -1,  4820,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1841,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3070,    -1,    -1,    -1,  3074,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,    -1,
      -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4864,    -1,  3750,    -1,  5482,    -1,    -1,  4220,    -1,    -1,
      -1,    -1,  4876,    -1,   221,   222,    -1,    -1,    -1,  1895,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5506,    -1,
      -1,    -1,    -1,    -1,  1910,   242,    -1,  1913,  1914,  5517,
      -1,    -1,   391,    -1,    -1,    -1,  4910,    -1,    -1,  3797,
      -1,    -1,    -1,    -1,    -1,  3803,    -1,  3805,    -1,    -1,
      -1,    -1,  5381,    -1,    -1,    -1,    -1,    -1,  1944,  1945,
    3818,    -1,  3820,    -1,    -1,    -1,   283,    -1,    -1,    -1,
    3177,    -1,    -1,    -1,    -1,    -1,    -1,  1039,    -1,    -1,
     297,    -1,    -1,   300,    -1,  3192,    -1,  4310,  1050,    -1,
    3197,    -1,    -1,    -1,    -1,    -1,  5584,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1066,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4336,  4988,    -1,    -1,    -1,  3225,    -1,
    2679,    -1,    -1,    -1,  2683,  2684,    -1,    -1,    -1,  3887,
      -1,    -1,    -1,  5007,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5654,    -1,    -1,    -1,
      -1,  3929,    -1,    -1,   391,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2741,    -1,    -1,    -1,    -1,    -1,  2747,    -1,
    3948,    -1,    -1,  2079,  3952,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5540,    -1,  5542,    -1,  3973,    -1,    -1,    -1,  5093,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2788,
      -1,    -1,  5720,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   706,  5734,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2679,    -1,  1228,    -1,  2683,  2684,
      -1,   732,    -1,    -1,    -1,   492,   493,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   502,   503,   504,   505,   506,
     507,   508,   509,   510,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4525,    -1,    -1,  5793,    -1,  4530,    -1,    -1,
      -1,    -1,    -1,    -1,  4072,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2741,    -1,    -1,    -1,
      -1,    -1,  2747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5219,    -1,  5221,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3471,    -1,    -1,  3474,    -1,  3476,
      -1,    -1,    -1,  2788,  3481,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5267,    -1,    -1,    -1,    -1,    10,  5887,
      -1,    13,    -1,  5277,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   877,    -1,    -1,    -1,
      -1,    -1,  3529,    35,    -1,    -1,    -1,    -1,    -1,    -1,
    3537,  5919,    -1,    45,    -1,    -1,    -1,    -1,  2997,    -1,
      52,    -1,  5930,  5317,    -1,    -1,    -1,    -1,  5322,    -1,
      -1,    -1,    -1,    -1,    -1,  3562,    -1,    -1,  4681,  5788,
      -1,    -1,    10,    -1,    -1,    13,    78,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      38,    -1,    -1,    -1,    -1,  4253,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,  3070,    -1,    -1,    -1,  3074,    -1,    -1,    -1,  1481,
      -1,    -1,    -1,    -1,    -1,  3632,    -1,  3634,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6032,    -1,  4304,    -1,    -1,    -1,
      -1,  4309,    -1,  4311,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5903,    -1,    -1,  4335,  1039,    -1,
      -1,   193,  2997,    -1,  4807,    -1,   198,  1549,    -1,  1050,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1066,    -1,    -1,    -1,   221,
     222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3177,    -1,
      -1,  3728,    -1,  4381,  4847,    -1,  4384,    -1,  1590,    -1,
     242,    -1,    -1,  3192,    -1,    -1,    -1,    -1,  3197,    -1,
      -1,    -1,    -1,    -1,    -1,   193,  4869,    -1,    -1,    -1,
     198,    -1,    -1,    -1,    -1,  3070,    -1,    -1,    -1,  3074,
      -1,  1623,  5536,  3770,    -1,    -1,  3225,    -1,    -1,    -1,
      -1,   283,    -1,   221,   222,    -1,  5550,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6013,   297,    -1,    -1,   300,    -1,
      -1,  3798,    -1,    -1,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5581,   320,    -1,
      -1,    -1,    -1,    -1,  6043,  6044,  4474,  4475,  4941,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4485,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4502,    -1,    -1,    -1,    -1,   297,
      -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,    -1,  3866,
      -1,    -1,  3177,    -1,    -1,    -1,    -1,  1228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3192,    -1,   391,
      10,  3888,  3197,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,  2679,    -1,    -1,    -1,  2683,  2684,    -1,
      -1,    -1,    -1,  3910,    -1,    35,    -1,    -1,  5682,    -1,
    3225,    -1,    -1,    -1,    -1,    45,    -1,    -1,  6147,    -1,
      -1,    -1,    52,    -1,    -1,  4583,    -1,    -1,  4586,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5062,
      -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,  1814,    -1,    -1,  2741,    -1,    -1,    -1,    -1,
      -1,  2747,    -1,  1825,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5747,    -1,  5749,    -1,    -1,    -1,  1841,
      -1,   493,    -1,    -1,    -1,  3992,    -1,    -1,    -1,    -1,
     502,   503,   504,   505,   506,   507,   508,   509,   510,    -1,
      -1,    -1,  2788,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3471,    -1,    -1,  3474,    -1,  3476,    -1,    -1,
      -1,    -1,  3481,    -1,    -1,    -1,    -1,    -1,  4035,    -1,
      -1,    -1,    -1,  1895,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,   493,    -1,    -1,  1910,    -1,
      -1,  1913,  1914,  4060,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   193,    -1,    -1,    -1,    -1,   198,    -1,
    3529,    -1,    -1,    -1,  5197,    -1,    -1,    -1,  3537,    -1,
      -1,    -1,  1944,  1945,    -1,    -1,    -1,    -1,    -1,    -1,
     209,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5875,   221,  3562,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   242,   232,  5888,    -1,    -1,    -1,    -1,    -1,
    1481,    -1,    -1,    -1,    -1,    -1,    -1,  5901,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,  5266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   283,    -1,    35,  3471,    -1,    38,  3474,
      -1,  3476,  4820,    -1,    -1,    45,  3481,   297,    -1,    -1,
     300,    -1,    52,  3632,    -1,  3634,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5960,  5961,  1549,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4864,    -1,    -1,    -1,
      -1,  2997,    -1,  4220,  3529,    -1,    -1,  2079,  4876,    -1,
      -1,    -1,  3537,    -1,    -1,    -1,    -1,    -1,    -1,  1590,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6019,    -1,  3562,    -1,    -1,
      -1,    -1,  4910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   391,  1623,  5386,    -1,    -1,    -1,    -1,    -1,  3728,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3070,    -1,    -1,    -1,  3074,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4310,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3770,    -1,   193,    -1,    -1,    -1,  3632,   198,  3634,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4336,
    4988,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3798,
      -1,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,  5007,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   242,   493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,   503,   504,   505,   506,   507,   508,   509,
     510,    -1,    -1,  6157,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3177,    -1,    -1,    -1,  5518,    -1,    -1,    -1,    -1,
    5523,  5524,    -1,   283,    -1,    -1,  3192,  3866,    -1,    -1,
      -1,  3197,    -1,  3728,    -1,    -1,    -1,   297,    -1,    -1,
     300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6202,  3888,
      -1,    -1,    -1,    -1,    -1,  5093,  6210,  6211,    -1,  3225,
      -1,    -1,    -1,    -1,    -1,    -1,  6220,    -1,    -1,    -1,
      -1,  3910,    -1,  1814,    10,  3770,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,  1825,    -1,    -1,    -1,    -1,    -1,
      -1,  4478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
    1841,    -1,    -1,  3798,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   391,    -1,  5636,    -1,    -1,    -1,    -1,  4525,    -1,
      -1,    -1,    78,  4530,    -1,   644,    -1,    -1,    -1,    -1,
      -1,   650,    -1,  3992,  1895,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,  1910,
      13,  3866,  1913,  1914,    17,    18,    19,    -1,    -1,    -1,
      -1,  5219,  5685,  5221,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,  3888,    -1,    38,  4035,    -1,    -1,    -1,
      -1,    -1,    45,  1944,  1945,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,  3910,    -1,    -1,    -1,    -1,
      -1,  4060,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5267,
      -1,    -1,    -1,   493,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,   502,   503,   504,   505,   506,   507,   508,   509,
     510,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,
      -1,    -1,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5317,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    -1,
      -1,    -1,    10,    -1,  4681,    13,    -1,  3992,    -1,    17,
      18,    19,    -1,    -1,    -1,  3471,   242,    -1,  3474,    -1,
    3476,    -1,    -1,    -1,    -1,  3481,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   824,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,  2079,    -1,
    4035,    -1,    -1,    -1,   843,    -1,    -1,   283,    -1,    -1,
     193,    -1,    -1,    -1,    -1,   198,    -1,    -1,    -1,    -1,
      78,   297,    -1,  3529,   300,  4060,    -1,    -1,    -1,    -1,
      -1,  3537,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,
      -1,  4220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3562,    -1,    -1,   242,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   913,    -1,    -1,    -1,    -1,    -1,
    4807,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2679,    -1,    -1,
     283,  2683,  2684,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   297,   391,   174,   300,    -1,    -1,
    4847,   960,    -1,    -1,    -1,    -1,  3632,    -1,  3634,    -1,
      -1,  4310,    -1,    -1,    -1,   193,    -1,    -1,    -1,    -1,
     198,    -1,  4869,    -1,    -1,    -1,    -1,    -1,   424,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4336,  5536,  2741,
      -1,    -1,    -1,   221,   222,  2747,    -1,    -1,    -1,    -1,
      -1,    -1,  5550,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   242,  4220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5581,    -1,    -1,  2788,    -1,   391,    -1,
      -1,    -1,    -1,    -1,  4941,    -1,    -1,   493,    -1,    -1,
      -1,    -1,  3728,    -1,    -1,   283,   502,   503,   504,   505,
     506,   507,   508,   509,   510,    -1,  1075,    -1,    -1,   297,
      -1,    -1,   300,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3770,  1104,  1105,  1106,    -1,    35,
      -1,    -1,    -1,    -1,    -1,  4310,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,  3798,    -1,    -1,    -1,    -1,    -1,    -1,  4478,
      -1,  4336,    -1,    -1,  5682,    -1,    -1,    -1,    -1,    -1,
     493,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,   502,
     503,   504,   505,   506,   507,   508,   509,   510,    -1,    -1,
      -1,    -1,    -1,   391,    -1,  5062,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4525,    -1,    -1,    -1,
      -1,  4530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3866,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5747,
      -1,  5749,    -1,    -1,  1213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3910,    -1,    -1,  1246,   174,    -1,
      -1,    -1,    -1,    -1,    -1,  2997,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,
      -1,    -1,   198,    -1,    -1,   493,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4478,   502,   503,   504,   505,   506,   507,
     508,   509,   510,    -1,    -1,   221,   222,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5197,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3992,    -1,  3070,    -1,
    4525,    -1,  3074,    -1,    -1,  4530,    -1,  5875,    -1,    -1,
      -1,    -1,  4681,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,
      -1,    -1,    -1,  5901,    -1,    -1,    -1,    -1,    -1,  4035,
      -1,   297,    -1,    -1,   300,    -1,    -1,    -1,    10,  5266,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,  1391,    -1,  4060,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3177,    -1,    -1,  2679,    -1,
      -1,    -1,  2683,  2684,    -1,    -1,    78,    -1,    -1,    -1,
    3192,    -1,    -1,    -1,    -1,  3197,   821,   822,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   391,    -1,    -1,  4807,    -1,
      -1,    -1,  1471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6019,    -1,  3225,    -1,    -1,  4681,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5386,
    2741,    -1,    -1,    -1,    -1,    -1,  2747,    -1,  4847,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4869,    -1,    -1,    -1,   899,    -1,   168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2788,    -1,    -1,
      -1,    -1,    -1,    -1,  4220,    -1,  1555,    -1,    -1,    -1,
      -1,   193,    -1,    -1,    -1,  1564,   198,   493,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,   503,   504,   505,
     506,   507,   508,   509,   510,    -1,    -1,    -1,    -1,   221,
     222,    -1,    -1,    -1,    -1,    -1,    -1,  1596,    -1,    -1,
      -1,    -1,  4941,  1602,  1603,    -1,    -1,  1606,    -1,    -1,
     242,    -1,  4807,    -1,    -1,    -1,    -1,    -1,    -1,  6157,
    1619,    -1,    -1,  1622,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5518,    -1,    -1,    -1,    -1,  5523,  5524,    -1,    -1,
      -1,    -1,    -1,    -1,  4310,    -1,    -1,    -1,    -1,    -1,
      -1,   283,  4847,    -1,    -1,  1020,  1021,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6202,   297,    -1,    -1,   300,    -1,
    4336,    -1,    -1,    -1,  4869,    -1,    -1,    -1,  1677,    -1,
      -1,    -1,  6220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1691,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5062,    -1,    -1,    -1,    -1,    -1,  3471,
      -1,    -1,  3474,    -1,  3476,    -1,    -1,    -1,    -1,  3481,
      -1,    -1,    -1,    -1,    -1,    -1,  4941,    -1,    -1,  5636,
      -1,    -1,    -1,    -1,    -1,    -1,  2997,    -1,    -1,   391,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3529,    -1,    35,
      -1,    -1,    -1,    -1,    -1,  3537,    -1,    -1,  5685,    45,
      -1,    -1,  1801,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,  4478,  1812,    -1,    -1,    -1,    -1,    -1,    -1,
    3562,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3070,
      -1,    -1,    78,  3074,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1854,  1855,    -1,  5197,  4525,
      -1,   493,    -1,    -1,  4530,    -1,    -1,  5062,    -1,    -1,
     502,   503,   504,   505,   506,   507,   508,   509,   510,    -1,
    1879,    -1,    -1,    -1,    -1,    -1,    10,  1886,    -1,    13,
    3632,    -1,  3634,    17,    18,    19,    -1,    -1,    -1,  1264,
      -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,  5266,    52,    -1,
      -1,    -1,    -1,    -1,  1299,    -1,  3177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    -1,    -1,
      -1,  3192,   198,    -1,    78,    -1,  3197,    -1,    -1,    -1,
    1959,    -1,    -1,  1328,  1329,  1330,    -1,  1332,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3225,    -1,  3728,  1352,    -1,    -1,
      -1,    -1,    -1,  1992,  1993,    -1,   242,    -1,    -1,    -1,
      -1,    -1,  5197,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2009,    10,    -1,  2012,    13,  4681,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3770,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,   283,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,  5386,    -1,    -1,
      -1,   297,    -1,    52,   300,    -1,  3798,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
      -1,  5266,    -1,    -1,   198,    -1,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1455,    -1,    -1,    -1,  1459,  1460,    -1,   221,   222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,    -1,    -1,  3866,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4807,    -1,    -1,    -1,   391,  3888,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3910,   168,
      -1,    -1,    -1,   297,    -1,    -1,   300,    -1,    -1,  5518,
      -1,  4847,    -1,    -1,  5523,  5524,    -1,    -1,    -1,    -1,
      -1,  5386,    -1,    -1,   193,    -1,    -1,    -1,    -1,   198,
      -1,    -1,    -1,  4869,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,
    3471,    -1,    -1,  3474,    -1,  3476,    35,    -1,    -1,    -1,
    3481,    -1,    -1,   242,    -1,    -1,    45,   493,    -1,    -1,
    3992,    -1,    -1,    52,    -1,    -1,   502,   503,   504,   505,
     506,   507,   508,   509,   510,    -1,    -1,   391,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4941,    -1,    -1,    -1,    78,
      -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,  3529,    -1,
      -1,    -1,    -1,  4035,    -1,    -1,  3537,  5636,   297,    -1,
      -1,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4060,    -1,
      -1,  3562,    -1,  5518,    -1,    -1,    -1,    -1,  5523,  5524,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1702,  1703,  1704,
      -1,    -1,    -1,   467,    -1,    -1,  5685,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,   503,
     504,   505,   506,   507,   508,   509,   510,    -1,    -1,    -1,
      -1,  3632,   391,  3634,   193,    -1,  5062,    -1,    -1,   198,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5636,    -1,   242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4220,    -1,
      -1,    -1,    -1,    -1,   283,    -1,    -1,  3728,    -1,    -1,
    5685,    -1,    -1,    -1,   493,    -1,    -1,    -1,   297,    -1,
      -1,   300,    -1,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3770,
      -1,  5197,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,
    2539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2549,    -1,    -1,   113,    -1,    -1,    -1,  3798,    -1,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4310,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,  2578,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,
      -1,    -1,   391,    -1,  4336,    -1,    -1,   157,    -1,    -1,
    5266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,
      -1,    -1,    -1,   183,    -1,  3866,  2625,  2626,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,    -1,    -1,  3888,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2659,    -1,    -1,    -1,    -1,    -1,  2031,    -1,    -1,  3910,
      -1,    -1,    -1,    -1,   234,  2040,  2041,  2042,  2043,    -1,
      -1,    -1,  2047,    -1,  2049,    -1,  2051,    -1,    -1,  2054,
    2055,  2056,    -1,    -1,   493,    -1,   256,  2062,    -1,    -1,
    2065,    -1,    -1,   502,   503,   504,   505,   506,   507,   508,
     509,   510,    -1,    -1,    -1,  2080,  2081,  2082,    -1,    -1,
    5386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2098,    -1,    -1,  4478,   297,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3992,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   332,   333,    -1,    -1,   336,    -1,    -1,    -1,
      -1,    -1,    -1,  4525,    -1,    -1,    -1,    -1,  4530,    -1,
      -1,    -1,    -1,  2792,  4035,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   363,    -1,    -1,   366,    -1,  2807,    -1,
     370,    -1,    -1,   373,    -1,    -1,    -1,    -1,    -1,  4060,
     380,    -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,    -1,
    2829,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   402,    -1,    -1,    -1,    -1,    -1,    -1,   409,
      -1,    -1,  5518,    -1,   414,    -1,   416,  5523,  5524,   419,
      -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   433,    -1,    -1,    -1,  2242,   438,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   464,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2915,  2916,    -1,    -1,
      -1,    -1,    -1,    -1,  2289,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4681,
      -1,    -1,  1344,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5636,    -1,    -1,    -1,    -1,    -1,    -1,  2342,    -1,  4220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1399,    -1,    31,
      -1,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3016,    -1,  5685,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    96,  4807,    98,    -1,    -1,  4310,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4336,    -1,    -1,    -1,    -1,
      -1,   133,    -1,   135,    -1,  4847,    -1,   139,    -1,    -1,
      -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   153,    -1,   155,    -1,    -1,    -1,  4869,    -1,    -1,
     162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,   180,    28,
      -1,    -1,    -1,    -1,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,    -1,  2529,   197,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2540,    -1,  2542,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4941,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   244,   245,    -1,  2580,    95,    -1,   250,  2584,
      -1,    -1,  2587,    -1,  2589,    -1,    -1,  2592,    -1,    -1,
      -1,    -1,   264,    -1,   113,    -1,    -1,  4478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,
    2645,  2646,    -1,    -1,  4525,    -1,    -1,   319,    -1,  4530,
      -1,   170,    -1,    -1,    -1,   327,    -1,   176,    -1,    -1,
      -1,    -1,    -1,    -1,   183,    -1,  1708,    -1,    -1,   341,
    1712,    -1,    -1,    -1,    -1,   347,   348,    -1,   350,    -1,
    5062,    -1,    -1,   355,   203,    -1,   358,    -1,    -1,   361,
      -1,    -1,   364,    -1,    -1,    -1,    -1,    -1,    -1,   371,
      -1,    -1,    -1,    -1,    -1,    -1,   378,   379,    -1,    -1,
      -1,    -1,    -1,  3352,   386,    -1,    -1,    -1,   390,    -1,
      -1,    -1,    -1,  2728,    -1,    -1,    -1,    -1,   400,    -1,
      -1,    -1,    -1,    -1,  3373,    -1,    -1,   256,    -1,    -1,
      -1,    -1,    -1,    -1,   416,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   436,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   447,    -1,    -1,   297,    -1,
      -1,   453,    -1,    -1,    -1,    -1,   458,    -1,    -1,    -1,
      -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   471,
    4681,    -1,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   332,   333,  5197,    -1,   336,    -1,    -1,
      -1,    -1,    -1,   495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   514,    -1,   363,   517,    -1,   366,    -1,    -1,
      -1,   370,    -1,    -1,   373,    -1,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   402,  5266,    -1,    -1,    -1,    -1,    -1,
     409,    -1,    -1,    -1,    -1,    -1,    -1,   416,    -1,    -1,
     419,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   431,    -1,   433,    -1,    -1,    -1,    -1,   438,
      -1,    -1,    -1,    -1,    -1,    -1,  4807,    -1,    -1,    -1,
      -1,    -1,   451,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   464,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2963,  2964,
    2965,    -1,    -1,    -1,  2969,    -1,  4847,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2029,  4869,    -1,
      -1,  2996,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3640,    -1,    -1,  5386,    -1,  2048,    -1,    -1,    -1,
    2052,  3650,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2067,  2068,  2069,    -1,  2071,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4941,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5518,    -1,    -1,    -1,
      -1,  5523,  5524,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3809,  3810,  3811,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5062,    -1,    -1,    -1,    -1,    -1,  3826,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3205,    -1,    -1,    -1,    -1,  3210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3859,  3860,    -1,    -1,    -1,  3864,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3254,
      -1,    -1,    -1,    -1,  5636,    -1,    -1,    -1,    -1,    -1,
    3265,    -1,  3267,  3268,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3281,    -1,    -1,  3284,
      -1,  3286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5685,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5197,  3322,    -1,  3324,
      -1,  3326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5266,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3417,    -1,    -1,    -1,    -1,  3422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4129,  4130,  4131,    -1,  2536,    -1,    -1,  3502,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2632,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2644,    -1,    -1,    -1,    -1,  2649,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5518,    -1,    -1,
      -1,    -1,  5523,  5524,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3755,    -1,    -1,    -1,    -1,  5636,  3761,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5685,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4455,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3840,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4487,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4554,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3989,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3998,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4008,    -1,    -1,    -1,  4012,  4013,    -1,
      -1,    -1,    -1,  4018,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4026,    -1,  4028,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4055,  4056,  4057,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4074,
      -1,    -1,  4711,  4712,  4713,  4714,    -1,  4082,    -1,    -1,
    4085,    -1,  4087,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4113,  4114,
      -1,    -1,    -1,    -1,    -1,  4120,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3208,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3228,    -1,    -1,    -1,
      -1,  3233,  4197,    -1,    -1,    -1,    -1,  3239,    -1,    -1,
      -1,    -1,  3244,  3245,    -1,  3247,    -1,    -1,    -1,  4214,
    3252,  3253,    -1,  3255,    -1,  3257,    -1,    -1,    -1,  3261,
      -1,    -1,  3264,    -1,    -1,    -1,    -1,  3269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3278,    -1,    -1,    -1,
      -1,  3283,    -1,    -1,    -1,    -1,    -1,    -1,  3290,  3291,
    3292,  3293,    -1,    -1,    -1,  3297,  3298,    -1,  3300,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3319,    -1,  3321,
      -1,    -1,    -1,    -1,    -1,    -1,  3328,  3329,  3330,  3331,
    3332,  3333,  3334,  3335,  3336,  3337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5055,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5066,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3517,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4531,  4532,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4542,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4612,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4625,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4639,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4678,  4679,    -1,    -1,    -1,    -1,    -1,
    4685,  4686,    -1,    -1,    -1,  4690,    -1,    -1,    -1,    -1,
      -1,    -1,  4697,    -1,    -1,  4700,  4701,    -1,    -1,    -1,
    5339,    -1,  4707,    -1,    -1,  5344,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3759,  3760,    -1,
      -1,    -1,  3764,    -1,  5363,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4750,    -1,    -1,    -1,    -1,
      -1,  3793,    -1,    -1,    -1,    -1,  4761,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4789,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5502,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4892,    -1,    -1,
      -1,    -1,    -1,    -1,  4899,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3988,    -1,    -1,    -1,
      -1,    -1,  3994,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4967,    -1,  5603,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4032,  4033,  5631,    -1,  4036,  4037,  4038,  4039,    -1,    -1,
    4042,  4043,  4044,  4045,  4046,  4047,  4048,  4049,  4050,  4051,
    4052,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4075,    -1,    -1,  4078,    -1,  4080,    -1,
      -1,  4083,  4084,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4107,  4108,  4109,  4110,    -1,
    4112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5124,
      -1,    -1,    -1,    -1,    -1,  5130,  5131,  5132,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5157,  5158,    -1,    -1,  5161,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5187,    -1,    -1,    -1,    -1,  4229,    -1,    -1,
      -1,    -1,    -1,  5198,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5214,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4448,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4491,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5528,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5570,    -1,    -1,    -1,    -1,
      -1,  4613,    -1,    -1,    -1,  4617,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4635,  4636,    -1,    -1,    -1,    -1,  4641,
    4642,  4643,  4644,    -1,    -1,    -1,  4648,  4649,  4650,  4651,
    4652,  4653,  4654,  4655,  4656,  4657,  4658,  4659,  4660,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4684,    -1,    -1,  4687,    -1,  4689,    -1,    -1,
      -1,    -1,    -1,  4695,  5659,    -1,  4698,  4699,    -1,    -1,
    4702,  4703,    -1,  5668,  5669,  5670,  4708,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5694,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5722,  4760,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4774,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5839,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5862,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5872,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4970,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5942,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5966,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5057,  5058,    -1,    -1,    -1,
      -1,    -1,    -1,  5065,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6067,    -1,    -1,    -1,  5108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6081,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5126,  5127,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5145,    -1,  5147,    -1,    -1,    -1,  5151,
    5152,  5153,    -1,    -1,  5156,    -1,    -1,  5159,  5160,    -1,
      -1,    -1,    -1,  5165,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5181,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5199,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5223,    -1,    -1,  6189,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5288,    -1,  5290,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5325,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5416,    -1,  5418,  5419,  5420,  5421,
    5422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5435,  5436,  5437,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5449,    -1,    -1,
    5452,    -1,    -1,    -1,  5456,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5489,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5660,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5679,    -1,  5681,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5733,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5769,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5835,    -1,    -1,    -1,    -1,    -1,    -1,
    5842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5886,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5985,  5986,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5999,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6040,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,  6065,     5,     6,    -1,     8,     9,    10,
      11,    12,    -1,    -1,  6076,  6077,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,  6133,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,   134,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   505,   506,   507,    -1,    -1,    -1,
      -1,    -1,    -1,   514,   515,     3,    -1,     5,     6,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
     448,   449,   450,   451,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,    -1,   495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,   506,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   514,   515,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,   493,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     505,   506,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,
     515,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,   448,   449,   450,   451,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   505,   506,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   514,   515,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,   448,
     449,   450,   451,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,   493,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,   505,   506,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   514,   515,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   515,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      -1,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,    -1,   155,   156,
     157,   158,    -1,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,    -1,    -1,    -1,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,    -1,
      -1,    -1,    -1,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,    -1,   240,   241,   242,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
      -1,    -1,   279,    -1,   281,   282,   283,   284,    -1,    -1,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,    -1,   324,    -1,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,    -1,   413,   414,    -1,    -1,
     417,   418,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,    -1,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,    -1,   459,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,   491,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,   515,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,    -1,   155,   156,   157,   158,    -1,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,    -1,   240,
     241,   242,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,    -1,    -1,   279,    -1,
     281,   282,   283,   284,    -1,    -1,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,    -1,   324,    -1,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,    -1,   413,   414,    -1,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,    -1,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,    -1,   459,   460,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,    -1,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,   489,   490,
     491,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,   515,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,    -1,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,   493,    -1,
     495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     505,   506,    -1,    -1,    -1,     3,    -1,     5,     6,   514,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
     448,   449,   450,   451,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,    -1,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,    -1,   495,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,   506,    -1,
      -1,    -1,     3,    -1,     5,     6,   514,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   505,   506,    -1,    -1,    -1,     3,
      -1,     5,     6,   514,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    36,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,   493,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   505,   506,    -1,    -1,    -1,     3,    -1,     5,     6,
     514,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    36,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,   493,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,   506,
      -1,    -1,    -1,     3,    -1,     5,     6,   514,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   505,   506,    -1,    -1,    -1,
      -1,    -1,   512,   513,   514,     3,    -1,     5,     6,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
     448,   449,   450,   451,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,   506,   507,
      -1,    -1,     3,    -1,     5,     6,   514,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   505,   506,    -1,    -1,    -1,     3,
      -1,     5,     6,   514,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,   493,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   505,   506,    -1,    -1,    -1,     3,    -1,     5,     6,
     514,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,   493,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,   506,
      -1,    -1,    -1,     3,    -1,     5,     6,   514,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   505,   506,    -1,    -1,    -1,
       3,    -1,     5,     6,   514,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,   428,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,    -1,
     493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   505,   506,    -1,    -1,    -1,     3,    -1,     5,
       6,   514,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,   493,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,
     506,    -1,    -1,    -1,     3,    -1,     5,     6,   514,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,   448,
     449,   450,   451,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   505,   506,    -1,    -1,
      -1,     3,    -1,     5,     6,   514,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,    -1,   417,   418,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,   448,   449,   450,   451,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   505,   506,    -1,    -1,    -1,     3,    -1,
       5,     6,   514,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,   493,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     505,   506,    -1,    -1,    -1,     3,    -1,     5,     6,   514,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,    -1,   417,
     418,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   446,   447,
     448,   449,   450,   451,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,   493,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,   506,    -1,
      -1,    -1,     3,    -1,     5,     6,   514,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   505,   506,    -1,    -1,    -1,     3,
      -1,     5,     6,   514,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,   448,   449,   450,   451,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,   493,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   505,   506,    -1,    -1,    -1,     3,    -1,     5,     6,
     514,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,    -1,
     417,   418,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,    -1,   493,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,   506,
      -1,    -1,    -1,     3,    -1,     5,     6,   514,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,    -1,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   505,   506,    -1,    -1,    -1,
       3,    -1,     5,     6,   514,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,    -1,   417,   418,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   505,   506,    -1,    -1,    -1,     3,    -1,     5,
       6,   514,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,   493,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   505,
     506,    -1,    -1,    -1,     3,    -1,     5,     6,   514,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,   451,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   505,   506,     3,    -1,
       5,     6,    -1,     8,     9,   514,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,    -1,   417,   418,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     505,   506,     3,    -1,     5,     6,    -1,     8,     9,   514,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,
       6,    -1,     8,     9,    -1,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,   514,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,   495,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,   505,
     506,   507,    -1,    -1,    -1,    -1,    -1,    -1,   514,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    -1,    -1,   495,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,   416,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,   495,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
     416,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   514,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   514,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,
      -1,    -1,    10,    11,    -1,    -1,    -1,    -1,   514,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,    -1,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,    -1,   183,    -1,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,   234,   235,   236,   237,
     238,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,   279,   280,   281,   282,   283,   284,   285,    -1,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,    -1,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
      -1,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,    -1,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,   491,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,     3,    -1,     5,     6,    -1,    -1,    -1,
      10,    11,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,    -1,   183,    -1,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,   236,   237,   238,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,   279,
     280,   281,   282,   283,   284,   285,    -1,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,    -1,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,    -1,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,   503,   504,   505,   506,   507,   508,   509,
     510,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    -1,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,    -1,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,    -1,   164,   165,   166,   167,    -1,   169,   170,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,    -1,   261,
     262,    -1,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,   297,   298,   299,   300,    -1,
     302,   303,   304,   305,    -1,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,    -1,
     462,   463,   464,   465,   466,   467,    -1,   469,    -1,    -1,
      -1,    -1,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,    -1,   490,   491,
      -1,   493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     502,   503,   504,   505,   506,   507,   508,   509,   510,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,   503,
     504,   505,   506,   507,   508,   509,   510,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,   503,   504,   505,
     506,   507,   508,   509,   510,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,   503,   504,   505,   506,   507,
     508,   509,   510,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   502,   503,   504,   505,   506,   507,   508,   509,
     510,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     502,   503,   504,   505,   506,   507,   508,   509,   510,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,   503,
     504,   505,   506,   507,   508,   509,   510,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,   503,   504,   505,
     506,   507,   508,   509,   510,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   507,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   507,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     507,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,    -1,   155,   156,   157,
     158,    -1,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,    -1,    -1,
      -1,    -1,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,    -1,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,    -1,
      -1,   279,    -1,   281,   282,   283,   284,    -1,    -1,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,    -1,   324,    -1,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
      -1,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,    -1,   413,   414,    -1,    -1,   417,
     418,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,    -1,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
      -1,   459,   460,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,   491,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,   507,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    -1,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,    -1,   155,   156,   157,   158,    -1,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,    -1,    -1,    -1,    -1,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,    -1,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,    -1,    -1,   279,
      -1,   281,   282,   283,   284,    -1,    -1,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,    -1,   324,    -1,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,    -1,   413,   414,    -1,    -1,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,    -1,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,    -1,   459,
     460,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,   507,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,
      -1,    -1,    -1,    -1,   505,   506,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,   418,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,
      -1,    -1,    -1,   505,   506,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
      -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,   418,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,
      -1,    -1,   505,   506,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      -1,   505,   506,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,   174,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     505,   506,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,   451,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,     5,     6,    -1,     8,     9,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,   105,   106,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,   418,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
      -1,    -1,   105,   106,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,   418,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,   105,   106,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,    -1,    -1,
      -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,   418,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,   105,
     106,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,    -1,    -1,   105,   106,
      -1,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,   418,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,   105,   106,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
     418,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,   102,    -1,    -1,   105,   106,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,   173,    -1,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,   418,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,   462,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,   173,    -1,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,   418,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,   462,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    99,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,   173,    -1,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,   418,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
     462,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    99,   100,   101,   102,
      -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
     173,    -1,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,   418,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,   462,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,    -1,    -1,
      -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,   173,    -1,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,   418,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,   462,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,
     106,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,   173,    -1,   175,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,   418,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,   173,    -1,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,   418,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,   462,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,   173,    -1,   175,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
     418,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,   462,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      -1,    80,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,   170,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
     170,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,   242,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,   180,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,   180,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,   170,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,   416,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,   170,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
     416,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,   106,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,   416,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,   297,   298,
     299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,   451,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
     416,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,   106,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,    -1,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,   185,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,    -1,   188,
     189,   190,   191,   192,    -1,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,    -1,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,   281,   282,    -1,   284,    -1,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,    -1,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,    -1,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,   432,   433,   434,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,    -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    -1,    92,    93,    94,    95,    96,    97,    -1,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,   122,   123,   124,   125,   126,   127,   128,    -1,
     130,   131,   132,   133,    -1,    -1,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
      -1,   161,    -1,   163,   164,   165,   166,   167,    -1,   169,
      -1,   171,   172,    -1,    -1,    -1,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,    -1,   188,   189,
     190,   191,   192,    -1,   194,   195,   196,   197,    -1,   199,
     200,   201,   202,   203,   204,   205,   206,    -1,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,    -1,   218,    -1,
     220,    -1,    -1,   223,    -1,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
      -1,   241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,    -1,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,   281,   282,    -1,   284,    -1,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,    -1,   297,   298,   299,
      -1,    -1,   302,   303,   304,    -1,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,    -1,
     360,   361,    -1,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,    -1,
     380,   381,   382,   383,   384,    -1,   386,   387,   388,   389,
     390,    -1,   392,   393,   394,   395,    -1,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,
     420,   421,   422,   423,    -1,   425,   426,   427,    -1,    -1,
     430,   431,   432,   433,   434,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,    -1,   446,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,    -1,   463,   464,   465,   466,    -1,    -1,   469,
      -1,    -1,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      -1,    92,    93,    94,    95,    96,    97,    -1,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,   120,
      -1,   122,   123,   124,   125,   126,   127,   128,    -1,   130,
     131,   132,   133,    -1,    -1,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,   147,   148,    -1,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,    -1,
     161,    -1,   163,   164,   165,   166,   167,    -1,   169,    -1,
     171,   172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,    -1,   188,   189,   190,
     191,   192,    -1,   194,   195,   196,   197,    -1,   199,   200,
     201,   202,   203,   204,   205,   206,    -1,   208,    -1,   210,
     211,   212,   213,   214,   215,   216,    -1,   218,    -1,   220,
      -1,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,    -1,
     241,    -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,    -1,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
     281,   282,    -1,   284,    -1,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,
      -1,   302,   303,   304,    -1,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,   360,
     361,    -1,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,   386,   387,   388,   389,   390,
      -1,   392,   393,   394,   395,    -1,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,
     421,   422,   423,    -1,   425,   426,   427,    -1,    -1,   430,
     431,   432,   433,   434,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,    -1,   446,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,   459,    -1,
     461,    -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,
      -1,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    -1,   120,    -1,
     122,   123,   124,   125,   126,   127,   128,    -1,   130,   131,
     132,   133,    -1,    -1,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,   147,   148,    -1,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    -1,   161,
      -1,   163,   164,   165,   166,   167,    -1,   169,    -1,   171,
     172,    -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,    -1,   188,   189,   190,   191,
     192,    -1,   194,   195,   196,   197,    -1,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,    -1,   210,   211,
     212,   213,   214,   215,   216,    -1,   218,    -1,   220,    -1,
      -1,   223,    -1,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,    -1,   241,
      -1,    -1,   244,   245,   246,    -1,    -1,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,    -1,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,   281,
     282,    -1,   284,    -1,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,
     302,   303,   304,    -1,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
      -1,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,   386,   387,   388,   389,   390,    -1,
     392,   393,   394,   395,    -1,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,    -1,    -1,   417,    -1,   419,   420,   421,
     422,   423,    -1,   425,   426,   427,    -1,    -1,   430,   431,
     432,   433,   434,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,    -1,   446,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
      -1,   463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    -1,    92,
      93,    94,    95,    96,    97,    -1,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,   120,    -1,   122,
     123,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,    -1,    -1,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,    -1,   161,    -1,
     163,   164,   165,   166,   167,    -1,   169,    -1,   171,   172,
      -1,    -1,    -1,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,    -1,   188,   189,   190,   191,   192,
      -1,   194,   195,   196,   197,    -1,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,
     223,    -1,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,
      -1,   244,   245,   246,    -1,    -1,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,    -1,   281,   282,
      -1,   284,    -1,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,
     303,   304,    -1,   306,    -1,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,    -1,   360,   361,    -1,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,   386,   387,   388,   389,   390,    -1,   392,
     393,   394,   395,    -1,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,    -1,    -1,   417,    -1,   419,   420,   421,   422,
     423,    -1,   425,   426,   427,    -1,    -1,   430,   431,   432,
     433,   434,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,    -1,   461,    -1,
     463,   464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,    -1,
      -1,    -1,   176,   177,   178,   179,    -1,   181,   182,    -1,
     184,   185,   186,    -1,   188,   189,   190,   191,   192,    -1,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,
      -1,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,    -1,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,   281,   282,    -1,
     284,    -1,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
     304,    -1,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,    -1,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,    -1,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,    -1,    -1,   417,    -1,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,   432,   433,
     434,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,   459,    -1,   461,    -1,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    -1,    92,    93,    94,
      95,    96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,   120,    -1,   122,   123,   124,
     125,   126,   127,   128,    -1,   130,   131,   132,   133,    -1,
      -1,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,    -1,   163,   164,
     165,   166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,
      -1,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,    -1,   188,   189,   190,   191,   192,    -1,   194,
     195,   196,   197,    -1,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,    -1,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,
     245,   246,    -1,    -1,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,    -1,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    -1,   281,   282,    -1,   284,
      -1,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,   304,
      -1,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    -1,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,   360,   361,    -1,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,    -1,   392,   393,   394,
     395,    -1,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
      -1,    -1,   417,    -1,   419,   420,   421,   422,   423,    -1,
     425,   426,   427,    -1,    -1,   430,   431,   432,   433,   434,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
      -1,   446,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,    -1,   461,    -1,   463,   464,
     465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    -1,    92,    93,    94,    95,
      96,    97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,   120,    -1,   122,   123,   124,   125,
     126,   127,   128,    -1,   130,   131,   132,   133,    -1,    -1,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,    -1,   163,   164,   165,
     166,   167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,
     176,   177,   178,   179,    -1,   181,   182,    -1,   184,   185,
     186,    -1,   188,   189,   190,   191,   192,    -1,   194,   195,
     196,   197,    -1,   199,   200,   201,   202,   203,   204,   205,
     206,    -1,   208,    -1,   210,   211,   212,   213,   214,   215,
     216,    -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,
     246,    -1,    -1,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,    -1,   284,    -1,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
      -1,   297,   298,   299,    -1,    -1,   302,   303,   304,    -1,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,    -1,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
     386,   387,   388,   389,   390,    -1,   392,   393,   394,   395,
      -1,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,    -1,
      -1,   417,    -1,   419,   420,   421,   422,   423,    -1,   425,
     426,   427,    -1,    -1,   430,   431,   432,   433,   434,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,    -1,
     446,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,    -1,   463,   464,   465,
     466,    -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   122,   123,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,    -1,    -1,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
     147,   148,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,    -1,   161,    -1,   163,   164,   165,   166,
     167,    -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
      -1,   188,   189,   190,   191,   192,    -1,   194,   195,   196,
     197,    -1,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
      -1,   218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,    -1,   241,    -1,    -1,   244,   245,   246,
      -1,    -1,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,    -1,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,   281,   282,    -1,   284,    -1,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,    -1,
     297,   298,   299,    -1,    -1,   302,   303,   304,    -1,   306,
      -1,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,   360,   361,    -1,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,   386,
     387,   388,   389,   390,    -1,   392,   393,   394,   395,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,    -1,    -1,
     417,    -1,   419,   420,   421,   422,   423,    -1,   425,   426,
     427,    -1,    -1,   430,   431,   432,   433,   434,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,    -1,   461,    -1,   463,   464,   465,   466,
      -1,    -1,   469,    -1,    -1,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    -1,   120,    -1,   122,   123,   124,   125,   126,   127,
     128,    -1,   130,   131,   132,   133,    -1,    -1,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,    -1,   163,   164,   165,   166,   167,
      -1,   169,    -1,   171,   172,    -1,    -1,    -1,   176,   177,
     178,   179,    -1,   181,   182,    -1,   184,    -1,   186,    -1,
     188,   189,   190,   191,   192,    -1,   194,   195,   196,   197,
      -1,   199,   200,   201,   202,   203,   204,   205,   206,    -1,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,    -1,
     218,    -1,   220,    -1,    -1,   223,    -1,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,    -1,   241,    -1,    -1,   244,   245,   246,    -1,
      -1,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
      -1,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,   281,   282,    -1,   284,    -1,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,    -1,   297,
     298,   299,    -1,    -1,   302,   303,   304,    -1,   306,    -1,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,   340,   341,   342,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,    -1,   363,   364,   365,   366,   367,
     368,    -1,   370,   371,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,   386,   387,
     388,   389,   390,    -1,   392,   393,   394,   395,    -1,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,    -1,    -1,   417,
      -1,   419,   420,   421,   422,   423,    -1,   425,   426,   427,
      -1,    -1,   430,   431,   432,   433,   434,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,    -1,   446,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,    -1,   461,    -1,   463,   464,   465,   466,    -1,
      -1,   469,    -1,    -1,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,   240,   241,   242,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,    -1,
     279,    -1,   281,   282,   283,   284,    -1,    -1,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,   304,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,    -1,   324,    -1,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,    -1,   413,   414,    -1,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,    -1,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,    -1,
     459,   460,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,    -1,   279,    -1,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,    -1,
     324,    -1,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,    -1,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,    -1,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,   240,   241,   242,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,    -1,   281,   282,   283,   284,    -1,    -1,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,    -1,   324,    -1,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,    -1,   413,   414,    -1,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,    -1,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,   282,   283,
     284,    -1,    -1,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,    -1,
     324,    -1,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,    -1,   413,
     414,    -1,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,    -1,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,   240,   241,   242,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,    -1,
     279,    -1,   281,   282,   283,   284,    -1,    -1,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,    -1,   324,    -1,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,    -1,   413,   414,    -1,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,    -1,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,    -1,   279,    -1,   281,   282,   283,
     284,    -1,    -1,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,    -1,
     324,    -1,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,    -1,   413,
     414,    -1,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,    -1,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,   240,   241,   242,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,    -1,
     279,    -1,   281,   282,   283,   284,    -1,    -1,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,    -1,   324,    -1,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,    -1,   413,   414,    -1,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,    -1,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,    -1,   279,    -1,   281,   282,   283,
     284,    -1,    -1,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,    -1,
     324,    -1,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,    -1,   413,
     414,    -1,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,    -1,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
      -1,    -1,   161,    -1,   163,   164,   165,   166,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,    -1,   218,
      -1,   220,   221,   222,   223,   224,   225,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,   240,   241,   242,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,    -1,    -1,
     279,    -1,   281,   282,   283,   284,    -1,    -1,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,    -1,   324,    -1,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,    -1,   413,   414,    -1,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,   426,   427,    -1,
      -1,   430,   431,    -1,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,    -1,
     459,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    -1,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    -1,    92,    93,
      94,    95,    96,    97,    -1,    99,   100,   101,   102,    -1,
      -1,    -1,   106,    -1,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    -1,   120,    -1,   122,   123,
     124,   125,   126,   127,   128,    -1,   130,   131,   132,   133,
      -1,    -1,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,   150,   151,   152,   153,
      -1,   155,   156,   157,   158,    -1,    -1,   161,    -1,   163,
     164,   165,   166,   167,    -1,   169,    -1,   171,   172,   173,
      -1,   175,   176,   177,   178,   179,    -1,   181,    -1,    -1,
      -1,   185,   186,    -1,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,    -1,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,    -1,   218,    -1,   220,   221,   222,   223,
     224,   225,    -1,    -1,    -1,    -1,   230,   231,   232,   233,
     234,   235,    -1,    -1,   238,    -1,   240,   241,   242,    -1,
     244,   245,   246,    -1,    -1,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,    -1,    -1,   279,    -1,   281,   282,   283,
     284,    -1,    -1,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,    -1,   297,   298,   299,    -1,    -1,   302,   303,
      -1,   305,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,    -1,
     324,    -1,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,   386,   387,    -1,   389,   390,   391,   392,   393,
     394,   395,    -1,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,    -1,   413,
     414,    -1,    -1,   417,   418,   419,   420,   421,   422,   423,
      -1,   425,   426,   427,    -1,    -1,   430,   431,    -1,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,    -1,   446,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,    -1,   459,    -1,   461,   462,   463,
     464,   465,   466,    -1,    -1,   469,    -1,    -1,   472,   473,
     474,   475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    -1,    -1,    54,    -1,    -1,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      -1,    -1,    71,    -1,    73,    74,    75,    76,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    92,    93,    94,    95,    96,    97,    -1,
      99,   100,   101,   102,    -1,    -1,    -1,   106,    -1,    -1,
      -1,   110,   111,   112,   113,   114,   115,    -1,    -1,   118,
      -1,   120,    -1,   122,   123,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,    -1,    -1,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,   150,   151,   152,   153,    -1,   155,   156,   157,   158,
      -1,    -1,   161,    -1,   163,   164,   165,    -1,   167,    -1,
     169,    -1,   171,   172,   173,    -1,   175,   176,   177,   178,
     179,    -1,   181,    -1,    -1,    -1,   185,   186,    -1,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,    -1,
     199,   200,   201,   202,   203,   204,   205,   206,    -1,   208,
     209,    -1,   211,   212,   213,   214,    -1,    -1,    -1,    -1,
      -1,   220,   221,   222,   223,   224,   225,    -1,    -1,    -1,
      -1,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
      -1,   240,   241,   242,    -1,   244,   245,   246,    -1,    -1,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,    -1,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,    -1,    -1,
     279,    -1,   281,   282,   283,   284,    -1,    -1,   287,    -1,
     289,   290,   291,    -1,   293,   294,    -1,    -1,   297,   298,
     299,    -1,    -1,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      -1,    -1,   321,   322,    -1,   324,    -1,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,   386,   387,    -1,
     389,   390,   391,   392,   393,    -1,   395,    -1,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,    -1,   413,   414,    -1,    -1,   417,   418,
     419,   420,   421,   422,   423,    -1,   425,    -1,    -1,    -1,
      -1,   430,   431,    -1,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,    -1,   446,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,    -1,
      -1,    -1,   461,   462,   463,   464,   465,   466,    -1,    -1,
     469,    -1,    -1,   472,   473,   474,   475,   476,   477,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    31,    33,    34,    51,    61,    73,    75,    76,
      82,    84,    96,    98,   115,   118,   133,   135,   139,   145,
     153,   155,   162,   180,   197,   244,   245,   250,   264,   282,
     319,   327,   341,   347,   348,   350,   355,   361,   364,   371,
     378,   379,   386,   390,   400,   416,   436,   447,   453,   458,
     471,   495,   497,   498,   499,   500,   501,   514,   521,   522,
     523,   524,   529,   530,   536,   537,   539,   540,   541,   542,
     544,   547,   559,   564,   565,   568,   569,   570,   588,   591,
     592,   607,   656,   659,   660,   663,   666,   667,   668,   676,
     683,   685,   686,   689,   692,   693,   697,   706,   710,   711,
     712,   715,   717,   718,   719,   720,   728,   730,   750,   754,
     756,   757,   767,   769,   776,   777,   780,   781,   782,   783,
     784,   793,   795,   797,   800,   804,   805,   815,   816,   821,
     826,   837,   869,   872,   873,   874,   879,   882,   884,   886,
     888,   889,   893,   894,   897,   899,   900,   904,   905,   906,
     909,   910,   911,   912,   913,   920,   922,   923,   924,   925,
     931,   933,   934,   940,   941,   942,   945,   946,   947,   948,
     950,   951,   953,   954,   956,   957,   959,   971,   973,   976,
     978,   979,   988,   990,   995,  1000,  1008,  1012,  1013,  1014,
    1015,  1016,  1017,  1023,  1059,   430,   474,   926,    28,    79,
      95,   113,   119,   137,   148,   157,   170,   176,   183,   203,
     234,   256,   297,   322,   332,   333,   336,   363,   366,   370,
     373,   380,   383,   402,   409,   414,   416,   419,   423,   433,
     438,   451,   464,   682,   926,     3,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    30,    31,    32,    40,    41,
      42,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    58,    59,    60,    61,    62,    63,
      64,    67,    68,    69,    70,    71,    73,    74,    75,    76,
      77,    79,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    92,    93,    94,    95,    96,    97,    99,   100,
     101,   102,   106,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   120,   122,   123,   124,   125,   126,   127,   128,
     130,   131,   132,   133,   136,   137,   138,   139,   140,   142,
     143,   144,   146,   147,   148,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   161,   163,   164,   165,   166,
     167,   169,   171,   172,   173,   175,   176,   177,   178,   179,
     181,   182,   184,   185,   186,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   199,   200,   201,   202,   203,
     204,   205,   206,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   218,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   238,
     239,   240,   241,   242,   244,   245,   246,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   281,   282,
     283,   284,   286,   287,   288,   289,   290,   291,   293,   294,
     297,   298,   299,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     321,   322,   323,   324,   325,   326,   327,   328,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   380,   381,   382,   383,   384,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   413,   414,   417,   418,   419,
     420,   421,   422,   423,   425,   426,   427,   430,   431,   432,
     433,   434,   436,   437,   438,   439,   440,   441,   442,   443,
     446,   447,   448,   449,   450,   453,   454,   455,   456,   457,
     458,   459,   461,   462,   463,   464,   465,   466,   469,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,  1120,
    1204,  1216,  1217,  1221,  1222,  1223,     3,    29,  1009,  1201,
    1216,  1221,   462,   514,   964,   295,   328,   926,    54,   514,
     599,    23,    41,    66,    79,   113,   119,   137,   148,   157,
     170,   179,   183,   246,   297,   300,   322,   336,   363,   373,
     383,   402,   409,   419,   420,   422,   423,   438,   445,   448,
     451,   608,   665,   772,   827,   838,    29,   327,  1201,  1009,
      29,   321,   381,   420,   422,     6,   233,   880,   881,  1207,
      23,    28,    66,    79,    95,   113,   137,   148,   157,   170,
     176,   183,   203,   256,   297,   310,   322,   333,   336,   363,
     366,   370,   373,   380,   383,   402,   409,   416,   419,   423,
     431,   433,   438,   451,   464,   682,   785,   787,   788,   926,
    1201,    98,   462,   514,   660,   663,   666,   959,   972,   976,
     979,   988,   995,  1000,  1008,  1012,    11,    22,    29,    49,
     165,   172,   174,   198,   235,   271,   330,   349,   505,   506,
     801,   802,  1009,  1206,  1208,    29,    31,    98,   345,   379,
     806,   807,   808,  1216,   170,  1216,  1203,  1207,   416,  1026,
     801,  1216,   355,   386,   390,   430,  1201,   310,   256,   514,
     892,   371,  1216,    29,   384,   426,   430,   551,   560,   561,
    1216,   180,   806,   807,  1216,   328,   926,  1216,   232,    29,
     134,  1028,  1029,    67,    92,   246,   266,   363,   373,   384,
     426,   430,   477,   548,   549,   550,   551,    29,   384,   426,
     430,   551,   430,   296,  1071,  1072,  1199,  1216,  1026,   507,
    1216,   175,   514,   965,   514,   343,  1018,  1019,  1201,  1018,
       3,    53,    55,    56,    69,    70,   116,   117,   138,   166,
     215,   216,   218,   267,   269,   288,   340,   388,   394,   426,
     427,   459,  1094,  1096,  1098,  1100,  1102,  1104,  1105,  1106,
    1108,  1109,  1110,  1112,  1113,  1217,  1221,  1028,  1029,  1030,
    1212,    12,  1213,  1214,  1216,  1213,  1213,  1013,  1014,  1017,
       0,   517,   514,   964,   149,   217,   301,   444,  1031,  1032,
    1013,  1015,  1016,   124,   213,   258,   450,   518,    35,   930,
     854,  1204,   790,  1216,   790,  1201,   331,   790,   433,  1201,
     112,   416,   842,  1204,  1216,  1223,     3,   105,   109,   385,
    1209,  1210,  1218,  1221,  1222,  1223,    29,   192,  1199,   289,
     464,    10,    17,    18,    19,    74,   161,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   876,   878,  1151,  1152,
    1216,   192,  1201,   842,  1201,    29,  1209,  1210,   842,  1201,
    1201,   192,  1199,  1201,   192,   790,  1201,   355,   386,    29,
     192,  1071,  1201,   376,  1201,   790,    29,   253,  1209,  1210,
     192,  1199,   233,   121,   223,   280,   339,   927,   928,   929,
     514,   512,   516,  1177,  1179,   492,   958,   959,   960,   961,
    1218,  1199,  1201,  1216,    28,    66,    80,    91,   113,   137,
     176,   203,   234,   297,   333,   363,   366,   409,   419,   431,
     438,   785,   786,   787,   788,  1207,   930,   975,   979,   988,
     995,  1000,  1012,  1199,   259,   790,   514,   192,   790,  1201,
     790,   433,   192,  1201,   112,   416,   420,   422,  1209,  1210,
     420,   422,    74,   161,   876,   353,  1201,  1201,  1209,   192,
     525,  1216,   192,  1201,   192,   526,   790,  1201,  1201,   376,
     790,   253,  1209,   343,   380,   416,   464,   256,    95,   203,
      28,    91,   176,   333,   370,   431,   433,   437,   677,    29,
    1201,  1010,   558,  1207,  1218,   881,   259,   192,   854,   855,
     192,   885,   192,  1201,   192,   792,  1094,   433,   112,   416,
     192,   841,   842,   192,  1210,  1211,    87,   464,    74,   161,
     192,   877,   878,    59,   192,   841,   192,  1211,   192,   841,
     192,  1201,   192,  1201,   376,   885,   192,   792,   192,   253,
    1211,   233,   192,   789,   790,   192,  1200,  1201,   192,  1201,
     930,   514,   977,   608,   972,   458,   958,   964,  1208,   802,
     803,    29,   803,  1208,   803,    29,   803,  1208,   803,   803,
     803,  1208,  1206,  1206,  1009,   803,   331,   514,   414,   514,
     633,   633,   633,   295,   428,   518,   633,   373,  1071,  1073,
     518,   921,   561,   549,   551,    29,   551,  1207,   514,   974,
      59,   464,   958,   113,   203,   373,   414,   416,   890,   891,
    1216,    48,   491,   223,   516,   298,   295,   174,   298,  1207,
     428,   930,   168,   798,   295,     5,     8,     9,    10,    12,
      37,    53,    55,    56,    65,    66,    69,    70,    77,    79,
     103,   104,   105,   106,   107,   108,   109,   116,   117,   119,
     154,   159,   160,   166,   182,   184,   215,   216,   218,   226,
     227,   228,   229,   239,   247,   248,   267,   269,   278,   280,
     285,   286,   288,   297,   308,   323,   340,   368,   385,   394,
     410,   415,   426,   427,   432,   434,   435,   445,   451,   459,
     479,   480,   481,   482,   484,   485,   486,   487,   493,   505,
     506,   507,   514,  1013,  1097,  1100,  1103,  1104,  1105,  1107,
    1108,  1109,  1112,  1113,  1117,  1119,  1120,  1121,  1123,  1147,
    1148,  1149,  1153,  1171,  1176,  1193,  1196,  1197,  1204,  1205,
    1206,  1207,  1216,  1195,  1196,  1207,    29,   566,  1198,  1199,
     384,   548,   119,   557,  1207,   558,  1207,    48,    71,   548,
     491,   395,   928,   298,   174,   428,   504,    48,   491,   223,
     929,   514,  1199,   507,  1179,  1073,   958,   173,   966,  1117,
    1156,  1018,   518,   514,   967,   461,  1111,  1111,  1111,   514,
    1099,  1099,   325,   514,  1101,    69,    70,  1111,  1099,  1096,
     495,   496,   514,  1114,   514,  1114,    37,  1095,   514,   114,
     190,   260,   263,   377,   489,   514,  1115,  1116,   516,   791,
    1099,  1195,  1180,   515,   515,   523,   958,   968,   969,   970,
    1199,    29,   134,  1027,  1027,    59,  1027,   162,   168,   243,
     292,  1035,  1037,  1038,  1053,  1055,  1056,  1057,  1031,  1032,
     174,   219,   219,  1071,  1074,   514,    68,   276,   311,   351,
     386,   514,   852,   311,   347,   351,   386,   791,   311,   351,
     386,     3,    90,   143,   249,   311,   319,   347,   351,   386,
     419,   421,   471,   559,   562,   935,   936,   937,   938,   822,
      25,   139,   311,   351,   386,   455,   575,  1201,    25,   139,
     386,   450,   543,   475,   192,  1071,    62,    97,   158,   195,
     238,   276,   280,   311,   312,   351,   360,   369,   378,   386,
     398,   407,   411,   466,   559,   563,   858,   870,   898,   514,
     839,  1179,   351,   543,   198,   154,    25,    31,    46,    76,
     132,   139,   142,   169,   205,   276,   280,   290,   299,   311,
     351,   354,   355,   386,   455,   571,   573,   574,   700,   898,
       5,   505,   506,   674,  1208,    29,   192,  1199,   790,   790,
     514,   875,   311,   386,   516,   154,   295,   311,   351,   386,
     870,   898,    25,   139,   311,   351,   386,   198,   538,   351,
     471,   495,   531,   538,   311,   351,   386,   870,   898,   295,
     311,   351,   154,    38,    60,   111,   201,   257,   261,   276,
     310,   351,   356,   380,   386,   400,   571,   671,   672,   311,
     351,   463,   700,   708,   154,   311,   351,   386,    25,    90,
     132,   139,   142,   311,   347,   351,   386,   393,   561,   549,
     198,   154,    46,   130,   276,   351,   386,   571,   572,   311,
     351,   355,   386,    88,   131,   314,   421,   295,    25,    31,
     139,   311,   351,   386,   589,   590,   538,   168,   351,   531,
     538,   154,   351,   386,   571,  1201,   241,   121,   296,   476,
     518,   927,    29,   134,   460,   507,   515,   847,  1117,  1157,
    1158,  1217,  1117,  1178,     3,    29,    33,    34,    35,    36,
      37,    38,    39,    43,    57,    65,    66,    72,    78,    80,
      91,    98,   103,   104,   105,   107,   108,   109,   119,   121,
     129,   134,   135,   141,   145,   149,   160,   162,   168,   170,
     174,   180,   183,   187,   198,   207,   217,   219,   236,   237,
     243,   247,   248,   280,   285,   292,   295,   296,   300,   301,
     320,   329,   345,   359,   379,   385,   396,   412,   415,   416,
     424,   428,   429,   435,   444,   445,   451,   452,   460,   467,
     468,   470,   471,   507,  1202,  1219,  1221,  1222,  1223,  1224,
    1177,   515,   518,   160,   295,   435,   555,   558,   674,   962,
     452,   955,   295,   854,   514,   790,  1201,  1094,   842,   289,
      74,   161,   878,   842,   842,   168,  1094,   790,  1201,  1201,
     515,   633,  1201,    72,  1094,   280,   174,   514,   758,   531,
      38,   949,  1201,   280,   531,   475,   192,  1199,   531,   790,
     790,   758,   448,   608,   295,   168,   471,   866,   531,   280,
      48,   545,   280,   438,   707,   280,   967,    90,   311,   684,
      88,   131,   314,   421,    38,   758,   168,   192,   531,   464,
     192,  1199,   192,   661,  1199,  1199,   464,   790,    87,   527,
    1204,   433,  1204,  1204,  1201,   168,  1201,   682,    40,    54,
     110,   212,   276,   375,   154,    63,   357,   518,   528,   154,
     514,   154,   531,   154,   518,   528,   475,   154,   518,   528,
     154,   518,   192,   789,   192,   790,   192,   790,   154,   518,
     528,  1211,   154,   528,   154,   154,   528,   154,   528,   154,
      88,   131,   314,   421,   168,   154,   528,   154,   168,   192,
     154,   518,   528,   154,   518,   528,   154,   295,  1156,   416,
     515,   972,   803,  1009,   803,  1009,   803,  1009,   803,  1009,
     803,  1009,  1009,  1009,   803,  1009,   514,   634,   635,  1216,
     634,    29,   113,   137,   170,   176,   233,   234,   313,   333,
     366,   373,   380,   416,   419,   438,   811,  1198,  1211,   808,
    1201,   198,   518,   991,  1207,  1094,  1160,    38,  1211,   527,
     515,   527,   527,   527,   241,  1216,   168,   811,  1211,   168,
     371,  1216,   558,   295,   514,  1180,   512,  1013,  1161,  1117,
    1175,   514,   514,   168,   514,   514,  1013,   514,   514,   514,
     514,   514,   514,   514,   514,   514,   514,   514,  1117,   514,
     514,   514,   514,   514,   514,   514,   514,   287,   624,   514,
     514,   514,   514,   514,   514,   514,   514,  1117,  1117,  1117,
    1013,  1117,  1156,  1179,  1207,   514,  1207,     3,    10,    13,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   164,
     165,   166,   167,   169,   170,   171,   172,   173,   175,   176,
     177,   178,   179,   181,   182,   184,   185,   186,   188,   189,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   218,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   261,   262,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   293,   294,   296,   297,
     298,   299,   300,   302,   303,   304,   305,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   320,   321,
     322,   323,   324,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   462,   463,   464,   465,   466,   467,
     469,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   490,   491,   493,   502,
     503,   504,   505,   506,   507,   508,   509,   510,  1151,  1153,
    1155,  1220,  1225,   472,  1134,   307,  1117,   163,  1135,   219,
     518,  1024,   514,  1207,  1179,  1024,   122,   194,   567,   518,
      71,   119,   558,    38,     3,   119,   246,   556,   674,  1113,
    1207,  1207,    93,   136,  1129,   102,   119,   552,   553,   555,
     674,   119,   552,   241,  1199,    94,   356,   794,   515,   964,
      35,    45,    52,    78,   193,   198,   221,   242,   297,   300,
     391,   515,   518,  1019,  1200,    38,   514,  1156,  1206,  1111,
    1111,    37,  1095,   426,   426,  1206,  1206,   512,   512,  1206,
     428,   428,   428,   514,   428,  1206,  1202,   516,  1099,   174,
    1060,    15,   504,  1177,  1215,   515,   518,   967,  1015,  1015,
    1033,  1034,  1117,  1015,   165,   271,  1044,   230,   276,   339,
     389,   450,    29,  1039,  1117,   505,   506,  1040,  1041,  1117,
    1119,  1053,  1054,  1038,  1037,  1035,  1036,   168,  1056,   290,
    1058,  1035,  1053,  1074,   980,  1199,  1074,    38,  1216,   386,
    1156,    68,   428,   428,   373,   198,   210,   301,   304,   388,
     460,   507,   845,   846,   847,   849,   851,   853,  1094,  1217,
     428,   463,   428,   373,   428,   428,   373,   243,   428,    79,
     428,   419,   548,   311,   935,   937,   504,   939,   168,   180,
     198,   361,   823,   824,    72,    91,   150,   170,   329,   445,
     630,   631,    91,   119,   280,   428,    91,   428,   119,   280,
     373,    91,   132,   142,   311,   351,   755,   373,   690,    28,
      66,   137,   176,   297,   333,   366,   431,   438,   785,   786,
    1201,   154,   351,   386,   571,   295,   674,   378,   238,   428,
    1216,   428,   285,   674,   123,   220,   373,   384,   430,   550,
     790,   357,   386,   858,   871,   127,   515,   840,   845,   428,
     451,   419,  1199,    80,   150,   192,   615,   630,  1216,    80,
      91,   895,   316,   295,   368,   370,   433,    91,   895,    32,
     354,   368,   370,   433,   368,  1199,   169,   205,   290,   790,
     514,   428,   428,   191,   514,   579,    23,   252,   419,   448,
     473,   579,    91,   518,   127,     5,     5,   311,   198,   154,
     351,   386,   571,   898,   452,   452,   277,  1094,   428,   373,
     514,   876,  1201,  1199,   428,   428,   373,   871,   127,   106,
     416,   417,   907,   908,  1072,  1199,  1216,   908,   428,   428,
     758,   908,   113,   386,   562,   428,   533,   562,   428,   428,
     373,   871,   127,  1199,   428,   428,  1199,  1096,   674,    59,
     673,   674,   674,   111,   257,   261,    59,   428,   531,   265,
     373,   531,   276,   672,   428,   428,   285,  1207,   700,   790,
     428,   428,   373,   402,   336,  1207,   336,   428,   336,   428,
     336,   758,   758,   419,  1071,   316,   316,    91,   428,   895,
     373,   428,   428,   579,   579,   790,   790,   790,   790,  1199,
      47,   457,    47,    47,   428,    47,   428,   457,   373,   514,
     518,   562,   451,   716,  1210,   428,   533,   562,  1199,   428,
     895,   373,   311,   351,   339,   352,   382,   554,   927,  1157,
    1157,  1158,   515,    15,    16,   518,  1031,  1032,   513,   519,
    1199,   960,  1201,  1199,   221,  1094,   221,   295,   221,   221,
     674,   790,   790,   221,   221,   221,  1094,   221,   221,   221,
     295,   428,   174,   428,   593,   438,   514,    38,   154,   790,
     759,   760,  1219,   935,  1094,   295,   154,   687,  1201,   280,
     316,   514,   532,   772,   452,   343,   464,  1199,    29,   908,
     758,   532,   154,  1210,    98,   180,   546,   607,   667,   730,
     804,   826,   931,   154,  1207,   708,   709,   154,   295,  1207,
    1210,   249,   790,   790,   790,   790,   146,   338,   514,   716,
     280,   532,  1199,   280,   669,   671,   280,    38,   290,   316,
     514,   633,   633,   192,   664,  1199,   168,   192,   525,  1216,
     514,   762,   852,  1201,   514,   843,   843,    38,  1094,    27,
      50,   214,   731,   233,   471,   473,  1011,   375,   855,   854,
    1094,  1201,   514,   792,  1094,   841,   842,  1211,  1210,   154,
     528,   154,   452,   154,   452,   877,   878,   528,   841,  1211,
     841,  1201,  1201,  1094,   792,  1211,   716,   154,   789,   790,
    1200,  1201,  1201,   790,   515,   192,  1199,   972,  1009,  1009,
    1009,  1009,  1009,  1009,   634,   515,   518,   515,   177,   334,
     367,   381,   417,  1200,   789,   112,   383,   841,  1200,   289,
     809,   810,  1216,   841,   841,  1200,  1198,  1198,  1200,   789,
     428,   181,   471,   820,   149,   243,   713,   714,    23,   152,
     368,   389,   992,  1071,   284,   993,   515,   518,   975,   428,
    1199,  1201,  1199,   525,   806,   807,   174,   820,   807,  1216,
      28,    80,   137,   176,   234,   333,   366,   438,   785,   786,
    1156,   513,  1156,  1161,  1162,   467,  1172,  1173,  1117,  1156,
     514,  1206,  1206,     3,   114,   190,   260,   263,   377,   489,
    1163,  1164,  1207,  1156,  1156,   359,  1013,  1014,  1117,  1182,
    1185,  1192,  1182,  1117,  1119,  1157,  1185,  1188,  1189,  1117,
    1189,  1156,  1206,  1206,  1117,  1117,   876,  1117,  1157,  1159,
    1166,   368,   505,   506,   514,  1118,  1119,  1153,  1167,   515,
    1156,  1117,  1159,  1168,  1117,    57,   174,   237,   429,  1117,
    1156,  1169,   134,   280,  1013,  1156,   265,  1119,  1117,  1127,
    1128,  1129,   265,  1117,  1129,   515,   518,  1206,  1115,  1094,
    1117,  1117,  1117,  1117,  1219,   426,    43,   412,  1181,   790,
    1117,   514,  1013,  1170,   134,   136,   160,   225,   272,   273,
     274,   275,   279,   280,   285,   435,   446,  1165,  1186,  1117,
     514,  1117,   428,    52,   193,   198,   242,   391,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,    29,    36,
     396,  1150,   183,  1135,   368,   514,  1147,   514,   306,  1139,
     179,   246,   416,   420,   422,   448,  1025,  1199,  1197,  1060,
    1157,  1060,  1199,   430,   514,  1207,   518,   515,   191,   191,
     528,   970,   959,   963,  1117,   515,   256,   280,  1020,  1156,
     515,   515,   512,   491,   491,   515,   515,  1206,   513,  1206,
     515,   190,   260,  1116,   260,  1116,  1116,  1206,   263,   515,
    1202,   236,   369,   488,   514,  1013,  1061,  1062,  1063,  1071,
    1077,  1087,  1120,  1122,  1123,  1193,  1216,   468,  1082,  1212,
     970,   968,   518,    39,   129,   452,   835,   368,   369,   505,
     506,  1041,  1043,  1119,   389,   230,   296,   518,     5,  1042,
    1206,  1042,   368,   369,  1043,  1198,   284,   393,   994,  1054,
    1036,   452,   989,   119,   309,   514,   981,  1012,    38,   452,
    1216,   514,   996,   997,   998,  1216,   515,  1210,  1201,  1201,
     304,    59,  1217,   515,   847,   849,   846,   849,  1217,   301,
     515,   518,   791,  1210,  1201,  1201,  1210,  1201,  1201,  1210,
     463,  1201,  1201,   119,   555,   674,   363,   451,   806,   373,
     180,   806,   514,  1201,   452,   828,   230,   230,   452,   624,
     655,   192,  1201,   285,  1210,  1201,  1201,  1117,   285,  1201,
    1201,    32,   354,   428,   428,  1201,   428,   691,   854,   514,
    1094,   842,    74,   161,   878,   842,   842,   168,  1094,   790,
    1201,   186,   276,   311,   351,   456,   694,   695,   696,  1071,
     428,   895,   373,   285,   123,   220,  1210,  1201,   295,  1201,
     295,   515,   518,  1209,  1211,  1201,   351,   571,   192,   615,
     280,  1094,  1201,  1206,  1216,  1199,  1201,   241,  1201,    29,
     451,  1201,   192,  1201,   192,  1216,   370,   433,   370,   433,
     241,  1201,    29,   451,  1201,   241,   368,  1199,    25,   139,
     386,   701,   702,   703,   704,  1219,  1210,  1201,   119,   175,
     281,   452,   578,   581,   582,  1219,   259,  1201,    76,   293,
    1201,   574,   295,   428,   419,  1199,   428,   895,   373,   127,
    1201,  1201,   518,   515,   518,  1210,  1201,   901,   902,  1219,
     295,   351,   428,   724,  1210,  1201,  1201,   295,  1071,   198,
     518,   633,   633,  1179,  1210,  1201,  1201,  1209,     3,    90,
     144,   205,   318,   443,   451,   454,   534,  1210,  1201,  1201,
     295,   351,  1210,  1201,   351,   386,   571,   671,   674,   790,
    1201,   674,   790,  1201,   674,  1210,  1201,   386,  1210,  1201,
    1201,  1208,  1200,  1200,  1210,   866,  1201,  1200,  1201,   351,
     386,   571,   572,  1199,  1199,  1201,  1201,  1201,  1201,  1210,
    1201,    25,    31,   139,   311,   351,   386,   311,   351,   386,
     758,   351,   386,   351,   386,   351,   898,  1086,  1216,   192,
     768,  1216,   192,  1216,  1210,  1201,  1201,  1207,  1201,   901,
      25,   590,   383,  1209,   351,   386,   571,  1201,  1201,  1201,
     428,   428,    85,   442,   339,   518,  1031,  1031,  1031,  1117,
    1117,   460,  1158,   515,  1117,  1178,   955,   285,   796,  1207,
      38,   796,   137,   790,   796,   796,   221,   452,   452,   796,
     796,   796,   233,   796,   796,   796,   790,   335,   594,   594,
     203,   416,   729,  1117,  1094,   790,   515,   518,   504,   621,
    1219,  1201,    63,   174,   373,   463,   688,   695,   696,   154,
     290,   242,   609,   611,   613,   615,   627,   630,    26,   198,
     363,   413,   534,   535,   168,  1201,   464,  1199,    38,   725,
     417,   866,   525,  1216,   545,   608,   838,  1201,   170,   790,
     514,   657,   658,  1122,  1216,   336,  1207,   758,   758,   758,
     758,   514,   758,  1084,  1085,  1086,   383,   154,   514,   154,
     154,   153,  1012,   790,   290,   609,  1216,   452,   650,   471,
     580,   280,    38,   633,  1207,   280,   295,     3,   763,   764,
     758,    27,   515,   844,   845,   850,    38,   233,   360,   431,
     470,   856,   857,   858,   859,   856,   295,   233,   290,   124,
     213,   436,   450,   732,   733,  1201,   189,   189,   168,   528,
      38,   531,   169,   943,   944,   528,   528,   789,   790,  1201,
     790,  1201,   528,   528,   528,   528,   233,   528,   383,   168,
     528,   528,   295,   528,   280,   515,   635,   198,   198,   198,
     198,   198,   475,  1200,   674,   675,   518,   516,   183,   812,
     813,  1210,    59,   817,   818,  1219,   428,   514,   174,   152,
     389,   152,   389,   368,   450,   262,  1094,  1210,   471,   662,
     295,   812,   528,   174,   854,   790,  1094,   842,   289,   842,
     842,  1094,   790,  1201,   515,   513,   513,   518,  1117,   141,
    1173,  1174,    38,   515,  1117,   515,   515,   515,   174,   515,
     515,  1094,   492,  1183,  1183,   515,    21,   285,   518,  1191,
     301,  1194,   519,   457,   515,   515,    21,   285,   518,  1190,
    1190,   515,   515,   515,   515,   518,   518,   515,   320,   515,
     515,   514,  1118,  1118,  1156,    13,    17,    18,    19,   198,
     221,   297,   502,   503,   504,   505,   506,   507,   508,   509,
     510,  1153,  1118,   515,   515,   168,   174,   391,   515,   515,
      38,  1169,  1156,  1169,  1169,   174,   515,   134,   515,  1219,
     317,  1132,    38,   515,   518,  1117,  1219,   518,  1117,  1180,
    1117,   515,   491,  1118,  1118,   147,  1156,   174,    37,   289,
     372,   457,   134,   136,   160,   279,   285,   435,   446,  1165,
    1186,   279,   471,   473,  1187,   147,   876,  1117,   412,  1181,
    1117,  1170,  1117,   428,   514,  1013,   514,  1139,   514,  1156,
     468,   514,  1140,  1216,   420,   422,   420,   422,  1199,  1026,
    1026,  1026,  1082,  1031,  1082,   928,  1206,  1115,   553,   970,
     256,   514,   515,  1206,  1114,  1114,   513,   513,   515,  1013,
    1077,  1087,   174,   514,  1013,  1062,  1063,    38,  1064,  1065,
    1216,   518,    99,   175,   209,   224,   240,   268,   362,  1068,
    1065,    38,  1064,  1067,  1216,  1065,   495,  1081,  1179,  1117,
     183,  1045,  1034,   297,  1151,  1154,   494,   836,     5,  1206,
    1043,   296,   471,   450,  1040,   251,  1061,   468,  1083,   458,
     414,   451,   982,   983,   984,  1216,   295,   985,  1216,  1062,
     998,   999,   518,  1060,   504,  1180,   853,   791,   849,   849,
      59,   851,   509,  1211,  1211,   295,  1200,   298,   295,  1117,
     631,  1201,   514,   514,   514,   655,   203,   514,   748,   154,
     528,   428,  1210,  1201,   558,  1094,   790,   790,  1094,   678,
    1201,   186,   456,   428,   428,   678,   694,   700,   351,   386,
     571,  1201,  1201,  1201,   211,   285,   157,   845,   310,   386,
     428,   280,   154,   405,   619,   620,   748,   386,    25,   139,
     355,   356,   386,   575,   583,   584,   700,   896,   378,   154,
     528,   154,   528,  1201,  1201,  1201,  1201,   378,   378,   241,
     703,   704,   703,   515,   518,   705,  1207,   203,   515,   518,
     504,   516,  1201,   157,  1210,  1201,   351,   386,   571,  1201,
    1201,  1201,   295,   311,   351,   386,    25,   139,   311,   351,
     386,  1094,   277,  1094,   515,   518,   504,  1199,   428,  1211,
     452,   721,   157,   633,   373,   907,   468,   640,   640,   633,
     243,   318,   285,  1207,   318,  1211,   449,   157,   428,   428,
     373,   402,   866,   866,   866,   310,   386,    91,   428,   895,
     373,   119,   168,   585,   164,   527,   428,   428,   253,   253,
     253,   428,   428,   373,   428,   428,   373,   428,   373,   428,
     373,   428,   127,   528,  1094,   280,  1207,   386,   896,   154,
     528,   428,   428,   515,  1201,   428,   895,   373,   428,  1210,
    1201,   515,   515,   515,  1158,   513,  1094,   790,   221,   796,
    1201,  1201,  1201,   221,   403,   404,   595,  1207,   595,   186,
     515,   515,   174,   758,   760,   277,   297,   505,   506,   674,
     761,   849,  1154,  1207,  1224,    72,    78,    91,   119,   121,
     178,   207,   280,   285,   329,   345,   445,   622,   623,   626,
     153,   467,   531,   558,  1201,   558,   299,   698,  1199,  1199,
    1199,   515,   518,  1211,   183,   363,  1211,  1206,   438,  1199,
     633,     3,   168,   726,   866,    48,   545,   416,   707,   112,
     967,  1117,   174,   518,  1200,   580,   765,   766,  1207,   515,
     518,  1201,   168,   634,  1199,   661,  1199,  1201,   662,   514,
     610,  1199,   515,  1201,   471,   473,   651,   579,    38,   154,
    1012,   650,   428,   154,  1071,   504,   515,   518,   732,   515,
     518,   119,   504,   860,  1207,   558,   416,   848,   849,   168,
     865,    51,   358,   861,   862,   859,   862,   124,   213,   379,
     450,   918,  1201,   290,   295,   300,   186,  1012,  1094,   514,
     515,   518,   528,   452,   528,   452,   528,  1201,  1201,   716,
     790,   154,   373,   373,   373,   373,   373,  1200,   518,   810,
    1216,  1210,   471,   518,   814,  1210,   518,   820,   160,   298,
     435,   819,  1073,   383,   152,   152,   112,   276,   811,   820,
    1211,   221,   221,   221,   221,   674,   221,   221,   221,   221,
     221,  1161,   424,  1117,   145,  1094,   515,  1117,  1183,   225,
    1185,   295,   295,  1182,  1185,    59,  1191,  1182,  1182,   295,
     295,  1189,  1187,  1187,  1165,  1117,  1117,   515,  1156,   518,
    1094,  1118,  1118,  1118,  1118,   134,   136,   280,  1118,  1118,
    1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1117,  1117,
    1117,  1094,   515,   515,   515,  1156,   515,   518,    59,  1119,
    1133,   515,  1219,  1128,   326,   408,  1131,   515,   518,   463,
    1124,    38,   515,  1207,  1117,    35,    35,  1117,   515,  1117,
     174,   279,  1187,   445,   445,  1117,   515,   147,  1118,  1118,
     147,   147,  1117,  1117,  1032,   515,  1156,   518,  1117,  1141,
    1216,  1026,  1026,  1026,  1026,  1199,  1199,  1199,  1045,   515,
    1045,   515,   975,   513,  1065,  1067,  1065,   514,   483,  1119,
     515,  1216,   514,  1062,   224,   305,  1069,  1062,  1069,   224,
    1068,  1069,   224,   418,  1075,   514,  1216,   514,   302,    59,
     187,  1052,   514,   836,   165,   235,   296,   471,   425,   102,
    1117,   359,   987,   457,   515,   518,  1180,    89,   987,   295,
     515,   518,   997,  1083,  1117,   515,   509,   853,   438,   177,
     367,   374,   381,   417,   439,   825,   168,   825,   515,   514,
     638,   639,   831,  1122,  1216,   634,   634,   748,  1201,   634,
     121,   207,   276,   280,   749,  1201,  1201,    38,   452,   452,
     233,   791,  1210,  1201,   428,   895,   373,   428,   211,  1201,
      59,   419,  1201,   154,   615,   119,  1216,    86,   617,   618,
     402,   178,   156,   191,   280,   579,   531,   112,   178,   280,
     402,   579,   617,   619,   672,   386,   584,   438,  1201,  1216,
     378,   702,  1201,   582,   761,  1219,  1201,   310,   386,   428,
     895,   373,   428,   157,   428,   428,   373,   176,   297,   405,
     770,   771,   176,   297,   778,   779,   428,   428,   373,   515,
     515,   515,   902,   277,   674,   849,   903,  1154,  1207,  1224,
     351,  1201,   514,   471,   722,  1201,   640,   106,  1216,   514,
     640,  1208,  1207,  1207,  1207,  1201,  1201,  1201,  1201,  1208,
      59,   419,  1201,  1201,  1201,  1201,   458,  1201,  1201,   168,
     168,   353,   168,   192,  1210,  1201,  1201,  1210,  1201,  1201,
    1201,  1201,  1201,  1201,  1201,   295,    78,   576,   154,    27,
      50,   438,  1216,  1201,  1207,   700,  1201,  1201,  1201,  1201,
    1031,   515,   221,   796,   221,   221,   221,   796,   531,   452,
     600,   601,   678,   748,   471,   473,   790,   514,   790,  1201,
    1118,    32,    59,   625,   122,   194,   121,   285,   230,  1199,
     624,   176,   333,   744,   751,   752,  1216,   687,   514,   316,
     514,   610,   628,   206,   645,   613,  1211,  1211,  1094,   514,
     580,    29,   124,   213,   379,   450,   727,   428,   723,  1210,
     192,  1199,   709,   475,   295,   515,  1061,   658,   866,   515,
     518,  1086,   698,   716,   515,   669,    38,   290,   316,   514,
     977,   612,   614,   616,   630,  1216,   316,   646,   647,   610,
     645,   579,   293,   295,   652,  1012,   664,   662,   580,  1207,
    1201,   828,   761,     3,   764,   295,   850,  1117,  1117,   518,
     514,   856,   438,   518,    44,  1117,   428,   514,   634,  1199,
     733,   678,   515,   943,   944,  1201,  1201,   528,   383,   528,
    1200,  1200,  1200,  1200,  1200,   674,   180,   813,   820,   818,
     515,  1201,   112,   174,   528,   820,   285,   799,  1207,   799,
     799,   799,   221,   799,   799,   799,   799,   799,  1117,   515,
     143,  1184,   515,   285,   285,   515,  1033,  1185,   285,   285,
    1185,  1185,   515,   515,   174,   515,  1117,   174,   134,   136,
     174,   168,   147,   515,   478,  1126,  1156,   344,   457,    59,
    1133,  1119,   469,   469,   515,  1117,   276,  1117,   518,  1125,
    1096,  1117,  1117,  1117,   231,   231,  1117,    35,    35,  1117,
    1117,   147,   515,   515,   515,  1117,   515,   316,  1142,  1199,
    1199,  1199,  1199,  1052,  1207,  1052,  1207,   515,  1078,  1079,
    1122,   514,  1132,  1064,   514,  1200,  1062,   295,   452,  1070,
    1062,   224,  1062,  1204,  1085,   514,  1085,  1216,  1027,  1117,
     470,  1136,   876,   425,   290,  1196,  1012,   309,  1012,   984,
     295,   514,   986,  1117,   504,   998,   987,   438,   515,   428,
     806,   174,   748,  1117,   515,   518,   471,    78,   830,   834,
     830,   515,   515,   515,   122,   194,   205,   121,   454,   528,
    1094,  1201,  1201,  1201,  1201,  1201,  1201,  1201,  1211,  1201,
     615,   119,  1216,   698,  1208,   625,   192,   192,   285,   674,
     625,   285,  1208,  1094,   528,   528,   504,    59,   419,  1201,
    1201,  1201,  1201,  1201,  1210,  1201,  1201,  1206,  1206,  1094,
     518,  1206,  1206,   518,  1210,  1201,  1201,   428,  1117,    72,
    1117,  1211,  1201,   428,   428,   174,   198,   471,  1200,  1200,
     790,  1200,   154,   157,   790,  1207,  1207,  1094,   528,   528,
     428,   515,   221,   796,   796,   796,   796,   514,   596,   597,
     531,   126,   176,   210,   176,  1117,   280,   623,   119,    38,
     866,   633,   866,  1204,    35,   153,   198,   699,   703,   290,
     609,   585,   151,   200,   514,   383,   452,   634,    38,  1211,
     721,   545,   280,   514,   170,  1201,   657,  1207,   383,   580,
     153,  1012,   790,   290,   609,   662,   515,   518,   471,   621,
      59,   650,   585,   646,    84,   419,   653,   471,   932,    38,
     653,   174,   295,   514,  1199,  1207,   847,   867,   868,  1217,
     862,  1094,   168,   863,  1199,   174,   428,   887,   346,   734,
     208,   679,   528,   515,   528,   528,  1201,   298,   219,   812,
     528,   799,  1201,   515,   515,   515,  1117,   515,  1118,   174,
    1117,  1117,  1117,   514,   515,   518,   515,  1133,   515,   457,
     399,   515,   202,   276,  1130,  1117,  1117,  1117,   515,    59,
    1031,  1136,  1136,   376,  1021,   515,   518,    38,  1080,   119,
    1092,  1093,  1118,    81,  1200,   515,  1117,   514,  1062,  1070,
     514,   515,  1085,   515,   101,   184,   365,   514,  1046,  1047,
    1048,  1049,  1050,  1051,  1117,  1137,  1138,  1216,  1031,   515,
    1009,   982,    91,   829,   831,   135,   467,  1001,  1002,  1117,
     812,   295,   812,   515,   199,   636,   639,   297,   876,   790,
     526,   790,   345,   636,   636,   515,   428,   386,   993,   621,
      38,   154,   154,   576,   761,  1211,  1201,   428,   514,   842,
     876,   878,   771,   514,   514,   779,  1201,   515,   514,   515,
     386,   993,  1201,  1201,   514,   514,   514,   471,   495,   952,
     353,   952,   952,   168,  1201,   576,  1201,   796,   602,   603,
    1219,    54,   100,   125,   143,   147,   169,   173,   188,   285,
     337,   598,   596,  1207,   842,    38,   883,   883,   515,   191,
     514,   452,   654,   254,   637,   654,   514,   752,   744,   514,
     515,   518,  1199,   515,   383,    29,    83,    86,    92,   120,
     178,   191,   204,   402,   405,   629,   629,  1198,  1201,  1201,
     515,  1012,   722,   154,   112,   698,   174,  1201,    38,  1201,
     662,   610,  1199,   515,   614,   299,  1216,   651,   646,   650,
     124,   139,   326,  1201,    64,    72,   246,  1012,   790,  1071,
     829,   174,   747,   849,   515,   518,   438,   145,   524,   861,
     864,  1082,   397,   397,   515,   270,   294,   735,   736,   737,
     168,   740,   678,   276,   456,   680,   681,  1201,   820,   168,
    1118,  1127,  1156,   276,   490,   202,   515,  1156,   185,   338,
     369,  1143,    58,   128,   111,  1022,  1081,  1078,   514,  1118,
     515,   518,    38,  1088,  1089,  1216,   515,  1200,  1156,   515,
     514,   387,   514,   515,   518,   518,    38,  1036,   457,  1201,
     515,   518,   281,   450,   255,   280,  1002,   814,   825,   528,
     830,   514,   866,   514,   835,   579,  1199,   866,   866,  1201,
     419,   191,   452,   577,   386,   993,  1201,  1160,   168,   774,
     774,  1160,  1160,  1117,   419,  1156,  1156,   586,   587,  1218,
     789,   790,   789,   790,  1200,   528,   515,   518,   507,   514,
     555,   604,   674,   949,  1207,   949,   280,   285,   337,   949,
     949,  1082,   883,    42,   196,   276,   632,   514,   670,  1117,
     203,   175,   315,   392,   295,   641,   642,   643,   515,  1204,
       6,   753,   703,   610,   645,  1201,   515,   698,   161,   773,
     580,   932,  1199,   475,  1061,   698,  1012,   977,   646,   610,
     645,   621,   514,   652,   650,   651,   369,   369,    72,   298,
      72,   662,   828,   515,  1199,   748,   856,   867,  1094,   517,
     135,   471,   471,   736,   368,   416,   738,   140,   741,   467,
     743,   456,   678,   698,   528,  1117,   515,   515,   457,    52,
     102,   441,  1117,  1144,  1145,  1144,  1144,   515,   165,   165,
     634,  1085,   518,  1093,  1219,   515,   518,   168,  1094,   515,
     515,  1156,   514,  1156,  1047,  1138,  1140,  1054,  1012,  1082,
     831,   386,    35,  1003,   255,   174,   634,   654,   876,   836,
     835,   633,   654,   654,  1201,   670,  1117,   419,   515,   301,
     376,   342,   775,   775,   515,   515,   515,  1201,   515,   515,
     515,   518,  1206,   952,   603,   555,   605,   606,  1207,  1207,
     285,   634,   507,   634,  1207,  1207,   205,   671,   515,   419,
     124,   450,   295,   643,   295,   642,   514,   515,   518,   585,
     383,   698,   790,    38,    38,   514,  1201,   932,   662,   650,
     585,   646,   514,   648,   649,  1122,  1216,   653,   651,   652,
     298,   298,   514,   199,   832,   168,   862,    30,   214,   919,
     176,   176,   949,   368,   401,   742,   514,   153,  1145,   368,
     167,   324,   167,   324,   150,  1146,  1146,  1146,    59,    59,
     386,   515,  1119,  1089,   302,     3,   119,   280,   285,  1090,
    1091,    38,  1066,   352,  1076,   515,  1046,   515,   996,  1117,
     424,  1003,   812,   515,   640,   515,   836,   637,   748,   748,
     993,  1201,   842,    59,   993,   428,   586,   790,   515,   518,
     634,   515,   406,  1201,    63,   276,   357,   386,   644,   644,
     515,     6,   383,  1201,   770,  1012,   698,   651,   646,   650,
    1117,   515,   518,   834,   834,   652,   653,   829,   514,   624,
     140,   281,   514,   914,   916,   920,   979,   988,   995,  1012,
    1023,   842,   842,   739,  1216,  1117,   744,    35,   102,   183,
     276,   425,   634,   634,  1216,  1132,  1118,  1118,   285,  1091,
    1216,   514,   515,  1082,   124,   135,   450,  1004,  1005,   424,
     528,   748,   641,   993,   790,   514,   606,    24,   119,   285,
    1201,   698,   932,   652,   650,   651,   515,   649,   526,   526,
     653,   515,   831,   833,   580,   368,   915,   916,   917,  1013,
    1014,   518,   518,   515,  1204,  1145,   368,   303,   386,   386,
     428,   452,    81,  1117,   281,   386,   135,   213,  1006,   748,
    1156,   633,   633,   698,   653,   651,   652,   834,   832,   515,
     518,   653,   743,   515,   517,   428,   174,   514,  1216,  1216,
    1204,  1205,  1216,  1088,   515,   996,   281,   119,   309,   458,
     514,  1007,   515,   652,   653,   526,   624,   831,  1082,   153,
     917,   397,   397,     5,   745,   746,  1206,  1207,  1219,   514,
     119,   515,   458,   982,   514,   983,   653,   580,   744,   471,
     471,   515,   518,  1157,  1205,   457,  1156,   515,   653,  1204,
     176,   176,   746,  1031,   452,  1007,   515,   309,  1007,  1082,
     514,   842,   842,   515,  1216,   982,   745,   457,   515,  1007
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   520,   521,   521,   521,   521,   521,   521,   522,   522,
     523,   523,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   524,   524,   524,
     524,   524,   524,   524,   524,   524,   524,   525,   525,   526,
     526,   527,   527,   528,   528,   528,   529,   530,   531,   531,
     531,   532,   532,   533,   533,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   535,   535,   535,   535,   535,   535,
     536,   537,   537,   538,   538,   539,   539,   539,   539,   540,
     540,   540,   540,   540,   540,   541,   542,   543,   543,   544,
     544,   544,   544,   545,   545,   546,   546,   546,   546,   546,
     546,   547,   547,   547,   547,   548,   548,   548,   549,   549,
     549,   549,   550,   550,   550,   550,   550,   550,   550,   550,
     550,   550,   550,   551,   551,   552,   552,   553,   553,   554,
     554,   554,   554,   555,   555,   555,   555,   556,   556,   556,
     556,   556,   556,   556,   557,   557,   557,   558,   558,   559,
     559,   560,   560,   560,   560,   561,   561,   562,   562,   563,
     563,   564,   564,   564,   564,   564,   564,   564,   565,   566,
     566,   567,   567,   568,   569,   569,   569,   569,   569,   570,
     570,   570,   570,   570,   570,   570,   570,   570,   570,   570,
     570,   570,   570,   570,   570,   570,   570,   570,   570,   570,
     571,   571,   572,   572,   572,   573,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   575,   575,   576,   576,
     577,   577,   578,   578,   578,   578,   579,   580,   580,   581,
     581,   582,   582,   582,   582,   583,   583,   584,   584,   584,
     584,   585,   585,   585,   585,   586,   587,   587,   588,   589,
     589,   590,   590,   590,   590,   591,   591,   592,   592,   593,
     593,   594,   594,   595,   595,   595,   596,   596,   597,   597,
     598,   598,   598,   598,   598,   598,   598,   598,   598,   598,
     598,   598,   598,   599,   599,   600,   600,   601,   601,   602,
     602,   603,   604,   604,   604,   604,   604,   605,   605,   606,
     607,   607,   607,   607,   607,   607,   608,   608,   608,   608,
     608,   608,   608,   608,   609,   609,   610,   610,   611,   611,
     612,   612,   613,   613,   613,   614,   614,   615,   616,   616,
     617,   617,   618,   618,   619,   619,   620,   620,   621,   621,
     622,   622,   622,   622,   623,   623,   623,   623,   623,   623,
     623,   623,   623,   624,   624,   624,   625,   625,   626,   626,
     626,   626,   627,   628,   628,   628,   629,   629,   629,   629,
     629,   629,   629,   629,   629,   629,   630,   630,   631,   631,
     631,   631,   631,   631,   631,   632,   632,   633,   633,   634,
     634,   635,   636,   636,   637,   637,   637,   637,   638,   638,
     639,   639,   640,   640,   641,   641,   641,   641,   641,   642,
     643,   644,   644,   644,   644,   644,   645,   645,   646,   646,
     647,   648,   648,   649,   649,   649,   650,   650,   651,   651,
     651,   652,   652,   652,   652,   653,   653,   654,   654,   655,
     656,   656,   657,   657,   658,   658,   658,   659,   659,   660,
     660,   661,   662,   662,   662,   663,   663,   664,   665,   665,
     666,   667,   667,   668,   668,   669,   669,   670,   670,   671,
     671,   672,   672,   672,   672,   672,   672,   672,   672,   672,
     672,   672,   672,   672,   672,   673,   673,   674,   674,   674,
     674,   675,   675,   676,   676,   677,   677,   678,   678,   679,
     679,   680,   680,   681,   681,   682,   682,   683,   684,   684,
     685,   685,   686,   686,   687,   687,   688,   688,   688,   688,
     689,   690,   690,   691,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   693,   694,   694,
     694,   694,   695,   695,   696,   696,   697,   697,   698,   698,
     699,   699,   700,   701,   701,   702,   702,   702,   702,   703,
     704,   705,   706,   706,   707,   707,   708,   708,   709,   709,
     710,   710,   710,   711,   711,   711,   711,   712,   713,   713,
     714,   714,   715,   715,   716,   716,   717,   717,   718,   719,
     720,   721,   721,   722,   722,   723,   723,   724,   724,   725,
     725,   726,   726,   727,   727,   727,   727,   727,   728,   729,
     729,   730,   730,   731,   731,   731,   732,   732,   733,   733,
     733,   733,   733,   734,   734,   735,   735,   736,   737,   737,
     738,   738,   739,   740,   740,   741,   741,   742,   742,   743,
     743,   744,   744,   745,   745,   745,   746,   746,   746,   746,
     747,   747,   748,   748,   749,   749,   749,   749,   749,   749,
     750,   750,   751,   751,   752,   753,   753,   754,   755,   755,
     755,   755,   756,   757,   757,   757,   757,   757,   757,   757,
     757,   757,   757,   757,   757,   757,   757,   757,   757,   758,
     759,   759,   760,   760,   761,   761,   761,   761,   761,   761,
     762,   763,   763,   764,   765,   765,   766,   766,   767,   767,
     767,   767,   768,   768,   769,   770,   770,   771,   771,   771,
     771,   771,   772,   772,   773,   773,   774,   774,   774,   775,
     775,   776,   777,   777,   778,   778,   779,   779,   780,   780,
     781,   781,   782,   783,   784,   784,   784,   784,   784,   784,
     784,   784,   784,   784,   784,   784,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   786,
     786,   786,   786,   786,   787,   787,   787,   787,   787,   787,
     787,   787,   788,   788,   788,   789,   789,   790,   790,   791,
     791,   792,   792,   793,   794,   794,   794,   795,   795,   795,
     795,   795,   795,   795,   795,   795,   795,   795,   795,   795,
     795,   795,   795,   795,   795,   796,   796,   797,   797,   797,
     797,   797,   797,   797,   797,   797,   797,   798,   798,   799,
     799,   800,   800,   801,   801,   801,   801,   801,   801,   801,
     801,   801,   801,   801,   801,   801,   801,   801,   801,   802,
     802,   803,   803,   804,   805,   805,   806,   806,   806,   806,
     806,   807,   807,   808,   808,   808,   808,   808,   809,   809,
     810,   810,   811,   811,   811,   811,   811,   811,   811,   811,
     811,   811,   811,   811,   811,   811,   811,   811,   811,   811,
     811,   811,   811,   812,   812,   813,   813,   814,   814,   815,
     815,   816,   816,   817,   817,   818,   819,   819,   819,   820,
     820,   821,   822,   822,   823,   823,   823,   824,   824,   824,
     825,   825,   825,   825,   825,   825,   826,   826,   827,   827,
     828,   828,   829,   829,   830,   830,   831,   831,   831,   832,
     832,   833,   833,   834,   834,   835,   835,   835,   836,   836,
     836,   837,   837,   837,   837,   838,   838,   839,   839,   840,
     840,   841,   841,   842,   842,   842,   842,   843,   843,   844,
     844,   845,   845,   845,   845,   845,   846,   846,   846,   846,
     846,   847,   848,   849,   849,   849,   850,   850,   850,   851,
     852,   852,   852,   852,   853,   853,   854,   855,   855,   856,
     856,   857,   857,   858,   858,   858,   858,   858,   858,   858,
     858,   858,   858,   858,   858,   858,   858,   858,   858,   858,
     859,   859,   859,   859,   859,   860,   860,   861,   862,   862,
     862,   863,   863,   864,   864,   865,   865,   866,   866,   867,
     868,   868,   869,   869,   869,   870,   870,   871,   871,   872,
     872,   872,   872,   872,   872,   873,   873,   874,   874,   875,
     875,   875,   875,   876,   876,   877,   877,   878,   879,   880,
     880,   881,   881,   882,   882,   882,   883,   883,   883,   884,
     885,   885,   886,   887,   887,   887,   887,   888,   889,   889,
     889,   890,   890,   891,   891,   892,   892,   893,   893,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   895,   895,   896,   896,   897,   897,
     897,   897,   897,   897,   898,   898,   899,   899,   899,   899,
     899,   899,   899,   899,   899,   899,   899,   899,   899,   899,
     899,   899,   899,   899,   899,   899,   899,   899,   899,   899,
     899,   899,   899,   900,   901,   901,   902,   902,   903,   903,
     903,   903,   903,   904,   905,   905,   905,   905,   905,   905,
     905,   905,   905,   905,   905,   905,   905,   905,   905,   905,
     905,   905,   905,   905,   905,   905,   905,   905,   906,   906,
     906,   907,   907,   907,   907,   907,   907,   907,   908,   908,
     909,   909,   909,   909,   910,   911,   911,   911,   911,   911,
     911,   911,   911,   911,   912,   912,   913,   914,   914,   914,
     915,   915,   916,   916,   916,   916,   916,   917,   917,   918,
     918,   918,   918,   919,   919,   919,   920,   921,   921,   922,
     923,   923,   924,   924,   924,   924,   924,   924,   924,   924,
     924,   924,   924,   924,   925,   925,   926,   926,   926,   927,
     927,   927,   927,   927,   928,   928,   928,   929,   929,   930,
     930,   930,   931,   931,   931,   931,   932,   932,   932,   932,
     933,   934,   935,   935,   936,   936,   937,   937,   937,   938,
     938,   938,   938,   938,   938,   938,   939,   939,   940,   940,
     940,   940,   941,   942,   942,   942,   942,   943,   943,   944,
     945,   946,   946,   947,   948,   948,   948,   948,   948,   948,
     948,   949,   949,   950,   951,   951,   951,   951,   951,   951,
     952,   952,   953,   954,   954,   954,   954,   955,   955,   956,
     956,   957,   957,   958,   958,   959,   959,   960,   961,   961,
     961,   962,   962,   962,   963,   963,   964,   964,   965,   965,
     966,   966,   967,   967,   968,   969,   969,   970,   970,   971,
     971,   971,   971,   972,   972,   972,   972,   972,   972,   972,
     972,   972,   972,   973,   974,   974,   975,   975,   975,   975,
     975,   976,   976,   976,   977,   977,   978,   978,   978,   978,
     979,   980,   980,   981,   981,   981,   981,   981,   982,   982,
     983,   983,   984,   985,   985,   985,   986,   986,   986,   987,
     987,   988,   989,   989,   990,   991,   991,   992,   992,   992,
     992,   992,   992,   992,   992,   993,   993,   994,   994,   994,
     995,   996,   996,   997,   997,   998,   999,   999,  1000,  1001,
    1001,  1002,  1002,  1002,  1002,  1002,  1003,  1003,  1004,  1005,
    1006,  1006,  1006,  1006,  1006,  1007,  1008,  1009,  1010,  1010,
    1010,  1010,  1010,  1010,  1011,  1011,  1011,  1012,  1012,  1013,
    1013,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1015,
    1015,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1017,  1017,
    1017,  1018,  1018,  1019,  1020,  1020,  1020,  1021,  1021,  1021,
    1022,  1022,  1022,  1023,  1023,  1024,  1024,  1025,  1025,  1025,
    1025,  1025,  1025,  1025,  1025,  1025,  1026,  1026,  1027,  1027,
    1027,  1028,  1028,  1029,  1029,  1030,  1030,  1031,  1031,  1032,
    1033,  1033,  1034,  1034,  1035,  1035,  1035,  1035,  1036,  1036,
    1037,  1037,  1037,  1037,  1037,  1037,  1038,  1038,  1039,  1039,
    1040,  1041,  1041,  1041,  1042,  1042,  1043,  1043,  1044,  1044,
    1045,  1045,  1046,  1046,  1047,  1047,  1047,  1047,  1047,  1048,
    1049,  1050,  1051,  1052,  1052,  1053,  1053,  1054,  1054,  1055,
    1055,  1056,  1057,  1057,  1057,  1057,  1058,  1058,  1059,  1059,
    1060,  1060,  1061,  1061,  1062,  1062,  1062,  1062,  1062,  1062,
    1062,  1062,  1062,  1062,  1063,  1063,  1063,  1063,  1063,  1063,
    1064,  1064,  1064,  1064,  1065,  1065,  1066,  1066,  1067,  1067,
    1067,  1067,  1067,  1068,  1068,  1068,  1068,  1069,  1069,  1070,
    1070,  1071,  1071,  1072,  1072,  1072,  1073,  1073,  1074,  1074,
    1074,  1075,  1076,  1076,  1077,  1077,  1078,  1079,  1079,  1080,
    1080,  1081,  1081,  1082,  1082,  1083,  1083,  1083,  1084,  1084,
    1085,  1085,  1086,  1087,  1087,  1088,  1088,  1089,  1089,  1089,
    1090,  1090,  1091,  1091,  1091,  1091,  1092,  1092,  1093,  1093,
    1094,  1094,  1094,  1094,  1094,  1094,  1095,  1095,  1095,  1096,
    1096,  1096,  1096,  1096,  1096,  1096,  1097,  1097,  1097,  1097,
    1098,  1098,  1099,  1099,  1100,  1100,  1100,  1100,  1100,  1100,
    1100,  1100,  1100,  1100,  1100,  1101,  1101,  1102,  1102,  1103,
    1103,  1104,  1105,  1106,  1106,  1107,  1107,  1108,  1109,  1110,
    1110,  1110,  1110,  1110,  1110,  1111,  1111,  1112,  1112,  1112,
    1112,  1113,  1114,  1114,  1114,  1115,  1115,  1115,  1115,  1115,
    1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,  1115,  1116,
    1116,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,
    1117,  1117,  1117,  1117,  1117,  1117,  1117,  1117,  1118,  1118,
    1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,
    1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,
    1119,  1119,  1119,  1119,  1119,  1119,  1119,  1119,  1119,  1119,
    1119,  1119,  1119,  1119,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1121,  1121,  1121,  1122,  1122,  1122,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,
    1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,  1123,
    1124,  1124,  1125,  1125,  1125,  1125,  1126,  1127,  1127,  1128,
    1128,  1129,  1129,  1130,  1130,  1130,  1131,  1131,  1131,  1132,
    1132,  1132,  1132,  1133,  1133,  1134,  1134,  1135,  1135,  1136,
    1136,  1137,  1137,  1138,  1139,  1139,  1139,  1140,  1141,  1141,
    1142,  1142,  1143,  1143,  1143,  1143,  1144,  1144,  1145,  1145,
    1145,  1145,  1145,  1146,  1146,  1146,  1146,  1146,  1147,  1147,
    1147,  1148,  1148,  1149,  1150,  1150,  1150,  1151,  1151,  1152,
    1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1153,  1153,  1154,  1154,  1155,  1155,  1155,  1155,  1155,
    1155,  1156,  1156,  1157,  1157,  1158,  1158,  1158,  1159,  1159,
    1160,  1160,  1161,  1161,  1161,  1162,  1162,  1163,  1164,  1164,
    1164,  1164,  1164,  1164,  1164,  1164,  1165,  1165,  1165,  1165,
    1166,  1166,  1167,  1168,  1168,  1168,  1168,  1168,  1169,  1169,
    1169,  1170,  1170,  1171,  1172,  1172,  1173,  1174,  1174,  1175,
    1175,  1176,  1176,  1177,  1177,  1177,  1177,  1178,  1178,  1179,
    1179,  1180,  1180,  1181,  1181,  1182,  1183,  1183,  1184,  1184,
    1185,  1185,  1186,  1186,  1186,  1186,  1186,  1187,  1187,  1187,
    1187,  1187,  1188,  1188,  1189,  1189,  1190,  1190,  1190,  1191,
    1191,  1191,  1192,  1192,  1193,  1193,  1194,  1194,  1195,  1195,
    1196,  1196,  1197,  1197,  1197,  1197,  1198,  1198,  1199,  1199,
    1200,  1200,  1201,  1202,  1203,  1204,  1204,  1205,  1205,  1205,
    1205,  1205,  1205,  1205,  1205,  1205,  1205,  1205,  1205,  1205,
    1206,  1207,  1208,  1208,  1208,  1209,  1210,  1210,  1210,  1210,
    1211,  1211,  1212,  1213,  1214,  1214,  1215,  1215,  1216,  1216,
    1216,  1217,  1217,  1217,  1218,  1218,  1218,  1218,  1219,  1219,
    1219,  1219,  1219,  1220,  1220,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,  1222,
    1222,  1222,  1222,  1222,  1222,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,
    1223,  1223,  1223,  1223,  1223,  1223,  1223,  1223,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,  1224,
    1224,  1224,  1224,  1224,  1224,  1224,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
    1225,  1225,  1225,  1225,  1225,  1225,  1225,  1225
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       0,     1,     0,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     2,     0,     1,     1,     1,     1,     1,
       1,     3,     2,     3,     3,     2,     5,     1,     3,     3,
       3,     3,     1,     3,     3,     2,     2,     2,     2,     3,
       3,     3,     3,     1,     3,     1,     3,     1,     1,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       3,     1,     2,     3,     2,     1,     1,     2,     1,     2,
       1,     3,     3,     2,     3,     4,     3,     2,     4,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     4,
       6,     4,     6,    10,    13,     4,     6,     4,    10,    13,
       4,     6,     4,     6,     5,     7,    11,    14,     5,     7,
       1,     3,     4,     4,     4,     3,     2,     5,     3,     6,
       4,     6,     6,     5,     7,     6,     6,     5,     5,     5,
       5,     9,     4,     5,     7,     6,     4,     8,     4,     2,
       4,     3,     6,     4,     3,     3,     3,     2,     2,     3,
       4,     4,     3,     3,     3,     3,     3,     3,     4,     4,
       3,     2,     3,     2,     2,     3,     4,     3,     2,     2,
       3,     4,     4,     4,     5,     1,     3,     2,     2,     0,
       2,     0,     1,     1,     1,     3,     3,     2,     0,     1,
       3,     3,     1,     5,     3,     1,     2,     1,     3,     2,
       3,     6,     6,    10,     1,     2,     1,     3,     4,     1,
       3,     4,     6,     4,     8,     2,     2,    11,     9,     1,
       1,     1,     0,     1,     1,     1,     1,     3,     2,     0,
       1,     1,     3,     3,     1,     1,     3,     3,     3,     3,
       4,     3,     2,     1,     0,     3,     0,     1,     0,     1,
       3,     2,     1,     1,     1,     3,     0,     1,     3,     1,
      13,    16,    12,    15,    14,    17,     1,     1,     2,     2,
       2,     2,     1,     0,     1,     0,     3,     0,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     6,     2,     4,
       2,     2,     1,     0,     2,     2,     1,     0,     2,     0,
       3,     1,     1,     2,     2,     1,     4,     4,     5,     2,
       5,     7,     5,     2,     3,     0,     1,     2,     1,     2,
       2,     2,     3,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     5,     9,
       3,     9,     4,    10,    11,     2,     0,     3,     0,     1,
       3,     1,     4,     0,     2,     2,     2,     0,     1,     3,
       3,     6,     4,     0,     1,     1,     2,     2,     0,     3,
       3,     2,     1,     1,     3,     3,     4,     0,     1,     0,
       6,     1,     3,     3,     3,     5,     2,     0,     2,     2,
       0,     3,     4,     4,     0,     2,     0,     4,     0,     3,
       8,    11,     1,     3,     1,     1,     3,     6,     8,     7,
      10,     6,     2,     3,     0,     8,    11,     5,     1,     0,
       6,     5,     8,     4,     6,     1,     0,     3,     0,     1,
       2,     2,     2,     1,     2,     3,     2,     2,     2,     2,
       3,     3,     3,     1,     3,     1,     0,     1,     2,     2,
       1,     1,     3,     6,    10,     1,     0,     1,     2,     2,
       0,     2,     2,     1,     0,     1,     0,     7,     2,     0,
       3,     5,     5,     8,     2,     0,     2,     2,     2,     1,
       5,     2,     0,     2,     6,     6,     6,    10,     6,     6,
       6,     9,     9,     6,     6,     9,     6,     7,     2,     2,
       2,     2,     1,     2,     1,     0,     7,     6,     4,     0,
       1,     3,     4,     1,     3,     1,     2,     2,     2,     2,
       1,     1,    10,    13,     2,     0,     2,     2,     1,     0,
       5,     4,     4,    11,    14,    12,    15,    11,     2,     1,
       4,     0,     8,    11,     1,     1,     7,     9,     8,    10,
       8,     4,     0,     5,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     1,     1,     1,     1,     1,     8,     1,
       1,    17,    21,     1,     1,     2,     1,     3,     1,     1,
       1,     3,     1,     2,     0,     1,     2,     4,     1,     1,
       1,     1,     1,     3,     0,     1,     0,     1,     1,     4,
       0,     1,     1,     1,     3,     0,     1,     1,     1,     1,
       2,     0,     0,     2,     2,     1,     2,     2,     2,     2,
      11,    13,     1,     3,     5,     1,     3,     5,     1,     2,
       2,     1,     8,     6,     5,     4,     4,     3,     7,     8,
       6,     6,     6,     6,     6,     4,     7,     5,     8,     3,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     3,     1,     0,     1,     3,     7,     9,
       9,     8,     3,     0,    13,     1,     3,     5,     5,     3,
       6,     2,     1,     0,     2,     0,     2,     4,     0,     1,
       0,     6,     8,     8,     1,     3,     5,     5,     7,     9,
       7,     9,     5,     6,     6,     4,     6,     4,     6,     8,
       4,     6,     4,     6,     5,     7,     1,     1,     1,     2,
       1,     2,     1,     1,     1,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     2,     2,     1,     3,     2,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     2,
       3,     1,     3,     5,     2,     2,     0,     6,     6,     6,
       6,     6,     6,     6,     6,     8,     9,     8,     6,     6,
       9,     9,     9,     7,    10,     1,     1,     8,     8,     8,
       8,     8,     8,     8,     9,     8,     8,     2,     0,     1,
       1,     2,     2,     1,     2,     3,     3,     3,     3,     4,
       4,     3,     3,     3,     4,     4,     3,     4,     4,     1,
       1,     1,     0,     8,     8,    11,     1,     1,     2,     4,
       5,     1,     3,     2,     2,     2,     2,     2,     1,     3,
       1,     3,     1,     2,     2,     4,     3,     2,     2,     2,
       2,     2,     2,     3,     2,     2,     2,     2,     5,     5,
       5,     5,     5,     1,     3,     1,     2,     3,     0,     5,
       7,     6,     9,     3,     1,     2,     1,     1,     1,     3,
       0,     5,     2,     0,     3,     3,     3,     7,     7,    10,
       1,     1,     1,     1,     1,     1,    16,    19,     1,     0,
       2,     0,     1,     3,     4,     5,     2,     2,     4,     4,
       0,     1,     3,     2,     0,     1,     1,     0,     2,     2,
       0,     9,    12,     7,     7,     2,     0,     3,     2,     1,
       3,     1,     3,     2,     1,     1,     2,     3,     2,     1,
       3,     3,     3,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     4,     5,     1,     3,     3,     1,
       3,     3,     5,     6,     1,     3,     2,     1,     3,     1,
       0,     1,     2,     4,     5,     1,     1,     1,     1,     3,
       3,     2,     2,     1,     2,     2,     2,     2,     1,     2,
       2,     2,     2,     1,     1,     1,     3,     2,     1,     4,
       0,     3,     0,     1,     1,     3,     5,     2,     0,     2,
       1,     3,     5,     5,     5,     1,     2,     1,     0,     4,
       6,     4,     6,     4,     6,     4,     6,     4,     6,     3,
       5,     5,     5,     1,     3,     1,     3,     2,     2,     1,
       2,     1,     2,    11,    10,    10,     2,     2,     0,     9,
       2,     0,    10,    11,    11,     5,     5,     8,     5,     5,
       5,     1,     1,     1,     1,     3,     0,     5,     5,     6,
       6,     6,     6,     6,     8,     8,     6,     6,     7,     9,
       9,     8,    10,     6,     6,     6,     6,     6,     6,     6,
       8,     6,     8,     6,     8,     7,     9,     6,     8,     7,
       9,     8,    10,     8,    10,     9,    11,     8,    10,     9,
      11,     8,     8,     7,     6,     6,     6,     6,     8,     8,
       8,     8,     6,     9,     1,     0,     2,     0,     8,     8,
       8,    10,     9,     8,     1,     0,     6,     6,     6,     6,
       6,     6,     6,     9,     9,     6,     6,     6,     8,     6,
       8,     8,     8,     8,     6,     8,     6,     8,     7,     9,
       7,     9,     6,     7,     1,     3,     3,     3,     1,     1,
       1,     1,     1,     7,     6,     6,     6,     6,     6,     6,
       7,     7,     6,     9,     9,     6,     6,     6,     6,     6,
       6,     8,     8,     8,     6,     7,     6,     6,     4,     7,
       6,     4,     4,     4,     3,     4,     3,     1,     1,     3,
       5,     5,     5,     5,     8,     5,     5,     6,     7,     7,
       7,     4,     4,     5,     4,     6,    13,     1,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     0,     3,     2,     0,     2,
       2,     2,     3,     3,     3,     3,     2,     3,     2,     5,
       4,     3,     3,     3,     3,     3,     1,     1,     0,     3,
       2,     2,     1,     2,     1,     3,     2,     1,     0,     2,
       3,     0,     9,    11,    12,    14,     3,     4,     4,     0,
       2,     5,     1,     0,     1,     2,     3,     3,     3,     1,
       2,     1,     1,     1,     1,     1,     1,     0,     5,     4,
       6,     6,     4,     3,     5,     7,     9,     1,     3,     1,
       5,     4,     4,     6,     4,     6,     6,     5,     7,     9,
       6,     1,     0,     6,    11,    11,    11,    13,     9,    11,
       1,     1,    10,     4,     6,     2,     5,     2,     0,     6,
       5,     3,     5,     1,     3,     1,     1,     2,     1,     1,
       1,     1,     1,     0,     1,     0,     1,     0,     1,     0,
       1,     0,     3,     0,     2,     1,     3,     1,     0,     2,
       4,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     3,     0,     1,     1,     1,     1,
       1,     3,     9,    12,     3,     0,     2,     3,     2,     3,
       7,     1,     3,     1,     4,     4,     7,     2,     1,     1,
       1,     3,     2,     8,     5,     0,     4,     3,     0,     2,
       0,     7,     2,     0,     5,     3,     0,     2,     2,     2,
       3,     1,     3,     1,     2,     1,     0,     1,     2,     0,
       8,     1,     3,     3,     5,     2,     1,     3,     9,     1,
       2,     5,     5,     6,     6,     7,     2,     0,     3,     1,
       2,     5,     5,     8,     3,     4,     7,     1,     0,     3,
       2,     2,     2,     2,     0,     2,     2,     1,     1,     3,
       3,     1,     2,     4,     4,     2,     3,     5,     5,     1,
       1,     9,     9,     1,     2,     4,     4,     4,     2,     2,
       3,     1,     3,     9,     1,     2,     0,     7,     7,     0,
      10,     6,     0,     1,     0,     2,     0,     3,     3,     4,
       4,     4,     4,     3,     2,     1,     1,     0,     1,     1,
       0,     1,     5,     1,     0,     1,     1,     1,     0,     3,
       1,     3,     4,     3,     2,     2,     1,     1,     1,     0,
       2,     4,     5,     6,     4,     5,     2,     3,     1,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       4,     0,     1,     3,     1,     1,     1,     1,     1,     2,
       4,     4,     5,     2,     0,     1,     3,     1,     0,     1,
       2,     3,     2,     4,     2,     3,     2,     0,     4,     5,
       2,     0,     1,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     1,     4,     3,     4,     5,     4,     5,     4,
       5,     2,     4,     1,     1,     0,     2,     0,     1,     4,
       5,     4,     0,     2,     2,     2,     1,     1,     0,     5,
       2,     1,     1,     2,     2,     4,     1,     3,     1,     2,
       3,     6,     4,     0,     2,     6,     2,     1,     3,     4,
       0,     2,     0,     2,     0,     2,     4,     0,     1,     0,
       1,     3,     3,     7,    12,     1,     3,     2,     3,     3,
       1,     2,     2,     2,     2,     1,     1,     3,     3,     2,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     4,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     4,     1,     2,
       2,     1,     3,     3,     2,     1,     0,     5,     2,     5,
       2,     1,     3,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     0,     1,
       4,     1,     3,     3,     5,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     2,     2,     3,     5,     4,     6,     3,
       5,     4,     6,     4,     6,     5,     7,     3,     2,     4,
       2,     3,     3,     4,     3,     4,     3,     4,     5,     6,
       6,     7,     6,     7,     3,     4,     4,     6,     3,     3,
       4,     3,     4,     4,     5,     4,     5,     1,     1,     3,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     5,     6,     3,     4,
       1,     1,     2,     4,     1,     1,     1,     2,     2,     2,
       2,     1,     1,     4,     3,     5,     6,     8,     6,     6,
       4,     4,     3,     1,     1,     1,     1,     5,     1,     1,
       4,     1,     4,     1,     4,     1,     4,     1,     1,     1,
       1,     1,     1,     1,     6,     4,     4,     6,     4,     4,
       4,     4,     4,     6,     5,     5,     5,     4,     6,     4,
       4,     4,     4,     5,     7,     7,     9,     5,     4,     6,
       5,     7,     7,     8,     4,     7,     4,     6,     6,     4,
       2,     3,     3,     3,     4,     0,     4,     1,     3,     3,
       1,     1,     1,     1,     2,     0,     2,     2,     0,     2,
       3,     3,     4,     2,     2,     5,     0,     5,     0,     2,
       0,     1,     3,     3,     2,     2,     0,     6,     1,     0,
       3,     0,     3,     3,     3,     0,     1,     4,     2,     2,
       2,     2,     2,     3,     2,     2,     3,     0,     4,     3,
       5,     4,     3,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     4,     1,     4,     1,     2,     1,
       2,     1,     3,     1,     3,     1,     3,     3,     1,     0,
       1,     3,     3,     3,     2,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       7,     5,     3,     5,     5,     3,     3,     5,     3,     2,
       1,     1,     3,     5,     1,     2,     4,     2,     0,     1,
       0,     1,     2,     2,     2,     3,     5,     1,     0,     1,
       2,     0,     2,     1,     0,     2,     3,     0,     2,     0,
       3,     0,     1,     2,     2,     2,     2,     3,     2,     3,
       2,     0,     1,     3,     3,     3,     3,     3,     0,     3,
       3,     0,     1,     3,     7,     7,     3,     0,     1,     0,
       1,     3,     3,     2,     1,     1,     1,     3,     1,     2,
       1,     3,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     6,     2,     3,     5,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     3,    10,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 920 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
				(void) yynerrs;		/* suppress compiler warning */
			}
#line 29315 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 925 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 29323 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 929 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 29332 "gram.c" /* yacc.c:1646  */
    break;

  case 5:
#line 934 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 29344 "gram.c" /* yacc.c:1646  */
    break;

  case 6:
#line 942 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 29356 "gram.c" /* yacc.c:1646  */
    break;

  case 7:
#line 950 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 29368 "gram.c" /* yacc.c:1646  */
    break;

  case 8:
#line 970 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 29384 "gram.c" /* yacc.c:1646  */
    break;

  case 9:
#line 982 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 29395 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1125 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29401 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1132 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29407 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1133 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29413 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1137 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29419 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1138 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29425 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1142 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 29431 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1143 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 29437 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1147 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 29443 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1148 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 29449 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1149 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 29455 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1159 "gram.y" /* yacc.c:1646  */
    {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 29466 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1175 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29479 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1197 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29485 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1198 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29491 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1202 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 29497 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1203 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29503 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1208 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 29512 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1213 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 29520 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1217 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29534 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1227 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 29546 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1235 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 29554 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1239 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 29562 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1243 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 29570 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1248 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29578 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1252 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 29627 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1299 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 29633 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 29641 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29649 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1310 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 29657 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1314 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 29665 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1318 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 29673 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1332 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29686 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1351 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 29699 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1360 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 29712 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1371 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 29718 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1372 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 29724 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1377 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29737 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1386 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29750 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1395 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29763 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1404 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 29776 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1426 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29788 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1434 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29800 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1442 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29812 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1450 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 29824 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1458 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29836 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1466 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29848 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1484 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29861 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1503 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 29875 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1514 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 29881 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1515 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 29887 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1527 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 29902 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1538 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 29917 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1549 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 29937 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1565 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 29957 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1584 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 29967 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1590 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29973 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1618 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minimum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 29984 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1625 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 29995 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1632 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 30006 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1639 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 30017 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1649 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 30030 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1658 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 30043 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1671 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 30056 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1680 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 30069 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1689 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 30081 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1697 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 30093 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1707 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 30099 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1709 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 30111 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1718 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 30127 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1730 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 30139 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1738 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30152 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1747 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 30168 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1759 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30181 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1768 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30194 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1777 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 30206 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1785 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30219 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1795 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 30232 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1805 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30238 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1807 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 30244 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1810 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30250 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1811 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30256 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1815 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 30262 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1817 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 30268 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1820 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 30274 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1821 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 30280 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1822 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 30286 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1823 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 30292 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1827 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 30298 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1828 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 30304 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1829 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 30310 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1835 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30316 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1848 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 30324 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1852 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 30332 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1856 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const    *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 30353 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1873 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 30365 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1880 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 30371 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1881 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30377 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1882 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30383 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1886 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30389 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1887 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30395 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1888 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30401 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1892 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30407 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1893 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30413 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1897 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 30419 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1899 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minimum */
					(yyval.node) = (Node *) n;
				}
#line 30429 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1907 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 30435 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1909 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 30447 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1917 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 30459 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1925 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 30471 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1936 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 30483 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1944 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 30494 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1954 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 30500 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1955 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 30506 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1960 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 30512 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1961 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 30518 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1968 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 30528 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1974 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 30538 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1980 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30549 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1987 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 30560 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1994 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 30571 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 2001 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 30582 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 2008 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 30593 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 2019 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30605 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2029 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30611 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2030 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30617 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2034 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30623 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2035 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30629 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2044 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 30639 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2060 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 30650 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2067 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 30661 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2074 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 30672 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2081 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 30683 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2088 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 30694 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2108 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30708 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2118 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30722 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2128 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30736 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2138 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30750 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2148 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30766 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2160 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30782 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2172 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30796 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2182 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30810 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2192 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30824 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2202 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30840 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2214 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30856 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2226 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30870 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2236 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30884 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2246 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30898 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2256 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30912 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2266 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30926 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2276 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 30940 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2286 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30956 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2298 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 30972 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2310 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 30986 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2320 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31000 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2332 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31006 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2333 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31012 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2339 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 31029 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2353 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 31046 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2366 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 31062 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2382 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 31079 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2399 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31092 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2409 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31105 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2419 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31118 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2429 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31131 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2439 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 31144 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2449 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 31156 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2458 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 31168 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2467 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 31180 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2476 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31193 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2486 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 31206 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2496 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *) n;
				}
#line 31225 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2512 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31238 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2522 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31251 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2532 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 31264 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2542 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 31277 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2552 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 31297 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2569 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31310 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2579 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31323 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2589 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31336 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2599 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31350 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2610 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31364 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2624 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 31383 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2640 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31395 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2649 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31407 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2658 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 31425 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2673 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31437 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2682 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31451 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2693 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 31465 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2704 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 31476 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2712 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31488 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2721 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31500 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2730 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 31511 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2738 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 31522 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2746 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31534 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2755 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31546 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2764 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31558 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2773 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 31569 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2781 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 31580 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2789 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31592 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2798 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 31603 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2806 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 31614 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2814 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31626 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2823 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31638 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2832 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31650 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2841 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31662 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2850 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 31674 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2859 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 31686 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2868 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 31700 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2879 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 31711 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2887 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 31723 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2896 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31735 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2905 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31747 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2914 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31759 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2923 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31771 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2932 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 31783 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2941 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31794 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2949 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31805 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2957 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31816 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2965 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 31827 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2972 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31839 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2982 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31845 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2983 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31851 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2988 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31864 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2996 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31870 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 3000 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31876 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 3001 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31882 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3006 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31894 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3014 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31906 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3022 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 31918 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3030 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 31930 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3040 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31936 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3043 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31942 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3044 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31948 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3048 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31954 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3049 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 31960 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3055 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 31968 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3059 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 31976 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3063 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 31985 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3068 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 31993 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3075 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 31999 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3077 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32005 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3082 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 32013 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3086 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 32021 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3090 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 32036 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3101 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 32044 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3109 "gram.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 32099 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3162 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 32114 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3175 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 32130 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3189 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 32143 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3201 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 32151 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3208 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 32159 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3212 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 32167 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3226 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 32181 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3238 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32187 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3239 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32193 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3245 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 32206 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3255 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32220 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3266 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32234 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3277 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32254 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3304 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32265 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3311 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 32276 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3347 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 32314 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3381 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 32338 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3403 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32344 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3404 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32350 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3408 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32356 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3409 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32362 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3418 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32368 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3419 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32374 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3420 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32380 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3423 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32386 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3424 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32392 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32398 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3430 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32404 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3435 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 32412 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3439 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 32420 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3443 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 32428 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3447 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 32436 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3451 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 32444 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3455 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 32452 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3459 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 32460 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3463 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 32468 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3467 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 32476 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 32484 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3475 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 32492 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3479 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 32500 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3483 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32508 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3492 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 32516 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3495 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 32522 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3500 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32530 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3503 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 32536 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3514 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 32544 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3518 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 32552 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3525 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 32560 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3531 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 32566 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3532 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 32572 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3533 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 32578 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3534 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 32584 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3535 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32590 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3540 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32598 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3544 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32606 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3551 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 32612 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3565 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32634 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3585 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32656 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3605 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32679 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3626 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32702 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3647 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 32725 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3668 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 32748 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3699 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32754 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3700 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32760 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3701 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32766 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3702 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 32772 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3704 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 32783 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3711 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 32794 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3717 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 32800 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3718 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 32806 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32812 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3723 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32818 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3727 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32824 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3728 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32830 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3733 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32838 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3737 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32846 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3744 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32854 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3748 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32862 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3754 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32868 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3755 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32874 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3756 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32880 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3760 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32886 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3761 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32892 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3765 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->storage_name = (yyvsp[-3].str);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 32918 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3789 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 32941 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3808 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 32964 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3829 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32970 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3830 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 32976 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3834 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32982 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3835 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32988 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3839 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32994 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3840 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 33000 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3844 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33006 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3845 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33012 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3849 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 33018 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3850 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33024 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3855 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 33036 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3862 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33042 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3863 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33048 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3865 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33066 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3897 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33078 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3905 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 33090 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3913 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33107 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3926 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33123 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3938 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 33140 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3951 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 33156 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3963 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 33170 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3973 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 33198 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3997 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 33219 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 4016 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33225 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 4017 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33231 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 4018 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33237 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 4022 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 33243 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 4023 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 33249 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 4043 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 33261 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 4051 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33273 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 4059 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33285 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 4067 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33297 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 4079 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 33310 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 4090 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 33316 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 4091 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 33322 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 4092 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 33328 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 4096 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 33334 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 4097 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 33340 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 4098 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 33346 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 4099 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 33352 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 4100 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 33358 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 4101 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 33364 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 4102 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 33370 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 4103 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 33376 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 4104 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 33382 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 4105 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 33388 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 4115 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 33400 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 4122 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33406 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 4127 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 33424 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 4142 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-8]);
					n->nulls_not_distinct = !(yyvsp[-7].boolean);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33445 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 4159 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33465 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 4176 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33485 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 4192 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33505 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4210 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33527 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4229 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 33551 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4250 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 33557 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4251 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 33563 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4255 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33569 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4256 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33575 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4260 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33581 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4261 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33587 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4265 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 33595 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4270 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33601 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33607 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4275 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 33615 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4279 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 33627 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4287 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 33635 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4291 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 33643 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4297 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 33649 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4299 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 33655 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4303 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 33663 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4308 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 33671 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4314 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 33677 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4315 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33683 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4320 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 33697 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4330 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 33711 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4340 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 33723 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4348 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 33735 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4356 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 33751 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4370 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 33765 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4382 "gram.y" /* yacc.c:1646  */
    {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 33773 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4389 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33785 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4397 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33797 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4405 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 33809 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4413 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 33821 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4421 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 33833 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4430 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33839 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4431 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33845 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4435 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 33851 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4436 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 33857 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4440 "gram.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = parsePartitionStrategy((yyvsp[-3].str));
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 33871 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4451 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 33877 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4452 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 33883 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4456 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 33898 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4467 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 33913 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4478 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 33928 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4491 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33934 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4492 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33940 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4497 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33946 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33952 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4499 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33958 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4502 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 33964 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4503 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 33970 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4504 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 33976 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4505 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 33982 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4508 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33988 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4509 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33994 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4512 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34000 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4513 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34006 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4516 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34012 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4538 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34028 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4551 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34044 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4571 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 34050 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4572 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 34056 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 34066 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4582 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 34076 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4588 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 34086 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4605 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 34099 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4614 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 34112 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4636 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 34130 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4650 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 34148 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4668 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 34164 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4682 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34170 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4683 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34176 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4684 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34182 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4697 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 34200 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4711 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 34218 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4728 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 34234 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4741 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 34240 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4742 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 34246 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4755 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 34259 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4776 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34274 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4787 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34289 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4801 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34302 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4810 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34315 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4821 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34321 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4822 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34327 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4825 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34333 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4826 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34339 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4829 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34345 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4830 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34351 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4834 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 34359 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4838 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 34367 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4842 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 34375 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4846 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 34383 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4850 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34391 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4854 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 34399 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4858 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 34407 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4862 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 34415 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4866 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 34423 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4870 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 34431 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4874 "gram.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 34440 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4879 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34448 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4883 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 34456 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4887 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34464 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4897 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 34470 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4898 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 34476 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4900 "gram.y" /* yacc.c:1646  */
    {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 34487 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4906 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 34493 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4909 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34499 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4910 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34505 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4923 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 34525 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4940 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34541 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4954 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34547 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4955 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34553 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4963 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34559 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4964 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 34565 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4968 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34571 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4969 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34577 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4973 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34583 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4974 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34589 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4978 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34595 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4979 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34601 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4995 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34615 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 5006 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 34621 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 5007 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 34627 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 5021 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 34639 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 5029 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 34651 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 5047 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34664 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 5056 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34677 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 5068 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34683 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 5070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34689 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 5075 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34697 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 5079 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34705 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 5083 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 34716 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 5090 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 34724 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 5102 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34736 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 5113 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34742 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 5115 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34748 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 5120 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34756 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 5133 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 34770 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 5143 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34784 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 5153 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34798 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 5163 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 34812 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 5173 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 34826 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 5183 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34840 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 5193 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34854 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 5203 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 34868 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 5213 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 34882 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 5223 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34896 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 5233 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 34910 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 5243 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 34924 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 5253 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 34938 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 5272 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34951 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 5283 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 34957 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 5284 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 34963 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 5285 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 34969 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 5286 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 34975 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 5290 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34981 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 5291 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34987 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 5295 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34993 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 5296 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34999 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5307 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35012 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5316 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 35025 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5328 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35031 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5329 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35037 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5334 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 35045 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5338 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 35053 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5345 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35059 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5350 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 35067 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5354 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 35075 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5361 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 35083 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5365 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 35092 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5370 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 35101 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5375 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 35109 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5382 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 35117 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5388 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35123 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5393 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35129 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5405 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35145 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5418 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35161 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5432 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35167 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5433 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35173 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5438 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35179 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5439 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35185 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5443 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35191 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5444 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35197 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5455 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 35211 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5465 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 35224 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5474 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35236 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5494 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35259 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5515 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35282 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5536 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35306 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5558 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35330 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5591 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 35346 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5605 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 35352 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5606 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 35358 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5611 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 35370 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5619 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 35381 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5635 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35395 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5645 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35409 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5657 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 35415 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5658 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 35421 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5671 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 35434 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5680 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 35447 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5698 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 35460 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5725 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35477 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5742 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35492 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5755 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35498 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5756 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35504 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5760 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35510 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5761 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35516 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5765 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35522 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 35528 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5770 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35534 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5771 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 35540 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5776 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 35558 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5789 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35564 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5793 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35570 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5794 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 35576 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5798 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 35582 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5799 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 35588 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5800 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 35594 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5801 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 35600 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5802 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 35606 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5813 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 35619 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5824 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 35625 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5825 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 35631 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5839 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 35656 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5863 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 35686 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5891 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 35692 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5892 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 35698 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5893 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 35704 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5898 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35710 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5900 "gram.y" /* yacc.c:1646  */
    {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 35733 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 35739 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5924 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 35745 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5926 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 35751 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5928 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 35757 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5930 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 35763 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35769 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35775 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5939 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35781 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5940 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 35787 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5945 "gram.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 35800 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5956 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35806 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5957 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35812 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5961 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35818 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5970 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35824 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5974 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35830 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5979 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 35838 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5983 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 35850 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5998 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35856 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5999 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35862 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 6003 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35868 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 6004 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35874 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 6013 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35880 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 6014 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35886 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 6015 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35892 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 6020 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 35900 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 6023 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35906 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 6024 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35912 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 6025 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 35918 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 6029 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 35924 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 6030 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 35930 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 6035 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35936 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 6037 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 35964 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 6063 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 35970 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 6064 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 35976 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 6065 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 35982 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 6066 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 35988 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 6067 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 35994 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 6068 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 36000 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 6083 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 36014 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 6095 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 36028 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 6108 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36034 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 6110 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 36040 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 6115 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 36046 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 6120 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36052 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 6122 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36058 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 6127 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 36070 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 6137 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 36076 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 6138 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 36082 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 6139 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 36088 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 6140 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 36094 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 6152 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 36106 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 6171 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36122 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 6183 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36139 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 6196 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36154 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 6207 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36169 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 6218 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 36185 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 6230 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36198 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 6239 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36210 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 6247 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36222 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 6255 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36236 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 6265 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36250 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 6275 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36264 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 6285 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36278 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 6295 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36292 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 6305 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36307 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 6316 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 36321 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 6326 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36336 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 6338 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36342 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 6341 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36348 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 6342 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 36354 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 6346 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36362 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 6350 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 36370 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 6356 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 36376 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 6357 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 36382 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6358 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 36388 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6359 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 36394 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6360 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36400 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6361 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 36406 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6364 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36412 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6367 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36418 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6368 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 36424 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6377 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36432 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6383 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36438 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6384 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36444 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6388 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36450 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6390 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 36456 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6401 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36472 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6413 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36488 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6425 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36504 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6437 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 36520 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6450 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36526 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6451 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36532 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6469 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36548 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6483 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36554 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6484 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36560 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6489 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36577 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6503 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36591 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6513 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 36604 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6522 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 36618 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6532 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36630 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6541 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36636 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6542 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36642 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6545 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36648 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6546 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36654 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6549 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36660 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6550 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36666 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36672 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6555 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 36690 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6568 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36696 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6574 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 36708 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6585 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36722 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6595 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36736 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6607 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36742 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6608 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36748 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6613 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36761 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6622 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 36774 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6635 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36789 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6646 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36804 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6660 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36819 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6671 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36834 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6694 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 36846 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6705 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 36858 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6724 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36873 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6735 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36888 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6746 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36903 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6757 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36918 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6768 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36933 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6779 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36948 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6790 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36963 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6801 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36978 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6812 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 36993 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6823 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 37008 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6834 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 37023 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6845 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 37038 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6859 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 37044 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6860 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 37050 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6861 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 37056 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6862 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 37062 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6863 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 37068 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6864 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 37074 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6865 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 37080 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6866 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 37086 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6867 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 37092 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6868 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 37098 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6869 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 37104 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6870 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 37110 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6871 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 37116 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6881 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 37122 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6882 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 37128 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6883 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 37134 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6884 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 37140 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6885 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 37146 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6889 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 37152 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6890 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 37158 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6891 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 37164 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6892 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 37170 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6893 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 37176 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6894 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 37182 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6895 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 37188 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6896 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 37194 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6901 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 37200 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6902 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 37206 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6903 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 37212 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6907 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 37218 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6908 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 37224 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6911 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37230 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6912 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 37236 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6916 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37242 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6918 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37248 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 37254 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6923 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 37260 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6935 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37273 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6946 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37279 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6947 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37285 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6948 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37291 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6959 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37304 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6968 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37317 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6977 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37330 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6986 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37343 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6995 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37356 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 7004 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37369 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 7013 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37382 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 7022 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37395 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 7031 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37408 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 7040 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37426 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 7054 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37439 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 7063 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37452 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 7072 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37465 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 7081 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37478 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 7090 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37491 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 7099 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37504 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 7108 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37517 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 7117 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37530 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 7128 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37536 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 7129 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37542 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 7145 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37556 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 7156 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37570 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 7167 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37584 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 7178 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37598 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 7189 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37612 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 7200 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37626 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 7211 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37640 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 7222 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37654 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 7233 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37668 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 7244 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 37682 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 7255 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37688 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 7256 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37694 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 7259 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37700 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 7260 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 37706 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 7271 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 37717 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 7278 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 37728 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 7287 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37741 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 7296 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37754 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 7305 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37767 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 7314 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37780 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 7323 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37793 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 7332 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 37806 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 7341 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37819 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 7350 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37832 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 7359 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37845 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 7368 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37858 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 7377 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37871 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 7386 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37884 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 7395 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37897 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 7404 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 37910 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 7413 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 37923 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7422 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 37936 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7449 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 37954 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7467 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37973 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7483 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 37992 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7510 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37998 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7512 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38004 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7514 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38010 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7516 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 38022 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7524 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 38034 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7533 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 38040 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7534 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 38046 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 7538 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 38058 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 7546 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 38070 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 7554 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 38082 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 7562 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 38093 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7569 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 38105 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7580 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 38113 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7584 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 38121 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7591 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = (yyvsp[0].str);
			}
#line 38129 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7595 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 38137 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7606 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38150 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7615 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38163 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7624 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38176 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7633 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38189 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7642 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38202 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7651 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38215 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7660 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38228 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7669 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38241 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7678 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38254 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7687 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38267 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7696 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38280 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7705 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38293 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7714 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38305 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7722 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38318 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7731 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38331 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7740 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38344 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7749 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38357 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7758 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38370 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7767 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38383 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7776 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38396 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7785 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 38409 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7797 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 38415 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7798 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 38421 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7802 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 38427 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7803 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 38433 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7808 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38439 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7809 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38445 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7820 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-3].list);
					n->grantee_roles = (yyvsp[-1].list);
					n->opt = NIL;
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38460 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7831 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-5].list);
					n->grantee_roles = (yyvsp[-3].list);
					n->opt = (yyvsp[-1].list);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38475 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7845 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->opt = NIL;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38491 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7857 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					DefElem *opt;

					opt = makeDefElem(pstrdup((yyvsp[-7].str)),
									  (Node *) makeBoolean(false), (yylsp[-7]));
					n->is_grant = false;
					n->opt = list_make1(opt);
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38510 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7874 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38516 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7875 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38522 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7880 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem(pstrdup((yyvsp[-1].str)), (yyvsp[0].node), (yylsp[-1]));
			}
#line 38530 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7886 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 38536 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7887 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 38542 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7888 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(false); }
#line 38548 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7891 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 38554 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7892 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 38560 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7903 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38572 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7913 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 38578 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7914 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38584 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7919 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38592 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7923 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38600 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 38608 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7939 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 38625 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7953 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38643 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7968 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38661 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7984 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 38667 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7985 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 38673 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7986 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 38679 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7987 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 38685 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7988 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 38691 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7989 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 38697 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 8004 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 38731 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 8036 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 38765 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 8068 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38771 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 8069 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38777 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 8073 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 38783 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 8074 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 38789 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 8077 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 38795 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 8078 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 38801 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 8084 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 38817 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 8096 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 38833 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 8115 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 38842 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 8120 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 38851 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 8125 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 38860 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 8131 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38866 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 8132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38872 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 8135 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 38878 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 8136 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 38884 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 8139 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38890 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 8140 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38896 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 8144 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 38902 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 8145 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 38908 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 8146 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 38914 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 8149 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 38920 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 8150 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 38926 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 8151 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 38932 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 8169 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38949 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 8183 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38967 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 8198 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 38984 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 8212 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 39001 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 8227 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39007 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 8228 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39013 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 8231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39019 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 8232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39025 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 8236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 39031 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 8237 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 39037 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 8241 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 39043 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 8243 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 39049 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 8248 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 39062 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 8262 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 39074 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 8270 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 39086 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 8278 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 39099 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 8293 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39105 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 8294 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39111 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 8298 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 39117 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 8300 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 39123 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 8315 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39137 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 8325 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39151 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 8335 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39165 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 8345 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39179 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 8355 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39193 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 8367 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 39199 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 8368 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 39205 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 8369 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 39211 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 8370 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 39217 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 8371 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 39223 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 8382 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 39235 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 8396 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 39241 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 8398 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 39251 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 8404 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 39262 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 8414 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 39270 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 8418 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 39279 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 8423 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 39288 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 8431 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 39303 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 8473 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 39311 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 8477 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 39319 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 8481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 39327 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 8485 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 39336 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 8492 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 39342 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 8493 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 39348 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 8498 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 39361 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 8509 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 39367 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 8511 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 39373 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 8516 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39379 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 8521 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39385 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 8522 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39391 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 8530 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 39399 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 8534 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 39407 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 8538 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 39415 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 8542 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 39423 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 8546 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 39431 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 8550 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 39439 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 8554 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 39447 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8558 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 39455 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8562 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 39463 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 8566 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 39471 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 8570 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 39479 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 8574 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 39487 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 8578 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 39495 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 8582 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 39503 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8586 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39511 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8590 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 39520 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8595 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 39528 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8602 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39536 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8606 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 39544 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8610 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 39552 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8614 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 39560 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8618 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 39568 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8623 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 39574 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8625 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 39582 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8631 "gram.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 39593 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8641 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 39601 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8645 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 39615 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8655 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 39623 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8662 "gram.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 39635 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8670 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 39643 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8681 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 39649 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8682 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 39655 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8686 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39661 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8687 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39667 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8691 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 39681 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8704 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 39689 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8708 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 39697 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8723 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39710 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8732 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39723 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8741 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 39736 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8753 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39742 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8754 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39748 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8778 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39763 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8789 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39778 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8800 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39793 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8811 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39808 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8822 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39823 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8833 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39838 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8847 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39853 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8858 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39868 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8872 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39883 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8883 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 39898 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8897 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 39910 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8905 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 39916 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8907 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 39922 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8909 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 39928 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8914 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 39934 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8916 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 39940 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8920 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 39946 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 39952 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8927 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 39964 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8946 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 39975 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39981 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8956 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 39987 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8961 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 39995 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8965 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 40003 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8978 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 40018 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8990 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 40033 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 9002 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 40048 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 9014 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 40054 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 9015 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 40060 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 9016 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 40066 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 9021 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 40081 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 9033 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40087 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 9034 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40093 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 9045 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 40108 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 9058 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 40116 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 9062 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 40124 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 9066 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 40132 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 9070 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 40140 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 9077 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40154 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 9099 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40171 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 9112 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = REINDEX_OBJECT_SCHEMA;
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40188 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 9125 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 40205 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 9139 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 40211 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 9140 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 40217 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 9143 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 40223 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 9144 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 40229 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 9147 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40235 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 9148 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 40241 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 9159 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 40255 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 9169 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 40269 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 9187 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40283 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 9197 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40297 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 9207 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40311 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 9217 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40325 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 9227 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40339 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 9237 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 40353 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 9247 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40367 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 9257 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40381 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 9267 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40395 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 9277 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40409 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 9287 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40423 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 9297 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40437 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 9307 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40452 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 9318 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40467 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 9329 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40481 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 9339 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40495 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 9349 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40509 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 9359 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40523 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 9369 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40537 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 9379 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40551 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 9389 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40566 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 9400 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40581 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 9411 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40596 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 9422 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40611 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 9433 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40626 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 9444 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40641 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 9455 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40656 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 9466 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40671 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 9477 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40686 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 9488 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40701 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 9499 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40716 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9510 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40731 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9521 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40747 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9533 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40763 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9545 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40779 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9557 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40795 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9569 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40811 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 9581 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40827 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 9593 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40842 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9604 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40857 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9615 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40873 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9627 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 40889 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9639 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40904 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9650 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40919 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9661 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 40932 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9670 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40946 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9680 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40960 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9690 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40974 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 9700 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 40988 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 9710 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41002 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9720 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41016 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9730 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41030 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9740 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41044 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9750 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41058 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9760 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41075 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9778 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 41081 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9779 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41087 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9790 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41101 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9800 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41115 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9810 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41129 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9820 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41144 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9831 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41158 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9841 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41172 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9852 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41178 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9853 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 41184 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9864 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41198 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9874 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41212 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9884 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41226 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9894 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41240 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9904 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41254 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9914 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41268 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9924 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41282 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9934 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41296 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9944 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41310 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9954 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41324 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9964 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41338 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9974 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41352 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9984 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41366 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9994 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41380 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 10004 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41394 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 10014 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41408 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 10024 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41422 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 10034 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41436 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 10044 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41450 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 10054 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41464 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 10064 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41478 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 10074 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41492 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 10084 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41506 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 10094 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41520 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 10104 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41534 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 10114 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 41548 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 10124 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 41562 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 10143 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41574 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 10152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41580 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 10153 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 41586 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 10157 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 41592 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 10159 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 41598 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 10164 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 41604 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 10165 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 41610 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 10166 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 41616 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 10167 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 41622 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 10168 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 41628 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 10181 "gram.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41640 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 10197 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41653 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 10206 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41666 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 10215 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41679 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 10224 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41692 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 10233 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41705 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 10242 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41718 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 10251 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41731 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 10260 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41744 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 10269 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41757 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 10278 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41770 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 10287 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41783 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 10296 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41796 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 10305 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41809 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 10314 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41822 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 10323 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41835 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 10332 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41848 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 10341 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41861 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 10350 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41874 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 10359 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41887 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 10368 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41900 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 10377 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41913 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 10386 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41926 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 10395 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41939 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 10404 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 41952 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 10432 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41964 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 10440 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 41977 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 10449 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 41991 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 10475 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 42004 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 10484 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 42015 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 10491 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 42025 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 10497 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 42056 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 10524 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 42070 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 10535 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 42083 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 10544 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 42093 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 10552 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 42099 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 10554 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 42105 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 10576 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42117 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 10584 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 42131 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 10594 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 42145 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 10604 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 42159 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 10623 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42173 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 10642 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42187 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 10652 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42201 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 10662 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42215 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 10672 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42230 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 10683 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42245 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 10694 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42260 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 10705 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 42275 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 10716 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 42290 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 10727 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42304 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 10745 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 42317 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 10754 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 42330 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 10773 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42347 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 10788 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42353 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 10789 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42359 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 10790 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42365 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10796 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 42375 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10802 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 42385 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10818 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42391 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 10819 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42397 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 10822 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 42403 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 10823 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 42409 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 10824 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 42415 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 10825 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 42421 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10829 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42427 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10830 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42433 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10831 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42439 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 10844 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42451 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 10854 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 42457 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 10855 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 42463 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 10859 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42474 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 10869 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42485 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 10876 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 42496 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 10896 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42509 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10905 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42521 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10913 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42534 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10922 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42547 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10931 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42559 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10939 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42571 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10947 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42583 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10955 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42595 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10963 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42607 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10971 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42619 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10979 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42631 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10987 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42643 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10998 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42655 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 11006 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42668 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 11023 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 42675 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 11026 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 42682 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 11029 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 42689 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 11032 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 42696 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 11035 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 42703 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 11042 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42709 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 11044 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 42715 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 11046 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 42721 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 11052 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42727 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 11056 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42733 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 11057 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42739 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 11058 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 42745 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 11072 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 42762 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 11086 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 42779 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 11100 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 42801 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 11119 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 42823 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 11139 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 42829 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 11140 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 42835 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 11141 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 42841 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 11142 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 42847 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 11153 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42858 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 11170 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 42870 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 11180 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42876 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 11181 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42882 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 11185 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 42888 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 11186 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 42894 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 11191 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (yyvsp[0].node), (yylsp[-2]));
				}
#line 42902 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 11195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 42910 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 11199 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 42918 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 11216 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 42924 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 11217 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 42930 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 11218 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42936 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 11219 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42942 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 11220 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42948 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 11221 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42954 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 11222 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 42960 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 11242 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 42972 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 11250 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 42984 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 11258 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 42997 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 11267 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 43008 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 11277 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 43020 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 11295 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 43033 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 11304 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 43046 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 11313 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43059 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 11322 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43072 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 11334 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 43080 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 11338 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 43088 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 11349 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 43096 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 11361 "gram.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 43107 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 11379 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 43118 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 11386 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 43129 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 11403 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 43143 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 11417 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43156 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 11427 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 43168 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 11436 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 43180 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 11445 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43193 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 11455 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43208 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 11467 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43223 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 11479 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43236 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 11502 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43248 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 11513 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 43264 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 11525 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 43280 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 11537 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 43296 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 11549 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 43312 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 11561 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43326 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 11571 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43340 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 11600 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 43355 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 11624 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 43370 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 11636 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 43383 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 11645 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 43398 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 11657 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 43413 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 11670 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43419 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 11671 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 43425 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 11684 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 43450 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 11705 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 43463 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 11716 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 43479 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 11728 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 43492 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 11740 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 43500 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 11744 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 43508 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 11756 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 43516 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 11762 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 43522 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 11763 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 43528 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 11764 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "format"; }
#line 43534 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 11768 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 43540 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 11769 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 43546 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 11770 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43552 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 11774 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43558 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 11775 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43564 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 11779 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43570 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 11780 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43576 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 11783 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43582 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 11784 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43588 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 11787 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43594 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 11788 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43600 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 11792 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43606 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 11793 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43612 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 11798 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 43620 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 11805 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43626 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 11807 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 43632 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 11811 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43638 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 11812 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43644 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 11826 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 43656 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 11834 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 43671 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 11845 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 43683 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 11853 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 43695 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11883 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 43708 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11893 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43714 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 11894 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43720 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 11913 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43732 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 11922 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 43753 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 11940 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 43774 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 11958 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43780 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 11959 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43786 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 11970 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 43797 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 11977 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 43808 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 11984 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 43819 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 11991 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 43830 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 12009 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 43842 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 12026 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 43850 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 12030 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 43859 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 12038 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43869 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 12044 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43880 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 12051 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43890 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 12057 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 43901 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 12064 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 43911 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 12072 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 43917 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 12073 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 43923 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 12078 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43929 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 12080 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 43935 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 12085 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43947 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 12096 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 43960 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 12106 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 43973 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 12115 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 43981 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 12122 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 43993 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 12131 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 44005 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 12139 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 44013 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 12145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44019 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 12146 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44025 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 12159 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 44040 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 12172 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44046 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 12173 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44052 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 12185 "gram.y" /* yacc.c:1646  */
    {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 44065 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 12195 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 44071 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 12196 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 44077 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 12199 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 44083 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 12200 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 44089 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 12201 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 44095 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 12202 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 44101 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 12203 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 44107 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 12204 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 44113 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 12205 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 44119 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 12206 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 44125 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 12209 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44131 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 12210 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44137 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 12214 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 44143 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 12215 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 44149 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 12216 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 44155 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 12232 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 44171 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 12245 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44177 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 12246 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 44183 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 12251 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 44192 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 12256 "gram.y" /* yacc.c:1646  */
    {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 44217 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 12280 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 44229 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 12290 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 44235 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 12291 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 44241 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 12307 "gram.y" /* yacc.c:1646  */
    {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-8].with);
					m->relation = (yyvsp[-5].range);
					m->sourceRelation = (yyvsp[-3].node);
					m->joinCondition = (yyvsp[-1].node);
					m->mergeWhenClauses = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 44257 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 12321 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44263 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 12322 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 44269 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 12327 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44280 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 12334 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = true;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44291 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 12341 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matched = false;
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 44302 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 12348 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = true;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 44316 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 12358 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matched = false;
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 44330 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 12370 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44336 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 12371 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 44342 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 12376 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 44356 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 12389 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 44370 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 12402 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44383 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 12411 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44396 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 12420 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44409 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 12429 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 44422 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 12438 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 44435 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 12450 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 44443 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 12462 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44457 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 12473 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44463 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 12476 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44469 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 12477 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 44475 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 12478 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 44481 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 12479 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 44487 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 12480 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 44493 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 12481 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 44499 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 12484 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44505 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 12485 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 44511 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 12486 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 44517 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 12539 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44523 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 12540 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 44529 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 12555 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44535 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 12557 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 44546 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 12564 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44558 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 12572 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44570 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 12580 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 44582 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 12588 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 44594 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 12596 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44606 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 12604 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 44618 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 12614 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44624 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 12615 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44630 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 12650 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44648 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 12666 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44667 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 12680 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44673 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 12682 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 44696 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 12701 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44704 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 12705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44712 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 12709 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 44720 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 12724 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 44731 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 12731 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 44742 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 12738 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 44753 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 12747 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44759 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 12748 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 44765 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 12752 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 44782 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 12767 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 44788 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 12768 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 44794 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 12769 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 44800 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 12774 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 44814 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 12784 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 44828 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 12794 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 44836 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 12801 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 44852 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 12813 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 44868 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 12825 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 44876 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 12831 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 44882 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 12832 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 44888 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 12837 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 44903 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 12848 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 44909 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 12857 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44918 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 12862 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44927 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 12867 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44936 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 12872 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44945 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 12877 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44957 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 12885 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 44969 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 12893 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 44978 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12898 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 44987 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 12903 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 44996 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 12914 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 45002 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 12915 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 45008 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 12916 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 45014 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 12923 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 45020 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 12924 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45026 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 12933 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45032 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 12934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45038 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 12938 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45044 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 12939 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45050 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 12943 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45056 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 12947 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 45062 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 12948 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 45068 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 12952 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 45081 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 12961 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 45094 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 12974 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 45103 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 12979 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 45112 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 12984 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 45120 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 12988 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 45133 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 12999 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 45139 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 13000 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 45145 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 13005 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 45158 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 13014 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 45171 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 13030 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 45184 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 13039 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 45197 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 13048 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 45210 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 13057 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 45223 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 13069 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45229 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 13072 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 45235 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 13076 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45241 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 13078 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 45250 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 13085 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45256 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 13105 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45262 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 13107 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 45268 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 13109 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 45274 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 13113 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 45280 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 13114 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 45286 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 13118 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45292 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 13119 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45298 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 13122 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45304 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 13123 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 45310 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 13149 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 45322 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 13157 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 45334 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 13167 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45340 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 13168 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 45346 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 13172 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45352 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 13173 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45358 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 13174 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45364 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 13175 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45370 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 13176 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45376 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 13181 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 45384 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 13194 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45392 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 13201 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45400 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 13208 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 45408 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 13214 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45414 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 13215 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45420 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 13219 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45426 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 13220 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45432 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 13224 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45438 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 13225 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45444 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 13229 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45450 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 13230 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 45456 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 13235 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 45469 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 13246 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 45475 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 13247 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 45481 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 13248 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 45487 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 13249 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 45493 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 13253 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45499 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 13254 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45505 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 13265 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 45516 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 13272 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 45527 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 13290 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45533 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 13291 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45539 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 13295 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45545 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 13296 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45551 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 13303 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 45560 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 13308 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 45573 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 13317 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 45585 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 13325 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 45598 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 13334 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45609 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 13341 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45621 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 13349 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45634 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 13358 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 45647 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 13367 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 45655 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 13371 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 45664 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 13397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 45672 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 13401 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 45690 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 13415 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 45715 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 13436 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 45741 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 13458 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 45758 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 13471 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 45776 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 13488 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 45786 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 13494 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 45795 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 13499 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 45805 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 13505 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 45814 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 13511 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 45820 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 13512 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 45826 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 13523 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 45836 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 13528 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 45842 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 13537 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 45850 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 13541 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 45858 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 13545 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 45869 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 13552 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 45880 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 13559 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 45888 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 13564 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 45894 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 13565 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 45900 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 13566 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 45906 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 13567 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 45912 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 13588 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 45920 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 13592 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 45928 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 13600 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 45939 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 13607 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45947 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 13614 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 45958 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 13621 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 45969 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 13628 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 45980 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 13638 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 45986 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 13639 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 45992 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 13653 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 46000 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 13657 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 46012 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 13665 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 46024 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 13679 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 46039 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 13692 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 46045 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 13693 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46051 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 13709 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 46066 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 13720 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 46081 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 13733 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 46087 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 13737 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 46093 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 13738 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 46099 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 13741 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46105 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 13742 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46111 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 13745 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 46117 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 13746 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46123 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 13751 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46129 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 13752 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46135 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 13757 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46141 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 13759 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 46154 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 13767 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46160 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 13772 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46166 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 13773 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46172 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 13778 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46180 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 13782 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46188 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 13788 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 46211 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 13813 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 46226 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 13825 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 46241 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 13837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46247 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13838 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46253 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13843 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 46271 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13857 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 46332 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13914 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 46347 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13928 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 46353 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13930 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 46359 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13935 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 46365 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13937 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 46371 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13939 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 46377 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13941 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 46383 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 13946 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46389 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 13948 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 46395 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 13953 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 46407 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 13961 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46419 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 13981 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 46428 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 13986 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 46438 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 13993 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 46447 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 13998 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 46457 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 14004 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 46466 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 14009 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 46476 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 14018 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 46482 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 14020 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 46488 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 14022 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 46494 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 14026 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46500 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 14027 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46506 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 14028 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46512 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 14029 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46518 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 14030 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46524 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 14032 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 46533 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 14037 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 46543 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 14056 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46549 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 14057 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46555 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 14058 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46561 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 14059 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 46567 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 14071 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46577 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 14077 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 46587 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 14084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46593 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 14085 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46599 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 14092 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46608 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 14097 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46617 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 14102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46626 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 14107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46635 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 14112 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46644 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 14117 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46653 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 14122 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46662 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 14127 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46672 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 14133 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46682 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 14139 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46692 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 14145 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46701 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 14152 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 46726 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 14173 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 46734 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 14183 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46742 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 14187 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46750 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 14195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46758 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 14199 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 46767 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 14207 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46780 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 14219 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46798 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 14240 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46806 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 14244 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46814 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 14250 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 46822 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 14254 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 46837 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 14267 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 46847 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 14275 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46859 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 14285 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46865 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 14287 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46871 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 14289 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 46877 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 14291 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46883 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 14293 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46889 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 14295 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 46895 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 14299 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 46901 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 14300 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46907 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 14308 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46920 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 14317 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46932 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 14325 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 46945 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 14334 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 46957 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 14345 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 46966 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 14352 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 46972 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 14353 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46978 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 14354 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46984 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 14359 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 46990 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 14361 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 46996 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 14363 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 47002 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 14365 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 47008 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 14367 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 47014 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 14369 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47020 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 14371 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 47029 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 14376 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 47038 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 14381 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 47048 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 14387 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47060 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 14395 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 47069 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 14400 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47080 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 14407 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 47090 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 14413 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47096 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 14418 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 47104 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 14422 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 47113 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 14457 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47119 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 14459 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 47125 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 14461 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47138 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 14470 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 47149 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 14486 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47155 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 14488 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47161 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 14490 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47167 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 14492 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47173 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 14494 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47179 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 14496 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47185 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 14498 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47191 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 14500 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47197 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 14502 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47203 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 14504 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47209 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 14506 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47215 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 14508 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47221 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 14510 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47227 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 14512 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47233 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 14515 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47239 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 14517 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47245 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 14520 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47251 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 14522 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47257 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 14524 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 47263 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 14526 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 47269 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 14529 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 47278 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 14534 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47291 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 14543 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 47300 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 14548 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47313 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 14557 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 47322 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 14562 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47335 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 14571 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 47344 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 14576 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47357 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 14586 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 47370 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 14595 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 47383 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 14604 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 47396 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 14613 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 47409 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 14632 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 47422 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 14641 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47435 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 14650 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47448 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 14659 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47461 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 14668 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 47482 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 14685 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47495 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 14694 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47508 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 14703 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47521 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 14712 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47534 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 14721 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 47547 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 14730 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 47560 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 14739 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 47568 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 14743 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 47576 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 14747 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 47588 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 14755 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 47600 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 14763 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 47612 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 14771 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 47624 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 14779 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 47649 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 14800 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 47676 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 14823 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 47692 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 14835 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 47703 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 14842 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 47723 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14858 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 47732 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14863 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47742 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14869 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 47753 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14876 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 47764 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14883 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47776 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14891 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 47788 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14900 "gram.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeJsonIsPredicate((yyvsp[-3].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-3]));
				}
#line 47798 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14919 "gram.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeNotExpr(makeJsonIsPredicate((yyvsp[-4].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-4])), (yylsp[-4]));
				}
#line 47808 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14937 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 47827 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14963 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47833 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14965 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 47839 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14967 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47845 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14969 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47851 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14971 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47857 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14973 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47863 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14975 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47869 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14977 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47875 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14979 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47881 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14981 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47887 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 14983 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47893 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 14985 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47899 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 14987 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47905 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 14989 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47911 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 14991 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47917 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 14993 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47923 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 14995 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 47929 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 14997 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47935 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 14999 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 47943 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 15003 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 47951 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 15007 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 47960 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 15012 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 47970 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 15027 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47976 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 15028 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47982 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 15030 "gram.y" /* yacc.c:1646  */
    {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 48003 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 15047 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 48020 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 15060 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48026 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 15062 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48032 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 15064 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 48048 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 15076 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 48077 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 15101 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48093 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 15113 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48109 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 15125 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 48121 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 15133 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 48136 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 15144 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 48151 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 15155 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 48163 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 15165 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 48173 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 15171 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 48186 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 15180 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 48200 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 15190 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 48214 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 15200 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 48231 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 15213 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 48245 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 15223 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 48268 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 15254 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 48308 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 15290 "gram.y" /* yacc.c:1646  */
    {
					JsonAggConstructor *n = IsA((yyvsp[-2].node), JsonObjectAgg) ?
						((JsonObjectAgg *) (yyvsp[-2].node))->constructor :
						((JsonArrayAgg *) (yyvsp[-2].node))->constructor;

					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) (yyvsp[-2].node);
				}
#line 48322 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 15300 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48328 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 15310 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48334 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 15311 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48340 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 15312 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48346 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 15320 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48357 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 15327 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 48365 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 15331 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 48373 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 15335 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48381 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 15339 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 48389 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 15343 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48397 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 15347 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 48405 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 15351 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48413 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 15355 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 48421 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 15359 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 48429 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 15363 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 48437 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 15367 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 48445 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 15371 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 48453 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 15375 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("system_user"),
											   NIL,
											   COERCE_SQL_SYNTAX,
											   (yylsp[0]));
				}
#line 48464 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 15382 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 48472 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 15386 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 48480 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 15390 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 48488 "gram.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 15394 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 48494 "gram.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 15396 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48505 "gram.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 15403 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48516 "gram.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 15410 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 48527 "gram.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 15417 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48538 "gram.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 15424 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 48553 "gram.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 15435 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48571 "gram.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 15449 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48585 "gram.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 15459 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 48600 "gram.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 15470 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 48620 "gram.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 15486 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48634 "gram.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 15496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48645 "gram.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 15503 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48656 "gram.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 15510 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 48667 "gram.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 15517 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 48675 "gram.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 15521 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 48687 "gram.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 15529 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 48700 "gram.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 15538 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 48713 "gram.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 15547 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 48721 "gram.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 15551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 48729 "gram.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 15555 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 48737 "gram.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 15559 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 48745 "gram.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 15563 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 48753 "gram.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 15567 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 48766 "gram.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 15576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 48774 "gram.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 15580 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 48788 "gram.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 15590 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 48796 "gram.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 15594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 48804 "gram.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 15598 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 48813 "gram.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 15603 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-5].ival);
					n->expr = (yyvsp[-4].node);
					n->typeName = (yyvsp[-2].typnam);
					n->indent = (yyvsp[-1].boolean);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 48828 "gram.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 15614 "gram.y" /* yacc.c:1646  */
    {
					/* Support for legacy (non-standard) json_object() */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("json_object"),
											   (yyvsp[-1].list), COERCE_EXPLICIT_CALL, (yylsp[-3]));
				}
#line 48838 "gram.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 15623 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = (yyvsp[-4].list);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48853 "gram.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 15634 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = NULL;
					n->absent_on_null = false;
					n->unique = false;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 48868 "gram.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 15649 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = (yyvsp[-3].list);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48882 "gram.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 15664 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayQueryConstructor *n = makeNode(JsonArrayQueryConstructor);

					n->query = (yyvsp[-3].node);
					n->format = (JsonFormat *) (yyvsp[-2].node);
					n->absent_on_null = true;	/* XXX */
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48897 "gram.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 15677 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = NIL;
					n->absent_on_null = true;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 48911 "gram.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 15692 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48917 "gram.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 15694 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 48923 "gram.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 15698 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 48929 "gram.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 15700 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 48935 "gram.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 15702 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 48941 "gram.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 15704 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 48947 "gram.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 15707 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48953 "gram.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 15710 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48959 "gram.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 15711 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48965 "gram.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 15715 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 48977 "gram.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 15723 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 48989 "gram.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 15732 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 48995 "gram.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 15733 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 49001 "gram.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 15736 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 49007 "gram.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 15737 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49013 "gram.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 15738 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49019 "gram.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 15741 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 49025 "gram.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 15742 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49031 "gram.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 15743 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49037 "gram.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 15749 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49045 "gram.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 15753 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 49053 "gram.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 15757 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49061 "gram.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 15761 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 49069 "gram.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 15776 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49075 "gram.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 15777 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49081 "gram.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 15781 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 49087 "gram.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 15782 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49093 "gram.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 15790 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49099 "gram.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 15791 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49105 "gram.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 15795 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 49111 "gram.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 15797 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 49117 "gram.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 15802 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 49128 "gram.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 15811 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 49134 "gram.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 15813 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 49152 "gram.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 15827 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 49158 "gram.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 15832 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 49177 "gram.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 15858 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49183 "gram.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 15859 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 49189 "gram.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 15862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49195 "gram.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 15863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49201 "gram.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 15872 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 49213 "gram.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 15880 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 49225 "gram.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 15888 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 49237 "gram.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 15896 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49250 "gram.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 15907 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 49272 "gram.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 15925 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 49314 "gram.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 15971 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49327 "gram.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 15980 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49340 "gram.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 15989 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49353 "gram.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 15998 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49366 "gram.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 16007 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 49379 "gram.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 16018 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 49385 "gram.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 16019 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 49391 "gram.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 16020 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 49397 "gram.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 16021 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 49403 "gram.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 16022 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 49409 "gram.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 16036 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49415 "gram.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 16037 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49421 "gram.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 16038 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 49427 "gram.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 16041 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49433 "gram.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 16042 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49439 "gram.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 16045 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 49445 "gram.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 16048 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 49451 "gram.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 16049 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 49457 "gram.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 16050 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 49463 "gram.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 16053 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49469 "gram.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 16054 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49475 "gram.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 16057 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 49481 "gram.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 16058 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 49487 "gram.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 16059 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 49493 "gram.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 16060 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 49499 "gram.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 16061 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 49505 "gram.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 16062 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 49511 "gram.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 16063 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 49517 "gram.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 16064 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 49523 "gram.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 16065 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 49529 "gram.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 16066 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 49535 "gram.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 16067 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 49541 "gram.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 16068 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 49547 "gram.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 16072 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49553 "gram.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 16074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49559 "gram.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 16079 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49565 "gram.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 16081 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49571 "gram.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 16086 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 49577 "gram.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 16088 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 49583 "gram.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 16090 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 49589 "gram.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 16092 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 49595 "gram.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 16094 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 49601 "gram.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 16096 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 49607 "gram.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 16108 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 49615 "gram.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 16112 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 49623 "gram.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 16119 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 49631 "gram.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 16123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 49639 "gram.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 16129 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 49647 "gram.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 16133 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 49661 "gram.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 16143 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 49675 "gram.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 16154 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49681 "gram.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 16155 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49687 "gram.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 16158 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 49693 "gram.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 16159 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 49699 "gram.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 16163 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 49707 "gram.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 16167 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 49715 "gram.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 16171 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 49723 "gram.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 16176 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49729 "gram.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 16177 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 49735 "gram.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 16183 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 49743 "gram.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 16192 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49749 "gram.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 16193 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 49755 "gram.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 16194 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 49761 "gram.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 16195 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 49767 "gram.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 16196 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 49773 "gram.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 16197 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 49779 "gram.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 16198 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 49785 "gram.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 16199 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 49791 "gram.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 16203 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 49797 "gram.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 16204 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 49803 "gram.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 16205 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 49809 "gram.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 16206 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 49815 "gram.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 16212 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49824 "gram.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 16217 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49833 "gram.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 16225 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 49839 "gram.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 16247 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49847 "gram.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 16251 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 49856 "gram.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 16256 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49871 "gram.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 16267 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 49892 "gram.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 16284 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 49900 "gram.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 16289 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 49906 "gram.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 16290 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49912 "gram.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 16291 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49918 "gram.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 16295 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 49930 "gram.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 16302 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 49936 "gram.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 16313 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 49951 "gram.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 16327 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 49957 "gram.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 16328 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 49963 "gram.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 16333 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 49976 "gram.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 16344 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49982 "gram.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 16345 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 49988 "gram.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 16348 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49994 "gram.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 16349 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 50000 "gram.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 16353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 50008 "gram.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 16357 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 50016 "gram.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 16364 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 50024 "gram.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 16368 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 50032 "gram.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 16372 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 50045 "gram.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 16381 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 50058 "gram.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 16392 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50064 "gram.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 16393 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 50070 "gram.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 16397 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 50076 "gram.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 16398 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 50082 "gram.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 16402 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50088 "gram.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 16403 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 50094 "gram.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 16413 "gram.y" /* yacc.c:1646  */
    {
				/* formatted_expr will be set during parse-analysis. */
				(yyval.node) = (Node *) makeJsonValueExpr((Expr *) (yyvsp[-1].node), NULL,
												castNode(JsonFormat, (yyvsp[0].node)));
			}
#line 50104 "gram.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 16422 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, (yyvsp[0].ival), (yylsp[-2]));
				}
#line 50112 "gram.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 16426 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
				}
#line 50120 "gram.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 16432 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = makeJsonEncoding((yyvsp[0].str)); }
#line 50126 "gram.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 16433 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_ENC_DEFAULT; }
#line 50132 "gram.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 16438 "gram.y" /* yacc.c:1646  */
    {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[-1].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format = (JsonFormat *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 50145 "gram.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 16446 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 50151 "gram.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 16450 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 50157 "gram.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 16451 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 50163 "gram.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 16452 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ARRAY; }
#line 50169 "gram.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 16453 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_OBJECT; }
#line 50175 "gram.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 16454 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_SCALAR; }
#line 50181 "gram.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 16459 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 50187 "gram.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 16460 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 50193 "gram.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 16461 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50199 "gram.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 16462 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50205 "gram.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 16463 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50211 "gram.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 16468 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 50217 "gram.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 16470 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 50223 "gram.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 16480 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 50229 "gram.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 16483 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 50235 "gram.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 16488 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50241 "gram.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 16489 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 50247 "gram.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 16490 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50253 "gram.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 16494 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 50259 "gram.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 16495 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 50265 "gram.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 16496 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 50271 "gram.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 16500 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 50277 "gram.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 16501 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));}
#line 50283 "gram.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 16511 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectAgg *n = makeNode(JsonObjectAgg);

					n->arg = (JsonKeyValue *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->agg_order = NULL;
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50300 "gram.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 16529 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayAgg *n = makeNode(JsonArrayAgg);

					n->arg = (JsonValueExpr *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->agg_order = (yyvsp[-3].list);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50316 "gram.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 16543 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 50322 "gram.c" /* yacc.c:1646  */
    break;

  case 2317:
#line 16544 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50328 "gram.c" /* yacc.c:1646  */
    break;

  case 2318:
#line 16553 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 50334 "gram.c" /* yacc.c:1646  */
    break;

  case 2319:
#line 16554 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 50340 "gram.c" /* yacc.c:1646  */
    break;

  case 2320:
#line 16558 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 50346 "gram.c" /* yacc.c:1646  */
    break;

  case 2321:
#line 16559 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 50352 "gram.c" /* yacc.c:1646  */
    break;

  case 2322:
#line 16563 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 50364 "gram.c" /* yacc.c:1646  */
    break;

  case 2323:
#line 16571 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 50376 "gram.c" /* yacc.c:1646  */
    break;

  case 2324:
#line 16579 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 50388 "gram.c" /* yacc.c:1646  */
    break;

  case 2325:
#line 16587 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 50405 "gram.c" /* yacc.c:1646  */
    break;

  case 2326:
#line 16609 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 50411 "gram.c" /* yacc.c:1646  */
    break;

  case 2327:
#line 16610 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 50417 "gram.c" /* yacc.c:1646  */
    break;

  case 2328:
#line 16622 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 50425 "gram.c" /* yacc.c:1646  */
    break;

  case 2329:
#line 16626 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 50433 "gram.c" /* yacc.c:1646  */
    break;

  case 2330:
#line 16632 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50439 "gram.c" /* yacc.c:1646  */
    break;

  case 2331:
#line 16634 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 50445 "gram.c" /* yacc.c:1646  */
    break;

  case 2332:
#line 16638 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50451 "gram.c" /* yacc.c:1646  */
    break;

  case 2333:
#line 16640 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50457 "gram.c" /* yacc.c:1646  */
    break;

  case 2334:
#line 16642 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50463 "gram.c" /* yacc.c:1646  */
    break;

  case 2335:
#line 16653 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 50469 "gram.c" /* yacc.c:1646  */
    break;

  case 2336:
#line 16655 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 50478 "gram.c" /* yacc.c:1646  */
    break;

  case 2337:
#line 16666 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 50486 "gram.c" /* yacc.c:1646  */
    break;

  case 2338:
#line 16670 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50494 "gram.c" /* yacc.c:1646  */
    break;

  case 2339:
#line 16674 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50502 "gram.c" /* yacc.c:1646  */
    break;

  case 2340:
#line 16678 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50510 "gram.c" /* yacc.c:1646  */
    break;

  case 2341:
#line 16682 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 50523 "gram.c" /* yacc.c:1646  */
    break;

  case 2342:
#line 16691 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50535 "gram.c" /* yacc.c:1646  */
    break;

  case 2343:
#line 16699 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50571 "gram.c" /* yacc.c:1646  */
    break;

  case 2344:
#line 16731 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 50579 "gram.c" /* yacc.c:1646  */
    break;

  case 2345:
#line 16735 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 50590 "gram.c" /* yacc.c:1646  */
    break;

  case 2346:
#line 16742 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 50602 "gram.c" /* yacc.c:1646  */
    break;

  case 2347:
#line 16750 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 50610 "gram.c" /* yacc.c:1646  */
    break;

  case 2348:
#line 16754 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 50618 "gram.c" /* yacc.c:1646  */
    break;

  case 2349:
#line 16758 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 50626 "gram.c" /* yacc.c:1646  */
    break;

  case 2350:
#line 16763 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 50632 "gram.c" /* yacc.c:1646  */
    break;

  case 2351:
#line 16764 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50638 "gram.c" /* yacc.c:1646  */
    break;

  case 2352:
#line 16766 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 50644 "gram.c" /* yacc.c:1646  */
    break;

  case 2353:
#line 16767 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 50650 "gram.c" /* yacc.c:1646  */
    break;

  case 2354:
#line 16768 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 50656 "gram.c" /* yacc.c:1646  */
    break;

  case 2355:
#line 16773 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 50699 "gram.c" /* yacc.c:1646  */
    break;

  case 2356:
#line 16814 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 50731 "gram.c" /* yacc.c:1646  */
    break;

  case 2357:
#line 16842 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 50739 "gram.c" /* yacc.c:1646  */
    break;

  case 2358:
#line 16846 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 50747 "gram.c" /* yacc.c:1646  */
    break;

  case 2359:
#line 16850 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 50755 "gram.c" /* yacc.c:1646  */
    break;

  case 2360:
#line 16856 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 50761 "gram.c" /* yacc.c:1646  */
    break;

  case 2361:
#line 16858 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 50767 "gram.c" /* yacc.c:1646  */
    break;

  case 2362:
#line 16875 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 50798 "gram.c" /* yacc.c:1646  */
    break;

  case 2363:
#line 16908 "gram.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50813 "gram.c" /* yacc.c:1646  */
    break;

  case 2364:
#line 16920 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50819 "gram.c" /* yacc.c:1646  */
    break;

  case 2365:
#line 16921 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 50825 "gram.c" /* yacc.c:1646  */
    break;

  case 2368:
#line 16942 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50831 "gram.c" /* yacc.c:1646  */
    break;

  case 2369:
#line 16943 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50837 "gram.c" /* yacc.c:1646  */
    break;

  case 2370:
#line 16944 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50843 "gram.c" /* yacc.c:1646  */
    break;

  case 2371:
#line 16949 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50849 "gram.c" /* yacc.c:1646  */
    break;

  case 2372:
#line 16950 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50855 "gram.c" /* yacc.c:1646  */
    break;

  case 2373:
#line 16951 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50861 "gram.c" /* yacc.c:1646  */
    break;

  case 2374:
#line 16956 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50867 "gram.c" /* yacc.c:1646  */
    break;

  case 2375:
#line 16957 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50873 "gram.c" /* yacc.c:1646  */
    break;

  case 2376:
#line 16958 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50879 "gram.c" /* yacc.c:1646  */
    break;

  case 2377:
#line 16959 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50885 "gram.c" /* yacc.c:1646  */
    break;

  case 2378:
#line 16965 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50891 "gram.c" /* yacc.c:1646  */
    break;

  case 2379:
#line 16966 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50897 "gram.c" /* yacc.c:1646  */
    break;

  case 2380:
#line 16967 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50903 "gram.c" /* yacc.c:1646  */
    break;

  case 2381:
#line 16968 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50909 "gram.c" /* yacc.c:1646  */
    break;

  case 2382:
#line 16969 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50915 "gram.c" /* yacc.c:1646  */
    break;

  case 2383:
#line 16975 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 50921 "gram.c" /* yacc.c:1646  */
    break;

  case 2384:
#line 16976 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 50927 "gram.c" /* yacc.c:1646  */
    break;


#line 50931 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 17948 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast   *n = makeNode(TypeCast);

	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.sval.type = T_String;
	n->val.sval.sval = str;
	n->location = location;

	return (Node *) n;
}

Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node       *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

Node *
makeIntConst(int val, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.ival.type = T_Integer;
	n->val.ival.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBoolAConst(bool state, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.boolval.type = T_Boolean;
    n->val.boolval.boolval = state;
    n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.bsval.type = T_BitString;
    n->val.bsval.bsval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
    A_Const    *n = makeNode(A_Const);

    n->isnull = true;
    n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node       *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}
/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location)));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Parse a user-supplied partition strategy string into parse node
 * PartitionStrategy representation, or die trying.
 */
static PartitionStrategy
parsePartitionStrategy(char *strategy)
{
	if (pg_strcasecmp(strategy, "list") == 0)
		return PARTITION_STRATEGY_LIST;
	else if (pg_strcasecmp(strategy, "range") == 0)
		return PARTITION_STRATEGY_RANGE;
	else if (pg_strcasecmp(strategy, "hash") == 0)
		return PARTITION_STRATEGY_HASH;

	ereport(ERROR,
			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
			 errmsg("unrecognized partitioning strategy \"%s\"",
					strategy)));
	return PARTITION_STRATEGY_LIST;		/* keep compiler quiet */

}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("invalid publication object list"),
				 errdetail("One of TABLE or TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				 parser_errposition(pubobj->location)));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid table name"),
						 parser_errposition(pubobj->location)));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("WHERE clause not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("column specification not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid schema name"),
						 parser_errposition(pubobj->location)));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

